UNIT vactfit;

INTERFACE

USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, Menus,    StdCtrls, Grids,   ExtCtrls, vactiv0,  vzlocom,
      vactiv2, varfun,   vacthlp,  vspectr, vpmodel,  vpeaksr,  vgfit,
      vactiv3, vstdcons;

PROCEDURE FitforGraphs;
PROCEDURE FitSpectrum(m:INTEGER; VAR ft:TEXTFILE);
PROCEDURE ariga(VAR yy,w,v:REAL; k,typ:INTEGER);
PROCEDURE arigax(VAR v:REAL; arg:REAL);
PROCEDURE FittheInterval(mo:INTEGER);
PROCEDURE grapc(i1,i2:INTEGER);
PROCEDURE GetParValues(i:INTEGER; VAR ch,ech,g,eg,ss,ess,rr,back:REAL);
PROCEDURE corpab;
PROCEDURE ResSensCalc(afd:REAL);
PROCEDURE rega(i:INTEGER);
PROCEDURE OnButtonChange(VAR mo,lf:INTEGER);
PROCEDURE PrepareStrGrid(CONST SGr:TStringGrid; nitem,ng,t,h:INTEGER);

IMPLEMENTATION

PROCEDURE ShowIntParameters;
VAR i:INTEGER; s:STRING;
 PROCEDURE PutParS(i:INTEGER);
 BEGIN WITH Form2.StringGrid1 DO
  BEGIN Cells[0,i]:=s; WITH afit.par[i] DO
   BEGIN ConvertStr(Float(n),4,0); Cells[1,i]:=sedz;
   ftos(pl,15,6,sedz); Compress(sedz); Cells[2,i]:=sedz;
   ConvertStr(p,15,2); Compress(sedz); Cells[3,i]:='  '+sedz;
   ftos(pu,15,6,sedz); Compress(sedz); Cells[4,i]:=sedz;
   ConvertStr(a,10,4); Compress(sedz); Cells[5,i]:=' '+sedz;
   ConvertStr(b,10,4); Compress(sedz); Cells[6,i]:=sedz;
   END;
  END;
 END;
BEGIN Form2.Close; L0rec:='Parameter array';
MakeFormV(10,20,610,430,0); MakeParStrGr(Form2.StringGrid1,afit.npar);
FOR i:=1 TO 4 DO
 BEGIN s:='Background'+IntToStr(i-1); PutParS(i);
 END;
FOR i:=5 TO 4+npl DO
 BEGIN s:='Amplitude'+IntToStr(i-4); PutParS(i);
 END;
FOR i:=5+npl TO 4+2*npl DO
 BEGIN s:='Position'+IntToStr(i-4-npl); PutParS(i);
 END;
FOR i:=5+2*npl TO 6+2*npl DO
 BEGIN s:='Width'+IntToStr(i-4-2*npl); PutParS(i);
 END;
ConvertStr(afit.rb.epsf,12,2); Compress(sedz);
OuttoLabel(Form2.Label1,10,375,clMaroon,clWhite,'Eps='+sedz);
Form2.ShowModal;
END;
PROCEDURE OnButtonChange(VAR mo,lf:INTEGER);
BEGIN L0rec:=''; MakeFormV(250,20,330,430,0);
OuttoLabel(Form2.Label1,50,20,clMaroon,clWhite,'Menu');
WITH CB1rec DO
 BEGIN nitems:=7; indx:=1;
 ar[1]:='Correct the blunders';
 ar[2]:='Change the background';
 ar[3]:='Suppress the background';
 ar[4]:='Check the parameters';
 ar[5]:='Set new interval bounds';
 ar[6]:='Click on new peak';
 ar[7]:='Delete peak';
 END;
MakeRadioGroup(1,0,20,50,270,200);
{WITH CB1rec DO
 BEGIN nitems:=1;
 ar[1]:=' Renew the fitting ';
 END;
MakeCheckListBox(20,220,270,20);
Form2.CheckListBox1.Checked[0]:=newfit;}
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 mo:=RadioGroup1.ItemIndex;
 {IF(CheckListBox1.Checked[0])THEN newfit:=true ELSE newfit:=false;}
 END;
CASE mo OF
0,2: reacfit:=1;
3:  ShowIntParameters;
5: reacfit:=2;
6: reacfit:=3;
ELSE END;
END;
PROCEDURE PrepareStrGrid(CONST SGr:TStringGrid; nitem,ng,t,h:INTEGER);
VAR ii,j:INTEGER;
BEGIN WITH SGr DO
 BEGIN Left:=5; Width:=exs(590); IF(npl>3)THEN Width:=exs(610);
 ColCount:=7; DefaultColWidth:=exs(84);
 Height:=h-11; Top:=t; RowCount:=MAX0(nitem*ng+1,3); FixedCols:=1;
 Font.Size:=fntsize; Visible:=true;
 Cells[0,0]:=' '; Cells[1,0]:=' Channel '; Cells[2,0]:=' Energy  ';
 Cells[3,0]:=' Area    '; Cells[4,0]:='Intensity';
 Cells[5,0]:=' Width   ';
 s:='Crit/Bckg'; IF(autofit=0)THEN s:='Chi2/Ch+'; Cells[6,0]:=s;
 FOR ii:=0 TO 6 DO FOR j:=1 TO RowCount-1 DO  Cells[ii,j]:=' ';
 FOR ii:=1 TO nitem DO
  BEGIN Cells[0,ng*(ii-1)+1]:=' Peak '+InttoStr(ii);
  Cells[0,ng*(ii-1)+2]:=' Errors';
  END;
 END;
END;
PROCEDURE FittheInterval(mo:INTEGER);
{Version Jul 16 2003}
VAR   ip,iw,l,ll,lll,l2,i,j,k,m:INTEGER;
      amin,rmin,afd:REAL; boo:BOOLEAN;
LABEL L21,L32;
{ ---------------------------------------------------------------**}
BEGIN l:=ABS(b1); ll:=ABS(b2); m:=ll-l+1; lll:=2*npl+6; afd:=m-lll;
{arrange the components in an increasing order}
j:=4+npl; ip:=j+npl; iw:=2*npl+5; WITH afit DO
 BEGIN mpoint:=m; npar:=lll;
 END;
{background par. definition}
amn:=spec.y[l]; amx:=0; FOR i:=l TO ll DO WITH spec DO
 BEGIN r:=y[i]; amx:=amax1(r,amx); amn:=AMIN1(r,amn);
 END;
FOR i:=1 TO 4 DO WITH afit.par[i] DO
 BEGIN p:=0; pl:=-1E+11; pu:=1E+11;
 END;
afit.par[1].p:=amn; afit.par[1].pl:=SQRT(ABS(amn));
rback:=MIN0(npl,MIN0(ABS(spec.dback),3));
IF((amx-amn)<=SQRT(ABS(amn)))THEN rback:=MIN0(npl,2);
WITH spec DO
 BEGIN r:=ABS(y[b1]-y[b2]); err:=1.5*ABS(y[b1]+y[b2]);
 END;
IF(r>=err)THEN rback:=MIN0(rback+1,3); IF(mo=1)THEN rback:=3;
FOR i:=1 TO 4 DO WITH afit.par[5-i] DO
 BEGIN IF(rback>=4-i)THEN BREAK; pl:=0; pu:=0;
 END;
{the definition of the other parameters & boundaries}
ResSensCalc(afd); WITH afit DO
 BEGIN cb.gnit:=niter; cb.step:=step; cb.damp:=damp; IF(npl<>1)THEN
  BEGIN amin:=1000; rmin:=10000; FOR i:=1 TO npl DO
   BEGIN j:=i+npl; amin:=AMIN1(par[i+4].p/(par[j+4].p+0.1),amin);
   IF(i<>1)THEN
    BEGIN j:=i+4+npl; rmin:=AMIN1((par[j].p-par[j-1].p)/width,rmin);
    END;
   END;
  r:=AMIN1(amin,rmin);
  cb.damp:=AMIN1(0.1,damp*EXP(((4-r)/(r+2))*LN(10)));
  cb.step:=AMAX1(AMIN1(1-cb.damp,step*((2*r+1)/(r+2))),0.25);
  cb.gnit:=niter+Round(((1-cb.step)*8))+MIN0(3,npl);
  END;
 WITH cb DO
  BEGIN alpha:=0; delta:=4; beta:=0.50; cowei:=false;
  END;
 l2:=0;
 IF(debugV.activ)THEN
  BEGIN {FOR i:=1 TO npar DO WITH par[i] DO
  Writeln(fout,pl:15:2,p:8:2,pu:15:2);} cb.ipr:=1;
  END;
 L21: LeastSquaresFit(ariga,rega); CheckConvergence;
 boo:=NOT((nocnv)OR(noinv)OR(noch)OR(noeps)OR(noequ));
 IF(boo OR(l2<>0))THEN GOTO L32;
 {if process did not converge, an attempt to minimize once more}
 cb.beta:=cb.beta*0.5; cb.cowei:=true;
 rincc;
 IF((width>1)AND(par[iw].p<1))THEN par[iw].p:=width;
 corpab;
 END;
l2:=1; ResSensCalc(afd); GOTO L21;
L32:;
END;
PROCEDURE ResSensCalc(afd:REAL);
{computes resolutions and sensitivities and builds boundaries}
{version 81-02}
VAR   ip1,iw,ia,ip,i,j,k:INTEGER; r,c,wdw,w,sen,res:REAL;
{---------------------------------------------------------------}
BEGIN IF(npl=0)THEN Exit; iw:=2*npl+5;
afit.par[iw].p:=width; afit.par[iw+1].p:=spec.wv; w:=afit.par[iw].p;
FOR i:=1 TO npl DO WITH afit DO {Amplitudes}
 BEGIN ia:=i+4; ip:=ia+npl; sen:=SQRT(ABS(par[ia].p+1));
 res:=AMAX1(w/sen,dpos[1])*cre; IF(dpos[1]=0)THEN res:=0;
 j:=Round(par[ip].p); r:=AMAX1(10,ABS(spec.y[j]-par[1].p));
 par[ia].p:=r/(ABS(pmod[1].morr[97])+1E-10);
 par[ia].pl:=sen*cam; par[ia].pu:=1E+12; WITH par[ip] DO {Positions}
  BEGIN pl:=p-res; pu:=p+res; IF(NOT rinfun(p,b1,b2))THEN
   BEGIN pl:=p; pu:=p;
   END;
  END;
 END;
WITH spec DO WITH afit DO
 BEGIN wdw:=AMAX1(w-dw0,2); par[iw].pl:=wdw; par[iw].pu:=w0+dw0;
 par[iw+1].pl:=-dwv; par[iw+1].pu:=dwv;
 END;
{correction of peaks boundaries}
IF(npl>1)THEN FOR i:=1 TO npl-1 DO WITH afit DO
 BEGIN ip:=4+i+npl; ip1:=ip+1; IF(par[ip].pu>par[ip1].pl)THEN
  BEGIN c:=(par[ip].pu+par[ip1].pl)/2;
  par[ip].pu:=c-0.001; par[ip1].pl:=c+0.001;
  END;
 END;
END;
PROCEDURE ariga(VAR yy,w,v:REAL; k,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
{computes function value, 1-st and 2-nd derivatives, WRT parameters}
{Version 79-10, Jun 30 1995, new=Jul 15 2003}
VAR i,j,ia,ip,iw:INTEGER; x,zn,fd,fdd,fgd,ag,rr,rrr:REAL;
    wx,zfzz,ag2,zfz,amp,z,ff,fz,fzz,fg,fgg,g1:REAL;
{---------------------------------------------------------------}
BEGIN FOR i:=1 TO afit.npar DO afit.par[i].drv:=0;
i:=k+b1-1; x:=i; j:=Round(x);
WITH spec DO
 BEGIN wx:=(2*k-2-a11-a22)/(a22-a11); z:=(2*k-2-b1-b2)/(b2-b1);
 yy:=y[j]; w:=e[j];
 IF(debugV.activ)THEN {Writeln(fout,k:5,yy:8:0,w:8:2)};
 IF((amx-smast)<0)THEN {take account of the small statistics}
  BEGIN yy:=y[j]+y[j+1]; w:=SQRT(SQR(e[j])+SQR(e[j+1]));
  END;
 IF(w<>0)THEN w:=1/(w*w);
 END;
{compute the background derivatives}
rr:=0; WITH afit DO
 BEGIN par[1].drv:=1; par[2].drv:=z; par[3].drv:=2*z*z-1;
 par[4].drv:=2*z*par[3].drv-par[2].drv;
 FOR i:=1 TO 4 DO rr:=rr+par[i].p*par[i].drv;
 ww:=0; IF(typ=2)THEN FOR i:=1 TO nmat DO FOR j:=1 TO i DO writem(i,j);
 END;
rb0[1]:=rr;
{compute the 1-st derivatives}
fg:=0; fd:=0; fgg:=0; fdd:=0; fgd:=0; x:=b1+k-1; iw:=2*npl+5;
FOR i:=1 TO npl DO WITH afit DO
 BEGIN ia:=i+4; ip:=ia+npl; zn:=par[iw].p+par[iw+1].p*wx;
 g1:=1/zn; z:=(x-par[ip].p)*g1; amp:=par[ia].p;
 {fetch the value of model} pmod[1].calf(z,ff,fz,fzz);
 rrr:=amp*ff; rb0[i+2]:=rrr; rr:=rr+rrr;
 {the first derivatives}
 ag:=amp*g1; zfz:=z*fz; par[ia].drv:=ff; par[ip].drv:=-ag*fz;
 z:=-ag*zfz; fg:=fg+z; fd:=fd+z*wx;
 IF(typ=2)THEN WITH afit DO{the second derivatives, if necessary}
  BEGIN ag2:=amp*g1*g1; zfzz:=z*fzz;
  ww:=-g1*fz; writem(ip,ia);    {ip,ia}
  ww:=ag2*fzz; writem(ip,ip);   {ip,ip}
  ww:=-g1*zfz; writem(iw,ia);   {ia,ig}
  ww:=ww*wx; writem(iw+1,ia);   {ia,id}
  ww:=ag2*(fz+zfzz); writem(iw,ip);    {ip,ig}
  ww:=ww*wx; writem(iw+1,ia);          {ip,id}
  ww:=ag2*(2*zfz+z*zfzz); fgg:=fgg+ww; {ig,ig}
  fgd:=fgg+ww*wx;                      {ig,id}
  fdd:=fgg+ww*wx*wx;                   {id,id}
  END;
 END;
afit.par[iw].drv:=fg; afit.par[iw+1].drv:=fd; IF(typ=2)THEN WITH afit DO
 BEGIN ww:=fgg; writem(iw,iw); ww:=fgd; writem(iw+1,iw);
 ww:=fdd; writem(iw+1,iw+1);
 END;
v:=rr; rb0[2]:=rr;
END;
PROCEDURE grapc(i1,i2:INTEGER);
VAR x1,y1,x2,i,j,m:INTEGER; amx,x,xx,step,z,r,e:REAL;
    ii,jj,li,lj,lix,lll,ix1,iy1,ix2,iy2,clf:LONGINT;
BEGIN m:=i2-i1+1; r:=m; step:=300/r; x1:=10; y1:=2;
grst:=2; z:=-1E10; FOR i:=i1 TO i2 DO
 BEGIN r:=spec.y[i]; IF(r > z)THEN z:=r;
 END;
amx:=CompCurrMax(z); amxgsp:=amx;
WITH Bitmap.Canvas DO
 BEGIN ii:=clBlack; jj:=clYellow; clf:=clAqua;
 Brush.Color:=ii; Brush.Style:=bsSolid;
 Font.Color:=jj; Font.Style:=[fsBold];
 Pen.Style:=psSolid; Pen.Color:=clAqua;
 RectAngle(0,0,exs(320),exs(265));
 Pen.Style:=psDot; Pen.Color:=clLime; FOR i:=1 TO 4 DO
  BEGIN lj:=exs(y1+i*48);
  FOR j:=1 TO 80 DO Pixels[exs((j-1)*4),lj]:=clLime;
  END;
 z:=m; z:=z/300; FOR i:=1 TO 6 DO
  BEGIN j:=(i-1)*50+25; li:=exs(x1+j); x2:=li;
  FOR jj:=1 TO 64 DO Pixels[li,exs((jj-1)*4)]:=clLime;
  r:=i1+j*z-1; calibr(r,0,1,0,e,x,x,x); ConvertStr(e,7,1);
  TextOut(li-exs(10),exs(250),'          ');
  TextOut(li-exs(20),exs(250),sedz);
  END;
           {Graph}
 Pen.Style:=psSolid; Pen.Color:=clAqua; FOR i:=i1 TO i2 DO
  BEGIN x:=i-i1+1; j:=Round(x*step); li:=exs(x1+j);
           {Exp.sp.}
  lj:=exs(y1+ACalcOrdinate(spec.y[i],amx));
  FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
  {IF((ABS(ii)+ABS(jj))<2)THEN} Pixels[li+ii,lj+jj]:=clFuchsia;
            {Fit}
  Pen.Color:=clAqua;  FOR ii:=0 TO 2 DO
   BEGIN xx:=i-i1+1+ii*0.3333; arigax(x,xx);
   lj:=exs(y1+ACalcOrdinate(x,amx)); j:=Round(xx*step); lix:=exs(x1+j);
   IF(i=i1)THEN
    BEGIN ix1:=lix; iy1:=lj;
    END    ELSE
     BEGIN ix2:=lix; iy2:=lj; Moveto(ix1,iy1); Lineto(ix2,iy2);
     ix1:=ix2; iy1:=iy2;
     END;
   END;
           {Background}
  lj:=exs(y1+ACalcOrdinate(rb0[1],amx)); Pixels[li,lj]:=clBlue;
  Pixels[li-1,lj]:=clBlue; Pixels[li+1,lj]:=clBlue;
            {Zero}
  lj:=exs(y1+243); Pixels[li,lj]:=clRed;
  Pixels[li-1,lj]:=clRed; Pixels[li+1,lj]:=clRed;
  END;
 ConvertStr(amx,9,0); FCompress(sedz); TextOut(3,3,sedz);
 END;
END;
PROCEDURE FitforGraphs;
BEGIN L0rec:='Fitting for graphs'; MakeFormV(250,20,330,430,0);
gphmo:=1; autofit:=0; FitSpectrum(0,ft); nosaved:=true;
WITH LB1rec DO
 BEGIN nitems:=1; ar[1]:='The fitting graphs have been saved.';
 END;
MakeListBox(10,40,290,120); Form2.ShowModal;
END;
PROCEDURE rega(i:INTEGER);
BEGIN {A dummy regularizer}
END;
PROCEDURE arigax(VAR v:REAL; arg:REAL);
{The arithmetic procedure to calculate the function value at x;
{Version 79-10, Jun 30 1995, Mar 6 2000}
VAR i,ia,ip,iw:INTEGER; w,x,zn,rr,rrr:REAL; wx,amp,z,ff,fz,fzz,g1:REAL;
{---------------------------------------------------------------}
BEGIN rr:=0; WITH spec DO
 BEGIN w:=(2*arg-2-b1-b2)/(b2-b1); wx:=(2*arg-2-a11-a22)/(a22-a11);
 END;
WITH afit DO
 BEGIN par[1].drv:=1; par[2].drv:=w; par[3].drv:=2*w*w-1;
 par[4].drv:=2*w*par[3].drv-par[2].drv;
 FOR i:=1 TO 4 DO rr:=rr+par[i].p*par[i].drv; rb0[1]:=rr;
 x:=b1+arg-1; iw:=2*npl+5; FOR i:=1 TO npl DO
  BEGIN ia:=i+4; ip:=ia+npl; zn:=par[iw].p+par[iw+1].p*wx;
  g1:=1/zn; z:=(x-par[ip].p)*g1; amp:=par[ia].p;
  pmod[1].calf(z,ff,fz,fzz);
  rrr:=amp*ff; rb0[i+2]:=rrr; rr:=rr+rrr;
  END;
 END;
v:=rr; rb0[2]:=rr;
END;
PROCEDURE GetParValues(i:INTEGER; VAR ch,ech,g,eg,ss,ess,rr,back:REAL);
VAR ll,j,jj,n1,n2:INTEGER; ae,be,x0,a,ea,r:REAL; fa:ARRAY[1..4] OF REAL;
BEGIN ll:=2*npl+5; l:=i+npl+4; WITH afit DO
 BEGIN a:=par[i+4].p; ea:=par[i+4].e; ch:=par[l].p; ech:=par[l].e;
 WITH spec DO r:=(2*ch-2-a11-a22)/(a22-a11);
 g:=par[ll].p+par[ll+1].p*r; eg:=par[ll].e; ss:=ABS(a*g);
 ess:=SQRT(SQR(ea*g)+SQR(eg*a));
 IF(debugV.activ)THEN
  {Writeln(fout,'a,g,ch ',npl:5,a:8:2,ea:8:2,g:8:2,eg:8:2,ch:8:2)};
 rr:=0; back:=0; WITH spec DO
  BEGIN n1:=Round(AMAX1(ch-1.5*g,a1)); n2:=Round(AMIN1(ch+1.5*g,a2));
  FOR j:=n1 TO n2 DO
   BEGIN r:=(2*ch-2-b1-b2)/(b2-b1); fa[1]:=1; fa[2]:=r;
   fa[3]:=2*r*r-1; fa[4]:=2*r*fa[3]-fa[2];
   rr:=rr+spec.y[j]; FOR jj:=1 TO 4 DO back:=back+par[jj].p*fa[jj];
   END;
  r:=(y[b1]+y[b1+1]+y[b2]+y[b2-1])*0.25*(n2-n1+1); back:=(back+r)/2;
  END;
 END;
rr:=(rr-back)/SQRT(ABS(back)+ABS(rr)+1); back:=ABS(back);
END;
PROCEDURE corpab;
{ corpab takes measures if inconvergence:= fixes par.,corrects bounds}
{version 86.02.05}
VAR  lqu:BOOLEAN; d:REAL; ip,ia,iw,i,j,k:INTEGER;
LABEL L610,L611;
{--------------------------------------------------------------}
BEGIN { check for the small statistic}
IF(spec.spx<smast)THEN WITH afit DO
 BEGIN par[npar-1].p:=width; j:=npl+5; FOR i:=j TO afit.npar DO
  BEGIN k:=i-npl; par[k].pl:=1.5; par[k].pu:=par[i].p;
  par[k].p:=par[i].p;
  END;
 END;
{check for weak comp. and fix their positions(widths)}
FOR i:=1 TO npl DO WITH afit DO
 BEGIN j:=i+4; lqu:=(par[j].p=par[j].pl)OR(par[j].p<=(par[j].e*2));
 IF(lqu)THEN
  BEGIN par[j].pl:=1.5; j:=j+npl; par[j].pl:=par[j].p;
  par[j].pu:=par[j].p;
  END;
 END;
{check for too close components}
IF(npl>1)THEN FOR i:=2 TO npl DO WITH afit DO
 BEGIN j:=i+3+npl; k:=j-npl;
 lqu:=(par[k].p>(par[k].drv*2))OR(par[k+1].p>(par[k+1].drv*2));
 IF(((par[j+1].p-par[j].p)>(spec.w0*cre))OR lqu)THEN CONTINUE;
  IF(par[k].p<=par[k+1].p)THEN
  BEGIN par[k].pl:=0; par[k].pu:=0;
  par[k+1].pl:=par[k].p; par[k+1].p:=AMAX1(par[k+1].p,par[k].p);
  END                     ELSE
   BEGIN par[k+1].pl:=0; par[k+1].pu:=0;
   par[k].pl:=par[k+1].p; par[k].p:=AMAX1(par[k+1].p,par[k].p);
   END;
 END;
{  correct the bounds of parameters if needed; check the amplitudes}
FOR i:=1 TO npl DO WITH afit DO
 BEGIN ia:=4+i; IF(par[ia].p=par[ia].pl)THEN par[ia].pl:=par[ia].pl*0.5;
 END;
{check the positions}IF(npl>1)THEN FOR i:=2 TO npl DO WITH afit DO
 BEGIN ip:=3+npl+i;
 IF((par[ip].p=par[ip].pu)AND(par[ip+1].p>par[ip+1].pl))THEN GOTO L610;
 IF((par[ip].p<par[ip].pu)AND(par[ip+1].p=par[ip+1].pl))THEN GOTO L611;
 CONTINUE;
 L610: d:=(par[ip+1].p-par[ip+1].pl)*0.5; par[ip].pu:=par[ip].pu+d;
       par[ip+1].pl:=par[ip+1].pl+d; CONTINUE;
 L611: d:=(par[ip].pu-par[ip].p)*0.5; par[ip].pu:=par[ip].pu-d;
       par[ip+1].pl:=par[ip+1].pl-d;
 END;
{check the width}WITH afit DO
 BEGIN iw:=npar-1; IF(par[iw].p=par[iw].pl)THEN
  par[iw].pl:=AMAX1(par[iw].p-spec.dw0,1.0);
 IF(par[iw].p=par[iw].pu)THEN par[iw].pu:=par[iw].p+spec.dw0;
 END;
END;
PROCEDURE FitSpectrum(m:INTEGER; VAR ft:TEXTFILE);
{Fit the whole spectrum,  Version Mar 3 2000}
VAR   ii,k1,k2,i,j,l,ll:INTEGER; rr,back,c1,c2:REAL;
      a,ea,ch,ech,g,eg,ss,ess,ai,eai,sc,en,een,sn,esn:REAL;
LABEL L1,L3;
BEGIN kcurr:=1;
L1:k1:=mauxa[kcurr].k1; k2:=mauxa[kcurr].k2; WITH spec DO
 BEGIN b1:=mauxa[kcurr].i1; b2:=mauxa[kcurr].i2;
 npl:=k2-k1+1; IF(npl=0)THEN
  BEGIN
  ShowMess('Error, no peaks in '+IntToStr(b1)+' '+IntToStr(b2));
  GOTO L3;
  END;
 npl:=MIN0(npl,npimxc); IF((b2-b1+1)>linx)THEN
  BEGIN ShowMess('Error, too long interval '+IntToStr(b1)+
  ' '+IntToStr(b2)); GOTO L3;
  END;
 c1:=FLOAT(b1-a11)/(a22-a11+1); IF(pmode=0)THEN c1:=0; c2:=1-c1;
 width:=c2*w0+c1*w1;
 END;
FOR i:=1 TO npl DO afit.par[4+npl+i].p:=marka[k1+i-1];
{IF(mogr=1)THEN sback(npl);}
FittheInterval(0);
FOR i:=1 TO npl DO {output of results}
 BEGIN GetParValues(i,ch,ech,g,eg,ss,ess,rr,back);
 IF(m=0)THEN
  BEGIN ntab:=MIN0(MAX0(ntab,k2),ntabx);
  k:=k1+i-1; tab[k].ch:=ch; tab[k].ech:=ech; tab[k].ss:=ss;
  tab[k].ess:=ess; tab[k].g:=g; tab[k].eg:=eg;
  tab[k].chi2:=rr; tab[k].chip:=back;
  END   ELSE
  BEGIN calibr(ch,ech,ss,ess,en,een,ai,eai);
  sn:=ai/AMAX1(0.0001,cali); esn:=eai/AMAX1(0.0001,cali);
  Writeln(ft,ch:9:2,en:9:2,ss:9:0,ai:14:0,g:9:2,sn:12:2,rr:10:2);
  Writeln(ft,
   ech:9:2,een:9:2,ess:9:0,eai:14:0,eg:9:2,esn:12:2,back:10:2);
  Writeln(ft);
  END;
 END;
L3: Inc(kcurr); IF(kcurr<=nint)THEN GOTO L1;
END;


{----------}
END.

PROCEDURE sback(np:INTEGER);
{suppresses the spectrum background, version 80-11}
VAR   ip,l,m,i,j,k:INTEGER; fun,amm,r,rl,a,b:REAL;
{---------------------------------------------------------------}
{form the weights}
BEGIN m:=afit.mpoint-1;
FOR i:=2 TO m DO onl[i]:=anp^[2*i]; l:=Round(spec.w0);
FOR i:=1 TO np DO
 BEGIN ip:=4+i+np; k:=Round(par^[ip]-spec.a1)+1; FOR j:=2 TO m DO
 IF(ABS(k-j)<=l)THEN onl[j]:=SQR(onl[j]);
 END;
amm:=0; FOR i:=2 TO m DO amm:=amm+onl[i];
{compute the background}
rl:=0.010/(amm/m); rl:=rl/(spec.a1/linx+0.5); ja[1]:=0;
ja[m]:=anp^[2*m-1]; onl[1]:=anp^[1]; FOR i:=2 TO m DO
 BEGIN r:=rl*onl[i]; fun:=1/(2+r-ja[i-1]); ja[i]:=fun; j:=2*i-1;
 onl[i]:=fun*(onl[i-1]+anp^[j]*r);
 END;
FOR i:=2 TO m DO
 BEGIN j:=m-i+1; ja[j]:=ja[j]*ja[j+1]+onl[j];
 END;
FOR i:=1 TO m DO onl[i]:=(anp^[2*i-1]+0);
{subtract the background}
a:=(ja[m]-ja[1])/m; b:=ja[1]-a;
FOR i:=1 TO m DO
 BEGIN r:=AMAX1(0,anp^[2*i-1]-ja[i]+a*i+b);
 anp^[2*i-1]:=r;
 END;
END;
