UNIT vactinf;
INTERFACE
USES Windows, Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,    vzlocom,  vactiv0,  varfun,
     vactiv2, vacthlp,  vpeaksr,  vstdcons, vactiv3,  vactmrk;

PROCEDURE ShowSpFilenames;
PROCEDURE ShowEnergyCalibration;
PROCEDURE ShowEfficiencyCalibration;
PROCEDURE ShowMarkedPeaks;
PROCEDURE ShowResultTable;

IMPLEMENTATION
{*******}
PROCEDURE ShowEnergyCalibration;
CONST chener:STRING = '* Channel  Energy  Error';
VAR i,j,k,ic:INTEGER; r,v,x,z,w,vt,dev,ch:REAL;
 FUNCTION CheckNP(n:INTEGER):BOOLEAN;
 CONST enp:STRING = 'Error, number of peaks ';
 BEGIN CheckNP:=false; IF(n>60)THEN
   BEGIN ShowMess(enp+'> 60'); CheckNP:=true; encm:=false;
   END;
 IF(n<2)THEN
   BEGIN ShowMess(enp+'< 2'); CheckNP:=true; encm:=false;
   END;
 END;
 PROCEDURE TakeFromMemo;
 VAR i,j:INTEGER;
 BEGIN ncen:=Form2.Memo1.Lines.Count;
 ic:=0; FOR i:=1 TO ncen DO WITH Form2.Memo1.Lines DO
  BEGIN FOR j:=1 TO 5 DO onl[j]:=0; s:=Strings[i-1]; Compress(s);
  IF(Length(s)<>0)THEN
   BEGIN fffins(k,Strings[i-1]); Inc(ic);
   wenc[ic].x:=onl[1]; wenc[ic].y:=onl[2]; wenc[ic].e:=onl[3];
   CheckZero(ok); IF(NOT ok)THEN Dec(ic);
   END;
  END;
 ncen:=ic; ArrangeEnergCalibr; FOR i:=1 TO ncen DO enc[i]:=wenc[i];
 END;
{*******}
BEGIN L0rec:='Energy calibration data: ch, E, [err]';
MakeFormV(250,20,330,430,0); SaveHelp(InpEnC_n,InpEnC);
WITH CB1rec DO
 BEGIN ar[1]:=' Non-linear'; ar[2]:=' Linear'; indx:=mocan+1; nitems:=2;
 END;
MakeRadioGroup(1,0,50,35,200,70);
s:='Number of calibration items = '+IntToStr(ncen);
OuttoLabel(Form2.Label1,40,175,clGreen,clWhite,s);

WITH CB1rec DO
 BEGIN nitems:=3;
 ar[1]:=' Use marked peaks as channels ';
 ar[2]:=' Take the data from result table ';
 ar[3]:=' Take the data from the screen ';
 END;
MakeCheckListBox(20,200,280,58);
Form2.CheckListBox1.Checked[0]:=false;
Form2.CheckListBox1.Checked[1]:=false;
Form2.CheckListBox1.Checked[2]:=false;

Form2.ShowModal; IF(ModalRes=0)THEN Exit;
mocan:=Form2.RadioGroup1.ItemIndex;
IF(Form2.CheckListBox1.Checked[0])THEN
 BEGIN IF(CheckNP(npeak))THEN Exit;
 FOR i:=1 TO npeak DO
  BEGIN enc[i].x:=marka[i]; enc[i].e:=0; enc[i].y:=0;
  END;
 ncen:=npeak;
 END;

IF(Form2.CheckListBox1.Checked[1])THEN
 BEGIN IF(CheckNP(ntab))THEN Exit;
 FOR i:=1 TO ntab DO
  BEGIN ch:=tab[i].ch; x:=tab[i].ech; calibr(ch,x,r,r,z,vt,r,r);
  enc[i].x:=ch; enc[i].e:=vt; enc[i].y:=z;
  END;
 ncen:=ntab;
 END;
IF((Form2.CheckListBox1.Checked[2])OR(ncen<2))THEN
 BEGIN MakeFormV(150,20,420,430,0); MakeMemo(15,380);
 Form2.Memo1.Lines.Add(chener);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 TakeFromMemo; IF(CheckNP(ncen))THEN Exit;
 END;

IF(mocan=1)THEN LinearCalibration;
MakeFormV(150,20,420,430,0); MakeMemo(15,380);
s:=chener; IF(mocan=1)THEN s:=s+'     Fit   ChiSquare';
Form2.Memo1.Lines.Add(s);
FOR i:=1 TO ncen DO
 BEGIN ConvertStr(enc[i].x,8,2); s:=sedz;
 ConvertStr(enc[i].y,8,2); s:=s+sedz;
 ConvertStr(enc[i].e,7,2); s:=s+sedz; IF(mocan=1)THEN
  BEGIN w:=SQR(1/AMAX1(enc[i].e,0.0001)); x:=enc[i].x; v:=enc[i].y;
  z:=((2*x-xclb1-xclb2)/(xclb2-xclb1))*1.732051;
  vt:=aclbr*z+bclbr; dev:=v-vt; ch:=SQR(dev)*AMAX1(0.000001,SQR(w));
  ConvertStr(vt,9,2); s:=s+sedz; ConvertStr(ch,12,2); s:=s+sedz;
  END;
 Form2.Memo1.Lines.Add(s);
 END;

Form2.ShowModal; IF(ModalRes=0)THEN Exit;
TakeFromMemo; IF(CheckNP(ncen))THEN Exit;
IF(mocan=1)THEN LinearCalibration; encm:=true;
END;
PROCEDURE ShowEfficiencyCalibration;
VAR i,j,k,ic:INTEGER; r:REAL; ra:CALIBREC;
BEGIN L0rec:='Efficiency calibration data: E, coef, [err]';
MakeFormV(250,20,330,430,0);
SaveHelp(InpEfC_n,InpEfC); MakeMemo(15,290);
s:='       Energy     Efficiency      Error ';
OuttoLabel(Form2.Label1,20,5,clGreen,clWhite,s);
FOR i:=1 TO ncef DO
 BEGIN ConvertStr(efc[i].x,10,2); s:=sedz;
 ConvertStr(efc[i].y,10,5); s:=s+sedz;
 ConvertStr(efc[i].e,10,5); s:=s+sedz;
 Form2.Memo1.Lines.Add(s);
 END;
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
ncef:=Form2.Memo1.Lines.Count;
ic:=0; FOR i:=1 TO ncef DO WITH Form2.Memo1.Lines DO
 BEGIN FOR j:=1 TO 5 DO onl[j]:=0; s:=Strings[i-1]; Compress(s);
 IF(Length(s)<>0)THEN
  BEGIN fffins(k,Strings[i-1]); Inc(ic);
  efc[ic].x:=onl[1]; efc[ic].y:=onl[2]; efc[ic].e:=onl[3];
  CheckZero(ok); IF(NOT ok)THEN Dec(ic);
  END;
 END;
ncef:=ic; IF(ncef=0)THEN
 BEGIN ShowMess('Empty lines. Cancelled'); efcm:=false; Exit;
 END;
ArrangeEfficCalibr; efcm:=true;
END;
PROCEDURE ShowResultTable;
VAR i,k,nt:INTEGER; r,ch1,ch2,ch,ech,g,eg,ss,ess,ai,eai,en,een:REAL;
BEGIN IF(ntab=0)THEN
 BEGIN ShowMess(' No fitted peaks'); Exit;
 END;
L0rec:='Result Table'; MakeFormV(100,20,550,430,0);
SaveHelp(ShResT_n,ShResT);
nt:=MIN0(ntab,650); k:=MAX0(nt*3,3);
s:='Channel  Energy       Area      Intensity      Width    Crit/Bckg';
OuttoLabel(Form2.Label1,110,5,clGreen,clWhite,s);

WITH LB1rec DO FOR i:=1 TO nt DO
 BEGIN ch:=tab[i].ch; ech:=tab[i].ech; ss:=tab[i].ss;
 ess:=tab[i].ess; g:=tab[i].g; eg:=tab[i].eg;
 ch1:=tab[i].chi2; ch2:=tab[i].chip;
 calibr(ch,ech,ss,ess,en,een,ai,eai); r:=i;
 ConvertStr(r,4,0); s:=' Peak'+sedz+'  ';
 ConvertStr(ch,8,2);s:=s+sedz;
 ConvertStr(en,8,2);  s:=s+sedz;
 ConvertStr(ss,8,0);  s:=s+sedz;
 ConvertStr(ai,10,0);  s:=s+sedz;
 ConvertStr(g,8,2);   s:=s+sedz;
 ConvertStr(ch1,9,2); s:=s+sedz; ar[(i-1)*3+1]:=s;
 s:=' Errors    ';
 ConvertStr(ech,8,2); s:=s+sedz;
 ConvertStr(een,8,2); s:=s+sedz;
 ConvertStr(ess,8,0); s:=s+sedz;
 ConvertStr(eai,10,0); s:=s+sedz;
 ConvertStr(eg,8,2);  s:=s+sedz;
 ConvertStr(ch2,9,2); s:=s+sedz; ar[(i-1)*3+2]:=s; ar[(i-1)*3+3]:=' ';
 END;
LB1rec.nitems:=k; MakeListBox(10,25,530,340); Form2.ShowModal;
END;
PROCEDURE ShowSpFilenames;
VAR i:INTEGER;
BEGIN L0rec:='List of spectrum names for processing';
MakeFormV(250,20,330,430,0); IF(nsfn=0)THEN
 BEGIN ShowMess('No spectrum names in the list'); Exit;
 END;
MakeMemo(5,310); WITH Form2.Memo1 DO
 BEGIN FOR i:=1 TO nsfn DO
  BEGIN s:=ExtractFileExt(sfnar[i]); ExtractFN(sfnar[i],sedz);
  Lines.Add(sedz+s);
  END;
 END;
Form2.ShowModal;
END;

PROCEDURE ShowMarkedPeaks;
VAR i,j,k,l,n:INTEGER; s:STRING; ch,en:REAL;
BEGIN IF(nint=0)THEN
 BEGIN ShowMess('No marked intervals'); Exit;
 END;
L0rec:='Marking data    '+IntToStr(nint)+' intervals    '+
IntToStr(npeak)+' peaks '; MakeFormV(250,20,330,430,0);
SaveHelp(ShowMaP_n,ShowMaP); MakeMemo(15,290);
k:=0; FOR i:=1 TO nint DO WITH mauxa[i] DO
 BEGIN Inc(k); r:=-i1; ConvertStr(r,10,0); s:=sedz;
 r:=-i2; ConvertStr(r,8,0);
 s:=s+' '+sedz+'  '+IntToStr(k2-k1+1)+' peak(s)';
 Form2.Memo1.Lines.Add(s);
 FOR j:=k1 TO k2 DO
  BEGIN Inc(k); ch:=marka[j]; r:=1; calibr(ch,r,r,r,en,r,r,r);
  ConvertStr(ch,8,1); s:=sedz; ConvertStr(en,8,1);
  s:=s+'   '+'( E= '+sedz+')'; Form2.Memo1.Lines.Add(s);
  END;
 END;
Form2.ShowModal; {IF(ModalRes=0)THEN Exit; n:=Form2.Memo1.Lines.Count;
k:=0; FOR i:=1 TO n DO WITH Form2.Memo1.Lines DO
 BEGIN s:=Strings[i-1]; IF(NOT CheckBlank(s))THEN
  BEGIN fffins(j,Strings[i-1]); FOR l:=1 TO j DO marka[k+l]:=onl[l];
  k:=k+j;
  IF(infun(j,ic1,ic2))THEN
   BEGIN Inc(k); marka[k]:=j;
   END;
  END;
 END;
npeak:=k; IF(k=0)THEN
 BEGIN ShowMess('Empty lines. Operation cancelled.'); Exit;
 END;
arran(marka,npeak,1); arran(marka,npeak,0);
WITH peaksr DO DivideTheInterval(ic1,ic2);
mrkmod:=1; MarkSpectrum;}
END;




END.
