UNIT vactiv0;

INTERFACE
USES Graphics, comctrls, Dialogs, SysUtils, Controls, vzlocom, varfun,
     vgfit,    vspectr,  vpmodel, vpeaksr;
TYPE CALIBREC = RECORD x,y,e:REAL; END;
     TABREC = RECORD ch,ech,ss,ess,g,eg,chi2,chip:REAL; END;
CONST strin1:STRING[29] = 'Number of Model (1=beg,2=end)';
      {maximum numbers of peaks in an interv}
      npmax:INTEGER = 300; npimxc:INTEGER = 50; nintmax:INTEGER = 2048;
      nspch:INTEGER = 16384;
CONST IDCaptions:ARRAY[1..3,0..9] OF STRING[20]
      =((' Smoothing  ',' Max.interval (chan)',' Sensitivity  ',
        ' Resolution  ',' kWidth',' adInterv (chan)','','','',''),
        ('','','','','','','','','',''),
        (' Width variable',' Delta Width V',' N of iterations ',
         '     Step       ','  Damper     ',' Backgr.degree ',
         ' Delta Pos.    ',' Normalization coef.','','')
         );
      x1graph:INTEGER = 2; y1graph:INTEGER = 100;
      hgraph:INTEGER = 272; wgraph:INTEGER = 620;
      ntabx:INTEGER = 1000;
      peakms:ARRAY[1..9] OF STRING =
      ('                    Select:',
       '   Number of Peak Model (0,1,2,3,4)','                    then',
       '   Check the beginning and end',
       '   channels of the spectrum interval',
       '   containing the peak for the model;','',
       '   Also the number of background','   channels at the edges.');
       PrepSGs:ARRAY[1..5] OF STRING = ('  Channel',' Argument',
       '  Area   ','  Width  ','Peak/Bckg');
      wrnum:STRING = 'Error, wrong numbers';
VAR
  sfnar:ARRAY[1..200] OF STRING; {array of spectrum names for loop}
  nsfn:INTEGER;               {Number of such names}
  snff:STRING;                {This array file name}
  gphfn:STRING;               {Fn for gph's}
  gphmo:INTEGER;              {Fit graph mode}
  ncl,grst,g1,g2,nreac:INTEGER; {n of clicks,gstat,beg.,end of zoomed,}
  cadl,ic1,ic2:INTEGER;       {Length,bounds of graph cadre}
  b1,b2:INTEGER;              {bounds of the fitted subinterval}
  aini1,aini2:INTEGER;        {ini-bounds}
  ki1,ki2:INTEGER;            {current bounds for fitted peaks in marka}
  ncadr:INTEGER;              {graph:  0=all the spectrum;  1=interval}
  datyp:INTEGER;              {0=spectr, 1=search, 3=Bounds data type}
  cam,cre:REAL;
  mogr:INTEGER;        {1(0) = (no) background subtraction}
  width:REAL;          {Width}
  mrkmod:INTEGER;      {Marking mode: 0=auto 1=manual 2=energy list}
  defps:INTEGER;       {default for peak search: 0=old 1=new}
  autofit:INTEGER;     {Fit mode. 0=auto; 1=dialog}
  npl:INTEGER;         {number of peaks in an interval}
  rl:REAL;             {smoothing}
  rback:INTEGER;       {current background degree}
  cmprs:INTEGER;       {compression factor}
  kcurr:INTEGER;       {current interval beginning for fitting }
  reacfit:INTEGER;     {if fitgraph click ->  0-show point, 1-react}
  niter:INTEGER;       {N of iterations}
  damp:REAL;           {Step,damper}
  amx,amn:REAL;        {spectrum max in an interval}

  nosaved:BOOLEAN;     {are the results saved?}
  nomo:BOOLEAN;        {true-norm by cali, false-norm by selected peak}
  success,ok:BOOLEAN;
  limm:BOOLEAN;        {lim res mode}

  encm,efcm:BOOLEAN;   {calibration made?}
  ncen,ncef:INTEGER;   {number of points for calibr.}
  mocan,mocaf:INTEGER; {modes for calibr. =  1:linear 0:numeric}
  aclbr,bclbr:REAL;    {coefficients for linear calibr.}
  xclb1,xclb2:REAL;    {interval bounds for linear calibr.}
  enc,efc,wenc:ARRAY[1..60] OF CALIBREC; {calibration arrays}

  cali:REAL;           {For peak area normalization}
  nenm:INTEGER;        {Number of energies for marking}
  enmlist:ARRAY[1..300] OF REAL; {list of energies for marking}
  tab:ARRAY[1..1000] OF TABREC; {Current fit result table}
  inl:ARRAY[1..1000] OF INTEGER;
  rb0:ARRAY[1..60] OF REAL;
  wh:REAL;             {Weight of ith spectrum channel}
  pmode:INTEGER;       {0=1 peak model;   1 = 2 models for beg. and end}
  reacb8:INTEGER;      {Number of reaction on button8 (Cancel)}
  fn,ftab,encf,efcf,mrkf:STRING;
  sav:ARRAY[1..100] OF REAL;
  ntab,ntab0:INTEGER;  {Current and old number of result table items}
  loopfn:STRING;       {Loop table file name}
  dirn,dirs:STRING;    {directories for vactiv.fn,spectrum dir}
  ifn:STRING;          {Ini file name}
  fv1,fv2:TEXTFILE; fb:FILE;
  i,j,k:INTEGER;
  l,lx,ly:LONGINT;
  jj:ARRAY[0..31] OF INTEGER;
  spec:TSpectrum;        {spectrum classes}
  afit:TParameter;       {fitting class}
  amxgsp:REAL;     {max for graphing single peaks}
FUNCTION ACalcOrdinate(z,amx:REAL):LONGINT;
FUNCTION CompCurrMax(snor:REAL):REAL;
PROCEDURE awidet(i1,i2:INTEGER; ur:REAL; VAR wi:REAL);
PROCEDURE calibr(ch,ech,a,ea:REAL; VAR en,een,ai,eai:REAL);
PROCEDURE NoCalibData;
PROCEDURE LinearCalibration;
PROCEDURE ArrangeEnergCalibr;
PROCEDURE ArrangeEfficCalibr;
PROCEDURE CheckZero(VAR ok:BOOLEAN);
PROCEDURE FormSpecErrors;
IMPLEMENTATION
PROCEDURE FormSpecErrors;
VAR i:INTEGER; r:REAL;
BEGIN WITH spec DO IF(smosp<>3)THEN FOR i:=a1 TO a2 DO
 BEGIN r:=y[i]; e[i]:=SQRT(ABS(0.9*r+0.1*SQR((covar*r)))+0.1);
 END;
END;
FUNCTION CompCurrMax(snor:REAL):REAL;
VAR spx:REAL;
BEGIN
CASE nscale OF
1: spx:=snor;
2: spx:=SQRT(ABS(snor));
3: spx:=LN(ABS(snor)+1);
4: spx:=snor*trimm;
ELSE spx:=1; END;
CompCurrMax:=spx;
END;
FUNCTION ACalcOrdinate(z,amx:REAL):LONGINT;
VAR r:REAL;
BEGIN
CASE nscale OF
2: z:=SQRT(ABS(z));
3: z:=LN(ABS(z)+1);
4: z:=AMIN1(z,amx);
ELSE END;
r:=z/AMAX1(amx,0.1)*240; r:=243-r;
ACalcOrdinate:=Round(r);
END;
PROCEDURE awidet(i1,i2:INTEGER; ur:REAL; VAR wi:REAL);
{determines the halfwidth of the peak, version 79-7}
VAR   l,i,j,k:INTEGER; rr,r,x1,x2:REAL;
LABEL L163,L166,L168,L172;
{--------------------------------------------------------------}
BEGIN IF((sa[i1+1]>=ur)OR(sa[i2-1]>=ur))THEN GOTO L172;
FOR i:=i1 TO i2 DO
 BEGIN r:=ABS(sa[i-1]); IF(r<ur)THEN GOTO L163;
 rr:=r-ABS(sa[i-2]); IF(rr=0)THEN GOTO L172; x1:=(r-ur)/rr;
 FOR j:=i1 TO i2 DO
  BEGIN l:=i2+i1-j; r:=ABS(sa[l-1]); IF(r<ur)THEN GOTO L166;
  rr:=r-ABS(sa[l]); IF(rr=0)THEN GOTO L172; x2:=(r-ur)/rr; GOTO L168;
  L166:;
  END; GOTO L172;
 L163:;
 END; GOTO L172;
L168: wi:=(l-i)+ABS(x1)+ABS(x2); Exit;
L172: wi:=-1;
END;
PROCEDURE calibr(ch,ech,a,ea:REAL; VAR en,een,ai,eai:REAL);
{ channel and area -> energy and intensity,  version Dec 23}
VAR i:INTEGER; r:REAL;
BEGIN en:=ch; een:=ech; ai:=a; eai:=ea;
IF(encm)THEN {energ.}
 BEGIN FOR i:=1 TO ncen DO onl[i]:=enc[i].y;
 FOR i:=1 TO ncen DO onl[i+ncen]:=enc[i].x;
 IF(mocan=1) THEN
  BEGIN en:=aclbr*((2*ch-xclb1-xclb2)/(xclb2-xclb1))*1.732051+bclbr;
  r:=aclbr*((2*(ch+ech)-xclb1-xclb2)/(xclb2-xclb1))*1.732051+bclbr;
  END        ELSE
   BEGIN lapin(onl,ncen,ch,en); lapin(onl,ncen,ch+ech,r);
   END;
 r:=ABS(r-en);
 FOR i:=1 TO ncen DO onl[i]:=enc[i].e; lapin(onl,ncen,ch,een);
 een:=SQRT(ABS(een*een+r*r));
 END;
IF(efcm)THEN  {effic.}
 BEGIN FOR i:=1 TO ncef DO onl[i]:=efc[i].y;
 FOR i:=1 TO ncef DO onl[i+ncef]:=efc[i].x;
 lapin(onl,ncef,en,r); IF(r<>0)THEN
  BEGIN ai:=a/r; eai:=ea/r;
  END;
 END;
END;
PROCEDURE NoCalibData;
BEGIN ShowMess('Error, no calibration data available!');
END;
PROCEDURE LinearCalibration;
{Version 81-04}
VAR i,j,k:INTEGER; wm,det,v,w,x,z,vt,dev,ch:REAL;
    am:ARRAY[1..2,1..2] OF REAL; farc:ARRAY[1..2] OF REAL;
BEGIN FOR i:=1 TO 2 DO
 BEGIN farc[i]:=0; FOR j:=1 TO 2 DO am[i,j]:=0;
 END;
xclb1:=enc[1].x; xclb2:=enc[ncen].x;
wm:=0; FOR i:=1 TO ncen DO wm:=wm+enc[i].e; wm:=wm/ncen;
wm:=AMAX1(wm,0.01); FOR i:=1 TO ncen DO
 BEGIN v:=enc[i].y; w:=SQR(1/AMAX1(enc[i].e,wm)); x:=enc[i].x;
 x:=((2*x-xclb1-xclb2)/(xclb2-xclb1))*1.732051;
 farc[1]:=farc[1]+w*v; farc[2]:=farc[2]+w*v*x;
 am[1,1]:=am[1,1]+w; am[1,2]:=am[1,2]+w*x; am[2,2]:=am[2,2]+w*x*x;
 END;
am[2,1]:=am[1,2]; det:=AMAX1(0.000001,am[1,1]*am[2,2]-SQR(am[1,2]));
{LSM-estimates} bclbr:=(am[2,2]*farc[1]-am[1,2]*farc[2])/det;
aclbr:=(am[1,1]*farc[2]-am[1,2]*farc[1])/det;
END;
PROCEDURE ArrangeEnergCalibr;
VAR i,j:INTEGER; ra:CALIBREC;
BEGIN FOR i:=2 TO ncen DO FOR j:=1 TO ncen-i+1 DO
 IF(wenc[j].x>wenc[j+1].x)THEN
  BEGIN ra:=wenc[j]; wenc[j]:=wenc[j+1]; wenc[j+1]:=ra;
  END;
END;
PROCEDURE ArrangeEfficCalibr;
VAR i,j:INTEGER; ra:CALIBREC;
BEGIN FOR i:=2 TO ncef DO FOR j:=1 TO ncef-i+1 DO
 IF(efc[j].x>efc[j+1].x)THEN
  BEGIN ra:=efc[j]; efc[j]:=efc[j+1]; efc[j+1]:=ra;
  END;
END;
PROCEDURE CheckZero(VAR ok:BOOLEAN);
BEGIN IF((onl[1]+onl[2]+onl[3])=0)THEN ok:=false ELSE ok:=true;
END;
{----------}
BEGIN nomo:=true; defps:=1; reacfit:=0;
END.
