UNIT vactmrk;
INTERFACE
USES Graphics, comctrls, Dialogs, SysUtils, Controls, vzlocom,  vactiv0,
     vactiv2,  vacthlp,  varfun,  vspectr,  vpmodel,  vpeaksr, vstdcons,
     vactiv3;
PROCEDURE MarkSpectrum;
PROCEDURE marks(VAR kc,np:INTEGER);
PROCEDURE fipea(ac,qc:REAL; VAR kc,np,m,ic:INTEGER);
PROCEDURE sensa(
         i1,i2,ip,inp:INTEGER; VAR jnp:INTEGER; VAR w,ck,con,cspu:REAL);
PROCEDURE resoa(i1,i2,inp:INTEGER; VAR jnp:INTEGER; w,a,slh:REAL);
PROCEDURE chesr(i1,i2,inp:INTEGER;VAR jnp:INTEGER; w,res:REAL);
PROCEDURE cowic(i1,i2:INTEGER; w:REAL; VAR sr,esr:REAL; VAR ip:INTEGER);
PROCEDURE corin(VAR kc:INTEGER; ac:REAL);
PROCEDURE PrepareMarking(VAR iop:INTEGER);
PROCEDURE marke(VAR n:INTEGER; VAR np:INTEGER);
PROCEDURE PrepEnergyList(VAR n:INTEGER);
PROCEDURE CheckMarkCorrect(VAR np:INTEGER);

VAR peak:ARRAY[1..1000] OF REAL;

IMPLEMENTATION
PROCEDURE PrepareMarking(VAR iop:INTEGER);
VAR i:INTEGER;
BEGIN L0rec:='Find the Peaks'; MakeFormV(250,20,330,430,0);
SaveHelp(SMDhelp_n,SMDhelp);
s:='Set the control data for peak search';
OuttoLabel(Form2.Label1,25,0,clGreen,clWhite,s);
strgrW[0]:=210; strgrW[1]:=80;
strgrT[1]:=' Width at the beginning (chan)'; strgrNn[1,1]:=spec.w0;
strgrT[2]:=' Width at the end(chan)'; strgrNn[2,1]:=spec.w1;
strgrT[3]:=' Width accuracy(chan)'; strgrNn[3,1]:=spec.dw0;
strgrT[4]:=' Sensitivity (0.5 - 3)'; strgrNn[4,1]:=sens;
strgrT[5]:=' Resolution (1-3)'; strgrNn[5,1]:=res;
strgrT[6]:=' Interval length'; strgrNn[6,1]:=linx;
PuttoTable(10,30,6,6,1,8);
WITH LB1rec DO
 BEGIN nitems:=3; ar[1]:='         Warning.';
 ar[2]:='The quality of peak search strongly';
 ar[3]:='depends on the accuracy of widths.';
 END;
MakeListBox(15,165,290,55); IF(mrkmod<>4)THEN
 BEGIN s:=' Specify the algorithm for peak search ';
 OuttoLabel(Form2.Label2,5,260,clMaroon,clWhite,s);
 WITH CB1rec DO
  BEGIN nitems:=2; indx:=1; IF(defps=0)THEN indx:=2;
  ar[1]:=' New algorithm'; ar[2]:=' Old algorithm';
  END;
 MakeRadioGroup(1,0,20,280,270,70);
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 6 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 IF(har[1]<=0)THEN ShowMess('Erroneous width')
              ELSE spec.w0:=har[1];
 IF(har[2]<=0)THEN ShowMess('Erroneous width')
              ELSE spec.w1:=har[2];
 IF(har[3]< 0)THEN ShowMess('Erroneous width accuracy')
              ELSE spec.dw0:=har[3];
 IF(har[4]<=0)THEN ShowMess('Erroneous sensitivity')
              ELSE sens:=har[4];
 res:=har[5]; i:=Round(har[6]);
 iop:=RadioGroup1.ItemIndex; defps:=1; IF(iop=1)THEN defps:=0;
 IF(infun(i,64,4096))THEN linx:=i
                     ELSE ShowMess('Wrong interval');
 END;
END;
PROCEDURE CheckMarkCorrect(VAR np:INTEGER);
VAR i,j,k,l:INTEGER;
BEGIN IF((peak[1]>=0)OR(peak[kc]>=0)OR(np<=0))THEN
 BEGIN ErrMark; ModalRes:=0; Exit;
 END;
i:=2; WHILE(i<=kc)DO
 BEGIN j:=0; WHILE((i<kc)AND(peak[i]>0))DO
  BEGIN Inc(i); Inc(j);
  END;
 IF(((i<(kc-2))AND((peak[i]>0)OR(peak[i+1]>0)))OR
   (((i=(kc-1))AND(peak[i+1]>0))))THEN
  BEGIN ErrMark; ModalRes:=0; Exit;
  END;
 i:=i+2;
 END;
npeak:=np;
j:=0; k:=0; FOR i:=1 TO kc DO IF(peak[i]<0)THEN
 BEGIN Inc(j); onl[j]:=-peak[i];
 END                                       ELSE
  BEGIN Inc(k); ja[k]:=peak[i];
  END;
nint:=j DIV 2;
FOR i:=1 TO nint DO
 BEGIN mauxa[i].i1:=Round(onl[(i-1)*2+1]); mauxa[i].i2:=Round(onl[i*2]);
 np:=0; FOR l:=1 TO k DO WITH mauxa[i] DO
  IF((ja[l]>=Float(i1))AND(ja[l]<=Float(i2)))THEN Inc(np);
 ha[i]:=np;
 END;
l:=1; FOR i:=1 TO nint DO
 BEGIN mauxa[i].k1:=l; l:=l+Round(ha[i])-1; mauxa[i].k2:=l; Inc(l);
 END;
FOR i:=1 TO npeak DO marka[i]:=ja[i];
END;
PROCEDURE MarkSpectrum;
VAR j,np,i,k,l,iop:INTEGER; no23:BOOLEAN;
BEGIN ModalRes:=1;
ntab0:=ntab; no23:=mrkmod IN [2,3];
CASE mrkmod OF
0,2,3:  {automatic} {by energies} {by channels}
   BEGIN PrepareMarking(iop); IF(ModalRes=0)THEN Exit;
   IF((nenm=0)AND(no23))THEN
    BEGIN ShowMess('No energy (line) list'); ModalRes:=0; Exit;
    END;
   IF(iop=1)THEN
    BEGIN marks(kc,np); IF(no23)THEN marke(nenm,np);
    END     ELSE WITH peaksr DO WITH spec DO
    BEGIN cw1:=(w1-w0)/(a22-a11+1); cw0:=w0-cw1*a11;
    MarkTheIntervals(spec,a11,a22,w0,w1,dw0);
    IF(mrkmod<>0)THEN
     BEGIN PrepEnergyList(nenm); MarkByEnergies(enmlist,nenm,a11,a22);
     END;
    DivideTheInterval(a11,a22); Exit;
    END;
   END;
1: BEGIN np:=npeak; FOR i:=1 TO kc DO peak[i]:=marka[i];
   END;
4: BEGIN{Marking on graph} IF(nenm=0)THEN
    BEGIN ShowMess('No marked points'); ModalRes:=0; Exit;
    END;
   PrepareMarking(iop); IF(ModalRes=0)THEN Exit;
   np:=nenm; FOR i:=1 TO np DO
    BEGIN k:=Round(enmlist[i]); FOR j:=-2 TO 2 DO
    IF(spec.y[k+j]>spec.y[k])THEN enmlist[i]:=k+j;
    END;
   FOR i:=1 TO np DO marka[i]:=enmlist[i];
   WITH peaksr DO WITH spec DO
    BEGIN cw1:=(w1-w0)/(a22-a11+1); cw0:=w0-cw1*a11; kw1:=cw1; kw0:=cw0;
    kws:=1; DivideTheInterval(a11,a22); Exit;
    END;
   END;
ELSE END;
{Check for correctness} CheckMarkCorrect(np);
END;
PROCEDURE PrepEnergyList(VAR n:INTEGER);
 FUNCTION incal(e:REAL):REAL;
 {incal inverts energies into channels, Version 82-02}
 VAR ch:REAL;
 BEGIN IF(mocan=1)THEN
 incal:=0.5*(((e-bclbr)*(xclb2-xclb1)/(aclbr*1.732051))+xclb1+xclb2)
                ELSE
  BEGIN lapin(onl,ncen,e,ch); incal:=ch;
  END;
 END;
VAR i:INTEGER;
{---}
BEGIN FOR i:=1 TO n DO wa[i]:=enmlist[i];
IF((NOT encm)AND(mrkmod=2))THEN ShowMess(
  'Warning, no previous calibration; energies treated as channels')
                  ELSE
 BEGIN FOR i:=1 TO ncen DO
  BEGIN onl[i]:=enc[i].x; onl[i+ncen]:=enc[i].y;
  END;
 FOR i:=1 TO n DO IF(mrkmod=2)THEN enmlist[i]:=incal(enmlist[i]);
 END;
arran(enmlist,n,1); cleanz(enmlist,n,-1); cleanz(enmlist,n,0);
END;
PROCEDURE marks(VAR kc,np:INTEGER);
{marks the spectrum i.e. finds intervals containing single peaks or
 multiplets;  version 85.10.14}
VAR   nk,ke,kx,kn,m,m1,i,j,k,i1,i2:INTEGER;
      dif1,dif2,r,qc,ff,fz,fzz,a,c1,c2,p,z,x,rl,am,amn,amx,w:REAL;
LABEL L1,L40,L30;
{---------------------------------------------------------------}
BEGIN kc:=0; np:=0; i1:=ic1; IF(i1=spec.a1)THEN Inc(i1);
L1: w:=cw1*i1+cw0; i2:=MIN0(i1+linx-1,ic2-1);
FOR j:=i1 TO i2 DO
 BEGIN k:=j-i1+1; z:=spec.y[j]; sa[k]:=AMAX1(z,0);
 END;
IF((i2-i1)<=(2*w))THEN GOTO L30;
m:=i2-i1+1; m1:=MIN0(1+(linx DIV 3)*2,m); IF(m1<m)THEN
 BEGIN FindMxn(sa,m1,m,amx,amn,kx,kn); i2:=i2-m+kn;
 END;
IF((ic2-ic1)<linx)THEN i2:=ic2-1;
{smooth the spectrum}
rl:=1; m:=i2-i1+1; m1:=m-1;
FindMxn(sa,1,m,amx,amn,kx,kn); kx:=MAX0(2,MIN0(kx,m1));
x:=ABS(sa[kx+1]+sa[kx]+sa[kx-1]-3*amn);
IF(x<(3*SQRT(ABS(3*amn+1))*sens))THEN GOTO L40;
i:=3; sa[1]:=AMIN1(sa[1],AMIN1(sa[2],sa[i]));
sa[m]:=AMIN1(sa[m],AMIN1(sa[m-2],sa[m-1])); WITH spec DO
 BEGIN z:=ABS(y[i1-1]+y[i1+1])*0.5;
 IF(ABS(sa[1]-z)>SQRT(z))THEN sa[1]:=z;
 z:=ABS(y[i2-1]+y[i2+1])*0.5; IF(ABS(sa[m]-z)>SQRT(z))THEN sa[m]:=z;
 END;
{take account of the small stat}
IF(amx<=smast)THEN
 BEGIN FOR i:=1 TO m1 DO sa[i]:=(sa[i]+sa[i+1]);
 sa[m]:=sa[m]+sa[m1]; amx:=AMAX1(sa[kx-1]+amx,amx+sa[kx+1]);
 END;
smooth(m,0,rl,q1,q2);
{reconstruct the maximum}
sd[kx]:=amx; sd[kx-1]:=(sd[kx-1]+sa[kx-1])*0.5;
sd[kx+1]:=(sd[kx+1]+sa[kx+1])*0.5;
FOR i:=2 TO m1 DO sa[i]:=AMAX1(sd[i],0);
{construct the background spline}
rl:=1; GetEnvelope{filtbk}(m,3,rl,0.5,0.5); FOR i:=1 TO m DO
 BEGIN IF(sa[i]<sd[i])THEN sd[i]:=sa[i]; sb[i]:=sd[i];
 END;
{construct the single peak}
FOR i:=1 TO 193 DO
 BEGIN x:=i; z:=(x-97)/w;
 pmod[1].calf(z,ff,fz,fzz); ha[i]:=100*ff;
 END;
{determine the asimmetry and curvature}
{ac:=0; z:=f0[nlb+1]/128; FOR i:=1 TO ke DO
 BEGIN r:=(i-nlb-1)/w; IF(ha[i]>z)THEN ac:=ac+r*ha[i];
 END;
i:=nlb+1; dif1:=(ha[i+1]-ha[i-1])*0.5;
dif2:=ha[i-1]-2*ha[i]+ha[i+1]; dif1:=dif1*amx; dif2:=dif2*amx;
r:=1+dif1*dif1; qc:=dif2/SQRT(r); }
{compute the quasi-curvatures}
wa[1]:=0; wa[m]:=0; FOR i:=2 TO m1 DO
 BEGIN dif1:=(sa[i+1]-sa[i-1])*0.5; dif2:=sa[i-1]-2*sa[i]+sa[i+1];
 r:=1+dif1*dif1; ff:=dif2/SQRT(r);
 SLanz(m,i,r,dif1,dif2); r:=1+dif1*dif1; ff:=(ff+dif2/SQRT(r))/2;
 ff:=ff+i*0.000007; wa[i]:=ff;
 END;
fipea(pmod[1].ac,qc,kc,nk,m,i1); np:=np+nk;
{loop end}
L40: i1:=i2; GOTO L1;
{correct the interval bounds}
L30: IF(kc<>0)THEN corin(kc,pmod[1].ac);
END;
PROCEDURE fipea(ac,qc:REAL; VAR kc,np,m,ic:INTEGER);
{fipea finds peaks and forms the marks, version 87.12.21}
VAR   lneg,lpos:BOOLEAN; jnp,ip,i1,i2,ii,inp,l,m1,i,j,k:INTEGER;
      a,wi,ur,ck,con,back,shi,cmax,err,cul,cuc,cur,w,slh:REAL;
LABEL L107,L102,L103,L1,L10,L106,L140,L104,L143,L152,L123,L201,L150,
      L160,L11;
{---------------------------------------------------------------}
BEGIN np:=0; m1:=m-1; l:=1; w:=cw1*(ic+(m DIV 2))+cw0;
slh:=ABS(res)*sens;
{the geometrical analysis}
{scan the string of the curvatures and pick out the n-plet}
i1:=1; inp:=0; ii:=2;
L107: i:=ii; cul:=wa[i-1]; cuc:=wa[i]; cur:=wa[i+1];
IF(ABS(cuc)<1.5)THEN GOTO L1;
lneg:=(cuc<cul)AND(cuc<cur); IF(lneg)THEN GOTO L102;
lpos:=(cuc>cul)AND(cuc>cur); IF(lpos)THEN GOTO L103; GOTO L1;
{store the peak location}
L102: inp:=inp+1; ha[inp]:=ii; GOTO L1;
{check whether the peak foot is found}
L103:  err:=5*SQRT(ABS(sa[ii]+sb[ii]+1))*sens;
IF((sa[ii]-AMIN1(sb[ii],AMAX1(sa[1],sa[m])))>err)THEN GOTO L1;
i2:=ii; IF((ii<>m)AND(sa[ii+1]<sa[ii]))THEN i2:=ii+1;
j:=MAX0(Round(w+spec.dw0+0.5),2*inp+5);
IF(((ii-i1)<j)AND(ii<>m))THEN GOTO L1; GOTO L140;
L1: ii:=ii+1; IF(ii<=m1)THEN GOTO L107;
{analyze the last interval}
i2:=m; ii:=m; GOTO L140;
L10: IF(i2<m1)THEN GOTO L106; GOTO L11;
{go to the next interval}
L106: i1:=i2; inp:=0; IF(i1>=m1)THEN GOTO L11; GOTO L1;
{find the maximum spectrum value in the interval}
L140: IF(inp=0)THEN GOTO L106; ip:=i1; cmax:=sa[ip];
FOR j:=i1 TO i2 DO BEGIN IF(sa[j]<=cmax)THEN GOTO L104;
cmax:=sa[j]; ip:=j;
L104:              END;
{the sensitivity analysis}
sensa(i1,i2,ip,inp,jnp,w,ck,con,sens);
{Writeln(db,'Aft-sensa ',i1:10,i2:10);
FOR i:=1 TO inp DO Writeln(db,ha[i]:10:2);}
IF(jnp=0)THEN GOTO L106; IF(jnp=inp)THEN GOTO L143;
arran(ha,inp,-1); inp:=jnp; arran(ha,jnp,1);
{the resolution  analysis}
L143: jnp:=inp;
{subtract the background}
FOR i:=i1 TO i2 DO
 BEGIN wa[i]:=0; back:=sb[i]; sa[i]:=AMAX1(sa[i]-back,0);
 END;
IF(((i2-i1)<Round(w))OR((spec.dw0/w)>0.5)OR(res<0))THEN GOTO L123;
{use the characteristic width-function}
IF(inp=1)THEN GOTO L160;
L152: a:=1/pmod[1].morr[97]; resoa(i1,i2,inp,jnp,w,a,slh);
L123: IF(jnp<>inp)THEN arran(ha,jnp,1); inp:=jnp;
{Writeln(db,'Aft-resoa ',i1:10,i2:10);
FOR i:=1 TO inp DO Writeln(db,ha[i]:10:2);}
{check for the statistical resolution}
L201: IF(inp=1)THEN GOTO L150;
chesr(i1,i2,inp,jnp,w,res); IF(inp=jnp)THEN GOTO L150;
{clear the zeroes (merge the peak positions)}
arran(ha,inp,-1); inp:=jnp; arran(ha,jnp,1);
{store the found peak locations}
L150: shi:=ic-1; kc:=kc+1; peak[kc]:=-(i1+shi);
FOR j:=1 TO inp DO
 BEGIN i:=kc+j; peak[i]:=ha[j]+shi;
 END;
kc:=kc+1+inp; peak[kc]:=-(i2+shi); np:=np+inp;
sa[i2]:=sa[i2]+back; sb[i2]:=back; wa[i2]:=cuc;
IF(np<npmax)THEN GOTO L10;
ShowMess(InttoStr(np)+' peaks already found, search stopped');
GOTO L11;
{check for the simmetric doublet}
{determine the width and asimmetry}
L160: ur:=sa[ip]*0.5; IF(sa[ip]<=100)THEN GOTO L152;
awidet(i1,i2,ur,wi); r:=w+1.25*spec.dw0+0.5; IF(wi<r)THEN GOTO L152;
r:=wi-w; cuc:=i1; ha[1]:=AMAX1(cuc,ip-r);
cuc:=i2; ha[2]:=AMIN1(cuc,ip+r); inp:=2; GOTO L152;
L11: ;
END;
PROCEDURE sensa(
 i1,i2,ip,inp:INTEGER; VAR jnp:INTEGER; VAR w,ck,con,cspu:REAL);
{sensa checks the found peaks by sensitivity criteria, version 87.12.21}
VAR   r,a,cl,amp,er1,er2,p,z,err,ab,ass,back:REAL;
      kx,kn,ip1,ip2,i,j,k,jx:INTEGER;
LABEL L146,L148,L145,L144,L11,L106;
{---------------------------------------------------------------}
{compute the background level}
BEGIN ck:=(sa[i2]-sa[i1])/(i2-i1); con:=sa[i1]-ck*i1;
back:=ck*ip+con; back:=AMIN1(back,sb[ip]);
{check for the sensitivity level}
{check by the area criterion}
ab:=0; ass:=0; ip2:=MIN0(i2,ip+Round(w)); ip1:=MAX0(i1,ip-Round(w));
FOR i:=ip1 TO ip2 DO
 BEGIN back:=ck*i+con; back:=AMIN1(back,sb[i]);
 ass:=ass+sa[i]; ab:=ab+back;
 END;
err:=SQRT(ABS(ass+ab+1))*sens*3; ass:=ass-ab; IF(ass<err)THEN GOTO L106;
{check the other peaks}
jnp:=inp; FOR i:=1 TO inp DO BEGIN
p:=ha[i]+0.5; j:=Round(p); jx:=j; IF(sa[j+1]>sa[j])THEN jx:=j+1;
IF(sa[j-1]>sa[j])THEN jx:=j-1; j:=jx; p:=j; z:=ck*p+con;
err:=SQRT(ABS(sa[j]+sb[j]+1))*sens*2.5;
IF((sa[j]-z)<(err*0.5))THEN GOTO L145;
amp:=sa[j]-AMIN1(z,sb[j]); ab:=sa[j-1]-AMIN1(sb[j-1],ck*(p-1)+con);
ass:=sa[j+1]-AMIN1(sb[j+1],ck*(p+1)+con);
er1:=SQRT(ABS(sa[j-1]+sb[j-1]+1))*sens*1.50;
er2:=SQRT(ABS(sa[j+1]+sb[j+1]+1))*sens*1.50;
cl:=AMIN1(1,0.5+sa[j]*0.002);
IF((amp>=err*cl)AND(ab>=er1*cl)AND(ass>=er2*cl))THEN GOTO L146;
GOTO L145;
{check for spurious peaks (having constant wings)}
L146: IF(cspu=0.5)THEN GOTO L144; kn:=Round(w); a:=SQRT(ABS(sa[j]));
ip1:=MAX0(j-kn,i1);
FOR kx:=ip1 TO j DO
 BEGIN r:=a*(2-(kx-ip1)/w)*sens;
 IF(ABS(sa[kx]-sa[j])>r)THEN GOTO L148;
 END; GOTO L145;
L148: ip2:=MIN0(j+kn,i2); FOR kx:=j TO ip2 DO
 BEGIN r:=a*(1+(kx-j)/w)*sens; IF(ABS(sa[kx]-sa[j])>r)THEN GOTO L144;
 END;
L145: ha[i]:=0; jnp:=jnp-1;
L144:;                       END;
L11: Exit;
L106: jnp:=0; GOTO L11;
END;
PROCEDURE cowic(i1,i2:INTEGER; w:REAL; VAR sr,esr:REAL; VAR ip:INTEGER);
{computes the area and its error of the residue, version Jan 30 1997}
VAR i:INTEGER;
{--------------------------------------------------------------}
BEGIN sr:=wa[i1]; ip:=i1; FOR i:=i1 TO i2 DO
 BEGIN IF(sr<wa[i])THEN
  BEGIN sr:=wa[i]; ip:=i;
  END;
 END;
ip:=MIN0(i2-1,MAX0(i1+1,ip));
IF(wa[ip-1]>wa[ip])THEN Dec(ip); IF(wa[ip+1]>wa[ip])THEN Inc(ip);
sr:=0; esr:=0; FOR i:=i1 TO i2 DO
 BEGIN sr:=sr+wa[i]; esr:=esr+sb[i]+sa[i];
 END;
sr:=sr/w; esr:=SQRT(ABS(esr/w))*3/w;
END;
PROCEDURE resoa(i1,i2,inp:INTEGER; VAR jnp:INTEGER; w,a,slh:REAL);
{checks the found peaks for resolution criteria, version 84.11.14}
VAR   ip,ip1,ip2,i,j,k:INTEGER; sr,esr,ff,fr,fl,fz,fzz,r,p,amp,z:REAL;
{---------------------------------------------------------------}
{use the characteristic width-function}
BEGIN r:=0.5/(w+spec.dw0); FOR i:=1 TO inp DO
 BEGIN p:=ha[i]; ip:=Round(p+0.5);
 IF(sa[ip-1]>sa[ip])THEN ip:=ip-1; IF(sa[ip+1]>sa[ip])THEN ip:=ip+1;
 amp:=sa[ip]*ABS(a); FOR j:=i1 TO i2 DO
  BEGIN z:=(j-p)/(w+spec.dw0);
  pmod[1].calf(z,ff,fz,fzz);
  pmod[1].calf(z+r,fr,fz,fzz);
  pmod[1].calf(z-r,fl,fz,fzz);
  wa[j]:=wa[j]+amp*AMAX1(ff,AMAX1(fr,fl));
  END;
 END;
FOR i:=i1 TO i2 DO wa[i]:=AMAX1(sa[i]-wa[i],0);
{check for the hidden peaks}
jnp:=inp; IF(inp>1)THEN FOR i:=2 TO inp DO
 BEGIN ip1:=Round(ha[i-1]+0.5); ip2:=Round(ha[i]+0.5);
 cowic(ip1,ip2,w,sr,esr,ip); IF(sr>(esr*slh*2))THEN
  BEGIN jnp:=jnp+1; ha[jnp]:=ip;
  END;
 END;
{check the left and right wings}
ip1:=i1; ip2:=Round(ha[1]+0.5); IF(sa[ip2]>(smast*2))THEN
 BEGIN cowic(ip1,ip2,w,sr,esr,ip); IF(sr>(esr*slh))THEN
  BEGIN Inc(jnp); ha[jnp]:=ip;
  END;
 END;
ip1:=Round(ha[inp]); ip2:=i2; IF(sa[ip1]>(smast*2))THEN
 BEGIN cowic(ip1,ip2,w,sr,esr,ip); IF(sr>(esr*slh))THEN
  BEGIN Inc(jnp); ha[jnp]:=ip;
  END;
 END;
END;
PROCEDURE chesr(i1,i2,inp:INTEGER;VAR jnp:INTEGER; w,res:REAL);
{checks the found peaks for statistical resolution, version 86.03.06}
VAR   kx,kn,j1,j2,ip1,ip2,i,j:INTEGER;
      wi,amp,r,err,d,dif,am,amx,amn,ur:REAL;
LABEL L133,L131;
{---------------------------------------------------------------}
BEGIN jnp:=inp; FOR i:=2 TO inp DO BEGIN
ip1:=Round(ha[i-1]); ip2:=Round(ha[i]); amp:=ABS(sa[ip1])+1;
r:=ABS(sa[ip2])+1; err:=8*SQRT(ABS(1/amp+1/r))*ABS(res);
d:=ha[i]-ha[i-1]; dif:=d/(w+spec.dw0);
IF((d<=1)OR((d<=2)AND(AMIN1(amp,r)<=200)))THEN GOTO L133;
IF((dif>err)AND(ABS(res)<3))THEN GOTO L131;
j1:=i1; IF(i>2)THEN j1:=Round(ha[i-2]);
j2:=i2; IF(i<inp)THEN j2:=Round(ha[i+1]);
j1:=MIN0(j1,ip1-1); IF(j1<i1)THEN j1:=ip1-1;
FindMxn(sa,j1,ip1,amx,amn,kx,kn);
{maxnm(j1,ip1,am,amx,amn,kx,kn);} j1:=kn; j2:=MAX0(j2,ip2+1);
FindMxn(sa,ip2,j2,amx,amn,kx,kn);
{maxnm(ip2,j2,am,amx,amn,kx,kn);} j2:=kn;
FindMxn(sa,ip1-1,ip2+1,amx,amn,kx,kn);
{maxnm(ip1-1,ip2+1,am,amx,amn,kx,kn);} ur:=amx*0.5;

awidet(j1,j2,ur,wi);
IF((wi>0)AND((wi-w)>=spec.dw0))THEN GOTO L131;
L133: jnp:=jnp-1; ha[i-1]:=0; ha[i]:=ip1+d*(r/(r+amp)); j:=Round(ha[i]);
sa[j]:=AMAX1(sa[j],AMAX1(amp,r));
L131:                              END;
END;
PROCEDURE corin(VAR kc:INTEGER; ac:REAL);
{corin corrects the intervals (adds the background tails)}
{version 86.02.14}
VAR   ioc,ik,n1,nin,j,i,k:INTEGER; rr,r,rw1,rw2,w,b,c1,c2,c3,c4:REAL;
LABEL L141,L140,L30;
 FUNCTION wf(a,x,b:REAL):REAL;
 BEGIN wf:=AMAX1(2.5,a*x+b);
 END;
{---------------------------------------------------------------}
BEGIN j:=SIGN(ac); IF(ABS(ac)<0.25)THEN j:=0;
CASE j OF
-1: BEGIN rw1:=3.5; rw2:=3;
    END;
 0: BEGIN rw1:=3.25; rw2:=3.25;
    END;
 1: BEGIN rw1:=3; rw2:=3.5;
    END;
ELSE END;
REPEAT nin:=0; i:=2;
{count the lengths of the intervals}
i:=2; WHILE(i<=kc)DO
 BEGIN j:=0; WHILE((i<kc)AND(peak[i]>0))DO
  BEGIN Inc(i); Inc(j);
  END;
 Inc(nin); inl[nin]:=j; i:=i+2;  {inl= numbers of peaks in interval}
 END;
{check for the background tails}
ik:=1; n1:=nin-1;
{correct the interval bounds for the backround}
FOR i:=1 TO n1 DO ja[i]:=0; IF(n1<=0)THEN GOTO L140;
L141: FOR i:=1 TO n1 DO
 BEGIN k:=ik+inl[i]+1; j:=inl[i];
 c1:=peak[k-1]; c2:=ABS(peak[k]); c3:=ABS(peak[k+1]); c4:=peak[k+2];
 w:=wf(cw1,(c2+c3)*0.5,cw0);
  {Writeln(db,peak[k]:10:2,peak[k+1]:10:2);}
  r:=c4-c1; b:=rw1+rw2; IF(r>(b*w))THEN {Resolution is OK}
  BEGIN peak[k]:=-(c1+AMAX1(rw2*w-j+1,w)); j:=inl[i+1];
  peak[k+1]:=-(c4-AMAX1(rw1*w-j+1,w));
  END                             ELSE {No Resolution}
   BEGIN peak[k]:=-(c1+r*rw2/b); peak[k+1]:=-(c4-r*rw1/b); ja[i]:=3;
   END;
  {Writeln(db,peak[k]:10:2,peak[k+1]:10:2);}
 ik:=k+1;
 END;
{Correct 1st and last bounds}
L140: c4:=peak[2]; w:=wf(cw1,c4,cw0);
peak[1]:=-AMAX0(ic1,Round(c4-rw1*w));
c1:=peak[kc-1]; w:=wf(cw1,c1,cw0);
peak[kc]:=-AMIN0(ic2,Round(c1+rw2*w));
{Check for the interval length}
ik:=1; FOR i:=1 TO nin DO
 BEGIN c1:=ABS(peak[ik]); c2:=peak[ik+1]; k:=ik+inl[i]; c3:=peak[k];
 c4:=ABS(peak[k+1]); j:=Round(c4-c1+1); IF(j>linx)THEN
  BEGIN r:=ABS(c2-c1); rr:=ABS(c4-c3);
  b:=Round((r+1)*(j-linx+1)/(r+rr+1))+1; peak[ik]:=-(c1+b);
  b:=Round((rr+1)*(j-linx+1)/(r+rr+1))+1; peak[k+1]:=-(c4-b);
  END;
 ik:=k+2;
 END;
{merge intervals if necessary and possible}
IF(n1=0)THEN GOTO L30;
ik:=1; FOR i:=1 TO n1 DO
 BEGIN k:=ik+inl[i]+2; j:=k+inl[i+1]+1;
 c1:=ABS(peak[ik]); c2:=ABS(peak[j]);
 IF((c1*c2<>0)AND(ja[i]=3)AND(Round(c2-c1+1)<=linx))THEN
  BEGIN peak[k-1]:=0; peak[k]:=0;
  END;
 ik:=k;
 END;
{purge the zeroes} cleanz(peak,kc,0); Inc(ioc);
UNTIL (ioc>=3);
L30: FOR i:=1 TO kc DO IF(peak[i]<0)THEN peak[i]:=Round(peak[i]);
END;
PROCEDURE marke(VAR n:INTEGER; VAR np:INTEGER);
{ to mark the spectrum on the basis of an energy list,  Dec 24 1996}
VAR   kk,it1,it2,ni,nin,i,j,k,l,iw:INTEGER;
      b,r,en,a,e,w,ch1,ch2,pos:REAL; s:STRING;
LABEL L134,L133,L132,L130,L140,L138;
BEGIN PrepEnergyList(n);
{analyse the marked interval array; }
nin:=0; i:=2;
L134: ni:=0;
L132:  IF(peak[i]<=0)THEN GOTO L130
                     ELSE
 BEGIN Inc(ni); Inc(i); IF(i<=kc)THEN GOTO L132 ELSE GOTO L133;
 END;
L130: Inc(nin); onl[nin]:=ni; i:=i+2;  {onl= list of peak numbers}
IF(i<=kc)THEN GOTO L134 ELSE GOTO L133;
{assign energies to intervals, nin intervals, n energies}
L133: it1:=1; j:=1; FOR i:=1 TO nin DO
 BEGIN ni:=Round(onl[i]); it2:=it1+ni+1; ch1:=peak[it1]; ch2:=peak[it2];
 ja[j]:=ch1; l:=0; FOR k:=1 TO n DO
  BEGIN pos:=enmlist[k]; IF((pos>=ABS(ch1))AND(pos<=ABS(ch2)))THEN
   BEGIN Inc(j); Inc(l); ja[j]:=pos; enmlist[k]:=0;
   END;
  END;
 IF(l<=0)THEN GOTO L138; IF(l>=ni)THEN GOTO L140;
 Dec(j); FOR k:=1 TO ni DO
  BEGIN kk:=it1+k; Inc(j); ja[j]:=peak[kk];
  END;
 l:=ni;
 L140: Inc(j); ja[j]:=ch2; Inc(j);
 L138: it1:=it2+1;
 END;
kc:=j-1; np:=0; FOR i:=1 TO kc DO
 BEGIN peak[i]:=ja[i]; IF(peak[i]>0)THEN Inc(np);
 END;
k:=0; WITH LB1rec DO FOR i:=1 TO n DO IF(enmlist[i]<>0)THEN
 BEGIN ch1:=ABS(enmlist[i]); IF(NOT rinfun(ch1,ic1,ic2))THEN CONTINUE;
 Inc(k); GetPeakWidthB(spec.y,spec.a2,ch1,w,a,b,ok); e:=SQRT(ABS(a));
 calibr(ch1,r,r,r,en,r,r,r);
 ConvertStr(ch1,8,2); Compress(sedz); s:='Peak '+sedz+' not found';
 ConvertStr(en,8,2); Compress(sedz); s:=s+'   Energy='+sedz;
 ar[(k-1)*2+1]:=s; nitems:=2*k;
 ConvertStr(a,10,0); Compress(sedz); s:='     Area estimate= '+sedz;
 ConvertStr(e,10,0); Compress(sedz); ar[(k-1)*2+2]:=s+' +- '+sedz;
 IF(ntab+1>ntabx)THEN ShowMessage('Error, too many peaks in the table')
                 ELSE
  BEGIN Inc(ntab); k:=ntab;
  tab[k].ch:=ch1; tab[k].ech:=0; tab[k].ss:=a;
  tab[k].ess:=e; tab[k].g:=w; tab[k].eg:=0; b:=b*3*w;
  tab[k].chi2:=a/AMAX1(SQRT(a+b),1); tab[k].chip:=3*SQRT(ABS(b));
  END;
 END;
FOR i:=1 TO n DO enmlist[i]:=wa[i];
IF(k<>0)THEN
 BEGIN L0rec:='List of not found peaks';
 MakeFormV(250,20,330,430,0);
 MakeListBox(5,20,310,310); Form2.ShowModal;
 END;
END;


END.
