UNIT varfun;
{Version November 18 1994}
INTERFACE
USES Dialogs, SysUtils, vzlocom;
TYPE ARRAYforSMOOS = ARRAY[1..8192] OF REAL;
     CHIQU = RECORD chi,q1:REAL; END;
VAR  is1,is2:LONGINT;
     z_r:REAL;
     sa,sd:ARRAY[1..16384] OF REAL;
     sb,wa,ha,ja:ARRAY[1..16384] OF REAL;
     arr,ari,orr,ori:ARRAY[1..16384] OF REAL;
     chi2sm,qcursm:EXTENDED;
     mat3:ARRAY[1..3,1..3] OF REAL;
     vec3,gra3:ARRAY[1..3] OF REAL;
     mat2:ARRAY[1..2,1..2] OF REAL;
     vec2,gra2:ARRAY[1..2] OF REAL;
     qq:CHIQU;

PROCEDURE cleanz(VAR ap:ARRAY OF REAL; VAR n:INTEGER; m:INTEGER);
PROCEDURE arran(VAR p:ARRAY OF REAL; VAR n:INTEGER; l:INTEGER);
FUNCTION  rndm(x:REAL):REAL;
FUNCTION rndmz(x:REAL):REAL;
PROCEDURE rannor(VAR a,b:REAL);
FUNCTION rndexp(lambda:REAL):REAL;
FUNCTION rndmg:REAL;
PROCEDURE lapin(CONST ai:ARRAY OF REAL;
                np:INTEGER; e:REAL; VAR eps:REAL);
PROCEDURE SLanz(n,i:INTEGER; VAR f,fz,fzz:REAL);
FUNCTION  iRandom(n:INTEGER):INTEGER;
PROCEDURE rpois(VAR n:INTEGER);
PROCEDURE InvertMatrix3(VAR ok:BOOLEAN; sym:BOOLEAN; VAR det:REAL);
PROCEDURE GetEnvelope(m,nl:INTEGER; rr,c0,c2:REAL);
PROCEDURE InvertSMatrix(nmat:INTEGER; VAR ifail:INTEGER);
FUNCTION erf(x:REAL):REAL;
PROCEDURE myerf(x:REAL; VAR y,dx:REAL);
FUNCTION ExpMoment(a,x:REAL; n:INTEGER):REAL;
PROCEDURE smooth(m,mo:INTEGER; rr:REAL; VAR chi,qq:REAL);
PROCEDURE GetChiQcur(m:INTEGER; VAR chi,qq:REAL);
PROCEDURE AutoSmooth(m:INTEGER; rsm,chi0:REAL; VAR nok:BOOLEAN);
PROCEDURE AutoEnvelope(m,nl:INTEGER);
PROCEDURE GetPeakWidth(CONST ar:ARRAY OF REAL;
                       ip,m:INTEGER; VAR wi:REAL);
PROCEDURE FindMxn(CONST ar:ARRAY OF REAL; j1,j2:INTEGER;
          VAR ax,an:REAL; VAR kx,kn:INTEGER);
PROCEDURE GetPeakWidthB(CONST ar:ARRAY OF REAL; m:INTEGER;
          VAR ch,wi,a,b:REAL; VAR ok:BOOLEAN);
PROCEDURE GetMedian(CONST sa:ARRAY OF REAL; m:INTEGER; VAR med:REAL);
PROCEDURE CompressArray(m:INTEGER; cc:REAL; VAR mn:INTEGER);
PROCEDURE rPoisson(a:REAL; VAR n:INTEGER);
PROCEDURE sfft(n:INTEGER; c:REAL; VAR i1,i2:INTEGER);
PROCEDURE sfftsh(nn,ish:INTEGER; c:REAL; VAR i1,i2:INTEGER);
PROCEDURE ConvoluteFunc(m,n2:INTEGER);
IMPLEMENTATION
PROCEDURE ConvoluteFunc(m,n2:INTEGER);
{ Convolute sa (s) and the kernel sb (R) arrays; result to sd
  Version: May 14 1992     Pascal: Dec 28 2005
              1     n
     z(i) = -----  SUM  s(i-j)R(j)
            2*n+1  j=-n
  -------------------------------------}
VAR i,j,k,n:INTEGER; rn,r:REAL;
BEGIN n:=n2 DIV 2; rn:=0; FOR i:=1 TO n2 DO rn:=rn+sb[i];
FOR i:=1 TO m DO
 BEGIN r:=0; k:=i-1; FOR j:=-n TO n DO
  IF(infun(k-j,0,m-1))THEN r:=r+sb[j+n+1]*sa[k-j+1];
 sd[i]:=r/rn;
 END;
END;
PROCEDURE sfftsh(nn,ish:INTEGER; c:REAL; VAR i1,i2:INTEGER);
{  Perform a Semi-Fast Fourie Transform of an array [-ish..ish]
   Dec 28 2005}
VAR i:INTEGER; q,z,sr,si:REAL;
BEGIN q:=-c*2*pi/nn; IF(c<0)THEN FOR i:=1 TO nn DO
 BEGIN z:=q*(ish+1)*(i-1); sr:=cos(z); si:=sin(z);
 ComplexMult(arr[i],ari[i],sr,si,orr[i],ori[i]);
 END;
sfft(nn,c,i1,i2);
IF(c>0)THEN FOR i:=1 TO nn DO
 BEGIN z:=q*(ish+1)*(i-1); sr:=cos(z); si:=sin(z);
 ComplexMult(orr[i],ori[i],sr,si,orr[i],ori[i]);
 END;
END;
PROCEDURE sfft(n:INTEGER; c:REAL; VAR i1,i2:INTEGER);
{  Perform a Semi-Fast Fourie Transform of an array [1..nn]
   Fortran Version: 24.03.1989  Pascal: Jun 4 1999
    n =   P1 * P2, where P1,P2 are simple numbers
          from arr,ari arrays to orr,ori ones
    ish = if array is ar[-ish,+ish], result is multiplied by
            exp(-q(ish)v
    C   = 1. means the direct Transform
    C   =-1. means the inverse Transform
    i1,i2 = simple multiples, n = i1 * i2 (approximately)
    if not given (i1=0,i2=0), selected automatically
-----------------------------------------------  }
VAR   i,j,l,ix,m,l1,l2,k,iin,jn:INTEGER; q,d,z,sr,si:REAL;
LABEL L8;
BEGIN d:=n; r:=SQRT(d); m:=Trunc(r);
{Compute the simple multiples i1 and i2}
IF((i1<>0)AND(i2<>0))THEN GOTO L8;
i1:=m; i2:=m; ix:=n-m*m; FOR i:=1 TO 7 DO
 BEGIN iin:=m+i-4; FOR j:=1 TO 7 DO
  BEGIN jn:=m+j-4; l:=iin*jn; IF((l>n)OR((n-l)>=ix))THEN ELSE
   BEGIN i1:=iin; i2:=jn; ix:=n-l;
   END;
  END;
 END;
{Start the transform}
L8: m:=i1*i2; d:=m; IF(c<0)THEN d:=1; d:=1/d;
q:=-c*2*pi/m; FOR i:=1 TO n DO
 BEGIN orr[i]:=arr[i]; ori[i]:=ari[i];
 END;
FOR i:=1 TO m DO
 BEGIN l2:=(i-1) DIV i1; l1:=(i-1)-l2*i1; sr:=0; si:=0;
 FOR j:=1 TO i1 DO
  BEGIN k:=l2+i2*(j-1); z:=q; z:=z*(j-1)*l1*i2;
  sr:=sr+orr[k+1]*COS(z)-ori[k+1]*SIN(z);
  si:=si+orr[k+1]*SIN(z)+ori[k+1]*COS(z);
  END;
 arr[i]:=sr; ari[i]:=si;
 END;
FOR i:=1 TO m DO
 BEGIN sr:=0; si:=0; l:=(i-1) DIV i1; l:=i-1-l*i1; FOR j:=1 TO i2 DO
  BEGIN k:=l+i1*(j-1); z:=q; z:=z*(i-1)*(j-1);
  sr:=sr+arr[k+1]*COS(z)-ari[k+1]*SIN(z);
  si:=si+arr[k+1]*SIN(z)+ari[k+1]*COS(z);
  END;
 orr[i]:=sr*d; ori[i]:=si*d;
 END;
END;
PROCEDURE rPoisson(a:REAL; VAR n:INTEGER);
{Purpose: To produce random Poisson-distributed numbers, parameter = a
          Version: November 17 1987,  pascal-version Dec 15 1999
          Version: May 22 2002}
VAR i,j:INTEGER; x,u:REAL;
BEGIN n:=0; j:=Round(a/0.001); FOR i:=1 TO j DO
 BEGIN x:=rndm(-1); IF(x<0.001)THEN Inc(n);
 END;
END;
PROCEDURE AutoEnvelope(m,nl:INTEGER);
{Smooth finding automatically the optimum lambda;
 Result = (1 - rsm) * f + rsm * s;  f-source, s-smoothed
 Jun 30 2003}
VAR i:INTEGER; rc,qcc,rr:REAL;
BEGIN qcc:=1E18; rc:=1; rr:=0.1; FOR i:=1 TO 15 DO
 BEGIN rr:=rr/2; GetEnvelope(m,nl,rr,0.5,0.5);
 IF(qq.q1<qcc)THEN
  BEGIN qcc:=qq.q1; rc:=rr;
  END;
 END;
GetEnvelope(m,nl,rc,0.5,0.5); qq.q1:=rc;
END;
PROCEDURE GetEnvelope(m,nl:INTEGER; rr,c0,c2:REAL);
{Purpose: build an envelope from below to a positive distribution.
          s(i) (in sa) being given, obtain the envelope y(i) (in sd)
          by minimizing(lambda=rr), nl iterations
                        2                               2
          sum u(i)*y'(i) + lambda * sum w(i)*(y(i)-f(i))

          where  y' -the 1st difference,
                 w  -weight,equal to
                     1/(1+c0*ABS(y0)+c2*y0''^2)
          y0'-the a priori estimate of y.
          u = 1 / (1 + s^2)
Version: Jun 5 2002 }
VAR   i,j,k,loop,m1:INTEGER; ax,fun,am,am1,am2,r,r0,r2,rl,ai,bi,fi:REAL;
      c,h,w,u:^ARRAYforSMOOS; fzz:REAL;
{--------------}
BEGIN m1:=m-1; FOR i:=1 TO m DO sd[i]:=sa[i]; IF(m<5)THEN Exit;
FOR i:=1 TO m DO
 BEGIN sd[i]:=SQRT(ABS(sd[i]))*SIGN(sd[i]);
 sa[i]:=SQRT(ABS(sa[i]))*SIGN(sa[i]);
 END;
{Scale} ax:=0; FOR i:=1 TO m DO ax:=AMAX1(sa[i],ax); ax:=AMAX1(ax,1);
FOR i:=1 TO m DO
 BEGIN sd[i]:=sd[i]/ax*1000; sa[i]:=sa[i]/ax*1000;
 END;
GetMem(c,m*8); GetMem(h,m*8); GetMem(w,m*8); GetMem(u,m*8);
am1:=0; u^[m]:=1; u^[1]:=1; FOR i:=2 TO m1 DO
 BEGIN u^[i]:=AMAX1(1/(1+SQR(sa[i])),0.00000001); am1:=am1+u^[i];
 END;
{Writeln(fout,'am1= ',am1:15:8,rr:15:8);}
{  M a i n   l o o p  } FOR loop:=1 TO nl DO
 BEGIN {Form the weights} am2:=0; w^[m]:=1; w^[1]:=1;
 FOR i:=2 TO m1 DO
  BEGIN r:=0; SLanz(m,i,r,r,fzz); r2:=ABS(fzz);
  IF(loop=1)THEN r:=1/(c0*r0+c2*r2+1)
            ELSE
    BEGIN r0:=sd[i]-sa[i]; r:=1; IF(r0<0)THEN r:=1/(r0*r0{+r2*r2}+1);
    END;
  w^[i]:=r; am2:=am2+r;
  END;
 am:=am1/am2; rl:=rr*am;
 {Writeln(fout,loop:8,am2:15:8,rl:15:8);}
 {Form the "chasing" coefficients}
 c^[1]:=0; h^[1]:=sd[1]; FOR i:=2 TO m1 DO
  BEGIN ai:=(u^[i+1]-u^[i-1])/4; bi:=-rl*w^[i]/u^[i];
  fi:=bi*sd[i]; fun:=1/(2-bi-(1-ai)*c^[i-1]); c^[i]:=(1+ai)*fun;
  h^[i]:=fun*((1-ai)*h^[i-1]-fi);
  END;
 {Form the envelope}
 FOR i:=2 TO m DO
  BEGIN j:=m-i+1; sd[j]:=c^[j]*sd[j+1]+h^[j];
  END;
 FOR i:=1 TO m DO sd[i]:=AMIN1(sd[i],sa[i]);
 {END of main loop}
 END;
WITH qq DO
 BEGIN chi:=0; q1:=0; FOR i:=2 TO m1 DO
  BEGIN chi:=chi+w^[i]*SQR(sd[i]-sa[i]);
  q1:=q1+u^[i]*SQR(sd[i+1]-sd[i-1])*0.25;
  END;
 END;
{back-scale} FOR i:=1 TO m DO
 BEGIN sd[i]:=sd[i]/1000*ax; sd[i]:=SQR(sd[i])*SIGN(sd[i]);
 sa[i]:=sa[i]/1000*ax; sa[i]:=SQR(sa[i])*SIGN(sa[i]);
 END;
FreeMem(c,m*8); FreeMem(h,m*8); FreeMem(w,m*8); FreeMem(u,m*8);
END;
FUNCTION rndm(x:REAL):REAL;
{ produce a uniformely distributed pseudo-random number in the range
 [0,1]. (F.James, CPC(60)3,p.329) Version: May 14 1991 }
VAR k,iz:LONGINT;
BEGIN k:=is1 DIV 53668; is1:=40014*(is1-k*53668)-k*12211;
IF(is1<0)THEN is1:=is1+2147483563; k:=is2 DIV 52774;
is2:=40692*(is2-k*52774)-k*3791; IF(is2<0)THEN is2:=is2+2147483399;
iz:=is1-is2; IF(iz<1)THEN iz:=iz+2147483562; rndm:=iz*4.656613E-10;
END;
FUNCTION rndmz(x:REAL):REAL;
{rndmz: produce uniformely distributed correlated pseudo-random number
 in the range [0,1]. Version: May 8 1991,  Delphi - Dec 1 2001}
VAR k,iz:LONGINT; q,y:REAL;
CONST con:ARRAY[1..5] OF REAL =
      (1.234567,1.345678,1.456789,1.567891,1.678912);
BEGIN k:=Round(ABS(z_r)); k:=(k MOD 5)+1; q:=ABS(z_r)/con[k];
q:=SQRT(q); z_r:=z_r+1; IF(z_r>1000002)THEN z_r:=SQRT(z_r){+Random};
y:=(q-Trunc(q))*39.87654321; y:=(y-Trunc(y)); rndmz:=y;
END;
PROCEDURE cleanz(VAR ap:ARRAY OF REAL; VAR n:INTEGER; m:INTEGER);
{Purpose: purges positive (m=+1), negative (m=-1)
          or zero (m=0) values from array ap.
          November 7 1994}
VAR i,k:INTEGER; ok:BOOLEAN;
BEGIN k:=0; FOR i:=0 TO n-1 DO
  BEGIN ok:=false; CASE m OF
  -1: IF(ap[i]>=0)THEN ok:=true;
   0: IF(ap[i]<>0)THEN ok:=true;
   1: IF(ap[i]<=0)THEN ok:=true;
                   ELSE END;
  IF(ok)THEN
   BEGIN ap[k]:=ap[i]; Inc(k);
   END;
  END;
n:=k;
END;
PROCEDURE arran(VAR p:ARRAY OF REAL; VAR n:INTEGER; l:INTEGER);
{Purpose: to arrange the array p in an increasing (l>0)
          or a decreasing (l<0) order
          or delete the coinciding neighbors (l=0)
          Version: Dec 11 1996}
CONST d:REAL = -0.123456789012;
VAR   i,j,k:INTEGER; r:REAL;
BEGIN IF(n<=1)THEN Exit;
CASE l OF
0: BEGIN FOR i:=0 TO (n-2) DO IF(p[i]=p[i+1])THEN p[i]:=d;
   k:=0; FOR i:=0 TO n-1 DO IF(p[i]<>d)THEN
    BEGIN p[k]:=p[i]; Inc(k);
    END;
   n:=k;
   END;
1: BEGIN FOR i:=0 TO n-2 DO FOR j:=0 TO n-i-2 DO IF(p[j]>p[j+1])THEN
    BEGIN r:=p[j+1]; p[j+1]:=p[j]; p[j]:=r;
    END;
   END;
-1:BEGIN FOR i:=0 TO n-2 DO FOR j:=0 TO n-i-2 DO IF(p[j]<p[j+1])THEN
    BEGIN r:=p[j+1]; p[j+1]:=p[j]; p[j]:=r;
    END;
   END;
ELSE END;
END;
PROCEDURE rannor(VAR a,b:REAL);
{ Purpose: to produce a normal N(0,1)-distributed pseudo-random number.
  Version: March 23 1989 }
VAR x1,x2,u1,u2,s,sq:REAL;
BEGIN REPEAT x1:=rndm(-1); x2:=rndm(-1); u1:=2*x1-1; u2:=2*x2-1;
      s:=SQR(u1)+SQR(u2);
      UNTIL((s<=1)AND(s>0)); sq:=sqrt(-2*LN(s)/s); a:=u1*sq; b:=u2*sq;
END;
FUNCTION rndexp(lambda:REAL):REAL;
{ Purpose: To produce a random number subjected to an exponential
           probability density:   exp(-lambda*t)
  Version: July 10 1992}
VAR xx:REAL;
BEGIN xx:={AMAX1(1E-35,}rndm(-1){)}; rndexp:=-LN(xx)/lambda;
END;
FUNCTION rndmg:REAL;
BEGIN rndmg:=2*(RNDM(-1)-0.5);
END;
PROCEDURE lapin(CONST ai:ARRAY OF REAL;
                np:INTEGER; e:REAL; VAR eps:REAL);
{performs 4 points cubic spline interpolation, version 82-02
 ai: y1 y2 ... yn x1 x2 ... xn, eps=result at e}
VAR   lsp:BOOLEAN; l,n,k1,i,j,k:INTEGER;
      det,h1,h2,h3,c1,c2,c3,d1,d2,d3,r1,r2,x0,x1,x2,x3,f0,f1,f2,f3,r:
      REAL;
LABEL L2,L10,L12,L11,L13;
{---------------------------------------------------------------}
BEGIN lsp:=true; k:=2*np; k1:=k-1; j:=np+1; eps:=ai[0];
{extrapolation}
IF(e<=ai[j-1])THEN
 BEGIN i:=2+np; l:=2; GOTO L13;
 END;
eps:=ai[np-1]; IF(e>=ai[k-1])THEN
 BEGIN i:=2*np; l:=np; GOTO L13;
 END;
{search the argument interval} r:=(ai[j-1]+ai[k-1])*0.5;
IF(e>r)THEN FOR i:=j TO k1 DO
  BEGIN IF((ai[i-1]<=e)AND(e<ai[i]))THEN GOTO L2;
  END  ELSE FOR n:=j TO k1 DO
 BEGIN i:=k-n+np; IF((ai[i-1]<=e)AND(e<ai[i]))THEN GOTO L2;
 END;
L2: l:=i-np; IF((l=1)OR(l>=(np-1)))THEN GOTO L11;
L10: x0:=ai[i-2]; x1:=ai[i-1]; x2:=ai[i]; x3:=ai[i+1];
     f0:=ai[l-2]; f1:=ai[l-1]; f2:=ai[l]; f3:=ai[l+1];
     IF(NOT lsp)THEN GOTO L12;
     IF((f3>=f2)AND(f2>=f1)AND(f1>=f0))THEN GOTO L11;
     IF((f3<=f2)AND(f2<=f1)AND(f1<=f0))THEN GOTO L11;
     h3:=x3-x2; h2:=x2-x1;
L12: h1:=x1-x0; IF(lsp)THEN
    BEGIN {parabolic spline interpolation} c1:=(h1+h2)/3; c2:=h2/6;
    c3:=(h2+h3)/3; det:=c1*c3-c2*c2; d1:=(f2-f1)/h2; d2:=(f3-f2)/h3-d1;
    d1:=d1-(f1-f0)/h1; r1:=(d1*c3-d2*c2)/det; r2:=(d2*c1-d1*c2)/det;
    r:=(x2-e); r:=r*r*r; det:=(e-x1); det:=det*det*det;
    eps:=r1*(r/(6*h2))+r2*(det/(6*h2))+(f1-(r1*h2*h2/6))*(x2-e)/h2+
    (f2-(r2*h2*h2/6))*(e-x1)/h2;
    END                ELSE
 BEGIN{linear interpol.} c1:=(x1-e)/h1; c2:=(e-x0)/h1; eps:=c1*f0+c2*f1;
 END;
Exit;
L11: l:=l+1; i:=i+1;
L13: lsp:=false; GOTO L10;
END;
PROCEDURE SLanz(n,i:INTEGER; VAR f,fz,fzz:REAL);
{Purpose: produce a smoothed by 4th difference filter data item and its
          derivatives;  Version: 24.11.1988}
BEGIN f:=sa[i]; fz:=0; fzz:=0; IF((n<5)OR(i=1)OR(i=n))THEN Exit;
IF((i=2)OR(i=(n-1)))THEN
 BEGIN f:=(sa[i-1]+sa[i+1])*0.5; fz:=(sa[i+1]-sa[i-1])*0.5;
 fzz:=sa[i+1]-2*sa[i]+sa[i-1]; Exit;
 END;
f:=(12*(sa[i-1]+sa[i+1])-3*(sa[i-2]+sa[i+2])+17*sa[i])/35;
fz:=(2*(sa[i+2]-sa[i-2])+(sa[i+1]-sa[i-1]))/10;
fzz:=(2*(sa[i+2]+sa[i-2])-(sa[i+1]+sa[i-1])-2*sa[i])/7;
END;
FUNCTION iRandom(n:INTEGER):INTEGER;
VAR r:REAL; i:INTEGER;
BEGIN r:=rndm(-1.0); i:=Round(r*n); iRandom:=MAX0(0,MIN0(n-1,i));
END;
PROCEDURE rpois(VAR n:INTEGER);
{Purpose: To produce random Poisson-distributed numbers, parameter = 1
          Version: November 17 1987,  pascal-version Dec 15 1999}
VAR i:INTEGER; x:REAL;
BEGIN n:=0; FOR i:=1 TO 50 DO
 BEGIN x:=rndm(-1); IF(x<0.02)THEN Inc(n);
 END;
END;
PROCEDURE InvertMatrix3(VAR ok:BOOLEAN; sym:BOOLEAN; VAR det:REAL);
{Symm.(sym=true) matrix 3*3 is in mat3 array.  Version Aug 31 2001
 Non-symmetr.case Apr 13 2006}
VAR i,j:INTEGER; a,b:ARRAY[1..3,1..3] OF REAL;
BEGIN FOR i:=1 TO 3 DO FOR j:=1 TO 3 DO a[i,j]:=mat3[i,j];
ok:=true; det:=a[1,1]*a[2,2]*a[3,3]+a[1,2]*a[2,3]*a[3,1]+
 a[1,3]*a[2,1]*a[3,2]-a[1,3]*a[2,2]*a[3,1]-a[1,2]*a[2,1]*a[3,3]-
 a[1,1]*a[2,3]*a[3,2]; IF(det=0)THEN
  BEGIN ok:=false; Exit;
  END;
b[1,1]:=(a[2,2]*a[3,3]-a[2,3]*a[3,2])/det;
b[2,2]:=(a[1,1]*a[3,3]-a[1,3]*a[3,1])/det;
b[3,3]:=(a[1,1]*a[2,2]-a[1,2]*a[2,1])/det;
b[1,2]:=-(a[2,1]*a[3,3]-a[2,3]*a[3,1])/det;
b[1,3]:=(a[2,1]*a[3,2]-a[2,2]*a[3,1])/det;
b[2,3]:=-(a[1,1]*a[3,2]-a[1,2]*a[3,1])/det;
CASE sym OF
true:  BEGIN b[2,1]:=b[1,2]; b[3,1]:=b[1,3]; b[3,2]:=b[2,3];
       END;
false: BEGIN b[2,1]:=-(a[1,2]*a[3,3]-a[3,2]*a[1,3])/det;
       b[3,1]:=(a[2,3]*a[1,2]-a[2,2]*a[1,3])/det;
       b[3,2]:=-(a[1,1]*a[2,3]-a[2,1]*a[1,3])/det;
       END;
ELSE END;
FOR i:=1 TO 3 DO FOR j:=1 TO 3 DO mat3[i,j]:=b[j,i];
END;
PROCEDURE InvertSMatrix(nmat:INTEGER; VAR ifail:INTEGER);
{Purpose: inverts a symmetrical matrix  onl(nmat,nmat);
          if failure ifail:=1 else ifail:=0; Fortran Version: 2.11.1988}
VAR   i,j,k,l,np,np1,jj,kk,ij,kj,ji,jl,ij0,ji0:INTEGER; elm,pivot:REAL;
      dia:ARRAY[1..128] OF BYTE; aua:ARRAY[1..128] OF REAL;
LABEL L100,L19;
BEGIN ifail:=1; IF(nmat>100)THEN GOTO L100;
np1:=nmat+1; FOR i:=1 TO nmat DO dia[i]:=1;
FOR i:=1 TO nmat DO
 BEGIN {Find pivot} pivot:=0; jj:=1; FOR j:=1 TO nmat DO
  BEGIN IF(dia[j]=0)THEN GOTO L19; elm:=ABS(onl[jj]);
  IF(elm<=pivot)THEN GOTO L19; pivot:=elm; k:=j; kk:=jj;
  L19: jj:=jj+np1;
  END;
 IF(pivot<1.E-16)THEN GOTO L100;
 dia[k]:=0; pivot:=-onl[kk];
 {Eliminate}
 kj:=k; np:=nmat; FOR j:=1 TO nmat DO
  BEGIN IF((j-k)=0)THEN
   BEGIN onl[kj]:=1/pivot; aua[j]:=0; np:=1;
   END             ELSE
    BEGIN elm:=-onl[kj]; aua[j]:=elm/pivot;
    IF(elm<>0)THEN
     BEGIN jl:=j; FOR l:=1 TO j DO
      BEGIN onl[jl]:=onl[jl]+elm*aua[l]; jl:=jl+nmat;
      END;
     END;
    onl[kj]:=aua[j];
    END;
  kj:=kj+np;
  END;
 END;
ij0:=1; ji0:=1; FOR i:=1 TO nmat DO
 BEGIN ij:=ij0; ji:=ji0; FOR j:=1 TO i DO
  BEGIN onl[ij]:=-onl[ij]; onl[ji]:=onl[ij]; ij:=ij+nmat; Inc(ji);
  END;
 ij0:=ij0+1; ji0:=ji0+nmat;
 END;
Exit;
L100: ifail:=0; {Failure return}
END;
FUNCTION erf(x:REAL):REAL;
{ Compute the ERF-function; Fortran Version: 15.07.1989;
  Pascal Jan 7 2003}
VAR n:INTEGER; uv,un,ef,x2,y,q:EXTENDED;
BEGIN y:=ABS(x); q:=y*1.E-7;
IF(y>3.9)THEN
 BEGIN IF(x>0)THEN erf:=1 ELSE erf:=-1; Exit;
 END;
x2:=x*x; uv:=x; ef:=uv; FOR n:=1 TO 60 DO
 BEGIN un:=-(n*2-1)*x2/n*uv/(n*2+1);
 IF(ABS(un)<q)THEN BREAK;
 ef:=ef+un; uv:=un;
 END;
erf:=1.128379*ef;
END;
PROCEDURE myerf(x:REAL; VAR y,dx:REAL);
{
                           1         x     -z**2/2
  computes the function -------- INTEGRAL e       dz  (y)
                        SQRT(2pi)  -inf

  and its derivative                                  (dx)
     Fortran Version 1988.07.06, Oct 26 1998;  Pascal Jan 7 2003}
CONST sqrpi:REAL = 0.3989423;
      arr:ARRAY[1..70] OF REAL = (
       0,       0.03983, 0.07926, 0.11791,  0.15542,   0.19146,
       0.22575, 0.25804, 0.28814, 0.31594,  0.34134,   0.36433,
       0.38493, 0.40320, 0.41924, 0.43319,  0.44520,   0.45543,
       0.46407, 0.47128, 0.47725, 0.48214,  0.48610,   0.48928,
       0.49180, 0.49379, 0.49534, 0.49653,  0.49744,   0.49813,
       0.49865, 0.49977, 0.49997, 0.499997, 0.49999997,
        0, 0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9,
      1.0, 1.1, 1.2, 1.3, 1.4, 1.5, 1.6, 1.7, 1.8, 1.9,
      2.0, 2.1, 2.2, 2.3, 2.4, 2.5, 2.6, 2.7, 2.8, 2.9,
      3.0, 3.5, 4.0, 4.5, 5.0);
VAR i:INTEGER; z:REAL;
BEGIN lapin(arr,35,ABS(x),z); y:=z+0.5; IF(x<0)THEN y:=0.5-z;
dx:=sqrpi*EXP(-AMIN1(0.5*x*x,277));
END;
FUNCTION ExpMoment(a,x:REAL; n:INTEGER):REAL;
VAR ax:REAL;
BEGIN ax:=a*x;
ExpMoment:=(PowerRI(ax,n)*EXP(ax)-2*EXP(ax)*(ax-1))/PowerRI(a,n+1);
END;
PROCEDURE GetChiQcur(m:INTEGER; VAR chi,qq:REAL);
VAR i:INTEGER; z:REAL;
BEGIN chi:=0; qq:=0; FOR i:=1 TO m DO
 BEGIN chi:=chi+SQR(sd[i]-sa[i])/AMAX1(1,ABS(sa[i])); z:=0;
 IF((i<>1)AND(i<>m))THEN z:=SQR(sd[i-1]-2*sd[i]+sd[i+1])/
  (1+SQR((ABS(sd[i-1]-sd[i])+ABS(sd[i]-sd[i+1]))*0.5)); qq:=qq+z;
 END;
chi:=chi/m;
END;
PROCEDURE smooth(m,mo:INTEGER; rr:REAL; VAR chi,qq:REAL);
{ smooth the data using the generalized spline filter;
  f(i) (in sa(m)) data being given, obtain the smoothed
  one s(i) (in sd(m)) by minimizing
                  2                           2
   SUM w(i)*s''(i)  + lambda * SUM (s(i)-f(i))  , where
       s'' - the 2nd difference,
       w   - weight, equal to SQRT(1/(1+s0))
       mo  - use weights from sd;
  Lambda is selected automatically.
  Version: 24.11.1988, Pascal-version: May 31 1999, Jan 19 2003 }
VAR   m1,m2,i,k,j:INTEGER; z,r,rl:REAL; sb,sc,se,wa:^ARRAYforSMOOS;
      a11,a12,a21,a22,d11,d12,d21,d22,eps,det:REAL;
BEGIN m1:=m-1; m2:=2*m*8; eps:=1E-10; rl:=rr/m; IF(m<=5)THEN
 BEGIN FOR i:=0 TO m DO sd[i]:=sa[i]; Exit;
 END;
GetMem(sb,m2); GetMem(sc,m2); GetMem(se,m2); GetMem(wa,m*8);
{Form the weights} IF(mo=0)THEN
 BEGIN FOR i:=2 TO m1 DO {Linked to 1000 scale}
  BEGIN r:=ABS(sa[i-1])+ABS(sa[i])+ABS(sa[i+1])+1; z:=sa[i]/1000;
  r:=ABS(1-z)*SQRT(r)+ABS(z)*r; wa^[i]:=AMAX1(1/r,eps);
  END;
 wa^[1]:=wa^[2]; wa^[m]:=wa^[m1];
 END                       ELSE FOR i:=1 TO m DO wa^[i]:=sd[i];
se^[1]:=sa[1]; se^[m]:=sa[m]; se^[m+1]:=0; se^[m*2]:=0; {g,v at 0}
sb^[1]:=0; sb^[m+1]:=0; sc^[1]:=0; sc^[m+1]:=0;
FOR i:=2 TO m1 DO {The forward cycle}
 BEGIN k:=i+m; a11:=2-sb^[i-1]; a12:=1-sb^[k-1];
 a21:=-(wa^[i-1]*sc^[i-1]+rl)/wa^[i+1];
 a22:=(2*wa^[i]-wa^[i-1]*sc^[k-1])/wa^[i+1];
 det:=a11*a22-a12*a21; IF(ABS(det)<1E-100)THEN det:=(1E-100)*SIGN(det);
 d11:= a22/det; d22:= a11/det; d21:=-a21/det; d12:=-a12/det;
 r:=(wa^[i-1]*se^[k-1]-rl*sa[i])/wa^[i+1];
 se^[i]:=d11*se^[i-1]+d12*r; se^[k]:=d21*se^[i-1]+d22*r;
 sb^[i]:=d11; sb^[k]:=d12; sc^[i]:=d21; sc^[k]:=d22;
 END;
FOR i:=1 TO m1 DO {The backward cycle}
 BEGIN j:=m-i; k:=j+m; se^[j]:=sb^[j]*se^[j+1]+sb^[k]*se^[k+1]+se^[j];
 se^[k]:=sc^[j]*se^[j+1]+sc^[k]*se^[k+1]+se^[k];
 END;
FOR i:=1 TO m DO sd[i]:=se^[i]; GetChiQcur(m,chi,qq);
FreeMem(sb,m2); FreeMem(sc,m2); FreeMem(se,m2); FreeMem(wa,m*8);
END;
PROCEDURE AutoSmooth(m:INTEGER; rsm,chi0:REAL; VAR nok:BOOLEAN);
{Smooth finding automatically the optimum lambda;
 Result = (1 - rsm) * f + rsm * s;  f-source, s-smoothed
 chi0 - admissible chi2 (not more than that).  Jan 19 2003}
VAR i,kx,kn,nloop:INTEGER; q1,rc,qcc,r,x,rr,amx,amn,chi:REAL;
    xx:ARRAY[1..5] OF REAL;
BEGIN FOR i:=1 TO m DO sd[i]:=sa[i];
FindMxn(sa,1,m,amx,amn,kx,kn);
nok:=false; IF((kx=1)OR(kx=m)OR(amx=amn))THEN
 BEGIN nok:=true; Exit;
 END;
FOR i:=1 TO m DO sa[i]:=1000/(amx-amn)*sa[i];
qcc:=1E18; rc:=1000; rr:=1000; FOR i:=1 TO 21 DO
 BEGIN rr:=rr/2; smooth(m,0,rr,chi,q1);
 {Writeln(fout,i:5,rr:12:8,chi:10:2,qcc:10:4);}
 IF((q1<qcc)AND(rinfun(chi,chi0*0.25,chi0*0.875)))THEN
  BEGIN qcc:=q1; rc:=rr;
  END;
 END;
x:=rc/1.5; r:=(2*rc-x)/20; FOR i:=1 TO 21 DO
 BEGIN rr:=AMAX1(0,x+(i-11)*r); smooth(m,0,rr,chi,q1);
 IF((q1<qcc)AND(rinfun(chi,chi0*0.25,chi0)))THEN
  BEGIN qcc:=q1; rc:=rr;
  END;
 {Writeln(fout,i:5,rr:12:8,chi:10:2,q1:10:4);}
 END;
{Writeln(fout,rc:12:8,qcc:10:4,r:10:3,x:10:4);}
smooth(m,0,rc,chi,qcc); r:=AMIN1(1,rsm); qq.q1:=rc; FOR i:=1 TO m DO
 BEGIN rr:=sd[i]; sd[i]:=(amx-amn)*((1-r)*sa[i]+r*rr)/1000;
 sa[i]:=(amx-amn)*sa[i]/1000;
 END;
END;
PROCEDURE GetPeakWidth(CONST ar:ARRAY OF REAL;
                       ip,m:INTEGER; VAR wi:REAL);
{determines the halfwidth of a peak (if no background),
 ip = position of max;  width -> wi;  if failure wi=-1
 version 79-7; Feb 21 2002; external indexation in ar starts with 1}
VAR i,j,ip1,ip2:INTEGER; ur,rr,x1,x2:REAL;
 {FUNCTION smv(i:INTEGER):REAL;
 BEGIN smv:=(ar[i+1]+ar[i]+ar[i-1])/3;
 END;}
BEGIN wi:=-1; j:=ip-1; {indexation 1 less}
IF(ar[j+1]>ar[j])THEN Inc(j); IF(ar[j-1]>ar[j])THEN Dec(j); ur:=ar[j]/2;
{IF((ar[j-1]<ur)OR(ar[j+1]<ur))THEN Exit;}
FOR i:=j-1 DOWNTO 1 DO IF(ABS(ar[i])<ur)THEN BREAK; IF(i=1)THEN Exit;
{FOR i:=j-1 DOWNTO 1 DO IF(ABS(smv(i))<ur)THEN BREAK; IF(i=1)THEN Exit;}
rr:=ABS(ar[i+1])-ABS(ar[i]); ip1:=i+1;
x1:=0; IF(rr>0.0001)THEN x1:=(ar[i+1]-ur)/rr ELSE Exit;
FOR i:=j+1 TO m-2 DO IF(ABS(ar[i])<ur)THEN BREAK;IF(i=(m-2))THEN Exit;
{FOR i:=j+1 TO m-2 DO IF(ABS(smv(i))<ur)THEN BREAK;
IF(i=(m-2))THEN Exit;}
rr:=ABS(ar[i-1])-ABS(ar[i]); ip2:=i-1;
x2:=0; IF(rr>0.001)THEN x2:=(ar[i-1]-ur)/rr ELSE Exit;
wi:=(ip2-ip1)+ABS(x1)+ABS(x2); IF(wi<0.25)THEN wi:=-1;
END;
PROCEDURE FindMxn(CONST ar:ARRAY OF REAL; j1,j2:INTEGER;
          VAR ax,an:REAL; VAR kx,kn:INTEGER);
{Purpose: to compute max, min, and their coordinates in ar[j1,j2]
 Version: 1978; Pascal Jan 22 2003}
VAR i,jx,jn:INTEGER; rr,xx,xn:REAL;
BEGIN IF(j2<j1)THEN
 BEGIN kx:=j1; kn:=jx; ax:=ar[j1-1]; an:=ax; Exit;
 END;
IF(j1<=0)THEN
 BEGIN kx:=1; kn:=kx; ax:=ar[0]; an:=ax; Exit;
 END;
jx:=j1-1; jn:=jx; xx:=ar[jx]; xn:=xx; FOR i:=j1-1 TO j2-1 DO
 BEGIN rr:=ar[i]; IF(xx<rr)THEN
  BEGIN xx:=rr; jx:=i;
  END;
 IF(xn>rr)THEN
  BEGIN xn:=rr; jn:=i;
  END;
 END;
Inc(jx); Inc(jn); kn:=jn; kx:=jx; ax:=xx; an:=xn;
END;
PROCEDURE GetPeakWidthB(CONST ar:ARRAY OF REAL; m:INTEGER;
          VAR ch,wi,a,b:REAL; VAR ok:BOOLEAN);
{determine width, area and position of a peak, if background
 version 85.10.14;  Pascal= Jan 22 2003}
VAR l,i1,i2,i,j,kx:INTEGER; amx,r,chm,back,ck,con:REAL;
 FUNCTION ckamn(j:INTEGER):BOOLEAN;
 BEGIN ckamn:=false;
 IF((ar[j-1]>=ar[j])AND(ar[j+1]>=ar[j]))THEN ckamn:=true;
 END;
{ ---------------------------------------------------------------}
BEGIN ok:=false; IF(NOT rinfun(ch,1,Float(m)))THEN Exit;
i1:=MAX0(Round(ch)-5,1); i2:=MIN0(Round(ch)+5,m);
FindMxn(ar,i1,i2,amx,r,kx,i);
a:=0; FOR i:=kx-2 TO kx+2 DO
 BEGIN a:=a+ar[i]; b:=ar[i]*(i-kx);
 END;
IF(a>0.01)THEN ch:=b/a+kx ELSE ch:=kx;
i1:=MAX0(kx-48,1); i2:=MIN0(kx+48,m-1);
l:=i1; FOR i:=kx-1 DOWNTO i1+1 DO IF(ckamn(i))THEN
 BEGIN l:=i; BREAK;
 END;
i1:=l; l:=i2; FOR i:=kx+1 TO i2 DO IF(ckamn(i))THEN
 BEGIN l:=i; BREAK;
 END;
i2:=l;
{find minmax} FindMxn(ar,i1,i2,amx,r,kx,i);
IF(amx<=(3*SQRT(ABS(amx))))THEN Exit;
FOR i:=i1 TO kx DO
 BEGIN j:=kx-i+i1; IF(ckamn(j))THEN BREAK;
 END;
i1:=j; FOR i:=kx TO i2 DO
 BEGIN IF(ckamn(i))THEN BREAK;
 END;
i2:=i; IF(i1=i2)THEN Exit;
ck:=(ar[i2]-ar[i1])/(i2-i1); con:=ar[i1]-ck*i1;{subtract the background}
a:=0; FOR i:=i1 TO i2 DO
 BEGIN l:=i-i1+1; back:=ck*i+con; r:=ar[i];
 chm:=AMAX1(r-back,0); onl[l]:=chm; a:=a+chm;
 END;
b:=back/(i2-i1+1);
{determine the aproximate width}
m:=i2-i1+1; j:=kx-i1+1; IF((onl[j]*0.5)<=SQRT(ABS(amx)))THEN Exit;
GetPeakWidth(onl,j,m,wi); IF(wi>0)THEN ok:=true;
END;
PROCEDURE GetMedian(CONST sa:ARRAY OF REAL; m:INTEGER; VAR med:REAL);
{Purpose: get the median; Version: March 16 1994; Delphi=Feb 3 2003}
VAR i:INTEGER;
BEGIN FOR i:=0 TO m-1 DO sd[i+1]:=sa[i]; arran(sd,m,1); i:=m DIV 2;
IF(Odd(m))THEN med:=sd[i+1] ELSE med:=(sd[i]+sd[i+1])/2;
END;
PROCEDURE CompressArray(m:INTEGER; cc:REAL; VAR mn:INTEGER);
VAR i,j,k:INTEGER; ec,v:REAL;
BEGIN IF(m>8192)THEN
 BEGIN ShowMess('Too long array'); Exit;
 END;
mn:=Round(Float(m)/cc)+2; FOR i:=1 TO mn DO sd[i]:=0;
FOR i:=1 TO m DO FOR j:=0 TO 999 DO
 BEGIN v:=sa[i]/1000; ec:=(i+0.001*j)/cc;
 k:=Round(ec)+1; IF(infun(k,1,mn))THEN sd[k]:=sd[k]+v;
 END;
END;
{--------------}
BEGIN is1:=12345; is2:=67890; z_r:=2; {rndm_zj:=false;}
END.


PROCEDURE GetSmoothDiff1(m:INTEGER; rr:REAL);
{Purpose: smooth a positive distribution.
          s(i) (in sa) being given, obtain the smoothed y(i) (in sd)
          by minimizing(lambda=rr)
                        2                               2
          sum u(i)*y'(i) + lambda * sum w(i)*(y(i)-f(i))
          where  y' -the 1st difference,
                 w  -weight,equal to 1/ABS(f)
          u = 1 / (1 + s^2)
Version: Jun 5 2002,   Aug 13 2002 }
VAR   i,j,k,m1:INTEGER; ax,fun,am1,am2,r,rl,ai,bi,fi:REAL;
      c,h,w,u:^ARRAYforSMOOS;
{--------------}
BEGIN FOR i:=1 TO m DO sd[i]:=sa[i]; IF((m<5)OR(rr=0))THEN Exit;
m1:=m-1; FOR i:=1 TO m DO
 BEGIN sd[i]:=SQRT(ABS(sd[i]))*SIGN(sd[i]);
 sa[i]:=SQRT(ABS(sa[i]))*SIGN(sa[i]);
 END;
{Scale} ax:=0; FOR i:=1 TO m DO ax:=AMAX1(sa[i],ax); ax:=AMAX1(ax,1);
FOR i:=1 TO m DO
 BEGIN sd[i]:=sd[i]/ax*1000; sa[i]:=sa[i]/ax*1000;
 END;
GetMem(c,m*8); GetMem(h,m*8); GetMem(w,m*8); GetMem(u,m*8);
am1:=0; u^[m]:=1; u^[1]:=1; FOR i:=2 TO m1 DO
 BEGIN u^[i]:=AMAX1(1/(1+SQR(sa[i])),1E-15); am1:=am1+u^[i];
 END;
{Form the weights} am2:=0; w^[m]:=1; w^[1]:=1;
FOR i:=2 TO m1 DO
 BEGIN r:=1/AMAX1(sa[i],1); w^[i]:=r; am2:=am2+r;
 END;
rl:=rr/1000; {Writeln(fout,'w1  w2 lamb ',am1:15:8,am2:15:8,rl:15:8);}
                 {  M a i n }
{Form the "chasing" coefficients}
c^[1]:=0; h^[1]:=sd[1]; FOR i:=2 TO m DO
 BEGIN ai:=(u^[i+1]-u^[i-1])/4; bi:=-rl*w^[i]/u^[i];
 fi:=bi*sd[i]; fun:=1/(2-bi-(1-ai)*c^[i-1]); c^[i]:=(1+ai)*fun;
 h^[i]:=fun*((1-ai)*h^[i-1]-fi);
 END;
{Form the smoothed}
FOR i:=2 TO m DO
 BEGIN j:=m-i+1; sd[j]:=c^[j]*sd[j+1]+h^[j];
 END;
{back-scale} FOR i:=1 TO m DO
 BEGIN sd[i]:=sd[i]/1000*ax; sd[i]:=SQR(sd[i])*SIGN(sd[i]);
 sa[i]:=sa[i]/1000*ax; sa[i]:=SQR(sa[i])*SIGN(sa[i]);
 END;
FreeMem(c,m*8); FreeMem(h,m*8); FreeMem(w,m*8); FreeMem(u,m*8);
END;
