UNIT vdoman;
INTERFACE
USES      vzlocom, vdomus0, comctrls, Dialogs, SysUtils, Controls,
          vdomus2, vdomfl,  vdomhlp,  Graphics, vstdcons, vpeaksr,
          varfun;
PROCEDURE TransformtoReversedSpace;
PROCEDURE SmooththeSpectrum;
PROCEDURE smooth3(rl:REAL; VAR cl,sme:REAL);
PROCEDURE compsmooth(VAR sm:REAL);
PROCEDURE DetermineWidths(i,j,k:INTEGER; VAR wx,wy,wz:REAL);
PROCEDURE CompAreas(VAR sum:REAL; PB:TProgressBar);
PROCEDURE FindthePeaks(PB:TProgressBar);
PROCEDURE AssigntheHKLs;
PROCEDURE Find1DimPeaks;
IMPLEMENTATION
PROCEDURE Find1DimPeaks;
VAR i,m:INTEGER; wi,a,b:REAL;
BEGIN FOR i:=1 TO 1024 DO spec.y[i]:=csp[i]; m:=i2-i1+1;
WITH peaksr DO WITH spec DO
 BEGIN deb:=false; dw0:=ABS(wxxu-wxxl); w0:=(wxxl+wxxu)*0.5;
 w1:=wid0; cw1:=dw0/(i2-i1); cw0:=w0-cw1*i1;
 MarkTheIntervals(spec,i1,i2,w0,w1,dw0);
 FOR i:=1 TO npeak DO WITH pkar[i] DO
  BEGIN {Writeln(fout,marka[i]:8:2);}
  GetPeakWidthB(csp,m,marka[i],wi,a,b,ok);
  x:=marka[i]; y:=0; z:=0; V:=a; wx:=wi; wy:=0; wz:=0;
  END;
 npk:=npeak;
 END;
END;
PROCEDURE AssigntheHKLs;
VAR   i,j,h,k,l,n:INTEGER; r,a,th,d,dnew:REAL; s:STRING;
BEGIN L0rec:='Assign the HKLs'; MakeFormV(200,20,330,430,0);
SaveHelp(Asshkls_n,Asshkls);
s:='For HKL-assignment set max d-deviation';
OuttoLabel(Form2.Label5,5,30,clGreen,clWhite,s);
{s:='is needed';
OuttoLabel(Form2.Label6,5,48,clGreen,clWhite,s);}
L1rec:=' D-deviation (in Angst) = '; E1rec:=FloatToStr(ddev);
MakeEdits(30,210,90,70,1);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 Zval(Edit1.Text,r); ddev:=r;
 END;
L0rec:='Input the HKL-file name'; fn:=vddir; GetFilename(fn,0);
IF(ModalRes=0)THEN Exit; {fnhkli:=fn;}
AssignFile(ft,fn{hkli}); Reset(ft);   {HKL input: Get hkl's and d's}
WHILE(NOT EoF(ft))DO
 BEGIN Readln(ft,sedz); i:=Pos('h   k   l',sedz); IF(i<>0)THEN BREAK;
 END;
IF(i=0)THEN
 BEGIN ShowMess('Error, no hkls in file '+fnhkli ); CloseFile(ft);
 Exit;
 END;
n:=0; WHILE(NOT EoF(ft))DO
 BEGIN Readln(ft,sedz); sedz:=sedz+' '; IF(sedz[1]='*')THEN CONTINUE;
 fffins(k,sedz); IF(k<5)THEN
  BEGIN ShowMess('Error ,wrong structure of hkl-file '+fnhkli);
  CloseFile(ft); Exit;
  END;
 Inc(n); WITH hkldar[n] DO
  BEGIN h:=Round(onl[1]); k:=Round(onl[2]); l:=Round(onl[3]); d:=onl[5];
  END;
 END;
CloseFile(ft);
MakeFormV(200,20,360,430,1); MakeMemo(10,340); {Assign}
WITH Form2.Memo1.Lines DO
 BEGIN Clear; Add('HKL-assignment');
 Add('File     = '+sfn);
 ConvertStr(ddev,7,4); Add('Deviation= '+sedz);
 Add('     D_new    D_table   h    k    l');
 FOR i:=1 TO npk DO
  BEGIN WITH pkar[i] DO computeD(x,y,z,a,th,dnew);
  ConvertStr(dnew,10,4); FOR j:=1 TO n DO WITH hkldar[j] DO
   BEGIN IF((dnew>=(d-ddev))AND(dnew<=(d+ddev)))THEN
    BEGIN ConvertStr(dnew,10,4); s:=sedz; ConvertStr(d,10,4); s:=s+sedz;
    r:=h; ConvertStr(r,5,0); s:=s+sedz;
    r:=k; ConvertStr(r,5,0); s:=s+sedz;
    r:=l; ConvertStr(r,5,0); s:=s+sedz; Add(s);
    END;
   END;
  END;
 END;
Form2.ShowModal;
END;
PROCEDURE smooth3(rl:REAL; VAR cl,sme:REAL);
{Purpose: To smooth the 3-dim.spectrum by 3fold Lanzos algor. }
{Version: Mar 27 1997 }
VAR i,j,k:INTEGER; rrl,fi,fj,fk,ff,rk,dif:REAL; kk:LONGINT;
BEGIN rrl:=AMAX1(AMIN1(rl,1),0);
FOR i:=i1 TO i2 DO FOR j:=j1 TO j2 DO FOR k:=k1 TO k2 DO
 BEGIN ssp[i,j,k]:=sp[i,j,k];
 IF((i > (i1+1))AND(i < (i2-1))AND(j > (j1+1))AND
    (j < (j2-1))AND(k > (k1+1))AND(k < (k2-1)))THEN
  BEGIN fi:=12*(sp[i-1,j,k]+sp[i+1,j,k])-3*(sp[i-2,j,k]+sp[i+2,j,k]);
  fj:=12*(sp[i,j-1,k]+sp[i,j+1,k])-3*(sp[i,j-2,k]+sp[i,j+2,k]);
  fk:=12*(sp[i,j,k-1]+sp[i,j,k+1])-3*(sp[i,j,k-2]+sp[i,j,k+2]);
  ff:=AMAX1((fi+fj+fk+51*sp[i,j,k])/105,0);
  ff:=(1-rrl)*sp[i,j,k]+rrl*ff; ssp[i,j,k]:=ff;
  END;
 END;
{ Compute the closeness and smoothnes }
kk:=(i2-i1+1)*(j2-j1+1)*(k2-k1+1); cl:=0;
FOR i:=i1 TO i2 DO FOR j:=j1 TO j2 DO FOR k:=k1 TO k2 DO
 BEGIN dif:=sp[i,j,k]-ssp[i,j,k]; cl:=cl+SQR(dif);
 END;
rk:=AMAX1(1,kk); cl:=cl/rk; compsmooth(sme); sme:=sme/rk;
END;
PROCEDURE CompAreas(VAR sum:REAL; PB:TProgressBar);
{***  Purpose: To compute the volumes of peaks,  Version: Apr 1 1997  }
VAR ii,iix,i,j,k:INTEGER; ch,r,v,amx,wx0,wy0,wz0,dx,dy,dz:REAL;
BEGIN FOR i:=1 TO npk DO onl[i]:=0;
wx0:=(wxxl+wxxu)*0.5; wy0:=(wyyl+wyyu)*0.5; wz0:=(wzzl+wzzu)*0.5;
FOR k:=k1 TO k2 DO
   BEGIN r:=k-1; r:=r*100/8; PB.Position:=Round(r);
 FOR j:=j1 TO j2 DO FOR i:=i1 TO i2 DO
 BEGIN v:=sp[i,j,k]; amx:=1.E15; FOR ii:=1 TO npk DO WITH pkar[ii] DO
  BEGIN dx:=(i-x)/wx0; dy:=(j-y)/wy0; dz:=(k-z)/wz0;
  r:=SQR(dx)+SQR(dy)+SQR(dz); IF(r < amx)THEN
   BEGIN amx:=r; iix:=ii;
   END;
  END;
 IF(amx < 3)THEN onl[iix]:=onl[iix]+v;
 END;
   END;
{Sort the areas}
sum:=0; FOR i:=1 TO npk DO
 BEGIN pkar[i].V:=onl[i]; sum:=sum+onl[i];
 END;
END;
PROCEDURE DetermineWidths(i,j,k:INTEGER; VAR wx,wy,wz:REAL);
VAR   iw:INTEGER;
      r,xr,xl,yr,yl,zr,zl,ur:REAL; wxl,wxr,wyl,wyr,wzl,wzr:REAL;
LABEL L12,L14,L32,L34,L44,L42;
BEGIN ur:=ssp[i,j,k]*0.5;
xr:=i; FOR iw:=i+1 TO i2 DO  { Find Wx}
 BEGIN r:=ssp[iw,j,k]; IF(r < ur)THEN
  BEGIN xr:=iw-(ur-r)/ABS(r-ssp[iw-1,j,k]); GOTO L32;
  END;
 END;
xr:=i2;
L32: xl:=i; FOR iw:=i-1 DOWNTO i1 DO
 BEGIN r:=ssp[iw,j,k]; IF(r < ur)THEN
  BEGIN xl:=iw+(ur-r)/ABS(r-ssp[iw+1,j,k]); GOTO L34;
  END;
 END;
xl:=i1;
L34: yr:=j; FOR iw:=j+1 TO j2 DO { Find Wy}
 BEGIN r:=ssp[i,iw,k]; IF(r < ur)THEN
  BEGIN yr:=iw-(ur-r)/ABS(r-ssp[i,iw-1,k]); GOTO L12;
  END;
 END;
yr:=j2;
L12: yl:=j; FOR iw:=j-1 DOWNTO j1 DO
 BEGIN r:=ssp[i,iw,k]; IF(r < ur)THEN
  BEGIN yl:=iw+(ur-r)/ABS(r-ssp[i,iw+1,k]); GOTO L14;
  END;
 END;
yl:=j1;
L14: zr:=k; FOR iw:=k+1 TO k2 DO  { Find Wz}
 BEGIN r:=ssp[i,j,iw]; IF(r < ur)THEN
  BEGIN zr:=iw-(ur-r)/ABS(r-ssp[i,j,iw-1]); GOTO L42;
  END;
 END;
zr:=k2;
L42: zl:=k; FOR iw:=k-1 DOWNTO k1 DO
 BEGIN r:=ssp[i,j,iw]; IF(r < ur)THEN
  BEGIN zl:=iw+(ur-r)/ABS(r-ssp[i,j,iw+1]); GOTO L44;
  END;
 END;
zl:=k1;
 { Convert to coordinates and print}
L44: wxr:=xr-i; wxl:=i-xl; wyr:=yr-j; wyl:=j-yl; wzr:=zr-k; wzl:=k-zl;
wx:=AMAX1(AMIN1(wxr+wxl,wxxu),1); wy:=AMAX1(AMIN1(wyr+wyl,wyyu),1);
wz:=AMAX1(AMIN1(wzr+wzl,wzzu),1);
END;
PROCEDURE FindthePeaks(PB:TProgressBar);
{***  Purpose: To search for 3-dimensional peaks Version: Mar 6 1997  }
VAR   ii1,ii2,jj1,jj2,kk1,kk2,ii,jj,kk,i,j,k,nt,np1,jn,kn:INTEGER;
      ok:BOOLEAN; x,y,rr,thr,thr1,s,r,dis:REAL; pkaw:PEAKAR3;
      qux1,qux2,quy1,quy2,quz1,quz2,qux,quy,quz:REAL;
      wh,wh1,wh2,whjn,whkn,pwh,cl,sm:REAL;
      st:STRING[172]; db:TEXTFILE; str:STRING;
LABEL L0,L18,L38,L7,L8,L10,L16,Lerr,Lend;
BEGIN L0rec:='Peak search'; MakeFormV(200,20,340,430,0);
SaveHelp(DFindP_n,DFindP); str:='Set the data for peak search';
OuttoLabel(Form2.Label5,5,30,clGreen,clWhite,str);
strgrW[0]:=150; strgrW[1]:=100;
strgrT[1]:='Smoothing coeff'; strgrNn[1,1]:=rl;
strgrT[2]:='Sensitivity    '; strgrNn[2,1]:=sens;
strgrT[3]:='Resolution     '; strgrNn[3,1]:=res;
strgrT[4]:='Lower N-width  '; strgrNn[4,1]:=wxxl;
strgrT[5]:='Upper N-width  '; strgrNn[5,1]:=wxxu;
strgrT[6]:='Lower X-width  '; strgrNn[6,1]:=wyyl;
strgrT[7]:='Upper X-width  '; strgrNn[7,1]:=wyyu;
strgrT[8]:='Lower Y-width  '; strgrNn[8,1]:=wzzl;
strgrT[9]:='Upper Y-width  '; strgrNn[9,1]:=wzzu;
strgrT[10]:='Min.hypervolume'; strgrNn[10,1]:=hvmin;
PuttoTable(35,50,10,10,1,8);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1;
 ar[1]:=' Find 3-dim. peaks';
 ar[2]:=' Find 1-dim. peaks in convoluted spectrum';
 END;
MakeRadioGroup(1,0,5,270,320,60);

WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 10 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 FOR i:=2 TO 10 DO IF(har[i]<=0)THEN GOTO Lerr;
 IF(NOT rinfun(har[1],0,1))THEN GOTO Lerr;
 rl:=har[1]; sens:=har[2]; res:=har[3]; wxxl:=har[4]; wxxu:=har[5];
 wyyl:=har[6]; wyyu:=har[7]; wzzl:=har[8]; wzzu:=har[9]; hvmin:=har[10];
 i:=RadioGroup1.ItemIndex;
 END;
IF(i=1)THEN
 BEGIN Find1DimPeaks; GOTO Lend;
 END;
smooth3(rl,cl,sm);
{Compress}
FOR k:=k1 TO k2 DO FOR j:=j1+1 TO j2 DO FOR i:=i1+1 TO i2-1 DO
 BEGIN rr:=ssp[i-1,j-1,k]+ssp[i,j-1,k]+ssp[i+1,j-1,k];
 rr:=rr+ssp[i-1,j,k]+ssp[i,j,k]+ssp[i+1,j,k]; ssp[i,j,k]:=rr/6;
 END;
WITH PB DO
 BEGIN Visible:=true; Left:=460; Top:=25; Width:=100;
 END;
{AssignFile(db,'a.sav'); Rewrite(db);  }
{ Main loop}
L0: npk:=0; FOR k:=k1 TO k2 DO
 BEGIN r:=k-1; r:=r*100/8; PB.Position:=Round(r);
 {Graph the spectrum}
 FOR j:=j1 TO j2 DO FOR i:=i1+1 TO i2-1 DO
  BEGIN ok:=true; rr:=ABS(ssp[i,j,k])+1E-3;
  IF(sens>=0)THEN thr:=AMAX1(SQRT(rr)*4,spx*0.03)*ABS(sens)
             ELSE thr:=-sens;
  thr1:=thr*0.5; nt:=0; s:=0;
  { Maximum/minimum condition }
  ii1:=MAX0(i-1,i1); ii2:=MIN0(i+1,i2);
  jj1:=MAX0(j-1,j1); jj2:=MIN0(j+1,j2);
  kk1:=MAX0(k-1,k1); kk2:=MIN0(k+1,k2);
  FOR ii:=ii1 TO ii2 DO FOR jj:=jj1 TO jj2 DO FOR kk:=kk1 TO kk2 DO
   BEGIN nt:=nt+1; s:=s+ABS(ssp[ii,jj,kk]);
   ok:=(ok)AND(rr > ssp[ii,jj,kk]);
   END;
  s:=s/MAX0(nt,1);
  {IF((s > thr1)AND(ABS(rr) > thr))THEN GOTO L18;}
  IF(NOT((ok)AND(ABS(rr) > thr)))THEN GOTO L38;
  IF(ABS(s) < thr1)THEN GOTO L38;
  IF(ABS(s-rr) < SQRT(s+rr)*ABS(sens))THEN GOTO L38;
  { Compute the quasicurvatures  }
  { i-axis   }
  IF((i > i1)AND(i < i2))THEN
   BEGIN qux1:=((ssp[i+1,j,k]-ssp[i-1,j,k])*0.5);{/d1;}
   qux2:=(ssp[i+1,j,k]-2*ssp[i,j,k]+ssp[i-1,j,k]);{ /d12}
   END
                         ELSE IF(i=i1)THEN
   BEGIN qux1:=(ssp[i+1,j,k]-ssp[i,j,k]);{ /d1}
   qux2:=(ssp[i+1,j,k]-2*ssp[i,j,k]);{ /d12}
   END                                ELSE
   BEGIN qux1:=(ssp[i,j,k]-ssp[i-1,j,k]);{ /d1}
   qux2:=(-2*ssp[i,j,k]+ssp[i-1,j,k]);{ /d12}
   END;
  { j-axis   }
  IF((j > j1)AND(j < j2))THEN
   BEGIN quy1:=((ssp[i,j+1,k]-ssp[i,j-1,k])*0.5);{ /d2}
   quy2:=(ssp[i,j+1,k]-2*ssp[i,j,k]+ssp[i,j-1,k]);{ /d22}
   END
                         ELSE IF(j=j1)THEN
    BEGIN quy1:=(ssp[i,j+1,k]-ssp[i,j,k]);{ /d2}
    quy2:=(ssp[i,j+1,k]-2*ssp[i,j,k]);{ /d22}
    END                               ELSE
    BEGIN quy1:=(ssp[i,j,k]-ssp[i,j-1,k]);{ /d2}
    quy2:=(-2*ssp[i,j,k]+ssp[i,j-1,k]);{ /d22}
    END;
  { k-axis   }
  IF((k > k1)AND(k < k2))THEN
   BEGIN quz1:=((ssp[i,j,k+1]-ssp[i,j,k-1])*0.5);{ /d3}
   quz2:=(ssp[i,j,k+1]-2*ssp[i,j,k]+ssp[i,j,k-1]);{ /d32}
   END                   ELSE IF(k=k1)THEN
    BEGIN quz1:=(ssp[i,j,k+1]-ssp[i,j,k]);{ /d3}
    quz2:=(ssp[i,j,k+1]-2*ssp[i,j,k]);{ /d32}
    END                               ELSE
     BEGIN quz1:=(ssp[i,j,k]-ssp[i,j,k-1]);{ /d3}
     quz2:=(-2*ssp[i,j,k]+ssp[i,j,k-1]);{ /d32}
     END;
  { Check the quasi-curvatures}
  qux:=qux2/SQRT(1+SQR(qux1));
  quy:=quy2/SQRT(1+SQR(quy1));
  quz:=quz2/SQRT(1+SQR(quz1));
  IF(AMAX3(ABS(qux),ABS(quy),ABS(quz)) < 3)THEN GOTO L38;
  { If no peak bypass  }
  L18: npk:=MIN0(512,npk+1); pkar[npk].x:=i; pkar[npk].y:=j;
  pkar[npk].z:=k; pkar[npk].V:=sp[i,j,k];
  x:=AMAX3(ABS(qux),ABS(quy),ABS(quz)); y:=(ABS(qux)+ABS(quy)+ABS(quz));
  {Writeln(db,i:4,j:3,k:3,rr:7:1,s:8:1,qux:7:1,quy:7:1,quz:7:1,
  x:6:1,y:6:1); }
  L38:;
  END;
 END;
{CloseFile(db); }

IF(npk>50)THEN
 BEGIN
 i:=MessageDlg('Too many peaks found = '+InttoStr(npk)+' Proceed? ',
 mtWarning,[mbYes,mbNo,mbRetry],0);
 IF(i=mrRetry)THEN
  BEGIN sens:=sens+0.1; GOTO L0;
  END;
 IF(i<>mrYes)THEN
  BEGIN npk:=0; PB.Visible:=false; Exit;
  END;
 END;
{ Check for the resolution}
np1:=npk; FOR i:=2 TO npk DO
 BEGIN dis:=1E12; FOR j:=1 TO np1 DO
  BEGIN IF(pkar[j].x=0)THEN GOTO L8; FOR k:=1 TO np1 DO
   BEGIN IF((k=j)OR(pkar[k].x=0))THEN GOTO L10;
   r:=SQRT(SQR((pkar[j].x-pkar[k].x)/(wxxl+wxxu))+
           SQR((pkar[j].y-pkar[k].y)/(wyyl+wyyu))+
           SQR((pkar[j].z-pkar[k].z)/(wzzl+wzzu)));
   IF(r<dis)THEN
    BEGIN dis:=r; jn:=j; kn:=k;
    END;
   L10:;
   END;
  L8:;
  END;
 IF(dis > res)THEN GOTO L16;
 { Merge too close peaks in a weighted way}
 whjn:=pkar[jn].wx; whkn:=pkar[kn].wx; wh:=AMAX1(1,whjn+whkn);
 wh1:=whjn/wh; wh2:=whkn/wh;
 pwh:=wh1*pkar[jn].x+wh2*pkar[kn].x;
 IF(wh1 > wh2)THEN
  BEGIN pkar[jn].x:=pwh; pkar[kn].x:=0;
  END         ELSE
   BEGIN pkar[kn].x:=pwh; pkar[jn].x:=0;
   END;
 pwh:=wh1*pkar[jn].y+wh2*pkar[kn].y;
 IF(wh1 > wh2)THEN
  BEGIN pkar[jn].y:=pwh; pkar[kn].y:=0;
  END         ELSE
   BEGIN pkar[kn].y:=pwh; pkar[jn].y:=0;
   END;
 pwh:=wh1*pkar[jn].z+wh2*pkar[kn].z;
 IF(wh1 > wh2)THEN
  BEGIN pkar[jn].z:=pwh; pkar[kn].z:=0;
  END         ELSE
   BEGIN pkar[kn].z:=pwh; pkar[jn].z:=0;
   END;
 jj:=0; FOR ii:=1 TO np1 DO WITH pkar[ii] DO
 IF((x*y*z)<>0)THEN
  BEGIN Inc(jj); pkar[jj]:=pkar[ii];
  END;
 np1:=jj;
 END;
L16: npk:=np1;
{ Find the width-intervals}
FOR  ii:=1 TO npk DO
 BEGIN i:=Round(pkar[ii].x); j:=Round(pkar[ii].y); k:=Round(pkar[ii].z);
 DetermineWidths(i,j,k,wx,wy,wz);
 pkar[ii].wx:=wx; pkar[ii].wy:=wy; pkar[ii].wz:=wz;
 END;
{Sort the peaks}
FOR i:=1 TO npk DO FOR j:=1 TO npk DO
 IF(pkar[i].x<pkar[j].x)THEN
  BEGIN pkaw:=pkar[j]; pkar[j]:=pkar[i]; pkar[i]:=pkaw;
  END;
CompAreas(sum,PB);
Lend: PB.Visible:=false;
r:=npk; ConvertStr(r,5,0); ShowMess(sedz+' peaks have been found');
{ShowthePeaks1.Enabled:=true; Showtheds1.Enabled:=true;}
nosaved:=true; Exit;
Lerr: ShowMess('Wrong search data');
END;
PROCEDURE TransformtoReversedSpace;
{***  Purpose: To transform the intensity distribution to reversed }
{     space coordinates.   Version: Apr 22 1997 }
VAR i,j,k,nx,ny,it,ix,iy,lx,ly:INTEGER; rx,ry,spc:REAL;
BEGIN nx:=32; ny:=8; rx:=mx2; rx:=rx/(nx*mN2); ry:=my2; ry:=ry/(ny*mN2);
lx:=1024 DIV 32; ly:=1024 DIV 8;
IF(NOT norevers)THEN
 BEGIN ShowMess('The spectrum (and peaks) already reversed'); Exit;
 END;
FOR i:=1 TO npk DO { Reverse the Found Peaks  }
 BEGIN it:=mN2-Trunc(pkar[i].x);    { time-of-flight}
 ix:=mN2+Trunc(pkar[i].x*pkar[i].y*rx+0.5); { x-angle}
 iy:=mN2-Trunc(pkar[i].x*pkar[i].z*ry+0.5); { y-angle}
 ix:=ix-mN2+1; iy:=iy-mN2+my2+1;
 pkai[i].x:=it; pkai[i].y:=ix; pkai[i].z:=iy; pkai[i].V:=pkar[i].V;
 END;
{Reverse the spectrum}
FOR i:=mN1 TO mN2 DO FOR j:=mx1 TO mx2 DO FOR k:=my1 TO my2 DO
 ssp[i,j,k]:=0;
FOR k:=k1 TO k2 DO FOR j:=j1 TO j2 DO FOR i:=i1 TO i2 DO
 BEGIN spc:=sp[i,j,k]; { Recompute the coordinates }
 it:=mN2-i;                 { time-of-flight}
 ix:=mN2+Trunc(i*j*rx+0.5); { x-angle}
 iy:=mN2-Trunc(i*k*ry+0.5); { y-angle}
 ix:=ix-mN2; iy:=iy-mN2+my2; ix:=ix+1; iy:=iy+1;
 IF((it>=i1)AND(it<=i2)AND(ix>=j1)AND(ix<=j2)AND(iy>=k1)AND
 (iy<=k2))THEN ssp[it,ix,iy]:=ssp[it,ix,iy]+Round(spc+0.5);
 END;
FOR k:=k1 TO k2 DO FOR j:=j1 TO j2 DO FOR i:=i1 TO i2 DO
 BEGIN spc:=ssp[i,j,k]; sp[i,j,k]:=Round(spc);
 END;
fismax3(0); Convolute; SetTheMaxima;
ShowMess(' Spectrum  ->  reversed space'); norevers:=false;
END;
PROCEDURE SmooththeSpectrum;
{Purpose: To smooth the 3-dim.spectrum by 3fold Lanzos algor. }
{Version: Mar 27 1997 }
VAR i,j,k:INTEGER; cl,sme,rrl,fi,fj,fk,ff,rk,dif:REAL; kk:LONGINT;
BEGIN L0rec:='Smoothing'; MakeFormV(200,20,330,430,0{no save});
SaveHelp(SmooSp_n,SmooSp);
s:=' Enter the smoothing coefficient';
L1rec:=' coefficient      = '; E1rec:=FloatToStr(rl);
OuttoLabel(Form2.Label5,5,30,clGreen,clWhite,s);
MakeEdits(50,200,60,70,1);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; Zval(Edit1.Text,r);
 IF(r<=0)THEN
  BEGIN ShowMess('Error, wrong smoothing coefficient'); Exit;
  END;
 END;
rl:=r; smooth3(rl,cl,sme);
MakeFormV(200,20,330,430,0); WITH LB1rec DO
 BEGIN nitems:=4;
 ar[1]:='The spectrum has been smoothed';
 ConvertStr(rl,10,3); ar[2]:='rl = '+sedz;
 ConvertStr(cl,10,3); ar[3]:='chi2 = '+sedz;
 ConvertStr(sme,10,3); ar[4]:='smoothness = '+sedz;
 END;
MakeListBox(20,40,270,120); Form2.ShowModal;
END;
PROCEDURE compsmooth(VAR sm:REAL);
{***  Purpose: To compute the smoothness,  Version: Mar 27 1997 }
VAR i,j,k,kk:INTEGER; dfi,dfj,dfk,dfii,dfjj,dfkk:REAL;
BEGIN sm:=0; FOR i:=i1+1 TO i2-1 DO
FOR j:=j1+1 TO j2-1 DO FOR k:=k1+1 TO k2-1 DO
 BEGIN dfi:=sp[i+1,j,k]-ssp[i,j,k]; dfj:=ssp[i,j+1,k]-ssp[i,j,k];
 dfk:=ssp[i,j,k+1]-ssp[i,j,k];
 dfii:=ssp[i+1,j,k]-2*ssp[i,j,k]+ssp[i-1,j,k];
 dfjj:=ssp[i,j+1,k]-2*ssp[i,j,k]+ssp[i,j-1,k];
 dfkk:=ssp[i,j,k+1]-2*ssp[i,j,k]+ssp[i,j,k-1];
 sm:=sm+(SQR(dfii)+SQR(dfjj)+SQR(dfkk))/(1+SQR(dfi)+SQR(dfj)+SQR(dfk));
 END;
END;
{-----------------------------------------------}
BEGIN;
END.
