UNIT vedz4;
{Purpose: to perform least square fitting;
Version: Dec 31 1996; Mar 23 2000, May 7 2000: no anp;
         Jan 19 2001: other mem.alloc.,
         Nov 25 2001: no newton;  class: Mar 26 2002}
INTERFACE
USES vzlocom, Dialogs, SysUtils;
{-----------------------------------------------}
CONST MIKZ_FNT1:ARRAY[1..720] OF STRING[8] =
{ 128 - 175,  8 * 14}
('128',
'........',
'........',
'...111..',
'..11.11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.111111.',
'.11..11.',
'.11..11.',
'.11..11.',
'........',
'........',
'........',
'129',
'........',
'........',
'.111111.',
'.11.....',
'.11.....',
'.11.....',
'.11111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11111..',
'........',
'........',
'........',
'130',
'........',
'........',
'.11111..',
'.11..11.',
'.11..11.',
'.11..1..',
'.1111...',
'.11..1..',
'.11..11.',
'.11..11.',
'.11111..',
'........',
'........',
'........',
'131',
'........',
'........',
'.111111.',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'........',
'........',
'........',
'132',
'........',
'........',
'..1111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'11111111',
'1......1',
'........',
'........',
'133',
'........',
'........',
'.111111.',
'.11.....',
'.11.....',
'.11.....',
'.11111..',
'.11.....',
'.11.....',
'.11.....',
'.111111.',
'........',
'........',
'........',
'134',
'........',
'........',
'1..11..1',
'.1.11.1.',
'.1.11.1.',
'.1.11.1.',
'..1111..',
'.1.11.1.',
'.1.11.1.',
'.1.11.1.',
'1..11..1',
'........',
'........',
'........',
'135',
'........',
'........',
'..1111..',
'.1...11.',
'.....11.',
'.....1..',
'...11...',
'.....1..',
'.....11.',
'.1...11.',
'..1111..',
'........',
'........',
'........',
'136',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11.111.',
'.111.11.',
'.11..11.',
'.11..11.',
'.11..11.',
'........',
'........',
'........',
'137',
'........',
'...11...',
'.1....1.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11.111.',
'.111.11.',
'.11..11.',
'.11..11.',
'.11..11.',
'........',
'........',
'........',
'138',
'........',
'........',
'.11...1.',
'.11..1..',
'.11.1...',
'.111....',
'.11.....',
'.111....',
'.11.1...',
'.11..1..',
'.11...1.',
'........',
'........',
'........',
'139',
'........',
'........',
'..11111.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'11...11.',
'........',
'........',
'........',
'140',
'........',
'........',
'.1....1.',
'.1....1.',
'.11..11.',
'.1.11.1.',
'.1.11.1.',
'.1....1.',
'.1....1.',
'.1....1.',
'.1....1.',
'........',
'........',
'........',
'141',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.111111.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'........',
'........',
'........',
'142',
'........',
'........',
'..1111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'..1111..',
'........',
'........',
'........',
'143',
'........',
'........',
'.111111.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'........',
'........',
'........',
'144',
'........',
'........',
'.11111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11111..',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'........',
'........',
'........',
'145',
'........',
'........',
'..1111..',
'.11...1.',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11...1.',
'..1111..',
'........',
'........',
'........',
'146',
'........',
'........',
'.111111.',
'...11...',
'...11...',
'...11...',
'...11...',
'...11...',
'...11...',
'...11...',
'...11...',
'........',
'........',
'........',
'147',
'........',
'........',
'.11...11',
'.11...11',
'.11..11.',
'..1..1..',
'...11...',
'...1....',
'..1.....',
'.1......',
'.1......',
'........',
'........',
'........',
'148',
'........',
'........',
'...11...',
'.111111.',
'1..11..1',
'1..11..1',
'1..11..1',
'.111111.',
'...11...',
'...11...',
'...11...',
'........',
'........',
'........',
'149',
'........',
'........',
'.1....1.',
'..1..1..',
'..1..1..',
'...11...',
'...11...',
'...11...',
'..1..1..',
'..1..1..',
'.1....1.',
'........',
'........',
'........',
'150',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.1111111',
'.......1',
'........',
'........',
'151',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.111111.',
'.....11.',
'.....11.',
'.....11.',
'.....11.',
'........',
'........',
'........',
'152',
'........',
'........',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.11111..',
'........',
'........',
'........',
'153',
'........',
'........',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.111111.',
'......1.',
'........',
'........',
'154',
'........',
'........',
'.111....',
'..11....',
'..11....',
'..11....',
'..1111..',
'..11..1.',
'..11..1.',
'..11..1.',
'..1111..',
'........',
'........',
'........',
'155',
'........',
'........',
'.11...1.',
'.11...1.',
'.11...1.',
'.11...1.',
'.111..1.',
'.11.1.1.',
'.11.1.1.',
'.11.1.1.',
'.111..1.',
'........',
'........',
'........',
'156',
'........',
'........',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11111..',
'.11...1.',
'.11...1.',
'.11...1.',
'.11111..',
'........',
'........',
'........',
'157',
'........',
'........',
'.11111..',
'.....11.',
'.....11.',
'.....11.',
'..11111.',
'.....11.',
'.....11.',
'.....11.',
'.11111..',
'........',
'........',
'........',
'158',
'........',
'........',
'.1..11..',
'.1.1..1.',
'.1.1..1.',
'.1.1..1.',
'.111..1.',
'.1.1..1.',
'.1.1..1.',
'.1.1..1.',
'.1..11..',
'........',
'........',
'........',
'159',
'........',
'........',
'..11111.',
'.11..11.',
'.11..11.',
'.11..11.',
'..11111.',
'....111.',
'...1.11.',
'..1..11.',
'.1...11.',
'........',
'........',
'........',
'160',
'........',
'........',
'........',
'........',
'..1111..',
'.....11.',
'.....11.',
'..11111.',
'.11..11.',
'.11..11.',
'..1111.1',
'........',
'........',
'........',
'161',
'........',
'........',
'......1.',
'.....11.',
'...11...',
'..11....',
'.11111..',
'.11..11.',
'.11..11.',
'.11..11.',
'..1111..',
'........',
'........',
'........',
'162',
'........',
'........',
'........',
'........',
'.11111..',
'.11..11.',
'.11..11.',
'.11111..',
'.11..11.',
'.11..11.',
'.11111..',
'........',
'........',
'........',
'163',
'........',
'........',
'........',
'........',
'.111111.',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'.11.....',
'........',
'........',
'........',
'164',
'........',
'........',
'........',
'........',
'..1111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'11111111',
'1......1',
'........',
'........',
'165',
'........',
'........',
'........',
'........',
'..1111..',
'.11..11.',
'.11..11.',
'.111111.',
'.11.....',
'.11..11.',
'..1111..',
'........',
'........',
'........',
'166',
'........',
'........',
'........',
'........',
'1..11..1',
'.1.11.1.',
'.1.11.1.',
'..1111..',
'.1.11.1.',
'.1.11.1.',
'1..11..1',
'........',
'........',
'........',
'167',
'........',
'........',
'........',
'........',
'..1111..',
'.1...11.',
'.....11.',
'...111..',
'.....11.',
'.1...11.',
'..1111..',
'........',
'........',
'........',
'168',
'........',
'........',
'........',
'........',
'.11...1.',
'.11...1.',
'.11..11.',
'.11.111.',
'.111.11.',
'.11..11.',
'.1...11.',
'........',
'........',
'........',
'169',
'........',
'........',
'....1...',
'...1....',
'.11...1.',
'.11..11.',
'.11.111.',
'.111.11.',
'.11..11.',
'.1...11.',
'.1...11.',
'........',
'........',
'........',
'170',
'........',
'........',
'........',
'........',
'.11...1.',
'.11..1..',
'.11.1...',
'.111....',
'.11.1...',
'.11..1..',
'.11...1.',
'........',
'........',
'........',
'171',
'........',
'........',
'........',
'........',
'..1111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'11...11.',
'........',
'........',
'........',
'172',
'........',
'........',
'........',
'........',
'.1....1.',
'.1....1.',
'.11..11.',
'.1.11.1.',
'.1....1.',
'.1....1.',
'.1....1.',
'........',
'........',
'........',
'173',
'........',
'........',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'.111111.',
'.11..11.',
'.11..11.',
'.11..11.',
'........',
'........',
'........',
'174',
'........',
'........',
'........',
'........',
'..1111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'..1111..',
'........',
'........',
'........',
'175',
'........',
'........',
'........',
'........',
'.111111.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'........',
'........',
'........');

CONST MIKZ_FNT2:ARRAY[1..240] OF STRING[8] =
{ 224 - 239,  8 * 14}
('224',
'........',
'........',
'........',
'........',
'.11111..',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11111..',
'.11.....',
'.11.....',
'.11.....',
'........',
'225',
'........',
'........',
'........',
'........',
'..1111..',
'.11..11.',
'.11.....',
'.11.....',
'.11.....',
'.11..11.',
'..1111..',
'........',
'........',
'........',
'226',
'........',
'........',
'........',
'........',
'.111111.',
'...11...',
'...11...',
'...11...',
'...11...',
'...11...',
'...11...',
'........',
'........',
'........',
'227',
'........',
'........',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'..11.11.',
'...111..',
'....1...',
'...1....',
'..1.....',
'..1.....',
'........',
'228',
'........',
'........',
'........',
'...11...',
'...11...',
'..1111..',
'.1.11.1.',
'.1.11.1.',
'.1.11.1.',
'..1111..',
'...11...',
'...11...',
'...11...',
'........',
'229',
'........',
'........',
'........',
'........',
'.1....1.',
'..1..1..',
'...11...',
'...11...',
'...11...',
'..1..1..',
'.1....1.',
'........',
'........',
'........',
'230',
'........',
'........',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.11..11.',
'.1111111',
'.......1',
'........',
'........',
'231',
'........',
'........',
'........',
'........',
'.11..11.',
'.11..11.',
'.11..11.',
'.111111.',
'.....11.',
'.....11.',
'.....11.',
'........',
'........',
'........',
'232',
'........',
'........',
'........',
'........',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.11111..',
'........',
'........',
'........',
'233',
'........',
'........',
'........',
'........',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.1.1.1..',
'.111111.',
'......1.',
'........',
'........',
'234',
'........',
'........',
'........',
'........',
'111.....',
'.11.....',
'.11.....',
'.11111..',
'.11...1.',
'.11...1.',
'.11111..',
'........',
'........',
'........',
'235',
'........',
'........',
'........',
'........',
'.11...1.',
'.11...1.',
'.11...1.',
'.111..1.',
'.11.1.1.',
'.11.1.1.',
'.111..1.',
'........',
'........',
'........',
'236',
'........',
'........',
'........',
'........',
'.11.....',
'.11.....',
'.11.....',
'.11111..',
'.11...1.',
'.11...1.',
'.11111..',
'........',
'........',
'........',
'237',
'........',
'........',
'........',
'........',
'.11111..',
'.....11.',
'.....11.',
'..11111.',
'.....11.',
'.....11.',
'.11111..',
'........',
'........',
'........',
'238',
'........',
'........',
'........',
'........',
'.1..11..',
'.1.1..1.',
'.1.1..1.',
'.111..1.',
'.1.1..1.',
'.1.1..1.',
'.1..11..',
'........',
'........',
'........',
'239',
'........',
'........',
'........',
'........',
'..11111.',
'.11..11.',
'.11..11.',
'..11111.',
'...1111.',
'..11.11.',
'.11..11.',
'........',
'........',
'........');
IMPLEMENTATION
BEGIN
END.
