UNIT vmriacry;
INTERFACE
USES Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,   vzlocom,  varfun,   vmria0,
     vmria2,  vmriasgm, vmriasp,  vmriahkl,vmriahlp, vspectr, vpmodel,
     vstdcons,vmria00;

PROCEDURE EnterPhaseInformation(mo:INTEGER);
PROCEDURE EnterAtomicInformation;
PROCEDURE Formhkls;
PROCEDURE Inputhkls;
PROCEDURE EnterCrystalInfo;
PROCEDURE EnterSpaceGroupInfo(iph,mo:INTEGER);
PROCEDURE FindXYZC(VAR s:STRING; ch:CHAR; VAR x:REAL);
PROCEDURE EnterTransformation(VAR st:STRING; il,iph:INTEGER);
PROCEDURE ShowSpectrumIntervals(x,y:INTEGER);
PROCEDURE FormHKL;
PROCEDURE BubbleSortHKLs;
PROCEDURE SetScreenSpaceGroup(iph:INTEGER);
PROCEDURE PurgeSupHKLs;
PROCEDURE Get_h0k0l0(iph:INTEGER);

IMPLEMENTATION
PROCEDURE Get_h0k0l0(iph:INTEGER);
{Get plane normal to magnetic moment}
BEGIN WITH lat[iph] DO
 BEGIN r:=radian; IF(syng=5)THEN
  BEGIN h0:=0; k0:=0; l0:=1; Exit;
  END;
 h0:=COS(har[1]/r); k0:=COS(har[2]/r); l0:=COS(har[3]/r);
 END;
END;
{IF(har[1]=0)THEN
  BEGIN h0:=1; k0:=0; l0:=0; Exit;
  END;
 IF(har[2]=0)THEN
  BEGIN h0:=0; k0:=1; l0:=0; Exit;
  END;
 IF(har[3]=0)THEN
  BEGIN h0:=0; k0:=0; l0:=1; Exit;
  END;
IF(har[1]=0)THEN fix1:=1 ELSE IF(har[2]=0)THEN fix1:=2 ELSE fix1:=3;
 fh:=0; fk:=0; fl:=0;
step:=0.1;  FOR i:=1 TO 3 DO har[i]:=COS(har[i]/r);
WITH lat[iph].lpi DO
 BEGIN al:=COS(alpha/r); be:=COS(beta/r); ga:=COS(gamma/r);
 END;
ch:=1E15; h1:=-50; k1:=-50; l1:=-50; h2:=50; k2:=50; l2:=50; it:=0;
CASE fix1 OF
1: BEGIN h1:=1; h2:=1;
   END;
2: BEGIN k1:=1; k2:=1;
   END;
3: BEGIN l1:=1; l2:=1;
   END;
ELSE END;
WITH lat[iph] DO WITH lat[iph].lpi DO
 BEGIN
 REPEAT FOR i:=h1 TO h2 DO FOR j:=k1 TO k2 DO FOR k:=l1 TO l2 DO
  BEGIN h0:=fh+i*step; k0:=fk+j*step; l0:=fl+k*step;
  CASE fix1 OF
  1: h0:=0.5;
  2: k0:=0.5;
  3: l0:=0.5;
  ELSE END;
  Q:=SQRT(ABS((o11*h0+o12*k0+o13*l0)*h0+(o22*k0+o23*l0)*k0+o33*l0*l0));
  r1:=(a*h0+b*ga*k0+c*be*l0)/Q;
  r2:=(a*ga*h0+b*k0+c*al*l0)/Q;
  r3:=(a*be*h0+b*al*k0+c*l0)/Q;
  dif:=AMAX3(ABS(har[1]-r1),ABS(har[2]-r2),ABS(har[3]-r3));
  IF(dif<ch)THEN
   BEGIN ch:=dif; hx:=h0; kx:=k0; lx:=l0;
   END;
  END;
 fh:=hx-0.5; fk:=kx-0.5; fl:=lx-0.5; step:=0.01; Inc(it);
 UNTIL it=2;
 h0:=hx; k0:=kx; l0:=lx;
 IF(ch>=0.1)THEN ShowMess('Angles may be little compatible');
 END;
END;}
 {End of refinement loop}
{DEBUG!!!} {Writeln(fout,har[1]:9:3,har[2]:9:3,har[3]:9:3);}
 {DEBUG!!!}{Writeln(fout,ch:9:3,h0:9:3,kx:9:3,lx:9:2,Q:9:3,' <-d0');}
{DEBUG!!!} {Writeln(fout,'cos= ',har[1]:9:3,har[2]:9:3,har[3]:9:3 );}
PROCEDURE EnterPhaseInformation(mo:INTEGER);
{mo=1  -> only unit cell info needed
 mo=2  -> only space group info needed
 mo=0  -> both needed }
VAR   i,j,k,iph,n,nn:INTEGER; ok:BOOLEAN; sph:STRING;
LABEL L1,Lend;
BEGIN SaveHelp(EntPhInf_n,EntPhInf);
FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN L0rec:='Phase information'; MakeForm(1);
 s:=' Specify the unit cell info';
 IF(nph>1)THEN s:=s+' for phase '+IntToStr(iph)+' ';
 IF(mo<>1)THEN
  BEGIN OuttoLabel(Form2.Label5,5,5,clTeal,clWhite,s);
  strgrW[0]:=180; strgrW[1]:=70;
  strgrT[1]:='Space group number ='; r:=nsg; strgrNn[1,1]:=r;
  strgrT[2]:='Setting =';  r:=AMAX0(sett,1); strgrNn[2,1]:=r;
  PuttoTable(30,22,2,2,1,8);
  OuttoLabel(Form2.Label7,30,300,clTeal,clWhite,
   ' See Help for non-standard group');
  WITH CB1rec DO
   BEGIN nitems:=3;
   ar[1]:=''; IF(iph>1)THEN ar[1]:=' The phase is MAGNETIC ';
   s:=' Non-standard space group from ';
   ar[2]:=s+'a file '; ar[3]:=s+'the screen ';
   END;
  MakeCheckListBox(6,316,300,55); WITH Form2.CheckListBox1 DO
   BEGIN FOR i:=0 TO 2 DO Checked[i]:=false;
   IF(keyma[iph]=1)THEN ok:=true ELSE ok:=false;
   IF(ok)THEN   {Magnetic}
    BEGIN Checked[0]:=ok;
    Checked[1]:=nonssgfl; Checked[2]:=nonssgsc; {for non-stand.gr}
    END;
   END;
  END;
 OuttoLabel(Form2.Label6,5,90,clTeal,clWhite,
  'Specify the symmetry if needed');
 WITH CB1rec DO
  BEGIN nitems:=7; indx:=syng;
  FOR i:=1 TO 7 DO ar[i]:=
   ' '+syngar[i,0]+'  '+syngar[i,1]+'  '+syngar[i,2];
  END;
 MakeCombo(30,107,255); iph_gl:=iph;
 MaketheButton(Form2.Button10,70,135,175,20,'Show the Space Group');
 MaketheButton(Form2.Button11,70,155,175,20,'Find the Space Group');

 WITH CB1rec DO
  BEGIN nitems:=7; indx:=lat[iph].nlatt+1;
  FOR i:=1 TO nitems DO ar[i]:=' Type '+nlatar[i];
  END;
 OuttoLabel(Form2.Label3,5,180,clTeal,clWhite,
  ' Select lattice type ');
 MakeRadioGroup(1,2,30,197,255,90);

 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  syng:=ComboBox1.ItemIndex+1; nlatt:=RadioGroup1.ItemIndex;
  IF(NOT CheckSyng_Latt(syng,nlatt))THEN
   ShowMess('Symmetry and Bravais type incompatible');
  IF(mo=1)THEN CONTINUE; {No space group info needed}
  FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
  WITH CheckListBox1 DO
   BEGIN nonssgfl:=Checked[1]; nonssgsc:=Checked[2];
   END;
  END;
 IF((har[2]=0)OR(har[2]=1.001))THEN
  BEGIN ShowMess('Wrong setting'); Exit;
  END;
 IF((har[1]=0)OR(har[1]=1.001))THEN
  BEGIN ShowMess('Error, wrong space group'); Exit;
  END;
 k:=Round(har[1]); j:=Round(har[2]);
 ok:=false; IF(j=2)THEN
  BEGIN FOR i:=1 TO 44 DO IF(k=isetar[i])THEN ok:=true;
  IF(NOT ok)THEN
   BEGIN ShowMess('No 2nd setting for '+IntToStr(k)); ModalRes:=0;
   Exit;
   END;
  END;
 nsg:=k; sett:=j; ModalRes:=1; WITH Form2.CheckListBox1 DO
  BEGIN keyma[iph]:=0; IF(Checked[0])THEN keyma[iph]:=1;
  {ok:=NOT(nonssgfl OR nonssgsc); IF(ok AND(keyma[iph]=1))THEN
   BEGIN s:='Is non-standard space group needed for magnetic phase?';
   i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0);
   IF(i=mrYes)THEN nonssgsc:=true;
   END;}
  i:=syngon(nsg,sett); IF(NOT(nsg IN [143..194]))THEN syng:=i;
  IF(i<>syng)THEN
   BEGIN s:='Warning, improper symmetry for this space group'+crc+
             'for '+syngar[i,2]+' better '+syngar[i,0]+' Replace?';
   j:=MessageDlg(s,MtWarning,[mbYes,mbNo],0);
   IF(j=mrYes)THEN syng:=i;
   END;
  IF(nonssgsc)THEN SetScreenSpaceGroup(iph) ELSE
  IF(nonssgfl)THEN EnterSpaceGroupInfo(iph,0)
              ELSE SetSpaceGroupInfo(iph);
  END;
 IF(ModalRes=0)THEN Exit;
 END;
IF(mo=2)THEN GOTO Lend;
L0rec:='Check lattice information';
MakeForm(1);
FOR iph:=1 TO nph DO WITH lat[iph] DO {Form the phase information}
 BEGIN strgrT[1]:=' A (Angs) ='; strgrNn[1,1]:=lpd.a;
 strgrW[0]:=180; strgrW[1]:=80;
 s:='Enter '+syngar[syng,0]+' cell parameters, ';
 sph:='phase '+IntToStr(iph)+' '; s:=s+sph;
 OuttoLabel(Form2.Label5,5,20,clGreen,clWhite,s);
 WITH lpd DO GetAlBeGa(alpha,beta,gamma,syng);
 CASE syng OF
 1: BEGIN n:=6; strgrT[2]:=' B (Angs) =';
    strgrT[3]:=' C (Angs) ='; strgrT[4]:=' alpha (Deg) =';
    strgrT[5]:=' beta (Deg) ='; strgrT[6]:=' gamma (Deg) =';
    strgrNn[2,1]:=lpd.b; strgrNn[3,1]:=lpd.c;
    r:=lpd.alpha; IF(r=0)THEN r:=90; strgrNn[4,1]:=r;
    r:=lpd.beta;  IF(r=0)THEN r:=90; strgrNn[5,1]:=r;
    r:=lpd.gamma; IF(r=0)THEN r:=90; strgrNn[6,1]:=r;
    END;
 2: BEGIN n:=4; strgrT[2]:=' B (Angs) ='; strgrT[3]:=' C (Angs) =';
    IF(sett=1)THEN strgrT[4]:=' gamma (Deg) ='
              ELSE strgrT[4]:=' beta (Deg) =';
    strgrNn[2,1]:=lpd.b; strgrNn[3,1]:=lpd.c;
    IF(sett=1)THEN strgrNn[4,1]:=lpd.gamma
              ELSE strgrNn[4,1]:=lpd.beta;
    END;
 3: BEGIN n:=3; strgrT[2]:=' B (Angs) ='; strgrT[3]:=' C (Angs) =';
    strgrNn[2,1]:=lpd.b; strgrNn[3,1]:=lpd.c;
    END;
 4: BEGIN n:=2; strgrT[2]:=' C (Angs) ='; strgrNn[2,1]:=lpd.c;
    END;
 5: n:=1;
 6: BEGIN n:=2; strgrT[2]:=' C (Angs) ='; strgrNn[2,1]:=lpd.c;
    END;
 7: BEGIN n:=2; strgrT[2]:=' alpha (Deg) ='; strgrNn[2,1]:=lpd.alpha;
    END;
 ELSE END;
 PuttoTable(20,55,n,n,1,8);
 {Get the data}Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO n DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 lp.a:=har[1];
 WITH lp DO
 CASE syng OF
 1: BEGIN lp.b:=har[2]; lp.c:=har[3];
    lp.alpha:=har[4]; lp.beta:=har[5]; lp.gamma:=har[6];
    END;
 2: BEGIN lp.b:=har[2]; lp.c:=har[3];
    IF(sett=1)THEN
     BEGIN lp.gamma:=har[4]; lp.beta:=90;
     END      ELSE
      BEGIN lp.beta:=har[4]; lp.gamma:=90;
      END;
    END;
 3: BEGIN lp.b:=har[2]; lp.c:=har[3];
    END;
 4: BEGIN lp.b:=har[1]; lp.c:=har[2];
    END;
 5: BEGIN r:=har[1]; lp.b:=r; lp.c:=r;
    END;
 6: BEGIN lp.b:=har[1]; lp.c:=har[2];
    END;
 7: BEGIN r:=har[1]; lp.a:=r; lp.b:=r; lp.c:=r;
    r:=har[2]; lp.alpha:=r; lp.beta:=r; lp.gamma:=r;
    END;
 ELSE END;
 WITH lp DO GetAlBeGa(alpha,beta,gamma,syng);
 WITH lp DO IF((a*b*c=0)OR(alpha*beta*gamma=0))THEN
  BEGIN ShowMess('Wrong unit cell parameters'); ModalRes:=0; Exit;
  END;
 lpd:=lp; lpd0:=lpd; vol:=getvol(lpd); vol0:=vol;
 InverseLatPar(lpd,lpi,voli,0); FormLatMatrix(iph);
 WITH lat[iph] DO Writeln(fout,'Phase ',iph:1,':  Space group= ',nsg:3,
  '  Setting= ',sett:1,' Volume= ',lat[iph].vol:7:1);
 WITH lp DO Writeln(fout,syngar[syng,0],' cell =',
  a:9:4,b:9:4,c:9:4,alpha:7:2,beta:7:2,gamma:7:2);
 {Enter plane h0,k0,l0 if magnetic}
 IF(keyma[iph]=1)THEN
  BEGIN s:='Set mag.moment angles, '+sph;
  OuttoLabel(Form2.Label5,5,20,clGreen,clWhite,s);
  GetMagMomAngles(iph,0);
  strgrT[1]:='Phi_a (deg) = '; strgrNn[1,1]:=har[1];
  strgrT[2]:='Phi_b (deg) = '; strgrNn[2,1]:=har[2];
  strgrT[3]:='Phi_c (deg) = '; strgrNn[3,1]:=har[3];
  PuttoTable(20,55,3,3,1,8);
  Form2.ShowModal; IF(ModalRes=0)THEN Exit; r:=radian;
  FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
  r:=0; FOR i:=1 TO 3 DO r:=r+ABS(har[i]);
  IF(r=0)THEN ShowMess('Mag.moment=0');
  Get_h0k0l0(iph);
  END;
 WITH lpd DO
  BEGIN ascx:=a; bscx:=b; cscx:=c;
  END;
 END;
SetNoPrep(7,true);
Lend:nophasi:=false;
END;
PROCEDURE EnterAtomicInformation;
VAR   i,j,k,iph,n,ii,jj:INTEGER; s:STRING; ss:STRING[3];
      ok,viewv:BOOLEAN; copOk:ARRAY[0..3] OF BOOLEAN;
CONST plco:STRING = '+++++++';
LABEL L2,L1,L3,NoMag;
{**************}
BEGIN IF(nophasi)THEN
 BEGIN ShowMess('Error, no phase information'); Exit;
 END;
SaveHelp(EntAtInf_n,EntAtInf); FOR iph:=1 TO nph DO WITH lat[iph] DO
 BEGIN L0rec:='Enter or Edit the atom list;   phase = '+IntToStr(iph);
 MakeForm(1); MakeMemo(20,270);
 s:='Tick magnetic atoms by =  ,e.g. Mn='; IF(iph<nph)THEN
  OuttoLabel(Form2.Label5,30,282,clGreen,clWhite,s);

 WITH Form2 DO
  BEGIN Memo1.Height:=exs(280); WITH CB1rec DO
   BEGIN nitems:=4; ar[1]:='Copy all atoms to the next phase';
   ar[2]:='Make full atom set for the next phase';
   ar[3]:='Copy magnetic atoms to next phase';
   ar[4]:='Make full magnetic set for next phase';
   END;
  IF(iph<nph)THEN
   BEGIN MakeCheckListBox(20,300,270,72);
   FOR i:=0 TO 3 DO CheckListBox1.Checked[i]:=false;
   END;
  WITH Memo1 DO FOR i:=1 TO nat DO
   BEGIN s:=atoms[i,iph].name; UpCaseStr(s);
   Compress(s); IF(s<>'')THEN Lines.Add(s);
   END;
  L2: ShowModal; IF(ModalRes=0)THEN Exit;
  IF(iph<nph)THEN FOR i:=0 TO 3 DO copOk[i]:=CheckListBox1.Checked[i];
  k:=1; WITH Memo1 DO FOR i:=1 TO Lines.Count DO
   BEGIN s:=Lines.Strings[i-1]; j:=Pos('=',s);
   Compress(s); IF(s='')THEN CONTINUE;
   WITH atoms[k,iph] DO
    BEGIN IF(j<>0)THEN
     BEGIN magat:=true; s[j]:=' ';
     END          ELSE magat:=false;
    UpCaseStr(s);
    END;
   ProcAtomName(s,iph,k,ok); IF(NOT ok)THEN GOTO L2; Inc(k);
   END;
  nat:=k-1;
           {OLD!!! Simple or full copying of atoms to next phase}
                  {Loop in atoms}
 viewv:=true; FOR i:=1 TO nat DO
  BEGIN L3: ModalRes:=1; MakeForm(1);
  strgrT[1]:='Occupation =';
  strgrT[2]:='X ='; strgrT[3]:='Y ='; strgrT[4]:='Z =';
  strgrT[5]:='T11 ='; strgrT[6]:='T12 ='; strgrT[7]:='T13 =';
  strgrT[8]:='T22 ='; strgrT[9]:='T23 ='; strgrT[10]:='T33 =';
  strgrT[11]:='Scattering length=';
  WITH atoms[i,iph] DO
   BEGIN strgrNn[1,1]:=occ; strgrNn[2,1]:=x; strgrNn[3,1]:=y;
   strgrNn[4,1]:=z; strgrNn[5,1]:=T11; strgrNn[6,1]:=T12;
   strgrNn[7,1]:=T13; strgrNn[8,1]:=T22; strgrNn[9,1]:=T23;
   strgrNn[10,1]:=T33; strgrNn[11,1]:=scat;
   IF(keyma[iph]=1)THEN
    BEGIN s:=' The phase is magnetic. ';
    OuttoLabel(Form2.Label7,70,2,clMaroon,clLime,s);
    strgrT[11]:='Magnetic moment'; strgrNn[11,1]:=mgmom;
    s:='Antiferromagnetic moments should be negative';
    OuttoLabel(Form2.Label8,5,285,clMaroon,clLime,s);

    L1rec:=' Enter ion name (e.g. MN+++)'; s:=atoms[i,iph].ionname;
    FOR jj:=2 TO Length(s) DO
     BEGIN IF(s[jj] IN ['0'..'9'])THEN
      BEGIN ii:=Ord(s[jj])-48; Delete(s,jj,1); E1rec:=s+Copy(plco,1,ii);
      END;
     END;
    IF(E1rec='')THEN E1rec:=atoms[i,iph].name;
    MakeEdits(5,200,320,70,1);
    END;
   END;
  s:='Atom '+IntToStr(i)+'  '+atoms[i,iph].name+
     '      Check atomic data.';
  OuttoLabel(Form2.Label6,5,24,clGreen,clWhite,s);
  strgrW[0]:=150; strgrW[1]:=100; PuttoTable(30,50,11,11,1,8);
  WITH CB1rec DO
   BEGIN nitems:=1; ar[1]:=' Skip further viewing';
   END;
  MakeCheckListBox(20,340,250,18);
  ok:=true; IF(viewv)THEN ok:=false; Form2.CheckListBox1.Checked[0]:=ok;

  WITH Form2 DO
   BEGIN IF(viewv)THEN ShowModal; IF(ModalRes=0)THEN Exit;
   viewv:=NOT CheckListBox1.Checked[0];
   FOR j:=1 TO 11 DO Zval(StringGrid1.Cells[0,j-1],har[j]);
   IF(keyma[iph]=1)THEN
    BEGIN atoms[i,iph].mgmom:=har[11]; s:=Edit1.Text; j:=0;
    FOR jj:=1 TO 10 DO IF(s[jj]='+')THEN Inc(j);
    IF(j=0)THEN
     BEGIN s:=Edit1.Text; j:=0; FOR jj:=1 TO 10 DO
      BEGIN ii:=Pos(IntToStr(jj),s); IF(ii<>0)THEN
       BEGIN j:=jj; BREAK;
       END;
      END;
     END;
    IF(NOT (j IN [0..5]))THEN ShowMess('Invalid ion name');
    END;
   END;
  MakeForm(1);
  WITH atoms[i,iph] DO
   BEGIN occ:=har[1]; x:=har[2]; y:=har[3]; z:=har[4]; T11:=har[5];
   T12:=har[6]; T13:=har[7]; T22:=har[8]; T23:=har[9]; T33:=har[10];
   scat:=har[11]; IF((scat=0)AND(keyma[iph]=0))THEN
    ShowMess('Warning, scattering amplitude = 0');
   IF(keyma[iph]=1)THEN
    BEGIN ss:=name+IntToStr(j); ionname:=ss; scat:=0;
    FOR j:=1 TO formfacaN DO WITH formfaca[j] DO IF(ionn=ss)THEN
     BEGIN Ab:=ffaca[1]; al:=ffaca[2]; Bb:=ffaca[3]; bl:=ffaca[4];
     Cb:=ffaca[5]; cl:=ffaca[6]; Db:=ffaca[7]; GOTO L1;
     END;
    s:='Ion '+ss+' not found. Replace?';
    ii:=MessageDlg(s,MtWarning,[mbYes,mbNo],0);
    IF(ii=mrYes)THEN GOTO L3;
    L1:;
    END;
   END;
  IF(keyma[iph]=1)THEN
   BEGIN L0rec:='Enter form-factor coefficients';
   MakeForm(1);
   strgrT[1]:='  A ='; strgrT[2]:='  a ='; strgrT[3]:='  B =';
   strgrT[4]:='  b ='; strgrT[5]:='  C ='; strgrT[6]:='  c =';
   strgrT[7]:='  D =';
   WITH atoms[i,iph] DO
    BEGIN strgrNn[1,1]:=Ab; strgrNn[2,1]:=al; strgrNn[3,1]:=Bb;
    strgrNn[4,1]:=bl; strgrNn[5,1]:=Cb; strgrNn[6,1]:=cl;
    strgrNn[7,1]:=Db;
    END;
   strgrW[0]:=100; strgrW[1]:=150; PuttoTable(30,20,7,7,1,8);

   WITH Form2 DO
    BEGIN IF(viewv)THEN ShowModal; IF(ModalRes=0)THEN Exit;
    FOR j:=1 TO 7 DO Zval(StringGrid1.Cells[0,j-1],har[j]);
    WITH atoms[i,iph] DO
     BEGIN Ab:=har[1]; al:=har[2]; Bb:=har[3]; bl:=har[4]; Cb:=har[5];
     cl:=har[6]; Db:=har[7];
     END;
    END;
   END;
  END;
           {Simple or full copying of atoms to next phase}
  IF(iph<nph)THEN
   BEGIN IF(copOk[0] AND(iph<nph))THEN {all atoms}
    BEGIN FOR i:=1 TO lat[iph].nat DO MoveAtoms(i,i,iph,iph+1);
    lat[iph+1].nat:=lat[iph].nat;
    END;
   IF(copOk[1] AND(iph<nph))THEN MakeSymmAtoms(iph,0);
   {all symmetric atoms}
   IF(copOk[2] AND(iph<nph))THEN {magnetic only}
    BEGIN IF(keyma[iph+1]<>1)THEN GOTO NoMag;
    k:=0; FOR i:=1 TO lat[iph].nat DO IF(atoms[i,iph].magat)THEN
     BEGIN Inc(k); MoveAtoms(i,k,iph,iph+1);
     END;
    lat[iph+1].nat:=k; IF(k=0)THEN ShowMess('No ticked magnetic atoms');
    END;
   IF(copOk[3] AND(iph<nph))THEN {all symmetric magnetic atoms}
    BEGIN IF(keyma[iph+1]<>1)THEN GOTO NoMag; MakeSymmAtoms(iph,1);
    IF(lat[iph+1].nat=0)THEN ShowMess('No ticked magnetic atoms');
    END;
   END;
  END;
 Writeln(fout,nat:4,' atom[s] set up, phase= '+IntToStr(iph));
 END;
SetNoPrep(1,true); CheckForIsotropy(0); Exit;
NoMag: ShowMess('Error, phase '+IntToStr(iph)+' not magnetic');
END;
PROCEDURE Formhkls;
VAR i,j,k,ii,iph:INTEGER; dmin,dmax,r:REAL;
BEGIN FOR iph:=1 TO nph DO IF(lat[iph].nat=0)THEN
 BEGIN s:='No atomic information for phase '+IntToStr(iph);
 s:=s+'. Still form?'; j:=MessageDlg(s,MtWarning,[mbYes,mbNo],0);
 lat[iph].nat:=1; IF(j=mrYes)THEN SetIniAtom(iph);
 END;
{Set common bounds for all spectra}
IF(spec[numsp].spin)THEN CalcDmaxn(dmax,dmin); dmin:=AMAX1(dmin,0.5);
L0rec:='Form hkl'; MakeForm(1); SaveHelp(Fhkls_n,Fhkls);
ShowSpectrumIntervals(20,30);

strgrW[0]:=120; strgrW[1]:=70;
r:=dmin; IF(r=0)THEN r:=0.75; strgrT[1]:='dmin ='; strgrNn[1,1]:=r;
r:=dmax; IF(r=0)THEN r:=20; strgrT[2]:='dmax ='; strgrNn[2,1]:=r;
PuttoTable(80,160,2,2,1,8);
MakeBevel(5,130,300,100,1); s:=' hkl forming in the range ';
OuttoLabel(Form2.Label5,10,140,clGreen,clAqua,s);

s:=' hkl forming for the phases: ';
OuttoLabel(Form2.Label6,10,240,clGreen,clWhite,s); WITH CB1rec DO
 BEGIN FOR i:=1 TO nph DO ar[i]:='   Phase '+IntToStr(i); nitems:=nph;
 END;
MakeCheckListBox(60,258,200,nph*18);
FOR i:=1 TO nph DO Form2.CheckListBox1.Checked[i-1]:=true;

Form2.ShowModal; IF(ModalRes=0)THEN Exit;
FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
IF(har[1]<0)THEN
 BEGIN ShowMess('Wrong d_min '+FloattoStr(har[1])); Exit;
 END;
dmin:=har[1];
IF(har[2]<0)THEN
 BEGIN ShowMess('Wrong d_max '+FloattoStr(har[2])); Exit;
 END;
dmax:=har[2]; IF(dmin>dmax)THEN Arrange2(dmin,dmax);
FOR iph:=1 TO nph DO IF(Form2.CheckListBox1.Checked[iph-1])THEN
 BEGIN WITH lat[iph] DO WITH lpd DO
  BEGIN ascx:=a; bscx:=b; cscx:=c;
  END;
 FormMillerIndices(dmin,dmax,iph);
 END;
j:=0; ii:=0; WITH LB1rec DO FOR i:=1 TO nph DO
 BEGIN k:=lat[i].nhkl; j:=j+k; Inc(ii);
 ar[ii]:=' Phase '+IntToStr(i)+':    '+IntToStr(k)+' hkls  formed';
 IF(k=1000)THEN
  BEGIN Inc(ii); ar[ii]:=' For phase '+IntToStr(i)+' too many hkls';
  Inc(ii); ar[ii]:=' No guarantee that they are right';
  END;
 IF(lat[i].Fkmax=0)THEN
  ShowMess('Warning, phase '+IntToStr(i)+' structure factors = 0');
 IF((keyma[i]=1)AND(lat[i].Fmmax=0))THEN
  ShowMess('Warning, phase '+IntToStr(i)+' magnetic factors = 0');
 END;
WITH LB1rec DO
 BEGIN IF(nph>1)THEN
  BEGIN Inc(ii); ar[ii]:=' Altogether '+IntToStr(j)+' hkls';
  END;
 nitems:=ii;
 FOR i:=1 TO ii DO Writeln(fout,ar[i]);
 END;
MakeForm(1); MakeListBox(20,160,270,150); Form2.ShowModal; CalcHKLNMax;
SetNoPrep(5,true);
END;
PROCEDURE PurgeSupHKLs;
VAR i,j,iph,ii,ht,kt,lt,lh,lk,ll:INTEGER;
BEGIN FOR iph:=1 TO nph DO WITH lat[iph] DO FOR j:=1 TO nhkl DO
 BEGIN lh:=hkla[j,iph].h; lk:=hkla[j,iph].k; ll:=hkla[j,iph].l;
 FOR i:=1 TO nut DO
  BEGIN r:=ut[1,i]*lh+ut[4,i]*lk+ut[7,i]*ll; ht:=Round(r);
  r:=ut[2,i]*lh+ut[5,i]*lk+ut[8,i]*ll; kt:=Round(r);
  r:=ut[3,i]*lh+ut[6,i]*lk+ut[9,i]*ll; lt:=Round(r);
  FOR ii:=j+1 TO nhkl DO WITH hkla[ii,iph] DO{Check for ident.indices}
   IF((ht=h)AND(kt=k)AND(lt=l))THEN dk:=-777;
  END;
 END;
FOR iph:=1 TO nph DO {Purge superflous hkls}
 BEGIN ii:=0; FOR j:=1 TO lat[iph].nhkl DO
  BEGIN hklr:=hkla[j,iph]; IF(hklr.dk<>-777)THEN
   BEGIN Inc(ii); hkla[ii,iph]:=hklr;
   END;
  END;
 lat[iph].nhkl:=ii;
 END;
END;
PROCEDURE EnterSpaceGroupInfo(iph,mo:INTEGER);
{Enter a non-standard space group,   Nov 5 2001}
VAR   i,j,k:INTEGER;
LABEL Lend;
BEGIN fn:=spgfn; ModalRes:=1; IF(mo=0)THEN
 BEGIN GetFilename(fn,0); IF(ModalRes=0)THEN Exit; spgfn:=fn;
 END;
AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
FOR i:=1 TO 8 DO onl[i]:=0;
EnterStr(ft); fffins(k,sedz); IF(k<>6)THEN GOTO Lend;
WITH lat[iph] DO
 BEGIN laue:=Round(onl[1]); ntlv:=MIN0(3,Round(onl[2]));
 nut:=MIN0(48,Round(onl[3])); csym:=Round(onl[4]); nlatt:=Round(onl[5]);
 syng:=Round(onl[6]);
 FOR i:=1 TO ntlv DO
  BEGIN EnterStr(ft); fffins(k,sedz); IF(k<>3)THEN GOTO Lend;
  FOR j:=1 TO 3 DO tlv[j,i]:=onl[j];
  END;
 FOR i:=1 TO nut DO
  BEGIN EnterStr(ft); IF(CheckBlank(sedz))THEN
   ShowMess('Error, blank line in space group');
  EnterTransformation(sedz,i,iph); IF(ModalRes=0)THEN GOTO Lend;
  END;
 IF(keyma[iph]=1)THEN
  BEGIN FOR i:=1 TO nut DO {Magnetic transforms}
   BEGIN EnterStr(ft); IF(CheckBlank(sedz))THEN
    ShowMess('Error, blank line in space group');
   EnterTransformation(sedz,i,iph); IF(ModalRes=0)THEN GOTO Lend;
   END;
  IF(mo=1)THEN
   BEGIN EnterStr(ft); fffins(i,sedz);
   IF(i<>3)THEN ShowMess('Suspicious mag.spin plane info');
   h0:=onl[1]; k0:=onl[2]; l0:=onl[3];
   END;
  END;
 END;
CloseFile(ft);
IF(mo=0)THEN
 BEGIN MakeForm(1); WITH LB1rec DO
  BEGIN nitems:=2;
  ar[1]:='Non-standard group read in.'; ar[2]:='See INFO about phase';
  END;
 MakeListBox(20,40,270,120); Form2.ShowModal;
 END;
Exit;
Lend: ShowMess('Wrong space group data'); ModalRes:=0; CloseFile(ft);
END;
PROCEDURE EnterCrystalInfo;
VAR   im,iop:INTEGER;
LABEL L1;
BEGIN sinf:=''; iop:=2;
IF(NOT spec[numsp].spin)THEN sinf:='No Spectrum '+IntToStr(numsp);
IF(NOT(mriamode IN [0,2]))THEN
 BEGIN mriamode:=0; sinf:=sinf+'    Rietveld mode is set';
 END;
L1:L0rec:='Enter the Crystal Information'; MakeForm(1);
SaveHelp(EntCrI_n,EntCrI);
OuttoLabel(Form2.Label6,5,30,clGreen,clWhite,selops);
WITH CB1rec DO
 BEGIN nitems:=6; indx:=iop;
 ar[1]:='   Set the number of phases';
 ar[2]:='Enter the phase information';
 ar[3]:='Enter the atomic information';
 ar[4]:='Form the hkl set';
 ar[5]:='Input the hkl set from a file';
 ar[6]:='Exit';
 END;
MakeRadioGroup(1,0,10,50,260,180);
IF(sinf<>'')THEN OuttoLabel(Form2.Label5,5,250,clWhite,clBlue,sinf);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; im:=RadioGroup1.ItemIndex;
 END;
CASE im OF
0: BEGIN SetNumberofPhases; iop:=2;
   END;
1: BEGIN EnterPhaseInformation(0); iop:=3; IF(ModalRes=0)THEN iop:=2;
   END;
2: BEGIN EnterAtomicInformation; iop:=4; IF(ModalRes=0)THEN iop:=3;
   END;
3,4: BEGIN IF(nophasi)THEN
    BEGIN ShowMess('First enter phase information'); iop:=2; GOTO L1;
    END;
     IF(im=3)THEN Formhkls ELSE Inputhkls; iop:=6;
     END;
5: Exit;
ELSE END;
GOTO L1;
END;
PROCEDURE ShowSpectrumIntervals(x,y:INTEGER);
BEGIN OuttoLabel(Form2.Label6,x+20,y,clMaroon,clWhite,
 '   Spectrum interval(s):   ');
ConvertStr(spec[1].a11,8,0); s:='1.  '+sedz;
ConvertStr(spec[1].a22,8,0); s:=s+'  -  '+sedz;
OuttoLabel(Form2.Label7,x,y+20,clGreen,clWhite,s);
IF(nsp>1)THEN
 BEGIN ConvertStr(spec[2].a11,8,0); s:='2.  '+sedz;
 ConvertStr(spec[2].a22,8,0); s:=s+'  -  '+sedz;
 OuttoLabel(Form2.Label8,x,y+36,clGreen,clWhite,s);
 END;
IF(nsp>2)THEN
 BEGIN ConvertStr(spec[3].a11,8,0); s:='3.  '+sedz;
 ConvertStr(spec[3].a22,8,0); s:=s+'  -  '+sedz;
 OuttoLabel(Form2.Label9,x,y+52,clGreen,clWhite,s);
 END;
IF(nsp>3)THEN
 BEGIN ConvertStr(spec[4].a11,8,0); s:='4.  '+sedz;
 ConvertStr(spec[4].a22,8,0); s:=s+'  -  '+sedz;
 OuttoLabel(Form2.Label10,x,y+68,clGreen,clWhite,s);
 END;
END;
PROCEDURE Inputhkls;
VAR i,j,iph:INTEGER; q,cosa,cosb,cosg,dk0,dmin,dmax,r,Fc,Fs,Fm:REAL;
BEGIN L0rec:='Input hkl set from a file'; MakeForm(1);
SaveHelp(Fhkls_n,Fhkls); MakeBevel(5,20,300,120,1);
OuttoLabel(Form2.Label5,15,30,clGreen,clWhite,'Select the phase');
CB1rec:=Num4Rec; MakeRadioGroup(1,0,140,30,150,90);
dmax:=0; dmin:=1E14; WITH spec[numsp] DO
 BEGIN r:=spec[numsp].chtod(AMAX0(a11-3,a1)); dmin:=AMIN1(dmin,r);
 r:=spec[numsp].chtod(AMIN0(a22+3,a2)); dmax:=AMAX1(dmax,r);
 END;
IF(dmin>dmax)THEN Arrange2(dmin,dmax);
L1rec:='dmin ='; ConvertStr(dmin,6,4); E1rec:=sedz;
L2rec:='dmax ='; ConvertStr(dmax,6,4); E2rec:=sedz;
MakeBevel(5,230,300,100,2); s:='Check the d-range of input hkls';
OuttoLabel(Form2.Label6,50,240,clGreen,clWhite,s);
MakeEdits(80,160,270,70,2);
OuttoLabel(Form2.Label3,15,173,clGreen,clWhite,'hkl file name =');
MakeEdit(Form2.Edit3,120,170,180,' ');

Form2.ShowModal; IF(ModalRes=0)THEN Exit;
fn:=Form2.Edit3.Text; Compress(fn); IF(NOT FileExists(fn))THEN
 BEGIN ShowMess('No file '+fn); ModalRes:=0; Exit;
 END;
s:=Form2.Edit1.Text; Zval(s,r); IF(r<0)THEN
 BEGIN ShowMess('Wrong d_min '+FloattoStr(r)); Exit;
 END;
IF(ModalRes<>0)THEN dmin:=r;
s:=Form2.Edit2.Text; Zval(s,r); IF((r<0)OR(r<dmin))THEN
 BEGIN ShowMess('Wrong d_max '+FloattoStr(r)); Exit;
 END;
IF(ModalRes<>0)THEN dmax:=r;
iph:=Form2.RadioGroup1.ItemIndex+1;
IF(lat[iph].nat=0)THEN
 BEGIN s:='No atomic information for phase '+IntToStr(iph)+'. Proceed?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Exit;
 END;
AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
i:=0; WHILE(NOT EoF(ft))DO
 BEGIN fffin(ft,1,5,j,onl); WITH hkla[i+1,iph] DO
  BEGIN h:=Round(onl[1]); k:=Round(onl[2]); l:=Round(onl[3]);
  mul:=Round(onl[4]); txtc:=Round(onl[5]);
  r:=radian; WITH lat[iph].lpi DO
   BEGIN cosa:=COS(alpha/r); cosb:=COS(beta/r); cosg:=COS(gamma/r);
   q:=SQR(a*h)+SQR(b*k)+SQR(c*l)+2*(a*h*b*k*cosg+b*k*c*l*cosa+
   c*l*a*h*cosb);
   END;
  IF(q<=0)THEN CONTINUE; dk0:=1/SQRT(q);
  IF((dk0<dmin)OR(dk0>dmax))THEN CONTINUE; Inc(i); i:=MIN0(i,1000);
  dk:=dk0; Fc:=0; Fs:=0;
  IF(lat[iph].nat<>0)THEN StructFactor(0,iph,h,k,l,mul,0,Fc,Fs,Fm);
  Fkc:=Fc; Fks:=Fs; Fkm:=Fm;
  END;
 END;
lat[iph].nhkl:=i;
WITH LB1rec DO
 BEGIN ar[3]:=' Phase '+IntToStr(iph)+':   '+IntToStr(i)+' hkls input.';
 ar[1]:=' '; ar[2]:=' '; ar[4]:=' '; IF(i=2000)THEN
  BEGIN ar[1]:=' For phase '+IntToStr(iph)+' too many hkls';
  ar[2]:=' No guaranty that they are right';
  END;
 nitems:=4;
 IF(lat[iph].nat=0)THEN ar[4]:='Zero-valued structure factors';
 END;
MakeForm(1); MakeListBox(20,160,270,150); Form2.ShowModal;
CalcHKLNMax;
SetNoPrep(5,true);
END;

PROCEDURE FindXYZC(VAR s:STRING; ch:CHAR; VAR x:REAL);
{Find +Ch,-Ch,Ch and delete it and form x (0,1,-1)
 Version: Oct 24 1996;  Delphi= Nov 2 2001}
VAR i0,ip,ib,im,li:INTEGER; plus,minus:STRING;
BEGIN plus:='+'+ch; minus:='-'+ch;
ip:=Pos(plus,s); ib:=Pos(ch,s); im:=Pos(minus,s); li:=2;
IF(ip<>0)THEN
 BEGIN x:=1; i0:=ip;
 END     ELSE
IF(im<>0)THEN
 BEGIN x:=-1; i0:=im;
 END     ELSE
IF(ib<>0)THEN
 BEGIN x:=1; li:=1; i0:=ib;
 END     ELSE
 BEGIN x:=0; li:=0; i0:=0;
 END;
Delete(s,i0,li);
END;
PROCEDURE EnterTransformation(VAR st:STRING; il,iph:INTEGER);
{Enter il_th iph phase space transformation string and process it;
        +-x+-y+-z+-const, +-x+-y+-z+-const, +-x+-y+-z+-const;
 Version: Oct 24 1996;  Delphi := Nov 2 2001}
VAR   i,im,i1,i2,le:INTEGER; x,v:REAL; ss:ARRAY[1..3] OF STRING;
LABEL Lend;
BEGIN WITH lat[iph] DO
 BEGIN FOR i:=1 TO 9 DO ut[i,il]:=0; FOR i:=1 TO 3 DO
  BEGIN shv[i,il]:=0; ss[i]:=' ';
  END;
 END;
Compress(st); UpCaseStr(st);
i1:=Pos(',',st); IF((i1>0)AND(i1<73))THEN st[i1]:=' ';
i2:=Pos(',',st); IF((i1>0)AND(i1<73))THEN st[i1]:=' ';
IF(((i1*i2)=0)OR(i1=i2))THEN GOTO Lend;
{Start the extraction}
ss[1]:=Copy(st,1,i1-1); ss[2]:=Copy(st,i1+1,i2-i1-1);
ss[3]:=Copy(st,i2+1,72);
{Main loop}
WITH lat[iph] DO FOR im:=1 TO 3 DO
 BEGIN v:=0;
 FindXYZC(ss[im],'X',x); ut[(im-1)*3+1,il]:=x;
 FindXYZC(ss[im],'Y',x); ut[(im-1)*3+2,il]:=x;
 FindXYZC(ss[im],'Z',x); ut[(im-1)*3+3,il]:=x;
 le:=Length(ss[im]); FOR i:=1 TO le DO
  BEGIN j:=Ord(ss[im,i]); IF((j<43)OR(j>57))THEN GOTO Lend;
  END;
 Compress(ss[im]); IF(le<>0)THEN
  BEGIN Valz(ss[im],v,i); IF(i<>1)THEN GOTO Lend;
  END;
 shv[im,il]:=v;
 END;
Exit;
Lend: ShowMess('Poor syntax= '+st); ModalRes:=0; Exit;
END;
PROCEDURE FormHKL;
{ generate indices h,k,l for AUTOX.
  Version: 30 Jul 1990  delphi=Mar 9 2001}
VAR   i,j,iph,lh,lk,ll,h2,k2,l2,hk,hl,hx,hn,kx,kn,lx,nre:INTEGER;
      hk2,hkl2,hkl,rh,rk,rl,rh2,rk2,rl2,rhk2,rhkl2,rhl,rhk,rhkl:INTEGER;
LABEL L101,L9;
BEGIN IF(keyAuto=1)THEN
 BEGIN FOR i:=1 TO mdsp DO WITH hkla[i,1] DO
  BEGIN h:=dspa[i].h; k:=dspa[i].k; l:=dspa[i].l;
  END;
 lat[iph].nhkl:=mdsp; Exit;
 END;
{Loop over phases} FOR iph:=1 TO nph DO
 BEGIN hx:=hmax[iph]; hn:=hmin[iph]; kx:=kmax[iph]; kn:=kmin[iph];
 lx:=lmax[iph];
 CASE lat[iph].syng OF
 1,7: ;
 2,6: kn:=MAX0(kn,0);
 ELSE hn:=MAX0(hn,0); kn:=MAX0(kn,0); END;
 {loop with respect to reflections}
 nre:=0; FOR lh:=hn TO hx DO FOR lk:=kn TO kx DO FOR ll:=0 TO lx DO
  BEGIN IF((lh=0)AND(lk=0)AND(ll=0))THEN GOTO L9;  {skip 000}
  IF((lh<0)AND(lk=0)AND(ll=0))THEN GOTO L9; {skip -00}
  IF((lh=0)AND(lk<0)AND(ll=0))THEN GOTO L9; {skip 0-0}
 {Remove lattice absences  P   A   B   C   F   I   R   H}
  CASE lat[iph].nlatt OF
 0: GOTO L101;
 1: IF(((ll+lk) MOD 2)=0)THEN GOTO L101;  {A face centred}
 2: IF(((lh+ll) MOD 2)=0)THEN GOTO L101;  {B face centred}
 3: IF(((lh+lk) MOD 2)=0)THEN GOTO L101;  {C face centred}
 4: IF((((lh+lk) MOD 2)=0)AND(((lk+ll) MOD 2)=0))THEN GOTO L101; {F cen}
 5: IF(((lh+lk+ll) MOD 2)=0)THEN GOTO L101; {I(body) centred}
 6: IF(((-lh+lk+ll) MOD 3)=0)THEN GOTO L101; {R centred}
  ELSE END;
  GOTO L9;
  L101: h2:=lh*lh; k2:=lk*lk; l2:=ll*ll;
  hk2:=h2+k2; hkl2:=hk2+l2; hl:=lh*ll; hk:=lh*lk; hkl:=hk+hl+lk*ll;
  {Case b=a (tetrag.,hexagon.)};
  FOR i:=1 TO nre DO
   BEGIN rh:=hkla[i,iph].h; rk:=hkla[i,iph].k; rl:=hkla[i,iph].l;
   rh2:=rh*rh; rk2:=rk*rk; rl2:=rl*rl; rhk2:=rh2+rk2; rhkl2:=rhk2+rl2;
   rhl:=rh*rl; rhk:=rh*rk; rhkl:=rhk+rhl+rk*rl;
   CASE lat[iph].syng OF{Take the symmetry into account}
  1:{Triclinic}IF((rh=-lh)AND(rk=-lk)AND(rl=0)AND(ll=0))THEN GOTO L9;
  2:{Monoclinic}
    IF((rh2=h2)AND(rk2=k2)AND(rl2=l2)AND(rhl=hl))THEN GOTO L9;
  3:{Orthorhombic}IF((rh2=h2)AND(rk2=k2)AND(rl2=l2))THEN GOTO L9;
  4:{Tetragonal}IF((rhk2=hk2)AND(rl2=l2))THEN GOTO L9;
  5:{Cubic}IF(rhkl2=hkl2)THEN GOTO L9;
  6:{Hexagonal}IF((rhk2+rhk=hk2+hk)AND(rl2=l2))THEN GOTO L9;
  7:{Rhombohedral}IF((rhkl2=hkl2)AND(rhkl=hkl))THEN GOTO L9;
   ELSE END;
   END;
 {Store}Inc(nre); IF(nre>=4000)THEN
   BEGIN ShowMess('Phase'+IntToStr(iph)+' D-interval too large'); BREAK;
   END;
  j:=nre; hkla[j,iph].h:=lh; hkla[j,iph].k:=lk; hkla[j,iph].l:=ll;
  L9:;
  END;
 lat[iph].nhkl:=nre;
 END;
IF(usespg)THEN
 BEGIN IF(nophasi)THEN
  BEGIN ShowMess('No space group set up'); Exit;
  END;
 PurgeSupHKLs; BubbleSortHKLs;
 END;
END;
PROCEDURE BubbleSortHKLs;
VAR j,iph:INTEGER; changed:BOOLEAN;
BEGIN FOR iph:=1 TO nph DO
 REPEAT changed:=false; FOR j:=1 TO lat[iph].nhkl-1 DO{Bubble Sorting}
  BEGIN IF(hkla[j,iph].dk<hkla[j+1,iph].dk)THEN
   BEGIN hklr:=hkla[j,iph]; changed:=true;
   hkla[j,iph]:=hkla[j+1,iph]; hkla[j+1,iph]:=hklr;
   END;
  END;
 UNTIL NOT changed;
END;
PROCEDURE SetScreenSpaceGroup(iph:INTEGER);
{Enter non-standard space group from screen, Mar 25 2005}
VAR   i,j,k:INTEGER; s:STRING;
BEGIN L0rec:='Enter space group info'; MakeForm(1);
strgrW[0]:=180; strgrW[1]:=100; WITH lat[iph] DO
 BEGIN strgrT[1]:='Laue'; strgrNn[1,1]:=laue;
 strgrT[2]:='Number of translations'; strgrNn[2,1]:=ntlv;
 strgrT[3]:='Number of transformations'; strgrNn[3,1]:=nut;
 END;
PuttoTable(15,50,3,3,1,8);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=lat[iph].csym+1;
 ar[2]:='Centrosymmetric';ar[1]:='Non-'+ar[2];
 END;
MakeRadioGroup(1,0,15,115,280,60);
OuttoLabel(Form2.Label1,20,200,clGreen,clWhite,
   ' Translations as strings with 3 numbers');
OuttoLabel(Form2.Label2,20,220,clGreen,clWhite,
   '  Example: 0,  0.5,  0.5');
OuttoLabel(Form2.Label3,20,240,clGreen,clWhite,
   ' Transformations as strings with formulae:');
OuttoLabel(Form2.Label4,20,260,clGreen,clWhite,
   '  Example:  -x,     y+0.5,    -z+0.5');
MakeBevel(15,195,285,90,1);
OuttoLabel(Form2.Label5,5,300,clBlue,clWhite,
   ' Later check the input: Info about phases');
WITH Form2 DO WITH lat[iph] DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 laue:=Round(har[1]); ntlv:=MIN0(3,Round(har[2]));
 nut:=MIN0(48,Round(har[3])); csym:=RadioGroup1.ItemIndex;
 END;
L0rec:='Enter strings with data'; MakeFormV(170,0,420,430,0);
MakeMemo(5,400); WITH lat[iph] DO WITH Form2.Memo1.Lines DO
 BEGIN FOR i:=1 TO ntlv DO
  BEGIN s:=''; FOR j:=1 TO 3 DO
   BEGIN ConvertStr(tlv[j,i],6,3); s:=s+sedz;
   END;
  Add(s);
  END;
 FOR i:=1 TO nut DO
  BEGIN ftrstr(i,iph,s); Add(s);
  END;
 END;

WITH Form2 DO WITH lat[iph] DO WITH Memo1.Lines DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO ntlv DO
  BEGIN s:=Strings[i-1]; fffins(k,s); FOR j:=1 TO 3 DO tlv[j,i]:=onl[j];
  END;
 FOR i:=1 TO nut DO
  BEGIN s:=Strings[i-1+ntlv]; EnterTransformation(s,i,iph);
  IF(ModalRes=0)THEN
   BEGIN ShowMess('Wrong space group data'); Exit;
   END;
  END;
 END;
END;



END.

PROCEDURE HKL0Fit3(iph:INTEGER);
{Gradient-descent based refinement: equations cos(phi_i) = R_i(h0,k0,l0)
  cos(phi_i) ~ R_i0 +sum dR_i/dh_j dh_j, Version Apr 14 2006
  Angles ph_i from har[i], initial hkl0 from lattice info}
VAR i,j,it:INTEGER; al,be,ga,r1,r2,r3,step,d0,dh,dk,dl,r:REAL;
BEGIN step:=0.1; r:=radian; FOR i:=1 TO 3 DO har[i]:=COS(har[i]/r);
FOR it:=1 TO 15 DO WITH lat[iph] DO WITH lat[iph].lpi DO
 BEGIN {Make matrix and vector}
 d0:=(o11*h0+o12*k0+o13*l0)*h0+(o22*k0+o23*l0)*k0+o33*l0*l0;
 d0:=SQRT(ABS(d0));
 dh:=o11*h0+0.5*o12*k0+0.5*o13*l0;
 dk:=o22*k0+0.5*o12*h0+0.5*o23*l0;
 dl:=o33*l0+0.5*o13*h0+0.5*o23*k0;
 al:=COS(alpha/r); be:=COS(beta/r); ga:=COS(gamma/r);
 r1:=a*h0+b*ga*k0+c*be*l0;
 r2:=a*ga*h0+b*k0+c*al*l0;
 r3:=a*be*h0+b*al*k0+c*l0;
 vec3[1]:=har[1]-r1/d0;
 vec3[2]:=har[2]-r2/d0;
 vec3[3]:=har[3]-r3/d0;
 mat3[1,1]:=a*d0-r1*dh;
 mat3[1,2]:=b*ga*d0-r1*dk;
 mat3[1,3]:=c*be*d0-r1*dl;
 mat3[2,1]:=a*ga*d0-r2*dh;
 mat3[2,2]:=b*d0-r2*dk;
 mat3[2,3]:=c*al*d0-r2*dl;
 mat3[3,1]:=a*be*d0-r3*dh;
 mat3[3,2]:=b*al*d0-r3*dk;
 mat3[3,3]:=c*d0-r3*dl;
 FOR i:=1 TO 3 DO FOR j:=1 TO 3 DO mat3[i,j]:=mat3[i,j]/(d0*d0*d0);
 mat3[1,1]:=1;
 mat3[1,2]:=0;
 mat3[1,3]:=0;
 mat3[2,1]:=0;
 mat3[3,1]:=0;
 InvertMatrix3(ok,false,r); IF(NOT ok)THEN BREAK;
 FOR i:=1 TO 3 DO
  BEGIN pa[i]:=0; FOR j:=2 TO 3 DO pa[i]:=pa[i]+vec3[j]*mat3[i,j];
  END;
 eps:=AMAX3(ABS(pa[1]),ABS(pa[2]),ABS(pa[3])); IF(eps<0.0001)THEN BREAK;
 FOR i:=1 TO 3 DO pa[i]:=step*pa[i];
 {DEBUG!!!}
 Writeln(fout,'pa ',pa[1]:8:3,pa[2]:8:3,pa[3]:8:3);
 Writeln(fout,'hkl0 ',h0:8:3,k0:8:3,l0:8:3);
 Writeln(fout,'ph,it,eps ',iph:5,it:4,eps:8:3);
 h0:=h0+pa[1]; k0:=k0+pa[2]; l0:=l0+pa[3];
 END; {End of refinement loop}
END;

