UNIT vmriafl;

INTERFACE

USES Windows,  Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs,  StdCtrls, ExtCtrls, Grids,    vzlocom,  varfun,   vmria0,
     vmria2,   vmriasp,  vgfit,    vmriarit, vmriahlp, vspectr,  vmria3,
     vmriacry, vpmodel,  vpeaksr,  vstdcons, vmriasgm, vmria00,
     vmriainf, vmriasim;

PROCEDURE FormDN2effSp;
PROCEDURE InputtheSpectrum(sve:INTEGER);
PROCEDURE MakeFourierSpectrum;
PROCEDURE OutputtheSpectrum;
PROCEDURE zlokar(VAR y,wh,f:REAL; k,typ:INTEGER);
PROCEDURE InputSpectrumData(sve:INTEGER);
PROCEDURE ReadDSpacings(CONST dsfn:STRING);
PROCEDURE MakePeakInfo(ii:INTEGER);
PROCEDURE ShowCurrentSpectrum;
PROCEDURE GetTOFInfo;


IMPLEMENTATION
PROCEDURE InputtheSpectrum(sve:INTEGER);
{sve = 0=effective; 1=spectrum;  2=variance}
VAR   i,j,ist:INTEGER; fn,s,ss:STRING; coincid:BOOLEAN;
LABEL L0,L1,L2;
{*}
BEGIN s:=IntToStr(numsp)+' input'; SaveHelp(IShelp_n,IShelp);
CASE sve OF
0: L0rec:='Effective spectrum '+s;
1: L0rec:='Spectrum '+s;
2: L0rec:='Variance '+s;
ELSE END;
MakeForm(1); s:=' effective spectrum';
CASE sve OF
0: BEGIN spvar:=0;{Eff.Spec. input} WITH CB1rec DO
    BEGIN nitems:=2; indx:=1;
    ar[1]:='Read a new'+s; ar[2]:='Set up the DN2'+s;
    END;
   MakeRadioGroup(1,0,20,100,270,70);
   WITH Form2 DO
    BEGIN ShowModal; IF(ModalRes=0)THEN Exit; numsp:=0;
    i:=RadioGroup1.ItemIndex; IF(i=1)THEN
     BEGIN FormDN2effSp; GOTO L1;
     END;
    END;
   fn:=spec[numsp].sfn;
   END;
1: BEGIN spvar:=0;{Spectrum input}fn:=spec[numsp].sfn;
   END;
2: BEGIN spvar:=1;{Variance input}fn:=spec[numsp].efn;
   END;
ELSE END;
{*}    {F I L E   N A M E}
s:='*.sp*';
ss:='All|*.*;|H(*.h)|*.h;|D(*.d)|*.d;|SPC(*.spc)|*.spc;|SP(*.sp)|*.sp';
OpenFileDial(Form2.OpenDialog1,fn,s,defspdir,ss);
IF(ModalRes=0)THEN Exit; defspdir:=ExtractFileDir(fn);
CASE sve OF
0: spec[numsp].sfn:=fn;
1: spec[numsp].sfn:=fn;
2: spec[numsp].efn:=fn;
ELSE END;
{*}    {Select file type}
OuttoLabel(Form2.Label5,10,10,clGreen,clWhite,'Select the file type:');
CB1rec:=SpTypeRec; i:=spec[numsp].smosp;
CASE sve OF
0: BEGIN i:=spec[numsp].smosp; j:=3;
   END;
1: BEGIN i:=spec[numsp].smosp; j:=4;
   END;
2: BEGIN i:=spec[numsp].emosp; j:=3;
   END;
ELSE END;
i:=MIN0(i,j);
CB1rec.nitems:=j; CB1rec.indx:=i; MakeRadioGroup(1,0,40,30,240,120);
IF(sve=1)THEN
 BEGIN WITH CB1rec DO
  BEGIN ar[1]:=' ToF Spectrum'; ar[2]:=' Angular distribution';
  ar[3]:=' Any spectrum'; nitems:=3; indx:=spec[numsp].tofang+1;
  END;
 MakeRadioGroup(2,0,40,180,240,80);
 OuttoLabel(Form2.Label6,10,160,clGreen,clWhite,
  'Select the spectrum type:');
 END;
{*}    {Specify skip and RBOrder modes}
WITH CB1rec DO
 BEGIN nitems:=4; ar[1]:=' Skip the header ';
 ar[2]:=' Reverse the bytes ';
 ar[3]:=' Starting channel = 1 ';
 ar[4]:=' Specify error type if ASCII';
 END;
MakeCheckListBox(50,290,220,70);
WITH Form2.CheckListBox1 DO
 BEGIN IF(skiph)THEN Checked[0]:=true ELSE Checked[0]:=false;
 IF(revby)THEN Checked[1]:=true ELSE Checked[1]:=false;
 IF(chan1)THEN Checked[2]:=true ELSE Checked[2]:=false;
 Checked[3]:=false;
 END;
{*}  {G E T}
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 ist:=RadioGroup1.ItemIndex+1;     {spectrum file type}
 CASE sve OF
 0,1: spec[numsp].smosp:=ist;  {sp/var}
 2: spec[numsp].emosp:=ist;    {eff.sp}
 ELSE END;
 IF(sve=1)THEN spec[numsp].tofang:=RadioGroup2.ItemIndex;
 WITH CheckListBox1 DO
  BEGIN IF(Checked[0])THEN skiph:=true ELSE skiph:=false;
  IF(Checked[1])THEN revby:=true ELSE revby:=false;
  IF(Checked[2])THEN chan1:=true ELSE chan1:=false;
 {*} {Specify error type}
  IF(Checked[3])THEN
   BEGIN MakeForm(1);
   WITH CB1rec DO
    BEGIN ar[1]:=' Errors'; ar[2]:=' Squared errors';
    ar[3]:=' Inversed squared errors'; nitems:=3; indx:=1;
    END;
   MakeRadioGroup(2,0,40,180,240,80);
   OuttoLabel(Form2.Label6,10,160,clGreen,clWhite,
    'Select the error type:');
   ShowModal; IF(ModalRes=0)THEN Exit;
   vartype:=RadioGroup2.ItemIndex;
   END;
  END;
 END;
{*} {Make reading}
s:=spec[numsp].sfn; UpCaseStr(s); IF(s='DUMMY')THEN GOTO L0;
InputSpectrumData(sve); WITH spec[numsp] DO
 BEGIN IF((spx=0)OR(NOT ok))THEN
  BEGIN ShowMess('++++ Error, wrong reading'); ModalRes:=0; Exit;
  END;
 IF(spx<1)THEN
  BEGIN s:='Poor data scale, max < 1'; spx:=1;
  i:=MessageDlg(s,MtWarning,[mbYes,mbAbort],0);
  IF(i<>mrYes)THEN ModalRes:=0; IF(i<>mrYes)THEN Exit;
  END;
 END;
spec[numsp].CheckErrorsFor0;
{*}
L0: MakeForm(1); SaveHelp(WidthInfo_n,WidthInfo);
IF(sve=2)THEN GOTO L1; IF(sve=0)THEN GOTO L2;
{*} {Widths}
OuttoLabel(Form2.Label5,5,0,clGreen,clWhite,
 'Check width information, analysis bounds');
strgrW[0]:=170; strgrW[1]:=70;
strgrT[1]:='Width 0 (chan) = '; strgrT[2]:='Delta Width0 (chan) = ';
strgrT[3]:='Width 1 = '; strgrT[4]:='Delta Width1 = ';
strgrT[5]:='Beginning (chan) = '; strgrT[6]:='End (chan) = ';
WITH spec[numsp] DO
 BEGIN strgrNn[1,1]:=w0; strgrNn[2,1]:=dw0;
 strgrNn[3,1]:=w1; strgrNn[4,1]:=dw1;
 strgrNn[5,1]:=a11; strgrNn[6,1]:=a22;
 END;
PuttoTable(40,20,6,6,1,8);
{*} {Background}
OuttoLabel(Form2.Label6,10,150,clGreen,clWhite,
 'Select the background mode');
CB1rec:=DBackRec; CB1rec.indx:=spec[numsp].dback+2;
MakeRadioGroup(1,0,50,170,200,190);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 spec[numsp].dback:=RadioGroup1.ItemIndex-1;
 FOR i:=1 TO 6 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
 WITH spec[numsp] DO
  BEGIN w0:=har[1]; dw0:=har[2]; w1:=har[3]; dw1:=har[4];
  a11:=Round(har[5]); a22:=Round(har[6]);
  END;
 END;
{*}     {Get TOF-info}
L2: WITH spec[numsp] DO
 BEGIN IF(tofang=2)THEN GOTO L1;
 GetTOFInfo; IF(ModalRes=0)THEN Exit; IF((ist=4)OR(sve=2))THEN GOTO L1;
 FOR i:=a1 TO a2 DO
  IF(tofang=0)THEN x[i]:=chtod(Float(i)); {ELSE x[i]:=i;}
 coincid:=false; FOR i:=a1 TO a2-1 DO IF(x[i]=x[i+1])THEN coincid:=true;
 IF(coincid)THEN ShowMess('Coinciding Xs (ds or thetas)');
 END;
{}
L1: MakeForm(1); WITH spec[numsp] DO WITH LB1rec DO
 BEGIN a11:=MAX0(a11,a1); a22:=MIN0(a22,a2); Irrange2(a11,a22);
 IF(sve=2)THEN ar[1]:='Variance read in';
 IF(sve=1)THEN
  BEGIN argff:=false; ic1:=Round(a1); ic2:=Round(a2); cadl:=ic2-ic1+1;
  CheckToFAInfo(numsp,ok);
  spin:=true; effn:=false; absn:=false;
  ar[2]:=''; IF(smosp<=3)THEN ar[2]:='  Poisson variance set up';
  ar[1]:='The spectrum read in.'+ar[2];
  END;
 IF(sve=0)THEN
  BEGIN CheckToFAInfo(0,ok);
  ar[1]:='Effective spectrum available';
  END;
 IF(sve=1)THEN CheckForSingleZeroes;
 END;
{*}
ncl:=0; IF((ist<>4)AND(spec[numsp].tofang=1)AND(sve=1))THEN
 ShowMess('Reminder! Not forget to execute "Assign 2thetas"');
END;
PROCEDURE OutputtheSpectrum;
VAR i,j,i1,i2,im:INTEGER; sx,r,sn:REAL;
BEGIN IF(spec[numsp].NoSpectrum(numsp))THEN Exit;
L0rec:='Output of the current spectrum ('+IntToStr(numsp)+') '+
        sptyp[spec[numsp].tofang];
IF(spec[numsp].tofang=1)THEN ch_ang:=true;
MakeForm(1); SaveHelp(NyetI_n,NyetI);
s:='Specify the output type';
OuttoLabel(Form2.Label6,40,5,clGreen,clWhite,s);
CB1rec:=SpTypeRec; CB1rec.nitems:=4; MakeRadioGroup(1,0,20,25,270,115);
MaketheButton(Form2.Button9,105,145,80,20,'Browse'); saveDm:=false;
OuttoLabel(Form2.Label7,190,145,clGreen,clWhite,
'First set all options');
IF(fnout='')THEN GetDir(0,fnout);
{L1rec:='File Name ='; E1rec:=fnout;}
L1rec:='Digit number after comma ='; E1rec:='0';
MakeEdits(10,190,170,90,1); {WITH Form2.Edit1 DO
 BEGIN Left:=105; Width:=Round(200*scrsize);
 END;}
WITH CB1rec DO
 BEGIN nitems:=3; ar[1]:=' Use format:   +-.zzzzzz+-E';
 ar[2]:=' Output only interval  ';
 ar[3]:=' Output channels as X, e.g. as d ';
 END;
MakeCheckListBox(30,220,250,58); WITH Form2.CheckListBox1 DO
 BEGIN Checked[0]:=false; Checked[2]:=ch_ang;
 END;
WITH CB1rec DO
 BEGIN nitems:=3; indx:=1;
 ar[1]:='   Output of spectrum counts';
 ar[2]:='   Output of spectrum errors';
 ar[3]:='   Show the spectrum';
 END;
MakeRadioGroup(2,0,20,280,270,85);
Form2.ShowModal; IF(ModalRes=0)THEN Exit; WITH Form2 DO
 BEGIN im:=RadioGroup1.ItemIndex; {fnout:=Edit1.Text;}
 spvar:=RadioGroup2.ItemIndex; IF(spvar=2)THEN
  BEGIN ShowCurrentSpectrum; Exit;
  END;
 WITH CheckListBox1 DO
  BEGIN scfrmt:=Checked[0]; ch_ang:=Checked[2];
  END;
 WITH spec[numsp] DO
  BEGIN i1:=a1; i2:=a2; IF(CheckListBox1.Checked[1])THEN
   BEGIN i1:=a11; i2:=a22;
   END;
  END;
 END;

Form2.SaveDialog1.Filter:='Files(.spc)|*.ini|All|*.*';
SaveFileDial(Form2.SaveDialog1,fnout,ok);
IF(NOT ok)THEN Exit;
s:=Form2.Edit1.Text; Zval(s,r);
IF(ModalRes=0)THEN
 BEGIN ShowMess('N of digits wrong= '+s); j:=0;
 END          ELSE j:=Round(r);
sx:=-1E17; sn:=1E17; FOR i:=i1 TO i2 DO WITH spec[numsp] DO
 BEGIN IF(spvar=0)THEN r:=y[i] ELSE r:=SQR(e[i]);
 IF(r > sx)THEN sx:=r; IF(r < sn)THEN sn:=r;
 END;
sx:=AMAX1(ABS(sx),ABS(sn)); ok:=true;
CASE im OF{Write}
0: BEGIN IF(sx>32767)THEN
    BEGIN ConvertStr(sx,25,0); Compress(sedz);
    ShowMess('Can not save spectrum as 2 byte data, max= '+sedz);
    ok:=false; Exit;
    END;
   spec[numsp].Write2Binary(i1,i2,fnout);
   END;
1: BEGIN IF(sx>2147483647)THEN
    BEGIN ConvertStr(sx,25,0); Compress(sedz);
    ShowMess('Can not save spectrum as 4 byte data, max= '+sedz);
    ok:=false; Exit;
    END;
   spec[numsp].Write4Binary(i1,i2,fnout);
   END;
2: spec[numsp].WriteTxt(i1,i2,fnout,j,scfrmt);
3: spec[numsp].WriteTxt3(i1,i2,fnout,j,scfrmt,ch_ang);
ELSE END;
MakeForm(1);
IF(spvar=0)THEN s:='Spectrum ' ELSE s:='Variance ';
s:=s+IntToStr(numsp);
WITH LB1rec DO
 BEGIN nitems:=2;
 IF(ok)THEN ar[1]:=s
       ELSE ar[1]:='Writing failure. Not ';
 ar[2]:='saved to '+fnout; Writeln(fout,ar[1]+' '+ar[2]);
 END;
MakeListBox(5,40,310,120); Form2.ShowModal;
END;
PROCEDURE GetTOFInfo;
VAR i,j:INTEGER;
BEGIN IF(mriamode=3)THEN Exit; MakeForm(1);
strgrW[0]:=170; strgrW[1]:=90;
CASE spec[numsp].tofang OF
0: BEGIN s:='Check the TOF - information:'; j:=4;
   strgrT[1]:='Channel width (mks) = ';
   strgrT[2]:='Spectrum delay (chan) =';
   strgrT[3]:='Bragg angle (deg) = ';
   strgrT[4]:='Flight Path(m) =';
   WITH spec[numsp] DO
    BEGIN strgrNn[1,1]:=chw; strgrNn[2,1]:=delay;
    strgrNn[3,1]:=theta; strgrNn[4,1]:=FPath;
    END;
   END;
1: BEGIN s:='Check the angular information:'; j:=4;
   strgrT[1]:='Zero shift (deg) ='; strgrT[2]:='Lambda (angst) = ';
   strgrT[3]:='Channel width (deg) = ';
   strgrT[4]:='2theta at chan1 (deg) = ';
   WITH spec[numsp] DO
    BEGIN strgrNn[1,1]:=delay; strgrNn[2,1]:=lambda; strgrNn[3,1]:=delx;
    strgrNn[4,1]:=x[a1];
    END;
   END;
ELSE Exit; END;
OuttoLabel(Form2.Label6,10,15,clGreen,clWhite,s);
IF(spec[numsp].tofang=1)THEN
 BEGIN s:='Warning: the spectrum is 2theta array.';
 OuttoLabel(Form2.Label7,40,40,clGreen,clWhite,s);
 s:='Zero shift also 2theta';
 OuttoLabel(Form2.Label8,40,55,clGreen,clWhite,s);
 END;
PuttoTable(30,90,j,j,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO j DO Zval(StringGrid1.Cells[0,i-1],har[i]);
 WITH spec[numsp] DO
  CASE tofang OF
  0: BEGIN chw:=har[1]; delay:=har[2]; theta:=har[3]; FPath:=har[4];
     END;
  1: BEGIN delay:=har[1]; lambda:=har[2]; chw:=har[3]; x[1]:=har[4];
     END;
  ELSE END;
 END;
END;
PROCEDURE ReadDSpacings(CONST dsfn:STRING);
{data format: d(or 0) err chan(th,2th) h k l}
VAR i,j,k:INTEGER; ch,r:REAL;
BEGIN AssignFile(ft,dsfn); {$I-} Reset(ft); {$I+}; i:=0;
WHILE(NOT EoF(ft))DO
 BEGIN FOR j:=1 TO 6 DO onl[j]:=0; EnterStr(ft); fffins(k,sedz);
 IF(k=0)THEN CONTINUE; Inc(i); WITH dspa[i] DO
  BEGIN d:=onl[1]; e:=onl[2]; x:=onl[3];
  IF((ABS(onl[1])+ABS(onl[3]))=0)THEN
   BEGIN ShowMess('Wrong data (ds,chans or angles'); ModalRes:=0; Exit;
   END;
  WITH spec[numsp] DO
   BEGIN ch:=(onl[3]-delay)/radian; IF(dstype=2)THEN ch:=ch/2;
   r:=505.556*SIN(theta/radian)*FPath;
   CASE dstype OF
   1,2: IF(ch<>0)THEN d:=0.5*lambda/SIN(ch); {Angles}
   3:   IF(r<>0)THEN d:=(chw*(onl[3]-delay))/r;   {ToF}
   ELSE END;
   END;
  h:=Round(onl[4]); k:=Round(onl[5]); l:=Round(onl[6]);
  END;
 END;
mdsp:=i; keyAuto:=0; CloseFile(ft);
END;
PROCEDURE MakeFourierSpectrum;
CONST posneg:ARRAY[1..2] OF STRING = ('Positive','Negative');
      shbfst:STRING = ' spectrum formed';
VAR xhead,i,j,ir,i1,i2,ms,j1,j2:INTEGER; sint,s,fn:STRING; ok:BOOLEAN;
    eneg,epos,x,th,r0,r1,x0,fpos,fneg,s11,s22,s12,b1,b2,det,ch,e,z:REAL;
    che:ARRAY[1..4] OF BOOLEAN; fnar:ARRAY[1..200] OF STRING;
 PROCEDURE DisplRes(n:INTEGER);
 BEGIN WITH LB1rec DO WITH spec[n] DO
  BEGIN nitems:=2; ar[1]:=s+shbfst+' as Sp'+IntToStr(n);
  ar[2]:='Range= '+IntToStr(a1)+' - '+IntToStr(a2);
  Writeln(fout,ar[1]+'; '+ar[2]);
  END;
 END;
 PROCEDURE GetPNW(i:INTEGER);
 BEGIN fneg:=spec[3].y[i]; fpos:=spec[2].y[i];
 eneg:=spec[3].e[i]; epos:=spec[2].e[i]; e:=SQRT(SQR(epos)+SQR(eneg));
 wh:=1/AMAX1(1,SQR(e)); {x:=(fpos-fneg)/AMAX1(e,1);
 IF(ABS(x)>th)THEN wh:=wh/AMAX1(1,ABS(x)*ABS(x));} z:=(2*i-x0)/cadl;
 END;
{*}
BEGIN spvar:=0; CB1rec.indx:=1; fn:='C:\'; xhead:=20; LB1rec.nitems:=0;
REPEAT L0rec:='Make a Fourier spectrum'; MakeForm(1);
SaveHelp(MakeFSp_n,MakeFSp); WITH CB1rec DO
 BEGIN nitems:=5;
 ar[1]:=' Form the positive spectrum';
 ar[2]:=' Form the negative spectrum';
 ar[3]:=' Adapt the both spectra';
 ar[4]:=' Form the Fourier difference';
 ar[5]:=' Exit';
 END;
MakeRadioGroup(1,0,20,30,260,180);
s:=' Max of positive spectrum should be greater ';
OuttoLabel(Form2.Label5,5,240,clMaroon,clWhite,s);
s:=' than that of negative one ';
OuttoLabel(Form2.Label6,5,257,clMaroon,clWhite,s);

Form2.ShowModal; IF(ModalRes=0)THEN Exit;
ir:=Form2.RadioGroup1.ItemIndex+1;
IF(ir<3)THEN WITH Form2 DO
 BEGIN WITH OpenDialog1 DO
  BEGIN Title:='      Select the file group';
  InitialDir:=defspdir; Options:=Options+[ofAllowMultiSelect];
  FileName:='';
  END;
 IF(OpenDialog1.Execute)THEN WITH OpenDialog1.Files DO
  BEGIN sfcount:=MIN0(Count,200);
  FOR i:=0 TO sfcount-1 DO fnar[i+1]:=Strings[i];
  END                   ELSE
  BEGIN ModalRes:=0; Exit;
  END;
 END;
i1:=spec[1].a1; i2:=spec[1].a2; ms:=0;
fn:=ExtractFileDir(fnar[1]); defspdir:=fn;
CASE ir OF
1,2:
   BEGIN MakeForm(1); FOR i:=1 TO 16384 DO onl[i]:=0; numsp:=1;
   FOR j:=1 TO sfcount DO
    BEGIN spec[1].sfn:=fnar[j]; spec[1].Read4Binary(ok);
    IF(ok)THEN
     BEGIN i1:=spec[1].a1; i2:=spec[1].a2;
     FOR i:=i1 TO i2 DO onl[i]:=onl[i]+spec[1].y[i]; Inc(ms);
     END;
    END;
   WITH spec[ir+1] DO
    BEGIN a1:=i1; a2:=i2; a11:=a1+1; a22:=a2-1; spin:=true;
    END;
   FOR i:=i1 TO i2 DO
    BEGIN spec[ir+1].y[i]:=onl[i]/AMAX0(1,ms);
    spec[ir+1].e[i]:=spec[ir+1].y[i];
    END;
   s:=posneg[ir]; DisplRes(ir+1); CB1rec.indx:=ir+1;
   MakeListBox(5,10,305,260); Form2.ShowModal;
   END;
3: BEGIN L0rec:=' Adapting positive and negative spectra';  { ADAPT }
   MakeForm(1); WITH spec[2] DO
    BEGIN j1:=a11; j2:=a22;
    END;
   MakeBevel(5,15,300,160,1);
   s:='Interval = '+IntToStr(j1)+'   '+IntToStr(j2);
   OuttoLabel(Form2.Label5,90,25,clGreen,clWhite,s);
   WITH CB1rec DO
    BEGIN nitems:=1; ar[1]:='   Suppress the linear coefficient';
    END;
   MakeCheckListBox(20,60,280,80); Form2.CheckListBox1.Checked[0]:=true;
    {Items.Add('   Form standard fit controls');
    Items.Add('   Fit the spectrum position');
    Items.Add('   Fit the width parameter W0');
    Items.Add('   Fit the width parameter W1');}
   MakeBevel(5,190,300,120,2);
   s:='Enter the interval bounds for adaptation';
   OuttoLabel(Form2.Label6,10,200,clGreen,clAqua,s);
   L1rec:='Beginning = '; E1rec:=IntToStr(j2-(j2 DIV 3));
   L2rec:='End = '; E2rec:=IntToStr(j2);
   MakeEdits(60,200,240,70,2);
   Form2.ShowModal; IF(ModalRes=0)THEN Exit;
   s:=Form2.Edit1.Text; Zval(s,r); ic1:=Round(r); spec[2].a11:=ic1;
   s:=Form2.Edit2.Text; Zval(s,r); ic2:=Round(r); spec[2].a22:=ic2;
   x0:=(ic1+ic2)DIV 2; cadl:=ic2-ic1+1; IF(cadl<1)THEN
    BEGIN ShowMess('Error, interval less than 1'); Exit;
    END;
   {FOR i:=0 TO 3 DO
    IF(Form2.CheckListBox1.Checked[i])THEN che[i+1]:=true
                                      ELSE che[i+1]:=false;}
   {gfit.npar:=4; mpoint:=ic2-ic1+1; FormParameters;} {cb.ipr:=1;}
   {IF(che[1])THEN WITH gfit.cb DO
    BEGIN gnit:=30; step:=0.25; damp:=0.01; liqu:=1;
    END;
   par[1].p:=1; par[1].pl:=0.1;
   par[2].pl:=0; par[2].pu:=0; par[2].p:=0;
   par[3].p:=1; par[3].pl:=0.9; par[3].pu:=1.5;}
   {IF(NOT che[2])THEN} { Switch off position}
    {BEGIN par[2].pl:=par[2].p; par[2].pu:=par[2].p;
    END;}
   {IF(NOT che[3])THEN  Switch off Width0
    BEGIN par[3].pl:=par[3].p; par[3].pu:=par[3].p;
    END;
   IF(NOT che[4])THEN  Switch off Width1
    BEGIN par[4].pl:=par[4].p; par[4].pu:=par[4].p;
    END;}
   {Fit and output}
   {LeastSquaresFit(zlokar,regul);}
   {prifch; cmax:=0; lsmprn(zlokar,cmax);}
   s11:=0; s22:=0; s12:=0; b1:=0; b2:=0; th:=12;
   {FOR j:=1 TO 3 DO}
    BEGIN FOR i:=ic1 TO ic2 DO
     BEGIN GetPNW(i); s11:=s11+fneg*wh*fneg; s12:=s12+fneg*wh*fneg*z;
     s22:=s22+fneg*wh*fneg*z*z; b1:=b1+fpos*wh*fneg;
     b2:=b2+fpos*wh*fneg*z;
     END;
    det:=s11*s22-s12*s12; IF((det=0)OR(s11=0))THEN
     BEGIN ShowMess('Error, determinant zero-valued'); Exit;
     END;
    IF(Form2.CheckListBox1.Checked[0])THEN
     BEGIN r0:=b1/s11; r1:=0;
     END                              ELSE
      BEGIN r0:=(b1*s22-s12*b2)/det; r1:=(b2*s11-s12*b1)/det;
      END;
    FOR i:=i1 TO i2 DO
     BEGIN z:=(2*i-x0)/cadl; spec[3].y[i]:=(r0+r1*z)*spec[3].y[i];
     spec[3].e[i]:=(r0+r1*z)*spec[3].e[i];
     END;
    th:=th/2; ch:=0; FOR i:=ic1 TO ic2 DO
     BEGIN GetPNW(i); ch:=ch+SQR(fpos-fneg)*wh;
     END;
    ch:=ch/cadl;
    END;
   sint:='Adaptation interval = '+IntToStr(ic1)+'-'+IntToStr(ic2);
   MakeForm(1); WITH LB1Rec DO
    BEGIN ar[1]:=' '; ar[2]:=sint; ar[3]:='Adaptation coefficients: = ';
    ConvertStr(r0,10,5); ar[4]:='  k0 = '+sedz;
    ConvertStr(r1,10,5); ar[5]:='  k1 = '+sedz;
    ConvertStr(ch,10,5); ar[6]:='  chi2 = '+sedz;
    nitems:=7; ar[7]:='Make graphs of spectrum2 on spectrum3';
    FOR i:=1 TO nitems-1 DO Writeln(fout,ar[i]);
    END;
   MakeListBox(5,10,305,260); Form2.ShowModal;
   CB1rec.indx:=4; {FOR i:=i1 TO i2 DO
    BEGIN zlokar(r,r,f,i-ic1+1,3); sp[2,i].y:=f;
    END;}
   LB1rec.nitems:=0;
   END;
4: BEGIN  FOR i:=i1 TO i2 DO
    BEGIN spec[1].y[i]:=spec[2].y[i]-spec[3].y[i];
    spec[1].e[i]:=AMIN1(SQRT(ABS(spec[2].e[i]+spec[3].e[i])),46340);
    END;
   WITH spec[1] DO
    BEGIN a1:=i1; a2:=i2; a11:=a1; a22:=a2; spin:=true;
    effn:=false; absn:=false; tofang:=0;
    END;
   SetNoPrep(13,true);
   {s:=' Check Spectrum 1 information';}
   CheckSpectrumInfo(s,1,ok); IF(NOT ok)THEN Exit;
   s:='RTOF'; DisplRes(1);
   MakeForm(1); MakeListBox(5,10,305,260);
   Form2.ShowModal; CB1rec.indx:=5;
   END;
5: Exit;
ELSE END;
UNTIL false;
END;
PROCEDURE InputSpectrumData(sve:INTEGER);
VAR i,i1,i2:INTEGER;
BEGIN WITH spec[numsp] DO
 BEGIN i1:=Round(a1); i2:=MAX0(Round(a2),nspch);
 IF(sve=2)THEN i:=emosp ELSE i:=smosp;
 CASE i OF{READ}
 1: Read2Binary(ok);
 2: Read4Binary(ok);
 3: ReadTxt(i1,i2,ok);
 4: ReadTxt3(i1,i2,ok); {threes x,y,e}
 ELSE END;
 fismax1;
 END;
END;
PROCEDURE FormDN2effSp;
VAR np:INTEGER; zd:REAL;
BEGIN WITH spec[0] DO
 BEGIN np:=1024; zd:=0; chw:=64; FPath:=25; delay:=0; spin:=true;
 spec[0].Vancal(np,chw,FPath,zd); a2:=1024; a11:=1; a22:=1024;
 sfn:='DN2-vanadium';
 END;
END;
PROCEDURE zlokar(VAR y,wh,f:REAL; k,typ:INTEGER);
{Purpose: Arithmetic procedure for comparing Fourier distributions
          f2(x) = A*f1((x-P)/(Dx+W))
Version: Mar 13 1998, May 31 2001}
VAR x,a,p,d,w,zn,z,fz,fzz,e:REAL; i,j:INTEGER;
BEGIN j:=k+ic1-1; y:=spec[1].y[j]; x:=j; WITH gfit DO
 BEGIN a:=par[1].p; p:=par[2].p; w:=par[3].p; d:=par[4].p;
 END;
zn:=(d*x+w); z:=(x-p)/zn; i:=Round(z); f:=spec[2].y[i]; fz:=0; fzz:=0;
IF((NOT((i=ic1)OR(i=ic2)))AND(InInt(i,ic1,ic2)))THEN WITH spec[2] DO
 BEGIN f:=y[i]; IF((i=ic1+1)OR(i=ic2-1))THEN
  BEGIN f:=(y[i-1]+y[i+1])*0.5;
  fz:=(y[i+1]-y[i-1])*0.5;
  fzz:=y[i+1]-2*y[i]+y[i-1];
  END                                        ELSE
  BEGIN
  f:=(12*(y[i-1]+y[i+1])-3*(y[i-2]+
   y[i+2])+17*y[i])/35;
  fz:=
   (2*(y[i+2]-y[i-2])+(y[i+1]-y[i-1]))/10;
  fzz:=(2*(y[i+2]+y[i-2])-
  (y[i+1]+y[i-1])-2*y[i])/7;
  END;
 END;
f:=((i-z)/2*fzz+fz)*(i-z)+f; WITH gfit DO
 BEGIN par[1].drv:=f; par[2].drv:=-a*fz/zn;
 par[3].drv:=par[2].drv*z; par[4].drv:=par[3].drv*x;
 END;
f:=a*f; e:=spec[1].e[j]; wh:=1/AMAX1(1,SQR(e));;
x:=(y-f)/e; IF(ABS(x)<0)THEN wh:=wh/AMAX1(1,ABS(x)*ABS(y));
END;
PROCEDURE MakePeakInfo(ii:INTEGER);
VAR i,j,k:INTEGER; ok:BOOLEAN; s1:STRING;
BEGIN s:='.......Info for Entering the '; k:=pmod[ii].typ;
ok:=k IN [1..8]; IF(ok)THEN s1:='Special ';
IF(k=0)THEN s1:='Real '; IF(k=-1)THEN s1:='Doublesigned ';
Writeln(fin,s+s1+' Model');
s:='* No of model'; IF(ok)THEN
 BEGIN Writeln(fin,s+' and type'); Writeln(fin,ii:2,k:3);
 IF(k IN [4,5,8])THEN
  BEGIN Writeln(fin,'* rvoigt'); Writeln(fin,rvoigt:10:4);
  END;
 Exit;
 END;
Writeln(fin,s); Writeln(fin,ii:2); WITH pmod[ii] DO
 BEGIN s:=IntToStr(nl)+' '; ftos(rl,14,7,sedz); s:=s+sedz;
 ftos(cs,14,7,sedz); s:=s+sedz; ftos(wi,14,7,sedz); s:=s+sedz;
 ftos(ac,14,7,sedz); s:=s+sedz; {ConvertStr(cpw,7,2);} s:=s+' 0';
 Writeln(fin,s);
 FOR i:=1 TO 39 DO
  BEGIN s:=''; FOR j:=1 TO 5 DO
   BEGIN k:=(i-1)*5+j; IF(k<194)THEN
    BEGIN r:=morr[k]; ftos(r,14,7,sedz); s:=s+sedz;
    END;
   END;
  Writeln(fin,s);
  END;
 END;
END;
PROCEDURE ShowCurrentSpectrum;
VAR i,j,k,l,m:INTEGER;
BEGIN L0rec:='Spectrum '+IntToStr(numsp)+' '+spec[numsp].sfn;
MakeForm(1);
s:=' Channel     X-value             Counts        Error';
OuttoLabel(Form2.Label5,5,0,clMaroon,clWhite,s);
WITH spec[numsp] DO
 BEGIN m:=(a2-a1) DIV 2000; IF((m*2000)<(a2-a1))THEN Inc(m); j:=1;
 k:=MIN0(2000,a2-a1);
 REPEAT WITH LB1rec DO
  BEGIN nitems:=k; FOR i:=1 TO k DO
   BEGIN l:=(j-1)*2000+i;
   ConvertStr(Float(l),5,0); s:=sedz; ConvertStr(x[l],12,4); s:=s+sedz;
   ConvertStr(y[l],11,0); s:=s+sedz;
   ConvertStr(e[l],9,0); s:=s+sedz; ar[i]:=s;
   END;
  MakeListBox(5,20,315,340);
  Form2.ShowModal; IF(ModalRes=0)THEN Exit; Inc(j);
  END;
 UNTIL j>m;
 END;
END;

BEGIN
END.
