UNIT vmriafs;
INTERFACE
USES Windows,  Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs,  StdCtrls, ExtCtrls, Grids,   vzlocom,  vmria0,   vmria2,
     vmriahkl, vmriahlp, vgfit,    varfun,  vmriarit, vstdcons, vmria00;

PROCEDURE FourierSynthesis;
PROCEDURE BuildFHKL(VAR ic:INTEGER; iph,io:INTEGER);
PROCEDURE PutFkArr(iref,iph,i,mcj,io:INTEGER; phc,phs:REAL);
PROCEDURE calcFk(x,y,z:REAL; iph,im,mdg,ic:INTEGER; VAR rr:REAL);
PROCEDURE calqc3(VAR ok:BOOLEAN; i,j,k:INTEGER);
PROCEDURE AnalyzeFourierMap3(ic,iph:INTEGER);
PROCEDURE AssignPeaksAtoms(iph:INTEGER);
PROCEDURE EnterExpFkcs;
PROCEDURE MakeMapGraph;
PROCEDURE ShowFSPeaks;
PROCEDURE FindNearestPeak(VAR irx:INTEGER; irc,iph:INTEGER);
PROCEDURE Prints;
VAR fres:ARRAY[1..3] OF REAL; {resolutions in 3dim Fourier synth.}
    nx,ny,nz,mn1,im:INTEGER;
    ic:INTEGER;  {number of hkls built for 3dim.synthesis}
    amapx,amapn:REAL;              {max,min of Fourier map}
    amapa,PMsfa:REAL;              {area of Rsf and PMsf}
    xi,yi,zi,dist:REAL;            {X of checked obj.,distance}
    prifour:BOOLEAN;               {save all fourier results in res}
IMPLEMENTATION
PROCEDURE Prints;
BEGIN IF(prifour)THEN Writeln(fout,s);
Inc(LB1rec.nitems); LB1rec.ar[LB1rec.nitems]:=s;
END;
PROCEDURE FourierSynthesis;
{ rho(R) = SUM exp(-q*H*V) SUM F(T'*H)*EXP(-q*((T'*H)*R))
            T                  R,
  R=coordinate, T=symmetry transform  q=i*2pi, i=-1^0.5

Version: Jan 29 1996, New Version: Apr 10 1996, Delphi=Aug 15 2001}
VAR   iph,i,j,i0,io,n:INTEGER; ok:BOOLEAN;
LABEL L1;
BEGIN L0rec:='3-dimensional Fourier synthesis';
MakeForm(1); SaveHelp(FSynth_n,FSynth);
s:=' Take the structure factors from: ';
OuttoLabel(Form2.Label6,40,0,clGreen,clWhite,s);
iph:=1; WITH CB1rec DO
 BEGIN nitems:=5; indx:=1; IF(mriamode=2)THEN indx:=2;
 ar[1]:=' Rietveld fitting';
 ar[2]:=' powder match';
 ar[3]:=' a file';
 ar[4]:=' as difference';
 ar[5]:=' calculated';
 END;
MakeRadioGroup(1,0,40,20,220,130);
strgrW[0]:=100; strgrW[1]:=78; strgrW[2]:=78;
s:=' Check the range of bin coordinates ';
OuttoLabel(Form2.Label7,25,150,clGreen,clWhite,s); WITH frec DO
 BEGIN strgrT[1]:=' x0 - x1'; strgrNn[1,1]:=x0; strgrNn[1,2]:=x1;
 strgrT[2]:=' y0 - y1'; strgrNn[2,1]:=y0; strgrNn[2,2]:=y1;
 strgrT[3]:=' z0 - z1'; strgrNn[3,1]:=z0; strgrNn[3,2]:=z1;
 END;
PuttoTable(25,170,3,3,2,{ndig}8);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=1;
 ar[1]:=' Fourier synthesis';
 ar[2]:=' Show the peaks';
 END;
MakeRadioGroup(2,0,50,245,220,60);
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:=' Save results in res-file';
 END;
MakeCheckListBox(50,310,220,20);
Form2.CheckListBox1.Checked[0]:=false;
L1rec:=' Sensitivity='; ConvertStr(frec.sens,5,2); E1rec:=sedz;
MakeEdits(50,200,337,70,1);
s:=' Level from Max for analyzing peaks ';
OuttoLabel(Form2.Label8,50,357,clMaroon,clWhite,s);

WITH Form2 DO WITH frec DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 io:=RadioGroup1.ItemIndex; im:=RadioGroup2.ItemIndex;
 prifour:=false; IF(CheckListBox1.Checked[0])THEN prifour:=true;
 IF(im=1)THEN
  BEGIN ShowFSPeaks; Exit;
  END;
 FOR i:=1 TO 2 DO Zval(StringGrid1.Cells[i-1,0],har[i]);
 x0:=har[1]; x1:=har[2]; dx:=(x1-x0)/30; nx:=30;
 FOR i:=1 TO 2 DO Zval(StringGrid1.Cells[i-1,1],har[i]);
 y0:=har[1]; y1:=har[2]; dy:=(y1-y0)/30; ny:=30;
 FOR i:=1 TO 2 DO Zval(StringGrid1.Cells[i-1,2],har[i]);
 z0:=har[1]; z1:=har[2]; dz:=(z1-z0)/30; nz:=30;
 mn1:=0;{3dim.} IF(x1=x0)THEN
  BEGIN nx:=1; mn1:=1;
  END;
 IF(y1=y0)THEN
  BEGIN ny:=1; mn1:=2;
  END;
 IF(z1=z0)THEN
  BEGIN nz:=1; mn1:=3;
  END;
 IF((x0=x1)AND(y0=y1)AND(z0=z1))THEN
  BEGIN ShowMess('Error, 3 equal bound pairs'); Exit;
  END;
 Zval(Edit1.Text,frec.sens);
 END;
{Get the phase}iph:=1; IF(nph>1)THEN
 BEGIN MakeForm(1); s:=' Select the phase ';
 OuttoLabel(Form2.Label6,40,10,clGreen,clWhite,s);
 CB1rec:=Num4Rec; MakeRadioGroup(1,0,50,30,200,120);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 iph:=Form2.RadioGroup1.ItemIndex+1;
 END;
CASE io OF
0: IF(nofit[1])THEN
    BEGIN ShowMess('No Rietveld fit performed'); Exit;
    END;
1: IF(nofit[3])THEN
    BEGIN ShowMess('No Powder Match performed'); Exit;
    END;
2: BEGIN IF(nophasi)THEN
    BEGIN ShowMess('No phase information available'); Exit;
    END;
   EnterExpFkcs; IF(ModalRes=0)THEN Exit ELSE GOTO L1;
   END;
3: BEGIN IF(nofit[3])THEN
    BEGIN ShowMess('No Powder Match performed'); Exit;
    END;
   PMsfa:=0; amapa:=0; i0:=Geti0(iph)+10;
   FOR i:=1 TO lat[iph].nhkl DO
    BEGIN PMsfa:=PMsfa+SQRT(ABS(gfit.par[i0+i].p));
    amapa:=amapa+SQRT(SQR(hkla[i,iph].Fkc)+SQR(hkla[i,iph].Fks))
    END;
   END;
4: IF(lat[iph].nhkl=0)THEN
    BEGIN ShowMess(cnohkl+' for this phase'); Exit;
    END;
ELSE END;
{Compute the Biso - median as a robust estimate i0:=Geti0(iph);
biso:=0; n:=lat[iph].nat; j:=n DIV 2;
FOR i:=1 TO n DO onl[i]:=pold[i0+15+(i-1)*10].p; marran(n,1);
IF(Odd(n))THEN biso:=onl[j+1]
          ELSE biso:=(onl[j]+onl[j+1])*0.5;}
L1: IF(io IN [0,1,3])THEN UpdateLatAt;
Writeln(fout,' ':10,'3-Dimensional Fourier Synthesis');
WITH frec DO Writeln(fout,'X,Y,Z range = ',
 x0:7:3,' - ',x1:7:3,y0:9:3,' - ',y1:7:3,z0:9:3,' - ',z1:7:3);
BuildFHKL(ic,iph,io);
MakeMapGraph; SaveHelp(ShFSPeaks_n,ShFSPeaks);
LB1rec.nitems:=0; AnalyzeFourierMap3(ic,iph);
ok:=false; FOR i:=1 TO nph DO ok:=ok OR (lat[i].nat<>0);
IF(ok AND(NOT(nfr=0)))THEN AssignPeaksAtoms(iph);
MakeForm(0); MakeListBox(0,5,310,360);
SetLength(hklaf,0);
Form2.ShowModal;
END;
PROCEDURE BuildFHKL(VAR ic:INTEGER; iph,io:INTEGER);
{To prepare increasing Miller indices and Fhkl's
 Version: Apr 8 1996, delphi: Aug 29 2001}
VAR   i,j,k,iref,jt,ihx,ikx,ilx,jh,jk,jl,lh,lk,ll,ntr,nlsh,nind:INTEGER;
      ii,ish,ih,ik,il,jc,imn,ihn,ikn,iln:INTEGER;
      x,y,z,ph,phc,phs,rr,coefc,sh1,sh2,sh3,eps,normc:REAL;
LABEL L19,L1;
BEGIN IF(io=2)THEN GOTO L1;  {Str.factors from file}
WITH lat[iph] DO
 BEGIN coefc:=Fkmax; IF(nsg<>0)THEN
  BEGIN ntr:=nut; nlsh:=ntlv+1;
  END                          ELSE
   BEGIN ntr:=1; nlsh:=1;
   END;
 END;
{Determine the maximum indices}
ihx:=0; ikx:=0; ilx:=0; WITH lat[iph] DO
FOR iref:=1 TO nhkl DO WITH hkla[iref,iph] DO FOR jt:=1 TO ntr DO
 BEGIN jh:=Round(ut[1,jt]*h+ut[4,jt]*k+ut[7,jt]*l);
 jk:=Round(ut[2,jt]*h+ut[5,jt]*k+ut[8,jt]*l);
 jl:=Round(ut[3,jt]*h+ut[6,jt]*k+ut[9,jt]*l);
 ilx:=MAX0(ilx,ABS(jl)); ikx:=MAX0(ikx,ABS(jk)); ihx:=MAX0(ihx,ABS(jh));
 END;
nind:=(ilx+1)*(2*ikx+1)*(2*ihx+1);
IF(nind>8125)THEN
 BEGIN ShowMess('Max indices too large; reduced.');
 ilx:=MIN0(ilx,12); ikx:=MIN0(ikx,12); ihx:=MIN0(ihx,12);
 END;
{Form the increasing indices}
SetLength(hklaf,0); ic:=0; FOR ll:=0 TO ilx DO {skip the negative l}
FOR lk:=-ikx TO ikx DO
 BEGIN IF((ll=0)AND(lk<0))THEN CONTINUE; {skip the negative k}
 FOR lh:=-ihx TO ihx DO
  BEGIN IF((lh<=0)AND(lk=0)AND(ll=0))THEN CONTINUE; {skip 000}
  Inc(ic); IF(ic>4000)THEN GOTO L19; SetLength(hklaf,ic);
  hklaf[ic-1].h:=lh; hklaf[ic-1].k:=lk; hklaf[ic-1].l:=ll;
  END;
 END;
L19: FOR i:=0 TO ic-1 DO WITH hklaf[i] DO {Form the Fhkl's}
      BEGIN Fkc:=0; Fks:=0;
      END;
WITH lat[iph] DO FOR iref:=1 TO nhkl DO WITH hkla[iref,iph] DO
 BEGIN FOR ish:=1 TO nlsh DO
  BEGIN IF(i=1)THEN
   BEGIN sh1:=0; sh2:=0; sh3:=0;
   END   ELSE
    BEGIN sh1:=tlv[1,ish-1]; sh2:=tlv[2,ish-1]; sh3:=tlv[3,ish-1];
    END;
  FOR jt:=1 TO ntr DO
   BEGIN IF(ntr>1)THEN
    BEGIN ih:=Round(ut[1,jt]*h+ut[4,jt]*k+ut[7,jt]*l);
    ik:=Round(ut[2,jt]*h+ut[5,jt]*k+ut[8,jt]*l);
    il:=Round(ut[3,jt]*h+ut[6,jt]*k+ut[9,jt]*l);
    ph:=(shv[1,jt]+sh1)*h+(shv[2,jt]+sh2)*k+(shv[3,jt]+sh3)*l;
    ph:=-pi2*ph; phc:=COS(ph); phs:=SIN(ph);
    END           ELSE
     BEGIN ih:=h; ik:=k; il:=l; phc:=1; phs:=0;
     END;
   {Find the hkl in Rietv.hkl-table}
   FOR i:=0 TO ic-1 DO
   IF((ih=hklaf[i].h)AND(ik=hklaf[i].k)AND(il=hklaf[i].l))THEN
    BEGIN PutFkArr(iref,iph,i,0,io,phc,phs); BREAK;
    END;
   FOR i:=1 TO ic DO
   IF((ih=-hklaf[i].h)AND(ik=-hklaf[i].k)AND(il=-hklaf[i].l))THEN
    BEGIN PutFkArr(iref,iph,i,1,io,phc,phs); BREAK;
    END;
   END;
  END;
 END;
L1: {Eliminate the zeroes}jc:=0; imn:=100;
ihn:=100; ihx:=-100; ikn:=100; ikx:=-100; iln:=100; ilx:=-100;
FOR i:=0 TO ic-1 DO
 BEGIN rr:=AMAX1(ABS(hklaf[i].Fkc),ABS(hklaf[i].Fks));
 IF(rr<0.00001)THEN CONTINUE;
 hklaf[jc].h:=hklaf[i].h; hklaf[jc].k:=hklaf[i].k;
 hklaf[jc].l:=hklaf[i].l;
 hklaf[jc].Fkc:=hklaf[i].Fkc; hklaf[jc].Fks:=hklaf[i].Fks;
 ihn:=MIN0(ihn,hklaf[jc].h); ihx:=MAX0(ihx,hklaf[jc].h);
 ikn:=MIN0(ikn,hklaf[jc].k); ikx:=MAX0(ikx,hklaf[jc].k);
 iln:=MIN0(iln,hklaf[jc].l); ilx:=MAX0(ilx,hklaf[jc].l);
 ii:=ABS(hklaf[jc].h)+ABS(hklaf[jc].k)+ABS(hklaf[jc].l);
 IF(ii>0)THEN imn:=MIN0(imn,ii); Inc(jc);
 END;
ic:=jc; {Form the resolutions}
fres[1]:=1/AMAX0(ihx-ihn+1,1)/1.4142136;
fres[2]:=1/AMAX0(ikx-ikn+1,1)/1.4142136;
fres[3]:=1/AMAX0(2*ilx+1,1)/1.4142136;
Writeln(fout,'   Sensitivity, XYZ-Resolutions:',
 frec.sens:7:4,fres[1]:9:3,fres[2]:6:3,fres[3]:6:3);
IF(imn<>1)THEN ShowMess('Warning!  No first reflections');
amapx:=-1E16; amapn:=1E16;
ActivateForm2(250,300,20); Form2.Top:=250; s:=' steps out of ';
FOR i:=1 TO 30 DO FOR j:=1 TO 30 DO FOR k:=1 TO 30 DO amap[i,j,k]:=0;
FOR i:=1 TO nx DO {Main loop}
 BEGIN Form2.Caption:=IntToStr(i)+s+IntToStr(nx)+' done'; Form2.Show;
 FOR j:=1 TO ny DO FOR k:=1 TO nz DO WITH frec DO
  BEGIN x:=x0+(i-1)*dx; y:=y0+(j-1)*dy; z:=z0+(k-1)*dz;
  calcFk(x,y,z,iph,im,0,ic,rr); rr:=AMAX1(rr,0);
  eps:=(((i-1)*ny+j)*nz+k)*1E-7; amap[i,j,k]:=rr+eps;
  amapx:=AMAX1(amapx,rr); amapn:=AMIN1(amapn,rr);
  END;
 END;
Form2.Close;
normc:=1000/AMAX1(1,amapx);
FOR i:=1 TO 30 DO FOR j:=1 TO 30 DO FOR k:=1 TO 30 DO {Norm to 1000}
 BEGIN rr:=amap[i,j,k]*normc; amap[i,j,k]:=rr;
 END;
amapx:=1000; amapn:=0;
END;
PROCEDURE MakeMapGraph;
VAR i,j,k,ii,jj,kk,ll,cl1,cl2:INTEGER; r:REAL;
 PROCEDURE GraphPortion(ih,jh:INTEGER; c:LONGINT);
 BEGIN WITH Form2.Image1.Canvas DO
  BEGIN Pixels[exs(kk-ih),exs(ll-jh)]:=c;
  Pixels[exs(kk+ih),exs(ll+jh)]:=c;
  Pixels[exs(kk+jh),exs(ll-ih)]:=c;
  Pixels[exs(kk-jh),exs(ll+ih)]:=c;
  END;
 END;
BEGIN WITH LB1rec DO WITH frec DO
 BEGIN ar[1]:='  Fourier synthesis.  XYZ-Range:';
 ConvertStr(x0,5,2); s:=sedz; ConvertStr(x1,5,2); s:=s+sedz;
 ConvertStr(y0,7,2); s:=s+sedz; ConvertStr(y1,5,2); s:=s+sedz;
 ConvertStr(z0,7,2); s:=s+sedz; ConvertStr(z1,5,2); s:=s+sedz;
 ar[2]:=s; ar[4]:=' '; ar[3]:='Max amplitude = 1000';
 ar[5]:='Click on graph points to get their X,Y';
 ar[6]:='Use OK and BACK buttons to go along Z';
 nitems:=6;
 END;
cl1:=clFuchsia; cl2:=clAqua; nreac2:=1; frec.zc:=1;
REPEAT MakeForm(1); MakeListBox(0,250,310,120);
MaketheButton(Form2.Button8,260,375,50,20,'Back');
MaketheButton(Form2.Button12,0,375,95,20,'Save the Map');
MaketheButton(Form2.Button1,94,375,43,20,'OK');
Form2.Image1.Visible:=true; ClearParArea;
WITH frec DO IF(zc<1)THEN zc:=1 ELSE IF(zc>nz)THEN zc:=nz ELSE;
k:=frec.zc; amx:=0;
WITH Form2.Image1.Canvas DO
 BEGIN Pen.Style:=psSolid;  Pen.Color:=clAqua; Pen.Color:=clYellow;
 Font.Color:=clLime; MoveTo(exs(125),exs(25)); LineTo(exs(280),exs(25));
 LineTo(exs(280),exs(185)); LineTo(exs(125),exs(185));
 LineTo(exs(125),exs(25));
 TextOut(exs(110),exs(10),'Y'); TextOut(exs(285),exs(190),'X');
 r:=frec.sens; FOR i:=1 TO nx DO FOR j:=1 TO ny DO
  BEGIN {IF(nx=1)THEN
   BEGIN ii:=j; jj:=k;
   END          ELSE
  IF(ny=1)THEN
   BEGIN ii:=i; jj:=k;
   END          ELSE
  IF(nz=1)THEN}
   BEGIN ii:=i; jj:=j;
   END;
  kk:=125+ii*5; ll:=180-jj*5; IF(ABS(amap[i,j,k])>(amapx*r))THEN
   Pixels[exs(kk),exs(ll)]:=clFuchsia;
  IF(ABS(amap[i,j,k])>(amapx*0.5))THEN GraphPortion(1,0,cl1);
  IF(ABS(amap[i,j,k])>(amapx*0.75))THEN
   BEGIN GraphPortion(2,0,cl1); GraphPortion(1,1,cl1);
   END;
  amx:=AMAX1(amx,amap[i,j,k]);
  END;
 WITH frec DO TextOut(exs(5),exs(210),'Z= '+FltoSt(z0+(k-1)*dz,2));
 END;
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
Inc(frec.zc);
UNTIL frec.zc > nz;
END;
PROCEDURE AnalyzeFourierMap3(ic,iph:INTEGER);
{ Find the 3dimensional peaks,
  Version: Jan 29 1996,  New Version: Apr 10 1996; delfi; Aug 31 2001}
VAR i,j,k,ii,jj,kk,it,ifail,kxr,kxl,kyr,kyl,kzr,kzl:INTEGER;
    x,y,z,xi,yi,zi,vF,step,wxr,wyr,wzr,wxl,wyl,wzl,rr,det,ur,rr0:REAL;
    ok:BOOLEAN; f:ARRAY[1..3] OF REAL;
BEGIN nfr:=0;
IF(prifour)THEN
 BEGIN Writeln(fout,' ':10,'Detected peaks:');
 Writeln(fout,'  N      X        Y        Z    Amplitude');
 END;
FOR ii:=1 TO nx DO FOR jj:=1 TO ny DO FOR kk:=1 TO nz DO WITH frec DO
 BEGIN x:=x0+(ii-1)*dx; y:=y0+(jj-1)*dy; z:=z0+(kk-1)*dz;
 calqc3(ok,ii,jj,kk); IF(NOT ok)THEN CONTINUE;
 {Gradient-descent based refinement: f(x)=f(x_0)+(f',d)+.5*(f''d,d)
  equation: f'(x)=0 <=>  f' - f''*d = 0}
 vF:=0; step:=0.1; FOR it:=1 TO 3 DO
  BEGIN xi:=x; yi:=y; zi:=z; calcFk(xi,yi,zi,iph,im,1,ic,rr);
  x:=xi; y:=yi; z:=zi; vF:=rr; IF(it=1)THEN rr0:=ABS(rr);
  InvertMatrix3(ok,true,det); IF((NOT ok) OR(ABS(rr)<rr0))THEN BREAK;
  FOR i:=1 TO 3 DO
   BEGIN f[i]:=0; FOR j:=1 TO 3 DO f[i]:=f[i]+gra3[j]*mat3[i,j];
   END;
  IF(AMAX3(ABS(f[1]),ABS(f[2]),ABS(f[3]))<0.0001)THEN BREAK;
  FOR i:=1 TO 3 DO f[i]:=step*f[i];
  x:=x+f[1]; IF(x>1)THEN x:=x-1; IF(x<-1)THEN x:=x+1;
  IF(x<x0)THEN x:=x0 ELSE IF(x>x1)THEN x:=x1 ELSE;
  y:=y+f[2]; IF(y>1)THEN y:=y-1; IF(y<-1)THEN y:=y+1;
  IF(y<y0)THEN y:=y0 ELSE IF(y>y1)THEN y:=y1 ELSE;
  z:=z+f[3]; IF(z>1)THEN z:=z-1; IF(z<-1)THEN z:=z+1;
  IF(z<z0)THEN z:=z0 ELSE IF(z>z1)THEN z:=z1 ELSE;
  END;
 {End of refinement loop}
 Inc(nfr); {one peak more} IF(nfr>500)THEN
  BEGIN nfr:=500; Exit;
  END;
 refla[nfr].x:=x; refla[nfr].y:=y; refla[nfr].z:=z; refla[nfr].v:=vF;
 IF(prifour)THEN Writeln(fout,nfr:5,x:9:3,y:9:3,z:9:3,vF:9:3);
 {Find the width-intervals}
 ur:=amap[ii,jj,kk]*0.5;
 kxr:=ii; FOR i:=ii+1 TO nx DO IF(amap[i,jj,kk]<ur)THEN{Find Wx}
  BEGIN kxr:=i; BREAK;
  END;
 kxl:=ii; FOR i:=ii-1 DOWNTO 1 DO IF(amap[i,jj,kk]<ur)THEN
  BEGIN kxl:=i; BREAK;
  END;
 kyr:=jj; FOR i:=jj+1 TO ny DO IF(amap[ii,i,kk]<ur)THEN{Find Wy}
  BEGIN kyr:=i; BREAK;
  END;
 kyl:=jj; FOR i:=jj-1 DOWNTO 1 DO IF(amap[ii,i,kk]<ur)THEN
  BEGIN kyl:=i; BREAK;
  END;
 kzr:=kk; FOR i:=kk+1 TO nz DO IF(amap[ii,jj,i]<ur)THEN{Find Wz}
  BEGIN kzr:=i; BREAK;
  END;
 kzl:=kk; FOR i:=kk-1 DOWNTO 1 DO IF(amap[ii,jj,i]<ur)THEN
  BEGIN kzl:=i; BREAK;
  END;
 {Convert to coordinates}
 wxr:=(kxr+1-ii)*dx; wxl:=-(kxl+1-ii)*dx;
 wyr:=(kyr+1-jj)*dy; wyl:=-(kyl+1-jj)*dy;
 wzr:=(kzr+1-kk)*dz; wzl:=-(kzl+1-kk)*dz;
 END;
rr:=0; FOR i:=1 TO nfr DO rr:=AMAX1(rr,refla[i].v);
WITH LB1rec DO
 BEGIN ConvertStr(rr,10,2); Compress(sedz); Inc(nitems);
 ar[nitems]:=' Max ampl.= '+sedz+'   Resolutions:';
 ConvertStr(fres[1],8,4); Inc(nitems); ar[nitems]:='  in x ='+sedz;
 ConvertStr(fres[2],8,4); Inc(nitems); ar[nitems]:='  in y ='+sedz;
 ConvertStr(fres[3],8,4); Inc(nitems); ar[nitems]:='  in z ='+sedz;
 END;
WITH LB1rec DO
 BEGIN Inc(nitems);
 ar[nitems]:='  '+IntToStr(nfr)+' map peaks detected.';
 FOR i:=1 TO nfr DO WITH refla[i] DO
  BEGIN s:=IntToStr(i); AdjustSt(s,3); ConvertStr(x,8,3); s:=s+sedz;
  ConvertStr(y,8,3); s:=s+sedz; ConvertStr(z,8,3); s:=s+sedz;
  ConvertStr(v,9,1); s:=s+sedz; Inc(nitems); ar[nitems]:=s;
  END;
 END;
END;
PROCEDURE PutFkArr(iref,iph,i,mcj,io:INTEGER; phc,phs:REAL);
{To put the Fhkl members to array hklaf
 Version: Apr 12 1996,  delphi: Aug 29 2001}
VAR i0:INTEGER; Fkcc,Fksc,rk:REAL;
BEGIN WITH hkla[iref,iph] DO
CASE io OF
0,4: BEGIN Fkcc:=Fkc{*mul}; Fksc:=Fks{*mul};
     END;
1: GetSingleFk(iref,iph,Fkcc,Fksc);
3: BEGIN GetSingleFk(iref,iph,Fkcc,Fksc);
   rk:=PMsfa/AMAX1(amapa,1); r:=Fkcc;
   Fkcc:=Fkcc-rk*Fkc; Fksc:=Fksc-rk*Fks;
   END;
ELSE END;
IF(mcj=1)THEN Fksc:=-Fksc; {conjugate Fk}
hklaf[i].Fkc:=Fkcc*phc-Fksc*phs; hklaf[i].Fks:=Fksc*phc+Fkcc*phs;
END;
PROCEDURE calcFk(x,y,z:REAL; iph,im,mdg,ic:INTEGER; VAR rr:REAL);
{To compute the Inverse Fourier Value; i.e. atomic density function
 im=0 Fourier;  im=1 Patterson;
 mdg=0 value only,    mdg=1  value+gradient
 Version: Feb 23 1996;  delphi: Aug 29 2001}
VAR i,j,iref:INTEGER; rc,rs,pi2,arg,cs,sn,Fkcc,Fksc,rrr:REAL;
BEGIN rc:=0; rs:=0; pi2:=pi*2; IF(mdg<>0)THEN
 BEGIN FOR i:=1 TO 3 DO gra3[i]:=0;
 FOR i:=1 TO 3 DO FOR j:=1 TO 3 DO mat3[i,j]:=0;
 END;
{FOR iref:=1 TO lat[iph].nhkl DO
 thm:=EXP(-AMIN1(biso/hkla[iref,iph].dk,64)); thm:=1; }
FOR iref:=1 TO ic DO WITH hklaf[iref] DO
 BEGIN arg:=-pi2*(h*x+k*y+l*z);
 cs:=COS(arg); sn:=SIN(arg); {Fkc:=Fkc*thm; Fks:=Fks*thm;}
 {Fourier or Patterson?}
 {IF(im<>0)THEN
  BEGIN Fkc:=SQR(Fkc)+SQR(Fks); Fks:=0;
  END;}
 Fkcc:=(Fkc*cs+Fks*sn){*2}; Fksc:=0; {Fourier}
 {Current item} rc:=rc+Fkcc;
 IF(mdg=0)THEN CONTINUE;
 {Compute the gradient and the 2derivative matrix}
 rrr:=Fks*cs-Fkc*sn; {1st derivat. wo 2pi}
 gra3[1]:=gra3[1]+h*rrr;
 gra3[2]:=gra3[2]+k*rrr;
 gra3[3]:=gra3[3]+l*rrr;
 rrr:=-(Fkc*cs+Fks*sn)*pi2; {2nd derivat. wo 2pi}
 mat3[1,1]:=mat3[1,1]+h*h*rrr+1E-5;
 mat3[2,1]:=mat3[2,1]+k*h*rrr;
 mat3[3,1]:=mat3[3,1]+l*h*rrr;
 mat3[1,2]:=mat3[1,2]+h*k*rrr;
 mat3[2,2]:=mat3[2,2]+k*k*rrr+1E-5;
 mat3[3,2]:=mat3[3,2]+l*k*rrr;
 mat3[1,3]:=mat3[1,3]+h*l*rrr;
 mat3[2,3]:=mat3[2,3]+k*l*rrr;
 mat3[3,3]:=mat3[3,3]+l*l*rrr+1E-5;
 END;
rr:=rc;
END;
PROCEDURE calqc3(VAR ok:BOOLEAN; i,j,k:INTEGER);
{ Analyze the quasicurvatures and max-condition
  Version: Jan 15 1996;  delphi; Aug 30 2001}
VAR   i1,i2,j1,j2,k1,k2,ii,jj,kk:INTEGER; ok1,ok2:BOOLEAN;
      rr,thr,qux,quy,quz,qux1,quy1,quz1,qux2,quy2,quz2,d12,d22,d32:REAL;
LABEL L25,L26;
BEGIN ok:=false; rr:=amap[i,j,k]+1E-3;
thr:=ABS(amapx-amapn)*frec.sens; ok1:=true; ok2:=true;
{Maximum/minimum condition}
i1:=MAX0(i-1,1); i2:=MIN0(i+1,nx);
j1:=MAX0(j-1,1); j2:=MIN0(j+1,ny);
k1:=MAX0(k-1,1); k2:=MIN0(k+1,nz);
FOR ii:=i1 TO i2 DO FOR jj:=j1 TO j2 DO FOR kk:=k1 TO k2 DO
 BEGIN ok1:=ok1 AND(rr>amap[ii,jj,kk]);
 ok2:=ok2 AND(rr<amap[ii,jj,kk]);
 END;
IF(ok1 AND(ABS(rr)>thr))THEN GOTO L25;
IF(ok2 AND(ABS(rr)>thr))THEN GOTO L25;
L26: ok:=false; Exit;
{Compute the quasicurvatures}
L25: WITH frec DO
 BEGIN d12:=dx*dx; d22:=dy*dy; d32:=dz*dz;
 END;
{IF(ABS(rr)<(thr*0.333))THEN GOTO L26;}
{i-axis}qux1:=0; qux2:=0;
IF((i>1)AND(i<nx))THEN
 BEGIN qux1:=((amap[i+1,j,k]-amap[i-1,j,k])*0.5)/frec.dx;
 qux2:=(amap[i+1,j,k]-2*amap[i,j,k]+amap[i-1,j,k])/d12;
 END;
IF((i=1)AND(nx<>1))THEN
 BEGIN qux1:=(amap[i+1,j,k]-amap[i,j,k])/frec.dx;
 qux2:=(amap[i+1,j,k]-2*amap[i,j,k])/d12;
 END;
IF((i=nx)AND(nx<>1))THEN
 BEGIN qux1:=(amap[i,j,k]-amap[i-1,j,k])/frec.dx;
 qux2:=(-2*amap[i,j,k]+amap[i-1,j,k])/d12;
 END;
{j-axis}quy1:=0; quy2:=0;
IF((j>1)AND(j<ny))THEN
 BEGIN quy1:=((amap[i,j+1,k]-amap[i,j-1,k])*0.5)/frec.dy;
 quy2:=(amap[i,j+1,k]-2*amap[i,j,k]+amap[i,j-1,k])/d22;
 END;
IF((j=1)AND(ny<>1))THEN
 BEGIN quy1:=(amap[i,j+1,k]-amap[i,j,k])/frec.dy;
 quy2:=(amap[i,j+1,k]-2*amap[i,j,k])/d22;
 END;
IF((j=ny)AND(ny<>1))THEN
 BEGIN quy1:=(amap[i,j,k]-amap[i,j-1,k])/frec.dy;
 quy2:=(-2*amap[i,j,k]+amap[i,j-1,k])/d22;
 END;
{k-axis}quz1:=0; quz2:=0;
IF((k>1)AND(k<nz))THEN
 BEGIN quz1:=((amap[i,j,k+1]-amap[i,j,k-1])*0.5)/frec.dz;
 quz2:=(amap[i,j,k+1]-2*amap[i,j,k]+amap[i,j,k-1])/d32;
 END;
IF((k=1)AND(nz<>1))THEN
 BEGIN quz1:=(amap[i,j,k+1]-amap[i,j,k])/frec.dz;
 quz2:=(amap[i,j,k+1]-2*amap[i,j,k])/d32;
 END;
IF((k=nz)AND(nz<>1))THEN
 BEGIN quz1:=(amap[i,j,k+1]-amap[i,j,k])/frec.dz;
 quz2:=(amap[i,j,k+1]-2*amap[i,j,k])/d32;
 END;
{Check the quasi-curvatures}
qux:=qux2/SQRT(1+SQR(qux1)); quy:=quy2/SQRT(1+SQR(quy1));
quz:=quz2/SQRT(1+SQR(quz1));
CASE mn1 OF
1: IF(AMIN1(ABS(quy),ABS(quz))>1.5)THEN ok:=true ELSE ok:=false;
2: IF(AMIN1(ABS(qux),ABS(quz))>1.5)THEN ok:=true ELSE ok:=false;
3: IF(AMIN1(ABS(qux),ABS(quy))>1.5)THEN ok:=true ELSE ok:=false;
ELSE
 IF(AMIN3(ABS(qux),ABS(quy),ABS(quz))>1.5)THEN ok:=true ELSE ok:=false;
     END;
END;
PROCEDURE EnterExpFkcs;
VAR kk:INTEGER;
BEGIN L1rec:=' Enter experimental str.factor file name '; fn:='';
SaveHelp(FSynth_n,FSynth); GetFilename(fn,0); IF(ModalRes=0)THEN Exit;
AssignFile(ft,fn); {$I-} Reset(ft); {$I+}; SetLength(hklaf,0);
ic:=0; WHILE(NOT EoF(ft))DO
 BEGIN fffin(ft,1,7,kk,onl); SetLength(hklaf,ic+1);
 WITH hklaf[ic] DO
  BEGIN h:=Round(onl[1]); k:=Round(onl[2]); l:=Round(onl[3]);
  {mul:=Round(onl[4]); dk:=onl[5];} Fkc:=onl[6]; Fks:=onl[7]; Inc(ic);
  END;
 END;
CloseFile(ft);
END;
PROCEDURE ShowFSPeaks;
VAR i:INTEGER;
BEGIN IF(nfr=0)THEN
 BEGIN ShowMess('No Fourier synthesis peaks available'); Exit;
 END;
L0rec:='   Output of Fourier results'; MakeFormV(15,20,450,430,1);
SaveHelp(ShFSPeaks_n,ShFSPeaks); ListBsav:=false;
WITH LB1rec DO
 BEGIN ar[1]:='   Peaks found by Fourier synthesis'; ar[2]:='';
 ar[3]:='   N       X       Y       Z   Ampl.';
 FOR i:=1 TO nfr DO WITH refla[i] DO
  BEGIN ConvertStr(Float(i),4,0); s:=sedz; ConvertStr(x,8,4); s:=s+sedz;
  ConvertStr(y,8,4); s:=s+sedz; ConvertStr(z,8,4); s:=s+sedz;
  ConvertStr(v,8,2); s:=s+sedz; Inc(j); ar[i+3]:=s;
  END;
 nitems:=3+nfr;
 END;
MakeListBox(20,5,350,360);
Form2.ShowModal;
END;
FUNCTION ANORM(x:REAL):REAL;
VAR y:REAL;
BEGIN y:=x; REPEAT IF(y>1)THEN y:=y-1; UNTIL y<=1;
REPEAT IF(y<-1)THEN y:=y+1; UNTIL y>=-1; ANORM:=y;
END;
FUNCTION QR(x,y,r:REAL):REAL;
VAR xx,yy:REAL;
BEGIN xx:=ANORM(x); yy:=ANORM(y);
QR:=AMIN1(ABS(1-xx-yy),ABS(xx-1+yy))/r;
END;
PROCEDURE FindNearestPeak(VAR irx:INTEGER; irc,iph:INTEGER);
{Find the nearest peak among Fourier-found}
VAR i,j,it,ir:INTEGER; xj,yj,zj,r:REAL; tr:ARRAY[1..3] OF REAL;
BEGIN dist:=1E16; FOR ir:=1 TO nfr DO IF((ir=0)OR(ir<>irc))THEN
WITH lat[iph] DO FOR it:=1 TO ntlv+1 DO
 BEGIN FOR i:=1 TO 3 DO IF(it=1)THEN tr[i]:=0 ELSE tr[i]:=tlv[i,it-1];
 FOR j:=1 TO nut DO WITH refla[ir] DO {Get the equivalent}
  BEGIN xj:=ut[1,j]*x+ut[2,j]*y+ut[3,j]*z+shv[1,j]+tr[1];
  yj:=ut[4,j]*x+ut[5,j]*y+ut[6,j]*z+shv[2,j]+tr[2];
  zj:=ut[7,j]*x+ut[8,j]*y+ut[9,j]*z+shv[3,j]+tr[3];
  xj:=ANORM(xj); yj:=ANORM(yj); zj:=ANORM(zj);
  r:=AMAX3(QR(xj,xi,fres[1]),QR(yj,yi,fres[2]),QR(zj,zi,fres[3]));
  IF(r<dist)THEN
   BEGIN dist:=r; {sym:=false; jphx:=jph;} irx:=ir;
   END;
  IF(csym=1)THEN
   BEGIN
   r:=AMAX3(QR(-xj,xi,fres[1]),QR(-yj,yi,fres[2]),QR(-zj,zi,fres[3]));
   IF(r<dist)THEN
    BEGIN dist:=r; {sym:=true; jphx:=jph;} irx:=ir;
    END;
   END;
  END;
 END; {nearest found}
END;
PROCEDURE AssignPeaksAtoms(iph:INTEGER);
{ Assign the found peaks to atom positions, Version: Feb 14 1997
  delphi version= Sep 18 2001}
CONST st1:STRING = ' phase,  item = ';
VAR   i,j,ir,it,jph,iat,jphx,irx:INTEGER;
      xj,yj,zj,vj,r:REAL; sym:BOOLEAN; tr:ARRAY[1..3] OF REAL;
LABEL Lend;
BEGIN FOR i:=1 TO nfr DO onl[i]:=0;
         {Assign found to available}
FOR i:=1 TO lat[iph].nat DO atoms[i,iph].ident:=false;
IF(prifour)THEN Writeln(fout,' ':20,'Atom assignment');
WITH LB1rec DO
 BEGIN Inc(nitems); ar[nitems]:=' ';
 Inc(nitems); ar[nitems]:='  '+'Atom assignment';
 Inc(nitems); ar[nitems]:=' ';
 END;
FOR iat:=1 TO lat[iph].nat DO
 BEGIN WITH atoms[iat,iph] DO {Take the atom}
  BEGIN xi:=x; yi:=y; zi:=z;
  END;
 FindNearestPeak(irx,0,iph); {Find the Nearest Peak}
 s:='Atom not found'; IF(dist<1)THEN
  BEGIN atoms[iat,iph].ident:=true; s:='OK';
  END;
 onl[irx]:=irx;{irx-th peak identified} WITH refla[irx] DO
  BEGIN xj:=x; yj:=y; zj:=z; vj:=v;
  END;
 IF(prifour)THEN
  BEGIN
  Writeln(fout,'Atom= ',iat:4,xi:8:4,yi:8:4,zi:8:4,'   Phase= ',iph:1);
  Writeln(fout,'Peak= ',irx:4,xj:8:4,yj:8:4,zj:8:4,vj:8:2);
  Writeln(fout,'   Distance = ',dist:10:2,'  ',s);
  END;
 WITH LB1rec DO
  BEGIN ConvertStr(xi,7,3); s:=sedz;
  ConvertStr(yi,7,3); s:=s+sedz; ConvertStr(zi,7,3); s:=s+sedz;
  s:=s+'  phase= '+IntToStr(iph); Inc(nitems); ar[nitems]:=s;
  ConvertStr(xj,7,3); s:=sedz; ConvertStr(yj,7,3); s:=s+sedz;
  ConvertStr(zj,7,3); s:=s+sedz; ConvertStr(vj,10,1); s:=s+sedz;
  Inc(nitems); ar[nitems]:=s;
  ConvertStr(dist,10,2); Inc(nitems); ar[nitems]:='   Distance = '+sedz;
  Inc(nitems); ar[nitems]:=' ';
  END;
 END;
IF(prifour)THEN Writeln(fout); s:='   Non-found atoms (phase)'; Prints;
s:=''; j:=0; FOR i:=1 TO lat[iph].nat DO IF(NOT atoms[i,iph].ident)THEN
  BEGIN sedz:=IntToStr(i); AdjustSt(sedz,4);
  s:=s+sedz+' ('+IntToStr(iph)+') '; Inc(j); IF(j=9)THEN
   BEGIN j:=0; Prints; s:='';
   END;
  END;
IF(s<>'')THEN Prints;
                {Assign peaks}
IF(prifour)THEN
 BEGIN Writeln(fout); Writeln(fout,' ':20,'Peak assignment');
 END;
FOR ir:=1 TO nfr DO IF(onl[ir]=0{non ident.})THEN {Check for equivalent}
 BEGIN WITH refla[ir] DO
  BEGIN xj:=x; yj:=y; zj:=z;
  END;
 {Find the Nearest Atom} dist:=1E16;
 WITH lat[iph] DO FOR it:=1 TO ntlv+1 DO
  BEGIN FOR i:=1 TO 3 DO IF(it=1)THEN tr[i]:=0 ELSE tr[i]:=tlv[i,it-1];
  FOR j:=1 TO nut DO {Get the equivalent}
  FOR iat:=1 TO lat[iph].nat DO WITH atoms[iat,iph] DO
   BEGIN xi:=ut[1,j]*x+ut[2,j]*y+ut[3,j]*z+shv[1,j]+tr[1];
   yi:=ut[4,j]*x+ut[5,j]*y+ut[6,j]*z+shv[2,j]+tr[2];
   zi:=ut[7,j]*x+ut[8,j]*y+ut[9,j]*z+shv[3,j]+tr[3];
   xi:=ANORM(xi); yi:=ANORM(yi); zi:=ANORM(zi);
   r:=AMAX3(QR(xj,xi,fres[1]),QR(yj,yi,fres[2]),QR(zj,zi,fres[3]));
   IF(r<dist)THEN dist:=r;
   IF(csym=1)THEN
    BEGIN
    r:=AMAX3(QR(-xj,xi,fres[1]),QR(-yj,yi,fres[2]),QR(-zj,zi,fres[3]));
    IF(r<dist)THEN dist:=r;
    END;
   IF(dist<1)THEN
    BEGIN onl[ir]:=ir;
    GOTO Lend;
    END;
   END;
  END; {nearest not found}
 Lend:;
 END;
s:='   Non-identified peaks'; Prints;
j:=0; FOR i:=1 TO nfr DO IF(onl[i]=0)THEN
 BEGIN s:=IntToStr(i); AdjustSt(s,3); WITH refla[i] DO
  BEGIN ConvertStr(x,8,3); s:=s+sedz; ConvertStr(y,8,3); s:=s+sedz;
  ConvertStr(z,8,3); s:=s+sedz; ConvertStr(v,9,1); s:=s+sedz; Prints;
  END;
 END;
IF(prifour)THEN Writeln(fout);
               {Check for independence}
s:=' '; Prints; s:=' Independent among Non-identified'; Prints;
FOR ir:=1 TO nfr DO IF(onl[ir]=0{non ident.})THEN {Check for equivalent}
 BEGIN WITH refla[ir] DO
  BEGIN xi:=x; yi:=y; zi:=z;
  END;
 FindNearestPeak(irx,ir,iph); IF(dist<1)THEN onl[ir]:=irx;{peak depend.}
 END;
FOR i:=1 TO nfr DO IF(onl[i]=0)THEN WITH refla[irx] DO
 BEGIN xj:=x; yj:=y; zj:=z; vj:=v;
 ConvertStr(xj,8,3); s:=sedz; ConvertStr(yj,8,3); s:=s+sedz;
 ConvertStr(zj,8,3); s:=s+sedz; ConvertStr(vj,8,1); s:=s+sedz; Prints;
 END;
END;



END.


 {dist:=1E16;
 FOR ir:=1 TO nfr DO FOR jph:=1 TO nph DO WITH lat[jph] DO
 FOR it:=1 TO ntlv+1 DO
  BEGIN FOR i:=1 TO 3 DO IF(it=1)THEN tr[i]:=0 ELSE tr[i]:=tlv[i,it-1];
  FOR j:=1 TO nut DO WITH refla[ir] DO
   BEGIN xj:=ut[1,j]*x+ut[2,j]*y+ut[3,j]*z+shv[1,j]+tr[1];
   yj:=ut[4,j]*x+ut[5,j]*y+ut[6,j]*z+shv[2,j]+tr[2];
   zj:=ut[7,j]*x+ut[8,j]*y+ut[9,j]*z+shv[3,j]+tr[3];
   xj:=ANORM(xj); yj:=ANORM(yj); zj:=ANORM(zj);
   r:=AMAX3(QR(xj,xi,fres[1]),QR(yj,yi,fres[2]),QR(zj,zi,fres[3]));
   IF(r<dist)THEN
    BEGIN dist:=r; sym:=false; jphx:=jph; irx:=ir;
    END;
   IF(csym=1)THEN
    BEGIN
    r:=AMAX3(QR(-xj,xi,fres[1]),QR(-yj,yi,fres[2]),QR(-zj,zi,fres[3]));
    IF(r<dist)THEN
     BEGIN dist:=r; sym:=true; jphx:=jph; irx:=ir;
     END;
    END;
   END;
  END;} {nearest found}

