UNIT vmriahlp;

INTERFACE

USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, vmria00,   vzlocom, vstdcons;

CONST
{*}ExtSize_n:INTEGER = -2;
   ExtSize:ARRAY[1..2] OF STRING = (
'Select coefficients (1, 1.25, or 1.5) for extending form sizes.',
'Select font sizes (8, 10, or 12 pixels), and HELP language.'
);
{*}GeneralH1_n:INTEGER = -64;                     {Key GENERAL}
   GeneralH1:ARRAY[1..64] OF STRING = (
'A normalized neutron diffraction spectrum with nph phases is:',
'                    nph',
'y(D) = exp(-ac*D) * SUM c_i Ph_i (D)  +  back(D)  +  e(D),   where',
'                    i=1',
'D      = channel',
'ac     = a correction multiple;',
'back   = the sum of all background components;',
'e(D)   = statistical error with zero-valued mean and variance v(D),',
'Ph_i(D,P) = SUM a_H ex mod(F_H^2 ) m((D - D_H)/(w1*D + w0))',
'              H',
'H     = vector (hkl),',
'',
'F_H  =  SUM n_j b_j exp(pi*i*(H,xj) - (Bj*H,H)) (structure factor)',
'        j=1',
'nj = occupation, (* spin if magnetic phase)',
'bj = coherent scattering length (or form-factor),',
'Bj = thermal tensor(B11,B12,B13,B22,B23,B33),isotropic=(B,0,0,0,0,0)',
'a_H  = multiplicities, corrected for Lorentz polarization factor',
'ex   = correction for primary extinction',
'D_H  = const * FlPath * SIN(theta+theta0) * dk - D0 (TOF-mode)',
'const = 2*252.778/channel width (in mksec)',
'FlPath = time of flight base (in meter)',
'dk   = interplanar distance',
'theta,theta0 = Bragg angle (in degr),its correction)',
'D0    = time delay (in channel)',
'Dk    = ARCSIN(lambda*qk/2) - D0                    (CWL-mode)',
'lambda = wave length (in Angst)',
'D0    = zero of the angle scale (in degree)',
'w0,w1 = width parameters',
'In CWL-mode the width looks:  w = SQRT(w0+w1*tg(D)+w2*tg(D)**2)',
'',
'back(D) is:',
'1/  a sum of Chebyshev orthogonal polynomials of degree <= 5;',
'          back(D)  =  SUM f_i  P_i  (Z), f_i=parameters',
'2/ or a real background model: (parameters are C,A0,A1,Pb,W0,W1)',
'   back(D)  =  C  +  (A_0  + A_1 *Z)* m ((D-Pb)/(W0+W1*Z))',
'',
'   The purpose of VMRIA is the evaluation of the parameters of the',
'sample crystal unit cell and atoms.',
'There can be several spectra (e.g. measured at different angles)',
'analyzed simultaneously. In this case each spectrum is described by',
'its own common parameters: background, TOF-path, theta, D0, acorr,',
'and for each phase: scaling multiple and width parameters.',
'   The main properties of the method, implemented in MRIA:',
'1) for the ith phase of all spectra (or for the ith spectrum with 1',
'   phase) a reflection peak model m_i(D) (i=1,4) (for the background',
'   m_0(D)) should be constructed; the background model is optional;',
'   for all peak one can use also only one model; default models are',
'   Gaussian for peaks and polynomial for the background.',
'2) the parameters are introduced into these models so that',
'          r(D,a,p,w0,w1) = a * m((D - p)/(w1*D + w0))',
'   where r is the shape of real reflection peak (also background).',
'3) the least-squares (LS) parameter estimates are obtained from MIN:',
'',
'   ch2=   SUM  wh(j)*( y(Dj) -  f(Dj,P))^2',
'',
'with respect to parameters P, where wh(j)=1/v(Dj), Dj=jth channel;',
'v = spectrum variance; P = vector of parameters; y = spectrum.',
'',
'The following constraints, based on physical considerations, may be',
'added:         fl=fk              (equal shape of some phase peaks)',
'               pj = aji*pi + bj             j > i',
'               pil  =<  pi  =<  piu,',
'where pi=i-th parameter;  pil=i-th lower limit; piu=i-th upper limit,'
);
{*}GeneralH2_n:INTEGER = -49;
   GeneralH2:ARRAY[1..49] OF STRING = (
'There are the following modes in MRIA.',
'1. variable wave length mode (TOF) - Default',
'   constant wave length mode (CWL)',
'2. polynomial for the background, - Default',
'   real shape for the background, needs real background model.',
'3. width is linear form    =   w_0 + w_1*ch      -1 < ch < 1, Default',
'   width is quadratic form =   w_0 + w_2*ch**2    0 < ch < 1',
'   width is sqrt: =  SQRT( w_0 + w_2*d**2 )       0 < d < inf',
'   ch = Chebyshev expression of channels , w_i = parameters',
'   d  = interplanar distance',
'4. no texture, default',
'   texture',
'5. different models for different phase peaks in one spectrum,default',
'   different models for different spectra peaks (with 1 phase)',
'The keys are set by commands of Setting Key or where prompted.',
'',
'                     POWDER INDEXING.',
'Let the sample have n phases, n<= 4.',
'Each d-spacing (d_k), k=1,..,m with errors (e_k) of each phase is',
'        d_k = f(P,H_k),',
'where P = a,b,c,cos(A),cos(B),cos(C),  H=hkl - Miller index triple',
'The problem is: For each phase find P and H_k for each k.',
'The quality functional to solve this problem looks like this:',
'         F = F_1(P,H_j^*) + vmin * F_2(P)',
'where H_j^* = the index values, minimizing the expression',
'         R_j =  \rho_2 [d_j,f(P,H_j)]',
'for each j and all the phases at the parameter vector P;',
'         F_1 =  SUM rho_1 [d_j,f(P,H_j^*)]   j=1,...,m',
'         F_2 =  SUM q_i Q_i             i=1,...,n_ph',
'where',
'Q_i = (a_i^2 + b_i^2 + c_i^2 + cos(A_i)^2 + cos(B_i)^2 + cos(C_i)^2',
'q_i  = normalizing factors.',
'Here rho_1 and rho_2 are metrics: quadratic, modulus, etc.',
'The following restrictions on the parameters and the volumes',
'are imposed  p_kl    <=   p_k    <=  p_ku',
'             volume(P)  <=   V_{imax}',
'vmin if not equal to zero provides for the "most cubic" unit cell.',
'',
'Algorithm is sequence of trials, each of which is:',
'1/ a random lattice parameter vector, satisfying the restrictions and',
'   symmetry conditions, is selected, and used as initial parameter',
'   values for an iteration minimization procedure which either',
'   refines the parameters or is stopped, if it does not converge.',
'2/ For each refined parameter vector reflections are assigned Miller',
'   indices, which minimize the quantities R_j (see above).',
'The optimum parameter vector over all the trials is the solution.',
'The indexing problem is difficult and its solution is not guaranteed,',
'therefore, use different strategies (take different V_max, parameter',
'regions, fitting modes, etc.).'
);
{*}GetStart_n:INTEGER =16;
   GetStart:ARRAY[1..32] OF STRING = (
'The simplest Rietveld analysis can be carried out as follows.',
'1/ Input the spectrum, the variance, and the effective spectrum',
'   normalize the spectrum by the effective one; correct if needed',
'   for absorption.Graph the spectrum,select the interval for analysis',
'2/ Enter the information about phases, lattice and atoms',
'3/ Form the hkls and make sure that they cover the interval(INFO-key)',
'4/ Make Rietveld Preparation and check the formed parameters;',
'   if needed, correct dependences between the parameters (see Help in',
'   Rietveld Preparation) and fix some parameters.',
'5/ Make Rietveld Fit;',
'6/ See the results (key Show Results); Save them to a file if needed;',
'The Powder Match and Powder Indexing are made in a similar way.',
'To customize all sorts of analysis methods one should try different',
'modes; one should bear in mind: VMRIA does not damage any files.',
'Some routine preparatory operations can be executed using INI-files',
'(examples of ini-files are attached to VMRIA).',
'⥩訩 Rietveld    ⢫ ⠪.',
'1/  ᯥ, ᯥ,  䥪⨢ ᯥ; ଠ',
'   ᯥ  䥪⨢  ࠢ, ᫨   .',
'   ந 䨪 ᯥ   ࢠ  .',
'2/  ଠ  䠧, ⪥ ⠫  ⮬.',
'3/ ନ஢ hkl-; ஢, 뢠   ࢠ(INFO-key)',
'4/ 믮 Rietveld Preparation  ஢ ஥ ࠬ;',
'   ᫨ , ⠭ ᨬ  ࠬࠬ (.Help ',
'   Preparing Rietveld)  䨪஢  ࠬ஢.',
'5/  Rietveld Fit;',
'6/ ஢ १ (Show Rresults);    䠩,᫨ .',
'Powder Match  Powder Indexing 믮 宦 ࠧ.',
' ᢮     ஡ ࠧ ⮤. ',
' : VMRIA   䠩.',
' ⨭ 樨  믮   INI-䠩',
'(ਬ ini-䠩  VMRIA ).'
);
{*}MenuComm_n:INTEGER =13;
   MenuComm:ARRAY[1..26] OF STRING = (
'FILE    = for in/output of spectra and INI-files.',
'SETTING = for (un)setting the different modes for the analysis',
'GRAPH   = for displaying graphs of: spectra, peak models, etc.',
'MARK    = for clicking with the mouse on the spectrum points, which',
'          will be used for the analysis.',
'PMODEL    = for dealing with the peak models.',
'TRANSFORM = for different types of spectrum transformations.',
'RIETVELD  = for Rietveld analysis, Powder Match, Fourier synthesis',
'INFO      = for displaying all possible sorts of information',
'AUTOX   = for Powder indexing',
'UPEAK   = for Peak analysis (peak search, peak/exponential fitting)',
'HELP    = general comments to the VMRIA program.',
'TEST    = for initializing test data.',
'FILE    =  /뢮 ᯥ஢  INI-䠩.',
'SETTING =  ⠭ ࠧ ० ',
'GRAPH   =  ᢥ稢 䨪: ᯥ஢,  ,  ..',
'MARK    =  ࠧ⪨, ..  㪠 誮  窨 ᯥ,',
'            ᯮ짮  .',
'PMODEL    =  ࠡ  ﬨ .',
'TRANSFORM =  ࠧ ८ࠧ ᯥ஢.',
'RIETVELD  =  Rietveld-, Powder Match,  Fourier ᨭ⥧',
'INFO      =  뤠 ࠧ筮 ଠ樨',
'AUTOX   =  樨 誮',
'UPEAK   =    ( ,  /ᯮ)',
'HELP    = 騥 ਨ  ணࠬ VMRIA.',
'TEST    =  樠樨 ⮢ .'
);
{*}OperGrph_n:INTEGER = 17;
   OperGrph:ARRAY[1..34] OF STRING = (
'Clicking on a graph point displays its channel, counts, etc.',
'Using Mark-command one can mark some points on the graph and build',
'a set of such points for further analysis (e.g.,for powder indexing);',
'cut a spectrum interval, an interval with peak for the model, etc',
'     Right-to-graph key meanings:',
'OK     = to terminate point marking',
'Cancel = to cancel the previous errorroneous marking',
'Next     = to go to the next spectrum interval',
'Previous = to go to the previous spectrum interval',
'Toggle X = to toggle between channels and interplanar distances',
'->GPH-file = save the fit results to a file with extention gph',
'->BMP-file = save the graph as a BMP-file',
'Plot phases= to draw graphs of separate phases (after Rietveld)',
'             or draw separate peaks (in UPEAK peak fitting)',
'Next spectr= switch to next spectrum graph (not more than 4)',
'Zoom = for zooming purposes. Zoom sets up an interval only for',
'       displaying; that for analysis remains old.',
'Click  窥 䨪 뢮  , 祭 ᯥ,  ..',
' Mark  ࠧ 窨  䨪  ந ',
'祪  쭥襣  (.,  樨 誮);',
'뤥 ࢠ ᯥ, ࢠ   ,  ..',
'     祭  ࠢ  䨪:',
'OK     =  ࠧ 祪',
'Cancel = ⬥ । ࠧ 窨',
'Next     = ३  ᫥饬 ࢠ ᯥ',
'Previous = ३  ।饬 ࢠ ᯥ',
'Toggle X = ३    d,  ',
'->GPH-file = ᯠ १   䠩  ७ gph',
'->BMP-file = ᯠ 䨪  BMP-䠩',
'Plot phases=  䨪 ⤥ 䠧 (᫥ Rietveld)',
'              ⤥  (᫥ UPEAK)',
'Next spectr=  䨪 ᫥饣 ᯥ (  4)',
'Zoom =  㢥祭. Zoom ந ࢠ ⮫쪮  ᬮ.',
'       ࢠ   ⠥ .'
);
{*}IShelp_n:INTEGER =  12;                       {Key FILE}
   IShelp:ARRAY[1..24] OF STRING = (
'The following file types (length < 16385) are admissible:',
'1/  binary file, 2 bytes per word',
'2/  binary file ,4 bytes per word',
'3/  ASCII free field array (separators commas or blanks)',
'4/  ASCII free field array, each line of which is: X, counts, [error]',
'Files can have 1024 bytes header and/or inverse byte sequence.',
'N of spectrum (default 1) to be input is set by button NEXT SPECTR',
'Except for type 4/ the Poisson error is formed:',
'           var(i) = SQRT( sp(i) + 1)  in channel i.',
'If a special spectrum variance is needed it is input after spectrum.',
'The spectrum types are: ToF, angular (CWL), and any.',
'Vanadium DN2 effective spectrum is built (no input).',
'⨬ ᫥騥 ⨯ 䠩 ( < 16385 .):',
'1/   䠩, 2   ᫮',
'2/   䠩, 4   ᫮',
'3/  ASCII 䠩, ଠ ᢮. (ࠧ⥫   ஡)',
'4/  ASCII 䠩, ଠ ᢮.,  ப: X, counts, [error]',
'   1024 . /  冷 ⮢.',
'N  ᯥ (default=1) ⠭  NEXT SPECTR',
' ᪫.⨯ 4/, ନ ᮭ᪠ 訡:',
'           var(i) = SQRT( sp(i) + 1)    i.',
'᫨ ᯥ  ᮭ᪠,   ᫥ ᯥ.',
' ᯥ஢: ToF, 㣫 (CWL),  any ᯥ.',
'䥪⨢ ᯥ  ( DN2) ந ( ).'
);
{*}SimSp_n:INTEGER = 7;
   SimSp:ARRAY[1..14] OF STRING = (
'The data (spectra or d-spacings) is simulated on the basis of',
'available information or that prompted for.',
'Specify the number of spectrum to which the simulated data should be',
'put and the mode of simulation - with (or without) errors, etc.',
'Single phases (+background) can be put to different spectra (1..4)',
'and seen on a common graph (using command Graph several spectra).',
'The ToF information can be formed separately or entered via dialog.',
' (ᯥ  d-spacing) ᨬ㫨  ᭮ 饩',
' 襭  室  ଠ樨.',
'  ᯥ,   ᨬ㫨஢   ',
'ᠭ  ० ᨬ樨 -  訡 ( ), .',
'⤥ 䠧 (+䮭)   ᠭ  ᯥ (1..4)',
'    饬 䨪(  Graph several spectra).',
'ToF ଠ   ⤥쭮    १ .'
);
{*}MakeFSp_n:INTEGER = 9;
   MakeFSp:ARRAY[1..18] OF STRING = (
'Mark positive and then negative spectra for adding. Positive is',
'greater than negative. While clicking use Click+Shift for contiguous,',
'and Click+Ctrl for separate marking.',
'Summary positive spectrum is spectrum No2, negative = No3.',
'Use command Graph Several Spectra to impose them on each other.',
'Adaptation sets the equal amplitude level of low-frequency components',
'of both positive and negative spectra; optionally it may also shift',
'the negative spectrum, and/or change its width.',
'The difference of positive and negative is RTOF spectrum (No1).',
' ⥫  ⥫ ᯥ  ᫮. ,',
' ⥫쭮.  clicking ᯮ.Click+Shift  ᬥ,',
' Click+Ctrl  ࠧ ࠧ⮪.',
'㬬 ⥫ ᯥ -  No2, ⥫ = No3.',
' Graph Several Spectra 뢠 ᯥ   㣠.',
'Adaptation  ࠢ묨 ஢  - ',
' ⥫쭮  ⥫쭮 ᯥ஢.   ⠪',
'ᤢ ⥫ ᯥ /   ਭ.',
' ⥫쭮  ⥫쭮 ᯥ஢ = RTOF ᯥ (No1).'
);
{*}SavIni_n:INTEGER = 11;
   SavIni:ARRAY[1..22] OF STRING = (
'The ini-file contains: Commands for different settings;',
'Commands for the input of the last analyzed spectrum, variance,',
'eff.spectrum; the normalization and correction for absorption.',
'Commands for input phase and atomic information',
'Command for forming hkls',
'Command for forming arrays for Rietveld analysis or Powder indexing.',
'The created ini-file can be edited in usual way by any text editor.',
'One can use the ini-file to avoid routine operations in the future',
'with data input and preparation for fitting.',
'In commands only capital letter matter. So Input Spectrum or',
'Info about Spectrum, or simply IS mean the same',
'ini-䠩 ᮤন:   ࠧ ஥;',
'   ᯥ  , ᯥᨨ  䥪.ᯥ;',
' ଠ樨  ४樨  .',
'   䠧  ⮬ ଠ樨',
'  ନ஢ hkl',
'  ⮢ Rietveld analysis  Powder indexing.',
' ini-䠩  ।஢  ⥪⮢ ।஬.',
' ᯮ짮 ini-䠩   ⨭ 権  ',
'  ⮢  ⨭  쭥襬.',
'  뢠 ⮫쪮  㪢.  Input Spectrum ',
'Info about Spectrum,   IS     .'
);
{*}WidthInfo_n:INTEGER = 20;
   WidthInfo:ARRAY[1..40] OF STRING = (
'There are the following modes for peak width (FWHM):',
'1/ width =   w_0 + w_1*z      -1 < z < 1          ToF mode',
'2/ width =   w_0 + w_2*z^2     0 < z < 1          ToF mode',
'3/ width =  SQRT( w_0 + w_2*d^2 ),  0 < d < inf   ToF mode',
'   z = Chebyshev function of channels , w_i = parameters',
'   d = d-spacing.     Default: mode 1/.',
'4/ anisotropic: width = normal + addi-width, depending on h (k or l)',
'5/ w = SQRT(w_0+w_1*tg(d)+w_2*tg(d)^2).           CWL mode',
'Delta W0,W1 give the limits for varying of the width.',
'***',
'There are the following modes for background parametrization:',
'1/ polynomial (degree <= 5) as background (default)',
'      Back(x) = SUM a_i * z^i,  a_i - parameters',
'   Too low degree not sufficient; if too high, Rietveld may fail.',
'2/ real shape for the background',
'   If a spectrum part m(x) looks as background, background model is:' ,
'       Back(x)  =  C + (A_0 + A_1 *z^2)* m ((x-P_b)/(W_0+W_1*z))',
'   x=channel, m = real background model; (default: m(x) = Gaussian).',
'***',
'm2 mode is using as peak model:  m(z)+(a0+a1*x)*m"(z)',
'ਭ  (FWHM)   ᫥騥 :',
'1/ width =   w_0 + w_1*z      -1 < z < 1          ToF mode',
'2/ width =   w_0 + w_2*z^2     0 < z < 1          ToF mode',
'3/ width =  SQRT( w_0 + w_2*d^2 ),  0 < d < inf   ToF mode',
'   z = 㭪 襢   , w_i = ࠬ',
'   d = ᪮⭮ ﭨ.     Default: mode 1/.',
'4/ ய.: width = ଠ + .,   h (k  l)',
'5/ w = SQRT(w_0+w_1*tg(d)+w_2*tg(d)^2).           CWL mode',
'Delta W0,W1  ࠭  ਭ.',
'***',
'   ᫥騥 :',
'1/  (⥯ <= 5)  ⢥ 䮭 (default)',
'      Back(x) = SUM a_i * z^i,  a_i - ࠬ',
'    ⥯ 筠, ᫨誮  蠥 室.',
'2/ ॠ쭠 ଠ 䮭',
'   ᫨  ᯥ m(x) 룫廊  䮭, ॠ쭠  䮭:' ,
'       Back(x)  =  C + (A_0 + A_1 *z)* m ((x-P_b)/(W_0+W_1*z))',
'   x=, m = ॠ쭠  䮭; (default: m(x) = ᨠ.)',
'***',
'm2 mode  ࠦ: m(z)+(a0+a1*x)*m"(z)  ⢥  '
);                                               {Key SETTINGS}
{*}AtomNum_n:INTEGER =4;
   AtomNum:ARRAY[1..8] OF STRING = (
'Set the number of independent atoms for each phase.',
'To enter the atomic information use command:',
'     Rietveld, Enter Crystallographic information.',
'Max number of independent atoms for each phase = 100.',
'⠭ ᫮ ᨬ ⮬   䠧.',
'⮬ ଠ  :',
'     Rietveld, Enter Crystallographic information.',
'Max ᫮ ᨬ ⮬   䠧 = 100.'
);
{*}SScaleM_n:INTEGER = 4;
   SScaleM:ARRAY[1..8] OF STRING = (
'Trimming coefficient means the cut-off level (between 0 and 1)',
'of the spectrum amplitudes.  Fitting error graph mode is:',
'1/ no error graph (default)  2/ relative error graph',
'X-logarithmic scale only for viewing, not for operations with graph',
'樥 trimming - ஢ १  ᯥ',
'( 0  1).   䨪 訡 ⨭:',
'1/  䨪 訡 (default)  2/ 䨪 ⭮⥫쭮 訡',
'X-䬨᪠ 誠 -  ᬮ,   権  䨪.'
);
{*}ZeroW_n:INTEGER = 4;
   ZeroW:ARRAY[1..8] OF STRING = (
'Spectrum errors within given range are zeroed. It is useful, if any',
'part of the spectrum can not be fitted well (in Rietveld analysis).',
'Save the spectrum (including the errors) as Spectrum 4 to restore',
'the initial state (by commands Transform, Arthmetic, Moving)',
'訡 ᯥ  㪠 ࢠ .  , ᫨',
' ࢠ    ( Rietveld analysis).',
'᫨ ᯠ ᯥ ( 訡)  Spectrum 4,  ⠭',
' 砫쭮 ﭨ ( Transform, Arthmetic, Moving)'
);
{*}ResFN_n:INTEGER = 1;
   ResFN:ARRAY[1..2] OF STRING = (
'Specify the new name for output file.',
'    室 䠩.'
);
{*}GraSS_n:INTEGER = 3;                         {Key GRAPH}
   GraSS:ARRAY[1..6] OF STRING = (
'The graphs of spectra will be imposed on each other;',
'The bounds of graphs are defined by the 1st spectrum interval.',
'Information about clicked points is valid only for the 1st spectrum.',
'䨪 ᯥ஢ 뢠   㣠;',
'࠭ 䨪 । ࢠ 1- ᯥ.',
'ଠ  祭 窠 ⢨⥫쭠 ⮫쪮  1- ᯥ.'
);
{*}GrPlDis_n:INTEGER = 3;
   GrPlDis:ARRAY[1..6] OF STRING = (
'Event distributions (x_i, y_i), i=1,2,...,m  can be mapped onto a',
'plane either as YX picture, or as rotated XY (X and Y change places)',
'in normal or logarithmic axes.',
'। ᮡ⨩ (x_i, y_i), i=1,2,...,m    ⮡ࠦ',
' ᪮  YX ⨭,   ⮬ XY (X  Y  )',
' 筮  䬨᪮ ⠡.'
);
{*}FoRMod_n:INTEGER = 7;                         {Key MARK}
   FoRMod:ARRAY[1..14] OF STRING = (
'This command builds models on the basis of real peaks from spectrum',
'Specify: 1) the spectrum interval, containing the peak,',
'2) length of background at the interval edges,',
'click manytimes on more(less) model smoothing; if OK, on QUIT + OK.',
'The formed model n is assigned to phase (or spectrum) n, (n=1,2,3,4)',
'Models are either positive, or double-signed (with negative tails)',
'Model 0 is for the background (if not polynomial is used)',
' ந   ᭮ ॠ   ᯥ',
': 1) ࢠ ᯥ, ᮤঠ騩 ,',
'2)  䮭   ࢠ,',
'᪮쪮 ࠧ click  more(less) model smoothing; ᫨ OK, QUIT+OK',
'஥  n ᢠ 䠧 ( ᯥ) n, (n=1,2,3,4)',
'   -  -묨 ( ⥫묨 墮⠬)',
' 0 -  䮭 (᫨  ᯮ )'
);
{*}FoSMod_n:INTEGER = 7;                         {Key PMODEL}
   FoSMod:ARRAY[1..14] OF STRING = (
'Standard peak models are: Gaussian, Lorentzian, the IAEA peak model,',
'Voigtian - convolution of 1/(1 + (x/r)^2) and gaussian,',
'Convolution of exp(-x/r) and a gaussian, two-sided exp(-ABS(x)),',
'special Det4 model, and pseudo-Voigt = r*Gauss+(1-r)*Lorenz.',
'Each phase (spectrum) can be described by its own model.',
'Model 0 is for the background (if not polynomial is used)',
'All 6 models can be made negative (looking down)',
'⠭  : ᨠ, ७樠,  ,',
'⨠ - ᢥ⪠ 1/(1 + (x/r)^2)  ᨠ,',
'ᢥ⪠ exp(-x/r)  ᨠ,  ஭ exp(-ABS(x)),',
'ᯥ樠쭠  Det4,  ᥢ- = r*Gauss+(1-r)*Lorenz.',
' 䠧 (ᯥ)  뢠 ᢮ ᮡ⢥ .',
' 0  䮭 (᫨  ᯮ )',
' 6    ⥫묨 (ᬮ騬 ).'
);
{*}MoveMod_n:INTEGER = 2;
   MoveMod:ARRAY[1..4] OF STRING = (
'Select the peak model on the left and the number on the right',
'to which the left model will be moved',
'Click    ᫥     ࠢ;   ',
'஬ 㤥 ᫠     ࠢ ஬.'
);
{*}NormSp_n:INTEGER =  7;                        {Key TRANSFORM}
   NormSp:ARRAY[1..14] OF STRING = (
'Normalization is dividing the spectrum by the effective one',
'For DN2 spectra the effective spectrum is built-in.',
'For arbitrary spectrum the corresponding effective spectrum should',
'be input beforehand.',
'For correction of spectra for absorption one needs to specify:',
'sample form, and two coefficients in the absorption formula.',
'To determine the latters use command Get Absorption Coefficients.',
'ଠ -  ᯥ  䥪⨢ ᯥ',
' ᯥ஢  DN2 䥪⨢ ᯥ ஥.',
' ந쭮 ᯥ ᮮ⢥騩 䥪⨢ ᯥ ',
'  ࠭.',
' ४樨 ᯥ   室   ࠧ,',
' 2 樥   樨. ⮡  । 㦨',
' Get Absorption Coefficients.'
);
{*}FitET_n:INTEGER = 5;
   FitET:ARRAY[1..10] OF STRING = (
'The tail of effective spectrum beginning with point where counts are',
'equal to 0.05 of max, or specified by the user, can be fitted by the',
'sum of constant and exponential, and (optionally) replaced by it.',
'Constant is subtracted from the eff.spectrum.',
'It is useful for normalization at the large wave lengths.',
' 䥪⨢ ᯥ, 稭  窨, 㤠 = 0.05 Max,',
' 㪠 짮⥫,    㬬 ⠭ ',
'ᯮ,  (option)  .',
'⠭ ⠥  䥪⨢ ᯥ.',
'   ଠ樨    .'
);
{*}SpFunc_n:INTEGER = 10;
   SpFunc:ARRAY[1..20] OF STRING = (
'Results of operations are put as spectra with a specified number.',
'Both smoothing and envelope from below are built automatically.',
'If the result quality is low, increase or decrease the smoother.',
'At the end click on Quit+Put Result to Spec.2, then on OK.',
'For compression one needs a compression factor ( > 1).',
'For interpolation one needs new i1,i2 - new spectrum bounds.',
'Spectr(d) -> Spectr(chan): Spectr(d) is input as triples (d,S,err).',
'For outlier correction mark previously them by clicking. They will be',
'replaced by zeroes or halfsums.',
'Recommended to apply operations to Spectrum 1',
' 権   ᯥ  ।묨 ࠬ.',
' ᣫ,  ஥ 饩 ᭨ ⢫.⮬᪨.',
'᫨ ⢮ १ , 㢫  㬥 smoother.',
' 祭 click  Quit+Put Result to Spec.2, ⥬  OK.',
' ᨨ 㦥 䠪 ᨨ ( > 1).',
' ௮樨 㦭  i1,i2 - ࠭ ᯥ.',
'Spectr(d) - Spectr(chan)": Spectr(d)   ன (d,S,err).',
' ४樨 롨 祪,   ᭠砫 ⬥ by clicking.',
'⮬    ﬨ  㬬.',
' ਬ 樨  Spectrum 1'
);
{*}SpArith_n:INTEGER =  5;
   SpArith:ARRAY[1..10] OF STRING = (
'Command for: forming constant spectra, moving the spectra and',
'arithmetic operations. The result of operations  + - * /  with',
'2 spectra is put to the spectrum 4. Spectrum errors are recalculated.',
'To show the spectra use command Graph Several Spectra or Key:',
'Next Spectr.Check/update (if needed) the spectrum info(command INFO).',
' : ନ஢ ﭭ ᯥ,뫪 ᯥ஢ ',
'䬥᪨ 権. 権 + - * /   2 ᯥࠬ',
'뫠  ᯥ 4. 訡 ᯥ 뢠.',
'䨪 ᯥ஢:  Graph Several Spectra  : Next Spectr.',
'஢/ (᫨ ) ଠ  ᯥ ( INFO).'
);
{*}AbsCoef_n:INTEGER =  9;
   AbsCoef:ARRAY[1..18] OF STRING = (
'Gets coefficients a_1,a_2 for the correction for absorption.',
'Needed: phase,lattice,atomic information and the quantities:',
'   Eff.Rad. = effective radius of the cylinder (cm)',
'   ros      = experimental density (g/cm3)',
'and for ith phase:',
'   z_i      = number of formulae per unit cell',
'and for ith atom:',
'   mul_i    = multiplicity (put equal to atomic occupation)',
'a_1, a_2 are used in Normalize command (Correct for Absorption).',
' 樥 a_1,a_2  ࠢ ᯥ  .',
'室: ଠ  䠧,祩,⮬  稭:',
'   Eff.Rad. = 䥪⨢ ࠤ 樫 ()',
'   ros      = ᯥਬ⠫쭠 ⭮ (/3)',
'   䠧:',
'   z_i      = ᫮    祩',
'   ⮬:',
'   mul_i    = ⢥(ࠢ ⮬ .)',
'a_1, a_2 ᯮ   Normalize (Correct for Absorption).'
);
{*}EvToSp_n:INTEGER =  6;
   EvToSp:ARRAY[1..12] OF STRING = (
'Transform an event sequence to a distribution (spectrum)',
'4 bounds are given: b1l b1r,  b2l b2r,  b3l b3r,  b4l b4r',
'and the skipping column number ic;',
'The sequence is scanned and events (e) satisfying conditions:',
'         bil   <=    e_i    <=   bir,     i # ic ',
'are added to the spectrum: sp[e_ic]=sp[e_ic]+1',
'८ࠧ ᫥⥫쭮 ᮡ⨩  । (ᯥ).',
' 4 ࠭: b1l b1r,  b2l b2r,  b3l b3r,  b4l b4r',
'   ய᪠ ic;',
'᫥⥫쭮 ᪠  ᮡ (e), ᫨:',
'         bil   <=    e_i    <=   bir,     i # ic ',
'ਡ  ᯥ: sp[e_ic]=sp[e_ic]+1'
);
{*}EntCrI_n:INTEGER = 3;                        {Key RIETVELD}
   EntCrI:ARRAY[1..6] OF STRING = (
'For Rietveld analysis & Powder Match the phase (space group,lattice)',
'information is needed; For Rietveld also atomic information.',
'For both hkls should be formed or input from a file.',
' Rietveld analysis & Powder Match 㦭 ଠ  䠧: ',
'࠭.㯯,ଠ  祩;  Rietveld ⠪  ⮬.',
'   hkl   ନ஢    䠩.'
);
{*}EntPhInf_n:INTEGER = 19;
   EntPhInf:ARRAY[1..38] OF STRING = (
'Unit cell description contains:',
'1/ Space group number SGN (1 < SGN < 230);',
'   Also non-standard transformations can be input by the user',
'2/ Setting (1 or 2) for monoclinic etc.symmetries.',
'4/ Direct lattice parameters A,B,C,alpha,beta,gamma',
'Parameters for fit are a*^2,b*^2,c*^2, a*b*cos(gamma*), etc.',
'For magnetic phase (2nd) non-standard space group is needed.',
'Information for non-standard group is: (in a special file)',
'1/   laue, ntlv, nut, ics, nlatt, syng                  1   line',
'2/   translation vectors (3 quantities for each);      ntlv lines',
'3/   symmetry transformation formulae;                 nut  lines',
'Example of a transformation',
'          -x+y+.5 ,      -y  ,        z-.66667',
'ntlv = number of translations; nut = number of transformations, <=48',
'ics  = (0)1 = (non)centrosymmetric; syng = symmetry number,',
'  coding= tricl:1, monocl:2, orth:3, tetr:4, cub:5, hex:6, rhe:7.',
'nlatt= lattice Bravais type (P,A,B,C,F,I,R  coded as  0,1,2,3,4,5,6);',
'For magnetic and anisotropic phase triclinic cell is recommended.',
'Find Space Group: put standard name,click on Find...,then replace;',
'ᠭ ୮ 祩 ᮤন:',
'1/  ࠭⢥ 㯯 SGN (1 < SGN < 230);',
'   짮⥫  ⠪  ⠭ 㯯.',
'2/ ⠭(1  2)    .. ᨭ.',
'4/ ࠬ אַ 祩 A,B,C,alpha,beta,gamma',
'ࠬ  : a*^2,b*^2,c*^2, a*b*cos(gamma*),  ..',
' ⭮ 䠧 (2) 㦭 ⠭⭠ .㯯.',
'ଠ  ⠭⭮ 㯯: ( ᯥ樠쭮 䠩)',
'1/   laue, ntlv, nut, ics, nlatt, syng                  1   ப',
'2/    ࠭樨 (3 稭  );      ntlv ப',
'3/    ८ࠧ ᨬਨ;                 nut  ப',
'ਬ ८ࠧ',
'          -x+y+.5 ,      -y  ,        z-.66667',
'ntlv = ᫮ ࠭権; nut = ᫮ ८ࠧ, <=48',
'ics  = (0)1 = ()業ᨬ᪠; syng =  ᨭ,',
'  = tricl:1, monocl:2, orth:3, tetr:4, cub:5, hex:6, rhe:7.',
'nlatt= ⨯ ⪨ ࠢ (P,A,B,C,F,I,R : 0,1,2,3,4,5,6);',
' ⭮  ய 䠧 ४ ਪ 祩',
'Find Space Group:  ⠭. 㯯,click Find..., ;'
);
{*}EntAtInf_n:INTEGER =  9;
   EntAtInf:ARRAY[1..18] OF STRING = (
'First, list of Mendeleev names for atoms is input;',
'Character = after name means the atom is magnetic; (e.g. MN=)',
'Next prompt is for occupation, coordinates, and thermal parameters',
'(in isotropic case only T_11) of each atom.',
'Coherent scattering amplitude can be checked and if needed corrected.',
'For magnetic phases ion name should be given by set of + or number',
'(e.g.Fe++) and 7 coefficients for form-factor should be checked.',
'Also spin orientations (+-1) are needed. Atoms for triclinic cell can',
'be built by: make full magnetic set for next phase (from current)',
'砫  ᯨ᮪ ᪨  ⮬;',
' = ᫥  砥,  ⮬ . (. MN=)',
' ᫥  , न,  ⥯ ࠬ',
'( ய 砥  T_11)  ⮬.',
'஢  ७⭮ ﭨ  ࠢ, ᫨ .',
'  䠧     冷 +  ன',
'(.Fe++)  ஢ 7 樥⮢  -䠪஢.',
' 㦭 ਥ樨 ᯨ (+-1).⮬  ਪ 祩 ',
'ந  ⥪饩 䠧: make full magnetic set for next phase'
);
{*}Fhkls_n:INTEGER =  4;
   Fhkls:ARRAY[1..8] OF STRING = (
'Check the spectrum bounds for hkl-range.',
'Check d_min and d_max; replace them if not correct.',
'hkls for each phase can be either built or input from a file;',
'The file is sequence of strings, each of which is: h k l mult;',
'࠭ ࢠ hkl । ࠭栬 ᯥ.',
'஢ d_min  d_max; , ᫨ .',
'hkls   䠧   ந,    䠩;',
'  ᫥⥫쭮 ப,   : h k l mult;'
);
{*}Rietv_n:INTEGER = 4;
   Rietv:ARRAY[1..8] OF STRING = (
'To make Rietveld or Powder Match analysis execute:',
'1/ Preparation (if many spectra, first set up many-spectrum mode)',
'2/ Making Rietveld or PM analysis',
'3/ Showing and saving the results',
'⮡ 믮 Rietveld  Powder Match   ᤥ:',
'1/ ⮢(᫨ ᪮쪮 ᯥ஢, ⠭ ० many-spectrum',
'2/ 믮 Rietveld  PM ;',
'3/ ᬮ  ᯠ १.'
);
{*}PrepRiet_n:INTEGER = -33;
   PrepRiet:ARRAY[1..33] OF STRING = (
'Unless all the information is given in INI-file, parameter bounds are',
'built automatically; for lattice/atom parameters they are built using',
'deviation percents.',
'Parameter array is sequence of records with 6 numbers in each:',
' i,   p_li,   p_i,   p_ui,   a_i,   b_i,        where',
'   i :  parameter number.',
'        if i=j               the jth parameter is independent.',
'        if i=k and k<j,     then  p_j = a_j * p_k + b_j',
'   p_i:  ith parameter value',
'   p_li: its lower bound',
'   p_ui: its upper bound',
'   a_i,b_i: coefficients of linear dependence between parameters',
'',
'Only independent atoms are parametrized.',
'Parameter are arranged as follows:',
'  10 parameters L,theta0,D0,b0,b1,b2,b3,b4,b5,ac for the 1st spectrum',
'  10 parameters c,A11,A12,A13,A22,A23,A33,W0,W1,ex for the 1st phase',
'  10 parameters b,x,y,z.B11,B12,B13,B22,B23,B33 for the 1st atom',
'  10 parameters b,x,y,z.B11,B12,B13,B22,B23,B33 for the 2nd atom',
'  ..............................     (n_atom(1) times)',
'  10 parameters c,A11,A12,A13,A22,A23,A33,W0,W1,ex for the 2nd phase',
'  10 parameters b,x,y,z.B11,B12,B13,B22,B23,B33 for the 1st atom',
'  ..............................     (n_atom(2) times)',
'  10 parameters L,theta0,D0,b0,b1,b2,b3,b4,b5,ac for the 2nd spectrum',
'   3 parameters c,W0,W1 for the 1st phase of the 2nd spectrum',
'  ..............................',
'      etc., on the total = 10+SUM (10+nat_i *10)+(10+3*nph)*(ns-1),',
'nph = number of phases, ns = number of spectra analyzed.',
'For the meaning of the names here see the command GENERAL HELP',
'',
'As Example see parameter array for ZrO2 sample (command HELP,Examples',
'of INI-files. 2% of Zr are replaced by Hf; it means Hf has the same',
'atoms, but occupations of Zr and Hf are 0.98 to 0.02.'
);
{*}InfoFCont_n:INTEGER = -25;
   InfoFCont:ARRAY[1..25] OF STRING = (
'GN-iter = maximum number of iterations',
'step    = the step length in iterations',
'damp    = the damping factor',
'eps_req = the desirable accuracy of minimisation (default=3)',
'delta   = delta for the generalized (e.g., robust) fitting.',
'beta    = beta   - " - " - " -    etc.',
' Let be  h(j)=(y(xj)-f(xj,pi))*SQRT(w(j)). To make the fitting robust',
' if ABS(h(j)) > delta, then h(j) ->  SQRT(c(j))*h(j).',
' where generalized weight c(j)=(1+beta)/((h0(j)/delta)^2+beta),',
' h0(j) is h(j) of previous iteration.',
'alpha = multiple for Bayesian estimation. Used only by AUTOX',
'skip  = skip-th points are used in a circular way.',
'Use of constant weights is recommended only if no convergence.',
'Guaranteed convergence = iterations are carried out if chi^2 drops.',
'',
'      Output control data for results of the fitting',
'conv   = ok(not) - the process has (not) converged.',
'matinv = ok(not) - the LS-matrix is (not) inverted.',
'GN-it  = the number of used iterations',
'paronb = not(ok) - there are (no) parameters on the boundary',
'chi/df = chi^2 per degree of freedom',
'chi+   = ratio of the positive chi2 to the total one',
'goodp  = part of points where chi2 is good',
'chidev = the admissible deviation of chi2 over the unity',
'chi_reg= the value of regulizer in the minimized functional.'
);
{*}ShFitRes_n:INTEGER = 13;
   ShFitRes:ARRAY[1..26] OF STRING = (
'For all parameters use the command INFO about PARAMETERs.',
' Rp  =  SUM ABS(Ie - Ic) / SUM ABS(Ie)',
' Rb  =  SUM ABS(Ie - Ic) / SUM ABS(Ie - B)',
' Rw  =  SQRT(SUM w(Ie-Ic)**2 / SUM wIe**2)',
' Re  =  SUM sigma / SUM ABS(Ie)',
'where Ie,Ic = experimental and calculated intensities, w = weights',
'B = background, sigma = spectrum errors.',
'and chi+ = ratio of positive chi2 (where Ic > Ie) and the total one',
'The fitting is good, when chi2 = ~ 1, and chi+ = ~ 0.5.',
'eps: large eps means that fitting did not yet reach the minimum.',
'Bad fitting may be due too high degree of background polynomial,',
'false hkls, false atoms, too many free parameters etc.',
'"Parameter hit the boundary" means: parameter bounds are incorrect.',
'  ࠬ ᯮ짮  INFO about PARAMETERs.',
' Rp  =  SUM ABS(Ie - Ic) / SUM ABS(Ie)',
' Rb  =  SUM ABS(Ie - Ic) / SUM ABS(Ie - B)',
' Rw  =  SQRT(SUM w(Ie-Ic)**2 / SUM wIe**2)',
' Re  =  SUM sigma / SUM ABS(Ie)',
' Ie,Ic = ᯥਬ⠫쭠  ⥮᪠ ⥭ᨢ, w = ',
'B = 䮭, sigma = 訡 ᯥ.',
' chi+ = ⭮襭 ⥫쭮 chi2( Ic > Ie)  .',
' , ᫨ chi2 = ~ 1,  chi+ = ~ 0.5.',
'eps: 讥 eps 砥,    ⨣  㬠.',
'     襭 ⥯ 䮭 ,',
' hkls,  ⮬, ᫨誮  ᢮ ࠬ஢  .',
'"Parameter hit the boundary" 砥,  ࠭ ࠬ஢ .'
);
{*}UpDParF_n:INTEGER = 2;
   UpDParF:ARRAY[1..4] OF STRING = (
'The parameter file is updated (if none available, a new one created).',
'This file may be further used as part of the INI-file.',
' ࠬ஢  ( ᮧ ).',
' 䠩  ⥬ ᯮ짮   INI-䠩.'
);
{*}SpecNum_n:INTEGER =2;
   SpecNum:ARRAY[1..4] OF STRING = (
'For simultaneous Rietveld analysis of several (up to 4) spectra.',
'For input or viewing of spectra use the button "Next Spectr"',
' ६ Rietveld  ᪮쪨 ( 4) ᯥ஢.',
'   ᬮ ᯥ஢ ᯮ짮  "Next Spectr"'
);
{*}FitStrFacs_n:INTEGER = 3;
   FitStrFacs:ARRAY[1..6] OF STRING = (
'Powder Match finds approximate unit cell, fitting reflections',
'as independent peaks. Too close peaks (closer than threshold) are',
'united - to make the procedure stable.',
'Powder Match 室 ਡ  祩,  ',
' ᨬ. 誮   ( 祬 threshold)',
'ꥤ - ⮡ ᤥ 楤 ⮩稢.'
);
{*}FSFparam_n:INTEGER = 5;
   FSFparam:ARRAY[1..10] OF STRING = (
'Parameter array for Powder matching has the following structure:',
' FPath, Delta Theta, Delay, 6 background parameters,acor - parameter;',
' Phase amplitude, 6 lattice parameters',
' W0,W1 - peak width parameters (in chan)',
' peak areas (~ squared structure factors) for each reflection.',
'ᨢ ࠬ஢  Powder match ᮤন:',
' FPath, Delta Theta, Delay, 6 ࠬ஢ 䮭, acor - ࠬ;',
'  㤠, 6 ࠬ஢ ୮ 祩;',
' W0,W1 - ࠬ ਭ  ( .)',
' 頤  (~⠬  䠪஢)   䫥.'
);
{*}FSynth_n:INTEGER = 14;
FSynth:ARRAY[1..28] OF STRING = (
'Building a 3-dimensional Fourier map of given structure factors(SF):',
'1/ obtained from the Rietveld fitting',
'2/ obtained from the Powder Match',
'3/ of the difference of both',
'4/ from structure factors taken from a file.',
'5/ calculated for given phase, atoms and hkls',
'Maxima coordinates in this map = atomic positions in the sample',
'The input information: x0,x1; y0,y1; z0,z1 =  X,Y,Z-range for the map',
'sens= sensitivity of peak search: as fraction of max SF',
'If from file, it must be a sequence of text lines(free field format):',
'       h  k  l mul  dk  Fcos  Fsin',
'where Fcos,Fsin = real and imaginary parts of the SF,',
'h,k,l = Miller indices, mul = multiplicity, dk = d',
'To see the results separately use "Show FS peaks" option.',
'ந 3-  Fourier   䠪஢ (SF):',
'1/  Rietveld ',
'2/  Powder Match',
'3/  ࠧ ',
'4/  䠩.',
'5/ ᫥   䠧, ⮬  hkl.',
'न ᨬ㬮 ⮩  =  ⮬  ࠧ.',
'室 ଠ: x0,x1; y0,y1; z0,z1  =  X,Y,Z-ࢠ  .',
'sens= ⢨⥫쭮 ᪠ :    max SF.',
'᫨  䠩,   ᫥⥫쭮 ப( free field format):',
'       h  k  l mul  dk  Fcos  Fsin',
' Fcos,Fsin = ⢨⥫쭠    SF,',
'h,k,l =  Miller, mul = multiplicity, dk = d',
'.१   樨 "Show FS peaks".'
);
{*}ShFSPeaks_n:INTEGER = 5;
ShFSPeaks:ARRAY[1..10] OF STRING = (
'These are the coordinates of peaks (atoms) in the Fourier map.',
'Amplitudes characterize peak significance: only large peaks',
'are more or less reliable.',
'Not identified peaks can point out to unknown atoms.',
'Some of the (also large) peaks may be dependent on each other.',
'뤠 न  (⮬)   Fourier.',
' ࠪਧ 稬 : ⮫쪮 訥 ',
'   .',
' ந஢   㪠뢠   ⮬.',
' (訥 ⮦)       㣠.'
);
{*}chancp_n:INTEGER = 3;
   chancpH:ARRAY[1..6] OF STRING = (
'If parameter array already formed, command can change direct cell',
'parameters and remake the parameter array - cell parameters have very',
'specific form and rebuilding them directly is inconvenient.',
'᫨ ᨢ ࠬ஢ 㦥 ନ஢,    ',
'ࠬ אַ 祩  । ᨢ - ࠬ 祩 ',
'᫮    ।  㤮.'
);
{*}InfoSpec_n:INTEGER = 2;                      {Key INFO}
   InfoSpec:ARRAY[1..4] OF STRING = (
'The information about the spectrum can be checked and if necessary',
'corrected.',
'ଠ  ᯥ   ஢७ , ᫨ 室,',
'⪮४஢.'
);
{*}infohkls_n:INTEGER = 3;
   infohkls:ARRAY[1..6] OF STRING = (
'Information about each reflection:',
'   h,k,l, multiplicity, d, Abs(F), Re(F)/Fmax,  Im(F)/Fmax,',
'where F=structure factor, Fmax= maximum absolute F.',
'ଠ   䫥  :',
'   h,k,l, multiplicity, d, Abs(F), Re(F)/Fmax,  Im(F)/Fmax,',
' F= 䠪, Fmax= ᨬ  F.'
);
{*}InfIniF_n:INTEGER = 3;
   InfIniF:ARRAY[1..6] OF STRING = (
'The input file may be edited and saved. In INI-files',
'asterisc at the 1st position of the line means comment;',
'command is recognized by capital letters; so Input a Spectrum = IS.',
'   ।஢  ᯠᥭ.  INI-䠩',
'窠  1 樨  砥 ਩;',
'  묨 㪢; ⠪  Input a Spectrum = IS.'
);
{*}InfoSetP_n:INTEGER = 2;
   InfoSetP:ARRAY[1..4] OF STRING = (
'Check the marked points and peak model numbers. One can edit the list',
'of these points: add new,delete old, and change model numbers.',
'஢ ⬥祭 窨    . ࠢ',
'ᯨ᮪  祪: ,㤠 窨;   .'
);
{*}EntDSpGr_n:INTEGER = -17;                     {Key AUTOX}
   EntDSpGr:ARRAY[1..17] OF STRING = (
'D-spacings can be input from a special file, or obtained from',
'the spectrum graph by previous clicking on the large separate peaks',
'(command MARK, Set of points) or finding these peaks automatically.',
'The special file is a sequence of lines, each containing numbers:',
'd_i, e_i, x_i, h_i, k_i, l_i, ph_i where',
'd_i=ith d-spacing(in Angst), e_i=its error (in Angst),',
'x_i = channel (TOF-case), or angle in degrees (ConstWaveLength case),',
'h_i, k_i, l_i, ph_i = its Miller indices and phase.   i=1,2,...,mds.',
'hkls needed if only lattice parameters should be fitted at known hkls',
'The points on the graph can be clicked in any sequence. Since the',
'clicking is not exact, option "refine peak positions" is foreseen.',
'Errors (accuracies) of d can be given for each d (if from file),',
'or put constant, if from graph; default = 0.001 Angst.',
'For automatic peak search sensitivity and resolution should be given,',
'defaults=1,1. The less sensitivity is the more weak peaks are found.',
'Peaks can be viewed on the graph using: GRAPH, Set of Points',
'If spectrum was input as d, counts, ds are taken instead of channels'
);
{
'D-spacing    䠩,     䨪 ᯥ',
'।⥫ clicking   ᯥ ( MARK,',
'Set of points),    ⮬᪨.',
' - ᫥⥫쭮 ப,    ᮤন:',
'd_i, e_i, x_i, h_i, k_i, l_i, ph_i ',
'd_i=i- d-spacing( Angst), e_i= 訡 ( Angst),',
'x_i =  (TOF),  㣮  ࠤ (ConstWaveLength),',
'h_i, k_i, l_i, ph_i =  Miller  䠧 .   i=1,2,...,mds.',
'hkl 㦭 ᫨  業 ࠬ ⪨   hkl',
'The points on the graph can be clicked in any sequence. Since the',
'clicking is not exact, option "refine peak positions" is foreseen.',
'Errors (accuracies) of d can be given for each d (if from file),',
'or put constant, if from graph; default = 0.001 Angst.',
'For automatic peak search sensitivity and resolution should be given,',
'defaults=1,1. The less sensitivity is the more weak peaks are found.',
'Peaks can be viewed on the graph using: GRAPH, Set of Points',
'If spectrum was input as d, counts, ds are taken instead of channels'
}
{*}PrepAuI_n:INTEGER = -16;
   PrepAuI:ARRAY[1..16] OF STRING = (
'There are 3 modes for powder indexing:',
'1/ Indexing only, lattice parameters being known and fixed',
'2/ Full powder indexing - both unit cell parameter determination',
'   and reflection indexing (default)',
'3/ Lattice parameter determination, reflections being indexed already',
'Also cynematic parameters: Flight path,theta,delay (or lambda,shift)',
'can be fitted. For this case channels (angles) along with d-spacings',
'should be contained in the d-distribution.',
'The preparation means:',
'1/ Get the symmetry of crystal and Bravais lattice type(default=P)',
'2/ Get the bounds for hkl-range to be tried; one should bear in mind',
'   that too large range slows down the indexing.',
'3/ Maximum volume of the elementary cell',
'4/ Volume minimizer - provides for "the most cubic" unit cell',
'5/ Initial lattice parameters and their bounds: the smaller the',
'   region of parameters, the more chances to get the right solution'
);
{*}MakeAuI_n:INTEGER = -17;
   MakeAuI:ARRAY[1..17] OF STRING = (
'Check whether the mode of powder indexing is correct.',
'Check whether the number of hkls generated is greater than the number',
'of reflections, but is not unreasonably large.',
'Select the proper fitting mode: least squares is more efficient,',
'but imposes stricter requirements on adequacy of model to data;',
'least modulus is more robust, but not so efficient.',
'Select the number of trials: random parameter vector are tried as',
'initial values for fitting and if it converges, the obtained values',
'are saved. The best of the saved values is solution of the problem.',
'Select the iteration number for each trial fit, the step and the',
'damper; large number of iterations, small step and large damper slow',
'down the fitting, but increase chances for fitting success; optimum',
'combination should be used.',
'If the mode "Measures against bad reflections" is on',
'some indices can be assigned to many reflections.',
'Deterministic trials mean: divide the total parameter region into',
'small bins and Monte-Carlo try in each bin (the most reliable fit).'
);
{*}AutoIRes_n:INTEGER = 6;
   AutoIRes:ARRAY[1..12] OF STRING = (
'A good quality of indexing is:',
'  small chi^2, average and max dif < error_exp, large (>10) criterion',
'Large ratio of N of err_resolved ds and N of d_exp may be result of:',
' 1/ ds are deficient  2/ real symmetry is higher than assumed',
'If measures against bad reflections have been undertaken,',
'some reflections can have coinciding indices.',
'襥 ⢮ 樨 砥',
'   chi^2, ।  max dif < error_exp, 让 (>10) criterion',
'讥 ⭮襭 N err_resolved ds  N d_exp   :',
' 1/ ds 䥪⨢  2/ ॠ쭠 ᨭ  祬 ।.',
'᫨ ᯮ짮  ⨢  䫥ᮢ,',
' 䫥   ᮢ騥 .'
);
{*}PriARef_n:INTEGER = 3;
   PriARef:ARRAY[1..6] OF STRING = (
'All reflections in the given interval at current lattice parameters',
'are listed. Each calculated reflection is matched by experimental one',
'if the mutual distance is smaller than eps_exp*SQRT(2) (in A)',
'뤠 䫥   ࢠ  ⥪ ࠬ ⪨',
' ᫥ 䫥 ࠥ ᯥਬ⠫ ',
'᫮   ﭨ < eps_exp*SQRT(2) ( A)'
);
{*}FitFTD_n:INTEGER = 3;
   FitFTD:ARRAY[1..6] OF STRING = (
'One can refine either Flight path, Delay, or Theta, Delay from',
'        d = f( ch, FPath,Theta,Delay), where ch=channel.',
'Spectral information + d-spacings are needed.',
' 筨  Flight path, Delay,  Theta, Delay ',
'        d = f( ch, FPath,Theta,Delay),  ch=.',
'室 ᯥࠫ쭠 ଠ + d-spacings.'
);
{*}AIParA_n:INTEGER = 1;
   AIParA:ARRAY[1..2] OF STRING = (
'Parameters: direct space A,B,C,COS(A),COS(B),COS(C) for each phase.',
'ࠬ:  A,B,C,COS(A),COS(B),COS(C)   䠧.'
);
{*}Ufindp_n:INTEGER =  11;                       {Key UPEAK}
   Ufindp:ARRAY[1..22] OF STRING = (
'For automatic peak finding one should set:',
'1. approximate width at the interval beginning (in chan)',
'2. approximate width at the interval end (in chan)',
'3. approximate width accuracy (in chan)',
'4. sensitivity - default is 1;',
'                 if weak peaks are missed, take smaller sens;',
'                 if too many peaks found, take larger sens.',
'5. resolution - default is 1;',
'6. small statistics - default = 20. Lesser counts treated specially.',
'Missed peaks can be added using MARK, Set of Points, without',
'resetting the counter.',
' ⮬᪮ ᪠   :',
'1. ਡ ਭ  砫 ࢠ ( .)',
'2. ਡ ਭ   ࢠ ( .)',
'3. ਡ 筮 ਭ ( .)',
'4. ⢨⥫쭮 - default = 1;',
'              ᫨ ய᪠ ᫠ ,   sens;',
'              ᫨ 室 ᫨誮  ,   sens;',
'5. ࠧ襭 - default = 1;',
'6. ஢  ⨪ - default = 20. ( ᯥ-ࠡ⪨).',
'ய饭   ;  MARK, Set of Points',
'  稪(no resetting the counter).'
);
{*}Ufit_n:INTEGER = 13;
   Ufit:ARRAY[1..26] OF STRING = (
'UPEAK fitting of peaks (or exponentials), each has its model (<=4).',
'The background is described either by polynomial or real shape model,',
'the degree and mode are in spectrum information',
'Mark peaks using command Mark Set of points, clicking on peak tops.',
'To graph peak marks use command Graph, Show set of points.',
'Assign models using command Mark, Assign the models, clicking on',
'numbers below. Or use Command Info about Set of Points.',
'For the ith model used the following quantities should be specified:',
'1/  delta pos - peak position accuracy in channels',
'2/  delta width_0 - width_0 accuracy in channels',
'3/  delta width_1 - width_1 accuracy in scale coefficients',
'The peak width at channel x is: width_0 + (x-x0)/(a2-a1)*width_1',
'where a1,a2-spectrum interval bounds, x0= its middle',
'UPEAK  ( ᯮ),   ᢮  (<=4).',
' 뢠     ॠ쭮 ,',
'⥯    ᯥࠫ쭮 ଠ樨.',
'   Mark Set of points, click  設 .',
'뢥 ⪨   䨪  Graph, Show set of points.',
'᢮   Mark, Assign the models, click ',
' .  ᯮ짮  Info about Set of Points.',
' i-    ᫥騥 稭:',
'1/  delta pos - 譮    .',
'2/  delta width_0 - 譮 width_0  .',
'3/  delta width_1 - 譮 width_1  樥 誠',
'ਭ    x =: width_0 + (x-x0)/(a2-a1)*width_1',
' a1,a2-࠭ ࢠ ᯥ, x0=  ।'
);
{*}UParA_n:INTEGER = 2;
   UParA:ARRAY[1..4] OF STRING = (
'Parameters: 6 background, n peak amplitudes, n peak positions,',
'4 couples W0,W1 for each model.',
'ࠬ: 6 䮭, n  , n  ',
'4  W0,W1   .'
);
{*}MakeGPH_n:INTEGER = 5;                       {Key Varias}
MakeGPH:ARRAY[1..10] OF STRING = (
'If the Rietveld fitting has been performed, its results can',
'be saved as text file (gph-file) of lines:',
'channel, exp.value, fit, sigma, d, peak indication, background value.',
'The data scale is artificial and ranges between -10 and 1000',
'The saved gph-file can be later entered but only for viewing.',
'᫨ Rietveld   ⢫,  १  ',
'ᯠᥭ  ⥪⮢ 䠩 (gph-file) :',
', ᯥ.祭, fit.祭, ᨣ, d, ਧ , 䮭',
'⠡  ⢥  祭  -10  1000',
'gph-file    ,  ⮫쪮  ᬮ 䨪.'
);
{*}EntBMPFN_n:INTEGER = 5;
   EntBMPFN:ARRAY[1..10] OF STRING = (
'Specify the BMP-file name where the current graph picture will be',
'saved. This file can be later used in programs for working with',
'graphs, as,e.g., WORD, etc.',
'Reversing the colors, i.e. transforming the graph to colors',
'white background + black picture is needed for a black/white printer.',
'  BMP-䠩  㤥 ᯠᥭ ᪠ ⨭ ࠭.',
' 䠩  㤥 ᯮ짮  ணࠬ  ࠡ  䨪',
', ਬ, WORD,  ..',
' 梥⮢ 㦥, .  ८ࠧ ⨭  梥⠬',
'" 䮭 + ୠ ⨭",  뢮  ୮- ਭ.'
);
{*}NyetI_n:INTEGER = -1;
   NyetI:ARRAY[1..1] OF STRING = (
'No comments are needed.'
);

IMPLEMENTATION

END.

{*}_n:INTEGER = ;
   :ARRAY[1..] OF STRING = (
);
