UNIT vmriarix;
INTERFACE
USES Windows,  Messages, Classes, Forms,    StdCtrls, ExtCtrls, Grids,
     Graphics, comctrls, Dialogs, SysUtils, Controls, vzlocom,  varfun,
     vmria0,   vmria2,   vgfit,   vmriahkl, vspectr,  vpmodel,  vpeaksr,
     vstdcons, vmria00;
TYPE TAULSM = CLASS(TParameter)
     PUBLIC { Public declarations }
      Ftot:REAL;      {In Monte-Carlo fitting global functional value}
      Fang,Fanx:REAL; {In MC fit current and global average deviation}
      Fabd,Fabx:REAL; {In MC fit current and global maximum deviation}
      ntries:INTEGER; {Number of initial parameter trials}
      ntrnd:INTEGER;  {Number of random tries in parameter sub-cell}
      PROCEDURE Arith(VAR y,w,v:REAL; kk,typ:INTEGER); OVERRIDE;
      PROCEDURE Regul(iit:INTEGER); OVERRIDE;
      CONSTRUCTOR Create(np,nm,m:INTEGER);
      PROCEDURE TrialFit;
      PROCEDURE MakeRandomSteps(VAR ok:BOOLEAN);
      PROCEDURE GetRandomParameter(iprob:INTEGER);
     PRIVATE { Private declarations }
     END;

PROCEDURE MakeAUFitResLB(VAR i:INTEGER);
PROCEDURE AssignHKLs;
PROCEDURE indexref(irfl:INTEGER);
PROCEDURE dhkl(iph:INTEGER);
PROCEDURE Makedk;
PROCEDURE PrintCurrState(ipr,npr:INTEGER);
PROCEDURE GetDDeviations;
PROCEDURE CountVisibleReflections(VAR cou:INTEGER; iph:INTEGER);
PROCEDURE MakeAuFitInfo(ipr,npr:INTEGER);
VAR aufit:TAULSM;

IMPLEMENTATION
PROCEDURE TAulsm.TrialFit;
{Trials + Fitting.  Aug 14 2002}
VAR   iph,ii,iprob,i0,i,j,ip,kp,ipsh,isyn,nr,ni,mg,idx:INTEGER;
      r,derv,y,w,f,h,h2,rr,wrob,rrr,grad,chi,qc,wsq:REAL; ok:BOOLEAN;
      parx:ARRAY[1..27] OF REAL;
LABEL L10,L20,Lend,L125,L23;
BEGIN FOR i:=1 TO npar DO par[i].e:=par[i].p;
IF(ntrnd<>0)THEN
 BEGIN MakeRandomSteps(ok); IF(NOT ok)THEN Exit;
 END;
FOR iprob:=1 TO ntries+1 DO FOR ii:=0 TO MAX0(0,ntrnd-1) DO{MAIN  LOOP;}
 BEGIN tertria:=(iprob=ntries+1);
 tergnit:=cb.gnit; terstep:=cb.step; IF(tertria)THEN
  BEGIN tergnit:=cb.gnit*3; terstep:=cb.step*0.5;
  FOR i:=1 TO npar DO par[i].p:=par[i].e; GOTO L10;
  END;
 IF(iprob=1)THEN GOTO L10;
 IF(ntrnd<>0)THEN GetRandomParameter(iprob)
             ELSE
 FOR ip:=1 TO npar DO WITH par[ip] DO IF(iprob<>1)THEN
  CASE bayes OF
  false: p:=pl+RNDM(-1)*(pu-pl);
  true:  BEGIN rannor(r,rr); r:=r/3;
         IF(r<0)THEN p:=AMAX1(pl,p+(p-pl)*r)
                ELSE p:=AMIN1(pu,p+(pu-p)*r);
         END;
  ELSE END;
  {the current vector is formed;}
 L10: FOR ip:=1 TO npar DO WITH par[ip] DO
  IF(n<=ip)THEN p:=a*par[n].p+b;
 Prepare00; Check00(ok); IF(NOT ok)THEN GOTO Lend;
 ok:=true; FOR iph:=1 TO nph DO WITH lp DO {Check the volume}
  BEGIN i:=(iph-1)*6; a:=par[i+1].p; b:=par[i+2].p; c:=par[i+3].p;
  alpha:=par[i+4].p; beta:=par[i+5].p; gamma:=par[i+6].p;
  j:=lat[iph].syng; IF(j=2)THEN
   MakeMostRectAng(a,b,c,alpha,beta,gamma,rr,j)
                           ELSE rr:=DCellVolume(a,b,c,alpha,beta,gamma);
  IF(rr<=0)THEN GOTO L20; IF(rr>vmax[iph])THEN
   BEGIN r:=PowerRR(vmax[iph]/(a*b*c),0.333); a:=r*a; b:=r*b; c:=r*c;
   END;
  par[i+1].p:=a; par[i+2].p:=b; par[i+3].p:=c;
  par[i+4].p:=alpha; par[i+5].p:=beta; par[i+6].p:=gamma;
  END;
 {Gauss-Newton process}
 i0:=1; typ:=1; IF(cb.gnit=0)THEN GOTO Lend; v_stop:=false;
 REPEAT rb.pconv:=1; ZeroVecMat; chi:=0; qc:=0; mg:=0; kp:=i0;
 rb.chir:=0; Fang:=0; Fabd:=0;
  REPEAT arith(y,w,f,kp,typ); IF(w=0)THEN{loop in points}
   BEGIN Inc(rb.kzer); GOTO L125;
   END;
  rr:=y-f; wsq:=SQRT(w); h:=ABS(rr)*wsq;{Process the weights}
  Fang:=Fang+ABS(rr); Fabd:=AMAX1(Fabd,ABS(rr));
  h2:=h*h; IF(h>=cb.delta)THEN
   BEGIN wrob:=(1+cb.beta)/(SQR(h/cb.delta)+cb.beta);
   w:=SQR(wsq)*wrob; h2:=h2*wrob;
   END;
  chi:=chi+h2; IF(h2<(1+SQRT(18/mpoint)))THEN mg:=mg+1;
  IF(rr>0)THEN qc:=qc+h2; rrr:=rr*w;
  FormMatVect(rr,rrr,w);
  L125: kp:=kp+cb.skip;
  UNTIL(kp>mpoint); {end loop in points}
 CompleteMatr(grad);
 {IF(keyAuto=1)THEN FOR i:=1 TO npar DO Write(fout,yar[i]:10:3);
 IF(keyAuto=1)THEN Writeln(fout,' der');}

 rb.chi2:=chi/rb.ndegf; rb.chipl:=qc/AMAX1(0.000001,chi);
 Fang:=Fang/AMAX0(mpoint-rb.kzer,1);
 rb.gpoin:=mg/MAX0(1,mpoint);
 regul(kp);{the regularisation or projection}
 DampMatrix;
 InvSMatrix; IF(ifail=0)THEN GOTO L20; {the matrix inversion}
 IF(nocomp)THEN {is the reciprocal matrix pos.defin.}
  BEGIN podem; IF(rb.pconv<>1)THEN GOTO L20;
  END;
 CorrectPars(0);
 ExpandVect;
 chisr:=rb.chi2+cb.alpha*rb.chir;
 CASE cb.liqu OF
 0: chinew:=Fabd;
 1: chinew:=Fang;
 2: chinew:=chisr;
 ELSE END;
 IF(cb.iconv=0)THEN GOTO L23; {stop if inconvergence}
 IF((cb.iconv=1)AND(chinew>chiold))THEN
  BEGIN rb.stop:=0; GOTO L20;
  END;
 IF(cb.iconv=2)THEN
  BEGIN IF(chinew<=chiold)THEN GOTO L23; WITH cb DO
   BEGIN step:=step*0.5; damp:=AMIN1(damp*2,100); skip:=1; GOTO L20;
   END;
  END;
 L23: chiold:=chinew;
 CorrectPars(1);
 MakeAccu(grad);
 IF(i0=cb.skip)THEN i0:=0; Inc(i0);
 Inc(rb.gnit); IF((rb.stop<>1)OR(rb.pminv=0))THEN GOTO L20;
 UNTIL(
  (rb.gnit>=tergnit)OR((rb.epsf<=cb.eps)AND(chisr<=cb.chi))OR(v_stop));
 IF(v_stop)THEN GOTO Lend;
 //CASE cb.liqu OF {metric: C,modulus,quadratic}
 //0:IF((Fabd>=Fabx)OR(NOT ok))THEN GOTO L20; {C}
 //1:IF((Fang>=Fanx)OR(NOT ok))THEN GOTO L20; {modul}
 //2:IF((chisr>=Ftot)OR(NOT ok))THEN GOTO L20;{quadr}
 //ELSE END;
 IF(Fang>=Fanx)THEN GOTO L20;
 IF(volc)THEN FOR iph:=1 TO nph DO WITH lp DO {Check the volume}
  BEGIN i:=(iph-1)*6; a:=par[i+1].p; b:=par[i+2].p; c:=par[i+3].p;
  alpha:=par[i+4].p; beta:=par[i+5].p; gamma:=par[i+6].p;
  rr:=DCellVolume(a,b,c,alpha,beta,gamma);
  IF(rr>vmax[iph])THEN GOTO L20;
  END;
 Ftot:=chisr; Fanx:=Fang; Fabx:=Fabd;{save the current optimum}
 FOR i:=1 TO npar DO parx[i]:=par[i].p;
 L20: IF(keyAuto<>1)THEN
  BEGIN nr:=MAX0(MIN0(ntries DIV 3,100),1); i:=iprob DIV nr;
  j:=-1; IF((i*nr)=iprob)THEN j:=0;
  IF((j=0)AND(dispfit))THEN PrintCurrState(iprob,ntries);
  IF((Fanx<0.00001)OR(v_stop))THEN ok:=false;
  IF(v_stop)THEN ntrT:=iprob;
  END;
 IF(cb.ipr<>0)THEN
  Writeln(fout,'trial=',iprob:6,' Ftot=',Ftot:15:2,
  ' dev=',Fanx:10:5,Fabx:10:5);
 IF((Ftot<cb.chi)OR(Fanx<0.0001)OR(NOT ok))THEN GOTO Lend;
 END; {End of trial loop;}
Lend: cb:=cb0;
FOR i:=1 TO npar DO par[i].p:=parx[i];
SaveErrors;
END;
PROCEDURE TAulsm.Arith(VAR y,w,v:REAL; kk,typ:INTEGER);
{ The LS-arithmetic procedure to compute function value and its
  derivatives with respect to parameters  Version: 31 Jul 1990 }
VAR   i,iph,iref,j,ir:INTEGER; lp:LATREC;
      wcc,ca2,cb2,cg2,cab,cbg,cag,zn11,zn1,abg,agb,bga,ah,bk,cl,r:REAL;
      abhk,achl,bckl,ca1,cb1,cg1,ab1,ac1,bc1,ah1,bk1,cl1,zn22,zn2:REAL;
      wch,z,d,rabg,lamb,Fp,theta,d0,ch,zz:REAL;
LABEL L1,L22;
BEGIN FOR i:=1 TO aufit.npar DO aufit.par[i].drv:=0; iref:=kk;
IF((kk=1)AND(keyAuto<>1))THEN AssignHKLs;
{Form function value and error}
iph:=dspa[iref].ph; j:=(iph-1)*6; y:=dspa[iref].d; w:=dspa[iref].e;
IF(dstype<>0)THEN y:=dspa[iref].x;
IF(typ<>3)THEN w:=eps_av; IF(w<>0)THEN w:=1/(w*w);
WITH dspa[iref] DO r:=AMAX1(0.00001,ABS(d-th));
IF(BadRMes AND(r>(3*aufit.Fang)))THEN w:=w/r;
wch:=spec[numsp].chw; IF(dstype<>3)THEN wch:=1;
{fetch lattice parameters}
WITH lp DO WITH aufit DO
 BEGIN a:=par[j+1].p; b:=par[j+2].p; c:=par[j+3].p;
 alpha:=par[j+4].p; beta:=par[j+5].p; gamma:=par[j+6].p;
 CASE keylatt OF
 0: WITH spec[numsp] DO
     BEGIN lamb:=lambda; Fp:=FPath; d0:=delay;
     END;
 1: BEGIN i:=nph*6; lamb:=par[i+1].p; Fp:=par[i+1].p; d0:=par[i+3].p;
    END;
 ELSE END;
 END;
ir:=dspa[kk].irfl; IF(keyAuto=1)THEN ir:=kk; hklr:=hkla[ir,iph];
{compute dk = d-position of the reflection}
IF(auparmod=1)THEN GOTO L1;
dhkl(iph); hkla[ir,iph].dk:=hklr.dk; d:=hklr.dk;
IF(d<=0.000001)THEN GOTO L22;
{wcc:=1;}
WITH lp DO WITH hklr DO WITH aufit DO
 BEGIN ca2:=SQR(alpha); cb2:=SQR(beta); cg2:=SQR(gamma);{The numerator}
 cab:=alpha*beta; cbg:=beta*gamma; cag:=alpha*gamma;
 zn11:=1-ca2-cb2-cg2+2*alpha*cbg; zn1:=SQRT(AMAX1(0,zn11));
 abg:=cab-gamma; agb:=cag-beta; bga:=cbg-alpha;{The denominator}
 ah:=SQR(h/a); bk:=SQR(k/b); cl:=SQR(l/c);
 abhk:=h*k/(a*b); achl:=h*l/(a*c); bckl:=k*l/(b*c);
 ca1:=1-ca2; cb1:=1-cb2; cg1:=1-cg2;
 ab1:=abhk*abg; ac1:=achl*agb; bc1:=bckl*bga;
 ah1:=ah*ca1; bk1:=bk*cb1; cl1:=cl*cg1;
 zn22:=ah1+bk1+cl1+2*(ab1+ac1+bc1); zn2:=SQRT(AMAX1(0,zn22));
 r:=zn1/AMAX1(1E-10,zn2); rabg:=r*r*r;
 par[j+1].drv:={wcc*}rabg*(ah1+ab1+ac1)/a;
 par[j+2].drv:={wcc*}rabg*(bk1+ab1+bc1)/b;
 par[j+3].drv:={wcc*}rabg*(cl1+ac1+bc1)/c;
 wcc:={wcc}1/AMAX1(1E-10,(zn22*zn2*zn1));
 par[j+4].drv:=wcc*(zn22*bga+zn11*(ah*alpha-abhk*beta-achl*gamma+bckl));
 par[j+5].drv:=wcc*(zn22*agb+zn11*(bk*beta-abhk*alpha+achl-bckl*gamma));
 par[j+6].drv:=wcc*(zn22*abg+zn11*(cl*gamma+abhk+achl*alpha-bckl*beta));
 dspa[kk].th:=d; zz:=lamb/(2*d); ch:=radian*arcsin(zz)-d0;
 z:=SQRT(AMAX1(0.0001,1-SQR(zz)));
 CASE dstype OF
 1: r:=-radian*zz/(z*d);
 2: BEGIN ch:=2*ch; r:=-2*radian*zz/(z*d);
    END;
 3: BEGIN r:=Fp*505.556*SIN(spec[numsp].theta/radian)*2*d/wch;
    ch:=spec[numsp].dtoch(d);
    END;
 ELSE END;
 IF(dstype<>0)THEN
  BEGIN dspa[kk].xc:=ch; FOR i:=1 TO 6 DO par[j+i].drv:=par[j+i].drv*r;
  END;
 i:=6*nph;
 IF(keylatt=1)THEN  {cynematic params}
  CASE dstype OF
  1,2: BEGIN par[i+1].drv:=radian/(2*d*z);
       par[i+2].drv:=0; par[i+3].drv:=-1;
       END;
  3:   BEGIN par[i+1].drv:=z; par[i+2].drv:=0; par[i+3].drv:=-1;
       END;
  ELSE END;
 END;
GOTO L22;
L1: {WITH hklr DO WITH lp DO
 q12:=ABS(a*h*h+b*k*k+c*l*l+alpha*k*l+beta*h*l+gamma*h*k);
IF(q12<=0.0000001)THEN GOTO L22; d:=q12;
hklr.dk:=d; hkla[ir,iph].dk:=d;
wcc:=1;
WITH hklr DO WITH aufit DO
 BEGIN y:=1/(y*y);
 drv[j+1]:=wcc*h*h;
 drv[j+2]:=wcc*k*k;
 drv[j+3]:=wcc*l*l;
 drv[j+4]:=wcc*k*l;
 drv[j+5]:=wcc*h*l;
 drv[j+6]:=wcc*h*k;
 dspa[kk].th:=d;
 END;}
L22: IF(dstype=0)THEN v:=d ELSE v:=ch;
IF(debugV.indtest)THEN WITH aufit DO
 BEGIN Writeln(fout,d:8:4,y:8:2,ch:8:2,z:8:4,dstype:4); WITH hklr DO
  Writeln(fout,'hkl ',h:4,k:4,l:4);
 {IF(kk=mpoint)THEN
  Writeln(fout,'D= ',drv[1]:8:3,drv[2]:8:3,drv[3]:8:3);}
 END;
END;
PROCEDURE dhkl(iph:INTEGER);
{Compute the interplanar distance using direct unit cell
 input hkl's in hklr;    result to hklr.dk
 Version: February 4 1993}
VAR a2,b2,c2,abc,abc2,ca2,cb2,cg2,rr,f:REAL; i:INTEGER; lpw:LATREC;
BEGIN WITH lpw DO WITH aufit DO
 BEGIN i:=(iph-1)*6; a:=par[i+1].p; b:=par[i+2].p; c:=par[i+3].p;
 alpha:=par[i+4].p; beta:=par[i+5].p; gamma:=par[i+6].p; {cosines}
 END;
WITH hklr DO WITH lpw DO
 CASE lat[iph].syng OF
 1: {Triclinic}
  BEGIN abc:=a*b*c; abc2:=2*abc; ca2:=alpha*alpha; cb2:=beta*beta;
  cg2:=gamma*gamma; rr:=AMAX1(0,1-ca2-cb2-cg2+2*alpha*beta*gamma);
  a2:=a*a; b2:=b*b; c2:=c*c;
  f:=b2*c2*h*h*(1-ca2)+a2*c2*k*k*(1-cb2)+a2*b2*l*l*(1-cg2);
  f:=f+abc2*c*h*k*(alpha*beta-gamma);
  f:=f+abc2*b*h*l*(alpha*gamma-beta);
  f:=f+abc2*a*k*l*(beta*gamma-alpha);
  IF(f>0)THEN dk:=abc*SQRT(rr/f) ELSE dk:=0;;
  END;
 2:{Monoclinic}
  BEGIN abc:=a*b*c; abc2:=2*abc; cb2:=beta*beta; rr:=AMAX1(0,1-cb2);
  a2:=a*a; b2:=b*b; c2:=c*c; f:=b2*c2*h*h+a2*c2*k*k*(1-cb2)+a2*b2*l*l;
  f:=f-abc2*b*h*l*beta; IF(f>0)THEN dk:=abc*SQRT(rr/f) ELSE dk:=0;
  END;
 3,4: BEGIN rr:=SQR(h/a)+SQR(k/b)+SQR(l/c); dk:=1/SQRT(rr);{Ortho,Tetra}
  END;
 5: BEGIN rr:=(h*h+k*k+l*l); dk:=a/SQRT(rr); {Cubic}
    END;
 6: BEGIN rr:=4/3*((h*h+h*k+k*k)/(a*a))+SQR(l/c); dk:=1/SQRT(rr);{Hexag}
    END;
 7: BEGIN ca2:=alpha*alpha; rr:=AMAX1(0,1-3*ca2+2*alpha*ca2);{Rhombohed}
    f:=(1-ca2)*(h*h+k*k+l*l); f:=f+2*(alpha*alpha-alpha)*(h*k+h*l+k*l);
    IF(f>0)THEN dk:=a*SQRT(rr/f) ELSE dk:=0;
    END;
 ELSE END;
END;
PROCEDURE AssignHKLs;
{To assign hkls and compute the distance functional Version: May 7 1991}
BEGIN Makedk; {Compute the calculated Dk's for all hkl's tried}
indexref(0); {Assign the HKL's}
END;
PROCEDURE Makedk;
{To compute the calculated dk's at current lattice parameters
 Version: November 27 1992}
VAR iph,iref,nre:INTEGER; d:REAL;
BEGIN FOR iph:=1 TO nph DO
 BEGIN {Loop over hkl's} nre:=lat[iph].nhkl;
 ihkln[iph]:=1; ihklx[iph]:=nre;
 dmin[iph]:=100; dmax[iph]:=0;
 FOR iref:=1 TO nre DO
  BEGIN hklr:=hkla[iref,iph]; dhkl(iph);
  d:=hklr.dk; hkla[iref,iph].dk:=d;
  IF(d<dmin[iph])THEN
   BEGIN dmin[iph]:=d; ihkln[iph]:=iref;
   END;
  IF(d>dmax[iph])THEN
   BEGIN dmax[iph]:=d; ihklx[iph]:=iref;
   END;
  hkla[iref,iph].ass:=false; {no reflection yet indexed}
  END;
 END;
END;
PROCEDURE indexref(irfl:INTEGER);
{To index irfl-th reflection (all if irfl=0)
 Version: November 27 1992, May 15 1996}
VAR   i,iph,icl1,icl2,ir,iphr,ipc,iref:INTEGER;
      indxB:BOOLEAN; dif,r,ch,d:REAL;
BEGIN IF(keyAuto=1)THEN {if indexed reflections}
 BEGIN FOR i:=1 TO mdsp DO WITH dspa[i] DO
  BEGIN ass:=true; ph:=1; th:=hkla[i,ph].dk;
  END;
 Exit;
 END;
                {Indexing and full auto}
icl1:=irfl; icl2:=irfl; IF(irfl=0)THEN
 BEGIN icl1:=1; icl2:=mdsp; {all reflections}
 END;
FOR ipc:=icl1 TO icl2 DO
 BEGIN ir:=1; iphr:=1; r:=1E18;
 ch:=dspa[ipc].d; {Experimental reflection} IF(ch<0)THEN CONTINUE;
 {Find the nearest among the generated reflections}
 FOR iph:=1 TO nph DO FOR iref:=1 TO {nref[iph]}lat[iph].nhkl DO
  BEGIN IF(hkla[iref,iph].ass)THEN CONTINUE;
  {hkl already assigned}
  d:=hkla[iref,iph].dk; dif:=ABS(d-ch); IF(dif<r)THEN
   BEGIN r:=dif; ir:=iref; iphr:=iph;
   END;
  END;
 {Ignoring bad reflections, multiple assignement}
 indxB:=(ir=ihkln[iphr])OR(ir=ihklx[iphr]); {ir on the boundary}
 IF(BadRMes OR indxB)THEN hkla[ir,iphr].ass:=false
                     ELSE hkla[ir,iphr].ass:=true;
 {WITH hkla[ir,1] DO
  Writeln(fout,ipc:4,ch:8:4,r:10:4,dk:10:4,ir:6,ass,BadRMes,indxB);}
 dspa[ipc].th:=hkla[ir,iphr].dk; dspa[ipc].ph:=iphr;
 dspa[ipc].irfl:=ir; dspa[ipc].ass:=true;
 dspa[ipc].h:=hkla[ir,iphr].h; dspa[ipc].k:=hkla[ir,iphr].k;
 dspa[ipc].l:=hkla[ir,iphr].l;
 END;
END;
PROCEDURE TAulsm.Regul(iit:INTEGER);
{To provide for the volume minimization Version: November 3 1993}
VAR i,iph,j:INTEGER; alph,vac,rr,r:REAL;
BEGIN alph:=aufit.cb.alpha;
FOR iph:=1 TO nph DO WITH aufit DO
 BEGIN vac:=alph*vmin[iph]*qv[iph];
 j:=(iph-1)*6; r:=0; IF(vmintyp=1)THEN r:=1; FOR i:=j+1 TO j+3 DO
  BEGIN readm(i,i);
  CASE vmintyp OF
  0: BEGIN r:=r+vac*SQR(par[i].p); ww:=ww+vac*par[i].p;
     END;
  1: BEGIN r:=r*par[i].p; rr:=par[j+1].p*par[j+2].p*par[j+3].p;
     ww:=ww+0.5*vac*rr/par[i].p;
     END;
  ELSE END;
  writem(i,i);
  END;
 rb.chir:=rb.chir+r;
 {rr:=par[j+1].p*par[j+2].p*par[j+3].p;
 IF(rr>vmax[iph])THEN
  BEGIN r:=PowerRR(vmax[iph]/rr,0.333333); par[j+1].p:=par[j+1].p*r;
  par[j+2].p:=par[j+2].p*r; par[j+3].p:=par[j+3].p*r;
  END;}
 END;
END;
PROCEDURE GetDDeviations;
VAR i,j,iph:INTEGER; r:REAL;
BEGIN FOR iph:=1 TO nph DO
 BEGIN Faph[iph]:=0; nasr[iph]:=0; Fapx[iph]:=0;
 END;
FOR i:=1 TO mdsp DO
 BEGIN j:=Round(dspa[i].ph); nasr[j]:=nasr[j]+1;
 r:=ABS(dspa[i].d-dspa[i].th);
 Fapx[j]:=AMAX1(Fapx[j],r); Faph[j]:=Faph[j]+r;
 END;
FOR iph:=1 TO nph DO Faph[iph]:=Faph[iph]/AMAX1(1,nasr[iph]);
END;
PROCEDURE MakeAUFitResLB(VAR i:INTEGER);
BEGIN WITH LB1rec DO WITH aufit DO
 BEGIN ar[i]:=' '; Inc(i); ar[i]:=compstr; Inc(i);
 IF(nocnv)THEN
  BEGIN ar[i]:=gf_pnc; Inc(i);
  END;
 IF(noinv)THEN
  BEGIN ar[i]:=gf_mni; Inc(i);
  END;
 IF((noch)OR(noequ))THEN
  BEGIN ar[i]:=gf_fng; Inc(i);
  END;
 IF(noeps)THEN
  BEGIN ar[i]:=gf_anr; Inc(i);
  END;
 IF(rb.pobi=1)THEN
  BEGIN ar[i]:=gf_phb; Inc(i);
  END;
 ar[i]:=' '; Inc(i);
 ConvertStr(rb.chi2,7,2); s:='  Ch2/df= '+sedz;
 ConvertStr(rb.chipl,5,2); s:=s+'     Ch+= '+sedz; ar[i]:=s; Inc(i);
 ConvertStr(rb.epsf,5,1); s:='  Eps= '+sedz;
 ConvertStr(rb.gnit,4,0); s:=s+'       Iterations= '+sedz;
 ar[i]:=s; nitems:=i;
 END;
END;
PROCEDURE MakeAuFitInfo(ipr,npr:INTEGER);
BEGIN strgrH[1]:=' '+IntToStr(ipr)+' tries';
strgrH[2]:=' out of '+IntToStr(npr)+';      Total N= '+IntToStr(ntrT);
WITH aufit DO
 BEGIN ConvertStr(Ftot,12,2); Compress(sedz); strgrH[3]:=' R= '+sedz;
 ConvertStr(Fanx,10,5); Compress(sedz);
 s:='Angst'; IF(dstype IN [1,2])THEN s:='Degr.';
 IF(dstype=3)THEN s:='Chan.'; s:='     Eps('+s+')= ';
 strgrH[3]:=strgrH[3]+s+sedz; ConvertStr(eps_av,12,5);
 strgrH[3]:=strgrH[3]+'     exp.error = '+sedz;
 END;
END;
PROCEDURE PrintCurrState(ipr,npr:INTEGER);
{To print the current state, Version: January 15 1993}
BEGIN MakeAuFitInfo(ipr,npr); WITH Form2 DO
 BEGIN Left:=0; Top:=0; Width:=exs(550); Height:=exs(410);
 Button5.Visible:=false; Color:=clGreen;
 Caption:=bblank+aapi;
 {WITH Image2 DO
  BEGIN Left:=0; Top:=exs(120); Width:=exs(516); Height:=exs(50);
  Visible:=true;
  END;}
 Timer1.Interval:=1; Wait(click1);
 OuttoLabel(Label5,15,10,clBlue,clWhite,strgrH[1]);
 OuttoLabel(Label6,115,10,clGreen,clWhite,strgrH[2]);
 OuttoLabel(Label7,5,30,clRed,clBlack,strgrH[3]);
 END;
END;
PROCEDURE CountVisibleReflections(VAR cou:INTEGER; iph:INTEGER);
VAR i,kx:INTEGER; d1,d2,r:REAL;
BEGIN d2:=dspa[1].d+0.01; d1:=dspa[mdsp].d-0.001;
cou:=0; FOR i:=1 TO lat[iph].nhkl DO
 BEGIN r:=hkla[i,iph].dk; IF(rinfun(r,d1,d2))THEN
  BEGIN Inc(cou); onl[cou]:=r;
  END;
 END;
marran(cou,-1);
REPEAT r:=1E15;
FOR i:=1 TO cou-1 DO IF(ABS(onl[i]-onl[i+1])<r)THEN
 BEGIN r:=ABS(onl[i]-onl[i+1]); kx:=i;
 END;
IF(r>(1.4*eps_av))THEN Exit;
onl[kx+1]:=(onl[kx]+onl[kx+1])*0.5; onl[kx]:=0;
mcleanz(cou,0);
UNTIL cou<=0;
END;
            {Autoindexing}
CONSTRUCTOR TAulsm.Create(np,nm,m:INTEGER);
BEGIN INHERITED Create(np,nm,m);
ntries:=1000; Ftot:=1E19; Fanx:=1E19; Fabx:=1E19;
END;
PROCEDURE TAulsm.GetRandomParameter(iprob:INTEGER);
VAR i,j,ii:INTEGER;
 PROCEDURE MakeCurrStep(i,j:INTEGER);
 BEGIN WITH par[i] DO IF(ntrnd=0)THEN p:=pl+RNDM(-1)*(pu-pl)
  ELSE p:=pl+(j+RNDM(-1))*ddstep[i].st;
 END;
BEGIN ii:=iprob; FOR i:=1 TO npar-1 DO WITH ddstep[i+1] DO
 BEGIN j:=ii DIV nprod; MakeCurrStep(i,j);
 ii:=ii-j*nprod; IF(i=npar-1)THEN MakeCurrStep(npar,ii);
 END;
FOR i:=1 TO npar DO WITH par[i] DO IF(n<=i)THEN p:=a*par[n].p+b;
END;
PROCEDURE TAulsm.MakeRandomSteps(VAR ok:BOOLEAN);
VAR i,j,nn:INTEGER;
BEGIN FOR i:=1 TO npar DO ddstep[i].st:=(par[i].pu-par[i].pl);
ok:=true; FOR j:=1 TO npar DO
 BEGIN nn:=1; FOR i:=j TO npar DO
  TRY nn:=nn*ddstep[i].nst;
  EXCEPT on EOverFlow DO
   BEGIN ok:=false; ShowMess('Overflow, too many random steps');
   Exit;
   END;
  END;
 ddstep[j].nprod:=nn;
 END;
ntries:=ddstep[1].nprod;
FOR i:=1 TO npar DO WITH ddstep[i] DO st:=st/Float(nst);
END;

{---------------------}
BEGIN
END.
