UNIT vmriasgm;
INTERFACE
USES Windows, Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,    vzlocom,  vmria0,   varfun,
     vmria2,  vmriasp,  vgfit,    vmriarit, vmriahlp, vspectr,  vpmodel,
     vpeaksr, vdata,    vstdcons, vmria00,  vmria3;
PROCEDURE SetNumberofSpectra;
PROCEDURE SetNumberofPhases;
PROCEDURE SetScalemode;
PROCEDURE GraphtheSpectrum;
PROCEDURE GraphtheFittedSpectrum;
PROCEDURE GraphPeakModel;
PROCEDURE GraphSeveralSpectra(VAR indi:STRING; VAR amx,amn:REAL);
FUNCTION GetTheorHKL(isp,j0:INTEGER; q:REAL):REAL;
PROCEDURE FormSpecialModels;
PROCEDURE TaketheModel(mo:INTEGER);
PROCEDURE ZeroWeights(VAR i1,i2:INTEGER);
PROCEDURE SetNAuxi(VAR i:INTEGER; idx:INTEGER);
PROCEDURE GetPhaseMode;
PROCEDURE GraphPlaneDistribution(CONST Ima1,Ima2: TImage);
PROCEDURE SetResFileName;
PROCEDURE MakeGPHFile(VAR Im2:TImage; im:INTEGER);
PROCEDURE ToggletheFormSize;
PROCEDURE SettheMainMode;
PROCEDURE MovethePeakModels(VAR i1,i2:INTEGER);
PROCEDURE SumSpecInterval(b1,b2:INTEGER);
PROCEDURE PutComment(VAR ok:BOOLEAN);
PROCEDURE SetNumberofDigits;
PROCEDURE SetVariousOptions;

CONST gphfn:STRING ='Enter the gph-file name';

IMPLEMENTATION
PROCEDURE SetVariousOptions;
VAR i:INTEGER; ok:BOOLEAN;
BEGIN REPEAT
{***} L0rec:=''; MakeForm(0);
s:=selops; OuttoLabel(Form2.Label5,5,20,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=5; indx:=1;
 ar[1]:='Quit';
 ar[2]:='Change the name of the Res-file';
 ar[3]:='Put a comment in the Res-file';
 ar[4]:='Set the number of AUTOX digits';
 ar[5]:='Set the identical spectrum intervals';
 END;
MakeRadioGroup(1,0,20,50,270,150);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 CASE i OF
 0: Exit;
 1: SetResFileName;
 2: BEGIN PutComment(ok); IF(ok)THEN WITH Form2.Memo1.Lines DO
     FOR i:=1 TO Count DO Writeln(fout,Strings[i-1]);
    END;
 3: SetNumberofDigits;
 4: BEGIN FOR i:=1 TO 4 DO WITH spec[i] DO
     BEGIN a11:=ic1; a22:=ic2; a1:=MIN0(a1,a11); a2:=MAX0(a2,a22);
     END;
    END;
 ELSE END;
 END;
      UNTIL false;
END;
PROCEDURE SetScalemode;
BEGIN L0rec:=' Graph modes'; MakeForm(1); SaveHelp(SScaleM_n,SScaleM);
s:='Select the scale';
OuttoLabel(Form2.Label5,10,30,clMaroon,clWhite,s);
s:='Select the pixel mode';
OuttoLabel(Form2.Label6,170,30,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN ar[1]:='Normal'; ar[2]:='SQRT'; ar[3]:='LN'; ar[4]:='Trimmed';
 nitems:=4; indx:=nscale;
 END;
MakeRadioGroup(1,0,10,50,120,120);
WITH CB1rec DO
 BEGIN ar[1]:=' 5 points '; ar[2]:=' 1 point '; ar[3]:=' Line ';
 nitems:=3; indx:=pixelm+1;
 END;
MakeRadioGroup(2,0,190,50,110,120);
L1rec:=' Trimming coefficient = '; ConvertStr(trimm,7,3); E1rec:=sedz;
MakeEdits(30,210,220,70,1);
WITH CB1rec DO
 BEGIN nitems:=3;
 ar[1]:=' Graph errors of fitted spectrum';
 ar[2]:=' X scale logarithmic';
 ar[3]:=' Long reflection indicators';
 END;
MakeCheckListBox(10,260,280,55); WITH Form2.CheckListBox1 DO
 BEGIN Checked[0]:=ErrGrM; Checked[1]:=xscale; Checked[2]:=LongArr;
 END;

WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 pixelm:=RadioGroup2.ItemIndex;
 nscale:=RadioGroup1.ItemIndex+1; IF(nscale=4)THEN
  BEGIN Zval(Edit1.Text,r); IF(ModalRes=0)THEN
   BEGIN ShowMess('Wrong trimming'); Exit;
   END;
  trimm:=r;
  END;
 WITH CheckListBox1 DO
  BEGIN ErrGrM:=Checked[0]; xscale:=Checked[1]; LongArr:=Checked[2];
  END;
 END;
END;
PROCEDURE SetNumberofDigits;
BEGIN L0rec:=''; MakeForm(0);
s:='Set number of digits after comma for AUTOX';
OuttoLabel(Form2.Label5,20,10,clMaroon,clWhite,s);
L1rec:=''; E1rec:=IntToStr(dignum); MakeEdits(10,120,50,70,1);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 Zval(Edit1.Text,r); dignum:=Round(AMIN1(r,10));
 END;
END;
PROCEDURE PutComment(VAR ok:BOOLEAN);
BEGIN L0rec:=' Enter the comments '; MakeFormV(0,20,620,430,0);
SaveHelp(blankH_n,blankH);
MakeMemo(5,590); WITH Form2 DO
 BEGIN ShowModal; ok:=false; IF(ModalRes<>0)THEN ok:=true;
 END;
END;
PROCEDURE SmootheModel(m:INTEGER);
{data in sa array, m items}
VAR   mof,li,lj,i:INTEGER; ax,an,rsm:REAL;
LABEL Lend;
BEGIN Bitmap:=TBitmap.Create; WITH Bitmap DO
 BEGIN Width:=exs(516); Height:=exs(323);
 END;
WITH pmrec DO
 BEGIN ax:=amx; an:=amn;
 END;
rsm:=qq.q1; mof:=3;
L0rec:=''; MakeFormV(90,0,530,450,0); SaveHelp(blankH_n,blankH);
Form2.Image2.Visible:=true;
REPEAT smooth(m,0,rsm,q1,q2); WITH CB1rec DO
 BEGIN nitems:=3; indx:=mof;
 ar[1]:=' Less smoothing'; ar[2]:=' More smoothing'; ar[3]:=' Quit';
 END;
MakeRadioGroup(1,0,300,0,200,70);
s:='Click on Less or More, then on OK';
OuttoLabel(Form2.Label5,5,30,clGreen,clWhite,s);
s:='If model is good, click on Quit, then on OK';
OuttoLabel(Form2.Label6,5,50,clGreen,clWhite,s);
WITH Form2.Image2.Canvas DO
 BEGIN Brush.Style:=bsSolid; Brush.Color:=0;
 FillRect(Rect(0,0,exs(516),exs(300)));
 END;
MakeBMFrame(ax,an);
WITH Bitmap.Canvas DO      {Plotting the Graph}
 BEGIN Pen.Style:=psSolid; Pen.Color:=clAqua; FOR i:=1 TO m DO
  BEGIN li:=exs(Round(Float(i)*512/AMAX0(1,m)));
  lj:=exs(CalcOrdinate(sa[i],ax,an)); DrawPixelPr(cola[2],li,lj,i,1,1);
  lj:=exs(CalcOrdinate(sd[i],ax,an)); DrawPixelPr(cola[3],li,lj,i,1,1);
  END;
 END;
Form2.Image2.Canvas.Draw(0,0,Bitmap);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN GOTO Lend;
 mof:=Form2.RadioGroup1.ItemIndex+1; IF(mof=3)THEN GOTO Lend;
 END;
IF(mof=1)THEN rsm:=rsm*1.5 ELSE rsm:=rsm/1.5;
UNTIL false;
Lend: Bitmap.Free; pmrec.lam:=rsm;
END;
PROCEDURE TaketheModel(mo:INTEGER);
{mo:  0 one-signed,  1 double,  2 both}
VAR i,m:INTEGER; r:REAL;
BEGIN IF(NOT spec[numsp].spin)THEN
 BEGIN msinf:='Error, no spectrum'; Exit;
 END;
L0rec:='Forming the real peak model'; MakeForm(1);
SaveHelp(FoRMod_n,FoRMod);
s:='Select the number of the model';
OuttoLabel(Form2.Label6,10,30,clGreen,clWhite,s);
CB1rec:=ModelNRec; MakeRadioGroup(1,0,20,50,273,165);
WITH CB1rec DO IF(mo=2)THEN
 BEGIN nitems:=2; ar[1]:='Form one-signed model';
 ar[2]:='Form double-signed model'; indx:=1;
 MakeRadioGroup(2,0,10,220,270,50);
 END;
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
nmod:=Form2.RadioGroup1.ItemIndex;
WITH pmod[nmod] DO
 BEGIN IF(mo=0)THEN ndsign:=true ELSE ndsign:=false; IF(mo=2)THEN
  BEGIN ndsign:=true;
  IF(Form2.RadioGroup2.ItemIndex=1)THEN ndsign:=false;
  END;
 WITH pmrec DO {from graph}
  BEGIN im1:=imod1; im2:=imod2; FindBackg(spec[numsp],im1,im2,Lbk);
  END;
 END;
L0rec:='Enter the data for peak model'; MakeForm(1);
strgrW[0]:=190; strgrW[1]:=80; WITH pmrec DO
 BEGIN strgrT[1]:='The beginning (in chan.) ='; strgrNn[1,1]:=im1;
 strgrT[2]:='The end (in chan.) ='; strgrNn[2,1]:=im2;
 strgrT[3]:='Background channels ='; strgrNn[3,1]:=Lbk;
 END;
PuttoTable(20,50,3,3,1,8);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
WITH Form2 DO WITH pmrec DO
 BEGIN FOR i:=1 TO 3 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
 ns:=numsp; im1:=Round(har[1]); im2:=Round(har[2]); Lbk:=Round(har[3]);
 IF(im2<=im1)THEN
  BEGIN msinf:='Wrong bounds '+IntToStr(im1)+' '+IntToStr(im2);
  ModalRes:=0; Exit;
  END;
 IF(Lbk=0)THEN WITH spec[numsp] DO
  BEGIN r:=AMAX3(y[im1],y[im2],1); IF(r>(5*SQRT(r)))THEN
   BEGIN s:='No background channels'+' Still proceed?'+crc+insd;
   i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Lbk:=1;
   END;
  END;
 WITH pmod[nmod] DO
  BEGIN camod_Prep(spec[numsp],m); IF(ModalRes=0)THEN Exit;
  SmootheModel(m); IF(ModalRes=0)THEN Exit;
  camod_Make(m); IF(ModalRes=0)THEN Exit;
  END;
 msinf:='Real model '+IntToStr(nmod)+' formed';
 END;
Writeln(fout,msinf);
END;
PROCEDURE SumSpecInterval(b1,b2:INTEGER);
VAR i:INTEGER;
BEGIN IF(NOT spec[numsp].spin)THEN
 BEGIN msinf:='Error, no spectrum'; Exit;
 END;
L0rec:='Summing the spectrum interval'; MakeForm(0);
strgrW[0]:=190; strgrW[1]:=80;
strgrT[1]:='The beginning (in chan.) ='; strgrNn[1,1]:=b1;
strgrT[2]:='The end (in chan.) ='; strgrNn[2,1]:=b2;
PuttoTable(20,50,2,2,1,8);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
WITH Form2 DO WITH spec[numsp] DO
 BEGIN FOR i:=1 TO 2 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
 b1:=MIN0(a2,MAX0(a1,Round(har[1])));
 b2:=MIN0(a2,MAX0(a1,Round(har[2]))); Irrange2(b1,b2);
 eps:=0; err:=0; FOR i:=b1 TO b2 DO
  BEGIN eps:=eps+y[i]; err:=err+SQR(e[i]);
  END;
 ConvertStr(eps,15,0); Compress(sedz); s:=sedz;
 err:=SQRT(err); ConvertStr(err,15,0); Compress(sedz);
 msinf:='Sum('+IntToStr(b1)+','+IntToStr(b2)+')= '+s+' Err= '+sedz;
 Writeln(fout,msinf);
 END;
END;
PROCEDURE MakeModMoving(i1,i2:INTEGER);
VAR i:INTEGER;
BEGIN FOR i:=1 TO 193 DO pmod[i2].morr[i]:=pmod[i1].morr[i];
pmod[i2].nl:=pmod[i1].nl; pmod[i2].rl:=pmod[i1].rl;
pmod[i2].cs:=pmod[i1].cs; pmod[i2].wi:=pmod[i1].wi;
pmod[i2].ac:=pmod[i1].ac; pmod[i2].ndsign:=pmod[i1].ndsign;
pmod[i2].typ:=pmod[i1].typ; pmod[i2].negm:=pmod[i1].negm;
END;
PROCEDURE MovethePeakModels(VAR i1,i2:INTEGER);
VAR   i:INTEGER;
BEGIN L0rec:='Peak Model Moving'; MakeForm(1);
SaveHelp(MoveMod_n,MoveMod); s:='Left peak model is moved to right one';
OuttoLabel(Form2.Label6,20,10,clMaroon,clWhite,s); CB1rec:=ModelNRec;
MakeRadioGroup(1,0,20,70,135,190); CB1rec.indx:=3;
MakeRadioGroup(2,0,175,70,135,190);
WITH CB1rec DO
 BEGIN nitems:=1;
 ar[1]:='Move Model 1 to all the models';
 END;
MakeCheckListBox(20,300,290,18); Form2.CheckListBox1.Checked[0]:=false;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i1:=RadioGroup1.ItemIndex; i2:=RadioGroup2.ItemIndex;
 IF(CheckListBox1.Checked[0])THEN
  BEGIN FOR i:=2 TO nphmax DO MakeModMoving(1,i);
  s:='Model 1 has been moved to all the models'; i2:=777;
  END                        ELSE
  BEGIN MakeModMoving(i1,i2);
  s:='Model '+IntToStr(i1)+' -> Model '+IntToStr(i2);
  END;
 END;
Writeln(fout,s);
END;
PROCEDURE SettheMainMode;
VAR i:INTEGER;
BEGIN L0rec:=''; MakeForm(0);
s:='Specify type of the problems to be solved';
OuttoLabel(Form2.Label5,20,10,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=4; indx:=mriamode+1;
 ar[1]:='Rietveld Fit';
 ar[2]:='AUTOX (powder indexing)';
 ar[3]:='Powder match';
 ar[4]:='UPEAK (peak analysis)';
 END;
MakeRadioGroup(1,0,20,50,270,120);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 IF((mriamode=3)AND(i IN [0,2]))THEN gfit.npar:=0;
 mriamode:=i;
 END;
Writeln(fout,CB1rec.ar[i+1]+' set up');
END;
PROCEDURE MakeGPHFile(VAR Im2:TImage; im:INTEGER);
VAR   i,j,n,ii,jj,ll,x1,y1,ist,iph:INTEGER; ok:BOOLEAN;
      r,an,ax,step,x,z,ve,vf,er,ch,d,xx,bkg:REAL;
      li,lj,ix1,iy1,ix2,iy2:INTEGER; s:STRING;
LABEL Lend;
BEGIN L0rec:=gphfn; MakeForm(1); SaveHelp(MakeGPH_n,MakeGPH);
CASE im OF
0: BEGIN IF(grst<>2)THEN         {to GPH.file}
    BEGIN ShowMess('No fitted graph'); ModalRes:=0; Exit;
    END;
   s:=vmdir+'\m.gph'; L1rec:='gph-file name ='; GetFilename(s,1);
   AssignFile(fin,s); Rewrite(fin);
   indi:='     '; indi[numsp+1]:='x'; ssmaxn(indi,ax,an);
   an:=AMIN1(an,0); FOR i:=ic1 TO ic2 DO WITH spec[numsp] DO
    BEGIN ve:=(y[i]-an)*1000/ax; r:=i;
    xx:=i-ic1+1; xarg:=xx+ic1-1; sarg:=numsp;
    CASE mriamode OF
    0,2: armrit(r,r,vf,Round(xx),4);
    3: arpeak(r,r,vf,Round(xx),4);
    ELSE END;
    vf:=(vf-an)*1000/ax; err:=e[i]*1000/ax;
    err:=(ve-vf)/AMAX1(err,0.01); d:=chtod(FLOAT(i)); ConvertStr(d,8,4);
    bkg:=rb0[1]*1000/ax; s:=sedz; sedz:=IntToStr(i);
    ok:=mriamode IN [0,2]; ii:=0;
    IF(ok)THEN FOR iph:=1 TO nph DO FOR j:=1 TO lat[iph].nhkl DO
     IF(Round(dtoch(hkla[j,iph].dk))=i)THEN
      BEGIN ii:=1; GOTO Lend;
      END;
    Lend: IF(argff)THEN WITH spec[numsp] DO
     BEGIN jj:=3; IF(ABS(x[i])>999)THEN jj:=0;
     d:=chtod(Float(i)); ConvertStr(d,8,4); s:=sedz;
     ConvertStr(x[i],7,jj);
     END;
    Write(fin,sedz:7,ve:8:0,vf:8:0,err:8:1,s:8,ii:2,bkg:8:0);
    IF(ok)THEN FOR iph:=1 TO nph DO
     Write(fin,(rb0[2+iph]+rb0[1])*1000/ax:8:0);
    IF(mriamode=3)THEN FOR ii:=1 TO npeak DO
     Write(fin,(rb0[2+ii]+rb0[1])*1000/ax:8:0);
    Writeln(fin);
    END;
   CloseFile(fin);
   END;
1: BEGIN L0rec:=gphfn; MakeForm(0); {from GPH.file}
   fn:=vmdir+'\'+'m.gph'; GetFilename(fn,0); IF(ModalRes=0)THEN Exit;
   AssignFile(fin,fn); {$I-} Reset(fin); {$I+}; IF(IOResult<>0)THEN
    BEGIN ShowMess(fn+' can not be opened'); ModalRes:=0; Exit;
    END;
   n:=0; IF(NOT EoF(fin))THEN
    BEGIN fffin(fin,1,1,i,onl); ic1:=1{Round(onl[1])};
    END                   ELSE
    BEGIN ModalRes:=0; ShowMess('gph.file is empty'); Exit;
    END;
   n:=1; ok:=false; WHILE(NOT EoF(fin))DO
   BEGIN EnterStr(fin); fffins(i,sedz); Inc(n);
   IF((onl[2]>1000)OR(onl[3]>1000)OR(i<7))THEN ok:=true;
   END;
   IF(ok)THEN ShowMess(fn+' is not a normal gph.file');
   cadl:=n; ic2:=ic1+n-1; z:=FLOAT(n)/512; ist:=n DIV 8;
   r:=34/512; ll:=Round(r*n); grst:=0;
   Reset(fin); step:=512/(ic2-ic1+1); x1:=x1graph; y1:=y1graph;
   WITH Im2.Canvas DO
    BEGIN Brush.Color:=0; FillRect(Rect(0,0,exs(wgraph-104),exs(324)));
    Font.Color:=clWhite; Font.Style:=[fsBold]; Font.Size:=8;
    END;
   WITH Im2.Canvas DO FOR i:=ic1 TO ic2 DO
    BEGIN x:=i-ic1+1; j:=Round(x*step); li:=x1+j; Pen.Color:=clAqua;
    fffin(fin,1,5,ii,onl);
    lj:=y1+CalcOrdinate(onl[4],1000,-10)-100;
    Pixels[exs(li),exs(lj)]:=clRed;
    lj:=y1+CalcOrdinate(onl[2],1000,-10)-100;
    FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
    IF((ABS(ii)+ABS(jj))<2)THEN
     Pixels[exs(li+ii),exs(lj+jj)]:=clFuchsia;
    lj:=y1+CalcOrdinate(onl[3],1000,-10)-100;
    IF(i=ic1)THEN
     BEGIN ix1:=li; iy1:=lj;
     END     ELSE
      BEGIN ix2:=li; iy2:=lj; Moveto(exs(ix1),exs(iy1));
      Lineto(exs(ix2),exs(iy2));
      ix1:=ix2; iy1:=iy2;
      END;
    IF(((i-ic1-ll)DIV ist)*ist=(i-ic1-ll))THEN
     BEGIN ConvertStr(onl[5],6,3); TextOut(exs(li-22),exs(302),sedz);
     END;
    END;{Loop end}
   CloseFile(fin);
   WITH Im2.Canvas DO FOR ii:=1 TO 8 DO
    BEGIN li:=34+(ii-1)*64;
    FOR jj:=1 TO 58 DO Pixels[exs(li),exs((jj-1)*5)]:=clLime;
    END;
   Im2.Visible:=true; Im2.Canvas.Font.Size:=fntsize;
   END;
ELSE END;
END;
PROCEDURE ToggletheFormSize;
VAR i:INTEGER;
BEGIN L0rec:=''; MakeForm(0);
s:='   Set the screen scale ';
OuttoLabel(Form2.Label1,50,32,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=2; ar[1]:='1'; ar[2]:='1.25'; ar[3]:='1.5';
 END;
MakeRadioGroup(1,0,50,50,200,80);
s:='   Set the font size ';
OuttoLabel(Form2.Label2,50,152,clMaroon,clWhite,s);
 WITH CB1rec DO
 BEGIN nitems:=3; indx:=3;
 ar[1]:=' Small (8)'; ar[2]:=' Regular (10)'; ar[3]:=' Large (12)';
 END;
MakeRadioGroup(2,0,50,170,200,80);
WITH CB1rec DO
 BEGIN nitems:=1;
 ar[1]:=' Use Russian Helps';
 END;
MakeCheckListBox(50,280,200,20);
Form2.CheckListBox1.Checked[0]:=RusHelp;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; i:=RadioGroup1.ItemIndex;
 CASE i OF
 0: scrsize:=1;
 1: scrsize:=1.25;
 2: scrsize:=1.5;
 ELSE END;
 i:=RadioGroup2.ItemIndex;
 CASE i OF
 0: fntsize:=8;
 1: fntsize:=10;
 2: fntsize:=12;
 ELSE END;
 RusHelp:=Form2.CheckListBox1.Checked[0];
 END;
END;
PROCEDURE GraphPeakModel;
VAR i,j,nm:INTEGER; ax,an,r:REAL;
BEGIN FOR j:=1 TO 7 DO
 BEGIN nm:=j MOD 7; r:=1; WITH pmod[nm] DO
  BEGIN IF(negm=1)THEN r:=-1;
  FOR i:=1 TO 193 DO onl[i]:=morr[i]*1000*r; ConvertStr(rvoigt,12,5);
  L0rec:='Model '+IntToStr(nm)+' = '+spmodn[typ]; Compress(sedz);
  IF(typ IN [4,5])THEN L0rec:=L0rec+'  R='+sedz;
  END;
 MakeForm(0); Form2.Color:=clGreen;
 LB1rec.nitems:=0; GraphSpecAndModel(Form2.Image1,193,1,0);
 WITH CB1rec DO
  BEGIN nitems:=1; ar[1]:=' Smooth the model ';
  END;
 MakeCheckListBox(40,350,250,18);
 Form2.CheckListBox1.Checked[0]:=false;
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  IF(NOT CheckListBox1.Checked[0])THEN CONTINUE;
  END;
 ax:=-1E12; an:=1E12; FOR i:=1 TO 193 DO {Smooth}
  BEGIN sa[i]:=onl[i]; ax:=AMAX1(ax,sa[i]); an:=AMIN1(an,sa[i]);
  END;
 WITH pmrec DO
  BEGIN amx:=ax; amn:=an; lbk:=0;
  END;
 qq.q1:=1; SmootheModel(193); IF(ModalRes=0)THEN Exit;
 pmod[nm].camod_Make(193); IF(ModalRes=0)THEN Exit;
 END;
END;
PROCEDURE GraphPlaneDistribution(CONST Ima1,Ima2: TImage);
VAR i,j,i1,i2,mixy,ixy:INTEGER; ic,li,lj:LONGINT;
    npoin,xlogs,ylogs:BOOLEAN;
    mxx,mnx,mxy,mny,bx1,bx2,by1,by2,r,o1,o2:REAL;
BEGIN L0rec:='Plane distribution';
MakeForm(1); SaveHelp(GrPlDis_n,GrPlDis);
{s:=' Is input of the event distribution needed? ';
OuttoLabel(Form2.Label7,15,10,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=2; IF(noeventf)THEN indx:=1 ELSE indx:=2;
 ar[1]:=' input needed'; ar[2]:=' input not needed';
 END;
MakeRadioGroup(2,0,60,30,200,60);}

OuttoLabel(Form2.Label7,60,10,clMaroon,clWhite,' Set the bounds ');
strgrW[0]:=40; strgrW[1]:=90; strgrW[2]:=90;
strgrT[1]:=' X'; strgrNn[1,1]:=0; strgrNn[1,2]:=1000000;
strgrT[2]:=' Y'; strgrNn[2,1]:=0; strgrNn[2,2]:=1000001;
PuttoTable(60,30,2,2,2,8);

s:=' Specify column combination in the event file ';
OuttoLabel(Form2.Label5,5,100,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=6; indx:=1; ar[1]:=' 1  2'; ar[2]:=' 1  3';
 ar[3]:=' 1  4'; ar[4]:=' 2  3'; ar[5]:=' 2  4'; ar[6]:=' 3  4';
 END;
MakeRadioGroup(1,0,60,120,200,140);
s:=' Select the scale;  default = normal ';
OuttoLabel(Form2.Label6,40,280,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=4; ar[1]:=' X axis logarithmic';
 ar[2]:=' Y axis logarithmic';
 ar[3]:=' XY axes reversed';
 ar[4]:=' point as point image';
 END;
MakeCheckListBox(60,300,200,70);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 mixy:=RadioGroup1.ItemIndex; {i:=RadioGroup2.ItemIndex;}
 IF(CheckListBox1.Checked[0])THEN xlogs:=true ELSE xlogs:=false;
 IF(CheckListBox1.Checked[1])THEN ylogs:=true ELSE ylogs:=false;
 IF(CheckListBox1.Checked[2])THEN ixy:=1 ELSE ixy:=0;
 IF(CheckListBox1.Checked[3])THEN npoin:=false ELSE npoin:=true;
 FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 bx1:=har[1]; by1:=har[2];
 FOR i:=1 TO 2 DO Zval(Form2.StringGrid1.Cells[1,i-1],har[i]);
 bx2:=har[1]; by2:=har[2];
 END;
CASE mixy OF
0: BEGIN i1:=1; i2:=2; END;
1: BEGIN i1:=1; i2:=3; END;
2: BEGIN i1:=1; i2:=4; END;
3: BEGIN i1:=2; i2:=3; END;
4: BEGIN i1:=2; i2:=4; END;
5: BEGIN i1:=3; i2:=4; END;
ELSE END;
{IF(i=0)THEN}
 BEGIN L0rec:='Enter the event file name';
 fn:='\zlok\mor.evf'; GetFilename(fn,0); IF(ModalRes=0)THEN Exit;
 AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
 mxx:=0; mnx:=1E17; mxy:=0; mny:=1E17;
 WITH Form3 DO
  BEGIN Left:=150; Top:=250; Width:=250; Height:=50; Show;
  Memo1.Visible:=false; Button1.Visible:=false; Label1.Visible:=false;
  END;
 ic:=0; FOR i:=1 TO 4 DO onl[i]:=1; WHILE(NOT EoF(ft))DO
  BEGIN fffin(ft,1,4,j,onl); IF(j=0)THEN CONTINUE;
  IF((rinfun(onl[1],bx1,bx2))AND(rinfun(onl[2],by1,by2)))THEN
   BEGIN Inc(ic); mxx:=AMAX1(mxx,onl[i1]); mxy:=AMAX1(mxy,onl[i2]);
   mnx:=AMIN1(mnx,onl[i1]); mny:=AMIN1(mny,onl[i2]);
   END;
  IF((ic MOD 10)*10=ic)THEN Form3.Caption:=IntToStr(ic);
  END;
 Form3.Close;
 IF(mnx=mxx)THEN
  BEGIN mnx:=bx1; mxx:=bx2;
  END;
 IF(mny=mxy)THEN
  BEGIN mny:=by1; mxy:=by2;
  END;
 IF(ixy=1)THEN
  BEGIN ZExchange(mxx,mxy); ZExchange(mnx,mny);
  END;
 IF((mxx=0)OR(mxy=0))THEN
  BEGIN ShowMess('X_max (or Y_max) = 0'); ModalRes:=0; Exit;
  END;
 ic1:=1; ic2:=ic; noeventf:=false;
 {$I-} Reset(ft); {$I+}; grst:=6; Bitmap:=TBitmap.Create;
 WITH Bitmap DO {Plotting the Graph}
  BEGIN Width:=exs(wgraph-104); Height:=exs(324); WITH Canvas DO
   BEGIN Brush.Color:=clWhite;
   FillRect(Rect(0,0,exs(wgraph-104),exs(323)));
   Brush.Color:=0; FillRect(Rect(3,2,exs(wgraph-107),exs(321)));
   END;
  END;
 amx:=mxx-mnx+1; amn:=mxy-mny+1;
 FOR i:=1 TO 4 DO onl[i]:=1; WHILE(NOT EoF(ft))DO WITH Bitmap.Canvas DO
  BEGIN fffin(ft,1,4,j,onl); IF(j=0)THEN CONTINUE;
  o1:=onl[i1]; o2:=onl[i2];
  IF(NOT ((rinfun(o1,bx1,bx2))AND(rinfun(o2,by1,by2))))THEN CONTINUE;
  IF(ixy=1)THEN ZExchange(o1,o2);
  IF(xlogs)THEN r:=LN(o1+1-mnx)/LN(amx)
           ELSE r:=(o1-mnx)/amx;
  li:=Round(r*(506-32))+33;
  IF(ylogs)THEN r:=LN(o2+1-mny)/LN(amn)
           ELSE r:=(o2-mny)/amn;
  lj:=300-Round(r*297);
  IF(npoin)THEN
   BEGIN FOR j:=-1 TO 1 DO Pixels[exs(li+j),exs(lj)]:=clFuchsia;
   Pixels[exs(li),exs(lj-1)]:=clFuchsia;
   Pixels[exs(li),exs(lj+1)]:=clFuchsia;
   END     ELSE Pixels[exs(li),exs(lj)]:=clFuchsia;
  END;
 WITH Bitmap.Canvas DO
  BEGIN Pen.Color:=clWhite; MoveTo(exs(30),exs(300+4));
  LineTo(exs(514),exs(300+4));
  MoveTo(exs(30),0); LineTo(exs(30),exs(300+4)); Font.Color:=clLime;
  ConvertStr(mnx,8,0); TextOut(exs(32),exs(307),sedz);
  ConvertStr(mxx,8,0); TextOut(exs(470),exs(307),sedz);
  ConvertStr((mxx+mnx)/2,8,0); TextOut(exs(251),exs(307),sedz);
  ConvertStr(mxy,8,0); Compress(sedz); TextOut(exs(5),exs(4),sedz);
  ConvertStr(mny,8,0); Compress(sedz); TextOut(exs(5),exs(290),sedz);
  ConvertStr((mxy+mny)/2,8,0); Compress(sedz);
  TextOut(exs(5),exs(147),sedz);
  END;
 WITH Ima2 DO
  BEGIN Visible:=true; Canvas.Draw(0,0,Bitmap); Bitmap.Free;
  END;
 CloseFile(ft);
 END;
{Info about the Distribution}
Bitmap:=TBitmap.Create; WITH Bitmap DO
 BEGIN Width:=exs(wgraph); Height:=exs(y1graph-1); WITH Canvas DO
  BEGIN Brush.Color:=clMaroon; FillRect(Rect(0,0,exs(wgraph),exs(100)));
  WITH Font DO
   BEGIN Color:=clWhite; Style:=[fsBold]; Size:=fntsize; Pitch:=fpFixed;
   END;
  TextOut(exs(21),exs(37),'X-Maximum = '+IntToStr(Round(mxx)));
  TextOut(exs(21),exs(19),'Y-Maximum = '+IntToStr(Round(mxy)));
  IF(ixy=0)THEN TextOut(exs(401),exs(19),'YX - graph')
           ELSE TextOut(exs(401),exs(19),'XY - graph (reversed)');
  Font.Color:=clLime;
  TextOut(exs(21),1,fn+'  '+IntToStr(ic)+' events');
  IF(xlogs)THEN TextOut(exs(201),exs(37),'X-log');
  IF(ylogs)THEN TextOut(exs(201),exs(19),'Y-log');
  END;
 END;
WITH Ima1 DO
 BEGIN Visible:=true; Canvas.Draw(0,0,Bitmap); Bitmap.Free;
 END;
END;
PROCEDURE SetResFileName;
BEGIN L1rec:='Enter ResFileName; Dir='+vmdir;
SaveHelp(ResFN_n,ResFN); fn:=vmdir+'\m.res';
GetFilename(fn,1); IF(ModalRes=0)THEN Exit;
IF(ExtractFileName(outfn)=ExtractFileName(fn))THEN
 BEGIN ShowMess('Output file name is the same'); Exit;
 END;
CloseFile(fout); ExtractFN(fn,sedz); outfn:=vmdir+'\'+sedz+'.res';
AssignFile(fout,outfn); ReWrite(fout);
END;
PROCEDURE GraphtheFittedSpectrum;
BEGIN IF(nofit[1] AND nofit[3] AND nofit[4])THEN
 BEGIN ShowMess('No fitting has been performed'); ModalRes:=0; Exit;
 END                                        ELSE
 BEGIN ic1:=spec[1].a11; ic2:=spec[1].a22; cadl:=ic2-ic1+1;
 END;
grst:=2; butar:='0000111111'; indi:=' x   '; ssmaxn(indi,amx,amn);
END;
PROCEDURE ZeroWeights(VAR i1,i2:INTEGER);
VAR i:INTEGER; s:STRING;
BEGIN L0rec:='Zeroing the weights'; MakeForm(1);
SaveHelp(ZeroW_n,ZeroW); MakeBevel(5,20,310,130,1);
s:='Errors within this range will be = 0';
OuttoLabel(Form2.Label5,20,40,clGreen,clAqua,s);
L1rec:='Beginning ='; E1rec:=IntToStr(i1);
L2rec:='End ='; E2rec:=IntToStr(i2); MakeEdits(40,160,70,70,2);
WITH CB1rec DO
 BEGIN nitems:=2; ar[1]:=' Save the current spectrum as Sp.4';
 ar[2]:=' Reset the weights of zero-valued counts';
 END;
MakeCheckListBox(5,180,310,40);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 Zval(Edit1.Text,r); i1:=Round(r); Zval(Edit2.Text,r); i2:=Round(r);
 s:=''; IF(CheckListBox1.Checked[0])THEN
  BEGIN CopySpectrum(numsp,4);
  s:='The spectrum '+IntToStr(numsp)+' saved as Spectrum 4';
  END;
 IF(CheckListBox1.Checked[1])THEN
  BEGIN WITH spec[numsp] DO
   BEGIN FOR i:=a1 TO a2 DO IF(y[i]=0)THEN e[i]:=0;
   END;
  i:=MessageDlg('Should the interval weights be also reset?',MtWarning,
  [mbYes,mbNo],0);
  IF(i=mrYes)THEN FOR i:=i1 TO i2 DO spec[numsp].e[i]:=0;
  END                        ELSE
    FOR i:=i1 TO i2 DO spec[numsp].e[i]:=0;
 END;
MakeForm(1); WITH LB1rec DO
 BEGIN nitems:=2; ar[1]:=s; ar[2]:='The weights have been zeroed';
 END;
MakeListBox(10,40,300,120); Form2.ShowModal;
Writeln(fout,'Weights in '+IntToStr(i1)+'-'+IntToStr(i2)+' reset');
END;
PROCEDURE GetPhaseMode;
VAR   i:INTEGER;
BEGIN L0rec:=''; MakeForm(0); s:='Click on the phases to be graphed';
OuttoLabel(Form2.Label6,35,30,clGreen,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=nph;
 FOR i:=1 TO nph DO ar[i]:='  Phase '+IntToStr(i)+'   '+colphtx[i];
 END;
MakeCheckListBox(30,80,250,15+15*nph);
FOR i:=1 TO nph DO Form2.CheckListBox1.Checked[i-1]:=true;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO CheckListBox1.Items.Count DO
  IF(CheckListBox1.Checked[i-1])THEN jja[i]:=1 ELSE jja[i]:=0;
 END;
END;
PROCEDURE GraphtheSpectrum;
BEGIN grst:=1; ModalRes:=1;
CASE grwhole OF
0: BEGIN indi:='     '; indi[numsp+1]:='x'; butar:='0000111111';
   ic1:=spec[numsp].a1; ic2:=spec[numsp].a2;
   END;
1: BEGIN butar:='0011111111'; IF((nofx(indi)=1)OR(nsp=1))THEN
    BEGIN indi:='     '; indi[numsp+1]:='x';
    END;
   ic1:=spec[numsp].a11; ic2:=spec[numsp].a22;
   END;
ELSE END;
END;
PROCEDURE GraphSeveralSpectra(VAR indi:STRING; VAR amx,amn:REAL);
VAR i:INTEGER;
BEGIN L0rec:=''; MakeForm(1); indi:='     '; SaveHelp(GraSS_n,GraSS);
s:='Click on the spectra to be graphed';
OuttoLabel(Form2.Label6,35,30,clGreen,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=5; FOR i:=1 TO 4 DO
  BEGIN WITH spec[i] DO
   IF(spin)THEN s:=ExtractFileName(sfn) ELSE s:='none';
  ar[i]:='  Spectrum '+IntToStr(i)+'     '+s;
  END;
 ar[5]:='     Intervals only';
 END;
MakeCheckListBox(30,80,250,95); Form2.CheckListBox1.Checked[4]:=true;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 4 DO
  IF(CheckListBox1.Checked[i-1])THEN
   BEGIN indi[i+1]:='x';
   IF(spec[i].NoSpectrum(i))THEN ModalRes:=0;
   END                      ELSE indi[i+1]:=' ';
 END;
IF(indi='     ')THEN
 BEGIN ShowMess('Error, no spectra marked'); ModalRes:=0; Exit;
 END;
grst:=1; FOR i:=5 DOWNTO 1 DO IF(indi[i]='x')THEN numsp:=i-1;
WITH spec[numsp] DO IF(Form2.CheckListBox1.Checked[4])THEN
 BEGIN ic1:=a11; ic2:=a22; grwhole:=1;
 END                                                  ELSE
 BEGIN ic1:=a1; ic2:=a2; grwhole:=0;
 END;
END;
PROCEDURE SetNAuxi(VAR i:INTEGER; idx:INTEGER);
BEGIN MakeForm(0); CB1rec:=Num4Rec; CB1rec.indx:=idx;
MakeRadioGroup(1,0,60,20,200,150);
WITH Form2 DO
 BEGIN ShowModal; i:=RadioGroup1.ItemIndex+1;
 END;
END;
PROCEDURE SetNumberofSpectra;
VAR i,j:INTEGER;
BEGIN L0rec:='   Set the number of spectra';
SaveHelp(SpecNum_n,SpecNum);
MakeForm(1); CB1rec:=Num4Rec; CB1rec.indx:=1;
MakeRadioGroup(1,0,60,20,200,150);
s:=' Warning '; OuttoLabel(Form2.Label5,95,200,clMaroon,clWhite,s);
s:=' Only for Rietveld many-spectrum analysis ';
OuttoLabel(Form2.Label6,5,218,clMaroon,clWhite,s);
s:=' For viewing use button NEXT SPECTR ';
OuttoLabel(Form2.Label7,5,236,clMaroon,clWhite,s);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex+1; IF(i<>1)THEN
  BEGIN j:=MessageDlg(strmsa,MtWarning,[mbYes,mbNo],0);
  IF(j=mrNo)THEN i:=1;
  END;
 nsp:=i;
 END;
SetNoPrep(5,true);
END;
PROCEDURE SetNumberofPhases;
BEGIN L0rec:='   Set the number of crystal phases';
MakeForm(0); CB1rec:=Num4Rec; CB1rec.nitems:=6; CB1rec.indx:=nph;
MakeRadioGroup(1,0,20,20,270,200);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; nph:=RadioGroup1.ItemIndex+1;
 END;
SetNoPrep(7,true); nstact:=false; IF(nph=1)THEN keyma[1]:=0;
END;
FUNCTION GetTheorHKL(isp,j0:INTEGER; q:REAL):REAL;
VAR Lpath,theta,theta0,D0,Dk,chwidth,sinT,const1,constCl:REAL;
BEGIN WITH gfit DO
IF(mriamode=0)THEN
 BEGIN Lpath:=par[j0+1].p; theta0:=par[j0+2].p;
 END          ELSE
  BEGIN Lpath:=spec[1].FPath; theta0:=0;
  END;
WITH gfit DO
 BEGIN D0:=par[j0+3].p; theta:=spec[isp].theta; chwidth:=spec[isp].chw;
 END;
sinT:=SIN((theta+theta0)/radian); const1:=2*252.778/chwidth;
constCl:=Lpath; IF(spec[numsp].tofang=0)THEN constCl:=const1*Lpath*sinT;
IF(spec[numsp].tofang=0)THEN {Dk} Dk:=constCl/(q)-D0
                        ELSE {angles}
 Dk:=(arcsin(AMIN1(LPath*q*0.5,1))-D0)/chwidth+1;
GetTheorHKL:=Dk;
END;
PROCEDURE FormSpecialModels;
VAR   i,j:INTEGER;
LABEL L1;
BEGIN SaveHelp(FoSMod_n,FoSMod);
L1: L0rec:='Select special model type and number';
MakeForm(1); WITH CB1rec DO
 BEGIN nitems:=10; FOR i:=1 TO 10 DO ar[i]:=spmodn[i];
 indx:=pmod[1].typ; IF(NOT(indx IN [1..10]))THEN indx:=1;
 END;
s:=' Type '; OuttoLabel(Form2.Label5,50,10,clMaroon,clWhite,s);
s:=' Number '; OuttoLabel(Form2.Label6,205,10,clMaroon,clWhite,s);
MakeRadioGroup(2,0,25,30,120,220);
CB1rec:=ModelNRec; MakeRadioGroup(1,0,170,30,120,220);
WITH CB1rec DO
 BEGIN nitems:=2; ar[1]:=' Make negative model ';
 ar[2]:=' PseudoVoigt=Gauss top,Lorentz bottom ';
 END;
MakeCheckListBox(30,260,240,40); WITH Form2.CheckListBox1 DO
 BEGIN Checked[0]:=false; Checked[1]:=mopv;
 END;
strgrW[0]:=220; strgrW[1]:=80;
strgrT[1]:='Enter  r   (Voigt,CoExp,PseudoV)='; strgrNn[1,1]:=rvoigt;
PuttoTable(10,320,1,1,1,8);
s:=' For Voigt use r<10, for CoExp r<15 ';
OuttoLabel(Form2.Label7,35,350,clGreen,clWhite,s);

WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup2.ItemIndex; nmod:=RadioGroup1.ItemIndex;
 nmod:=Form2.RadioGroup1.ItemIndex; mopv:=CheckListBox1.Checked[1];
 Zval(StringGrid1.Cells[0,0],har[1]); IF(ModalRes=0)THEN Exit;
 rvoigt:=har[1]; cfpv:=har[1];
 j:=i+1; pmod[nmod].typ:=j; pmod[nmod].makesm;
 IF(CheckListBox1.Checked[0])THEN pmod[nmod].negm:=1;
 END;
FOR i:=1 TO 193 DO onl[i]:=pmod[nmod].morr[i]*1000;
L0rec:=' '; i:=pmod[nmod].typ; IF(i IN [0..8])THEN L0rec:=spmodn[i];
L0rec:='Model'+IntToStr(nmod)+' = '+L0rec;
MakeForm(1); LB1rec.nitems:=0;
GraphSpecAndModel(Form2.Image1,193,1,0); Form2.ShowModal;
IF(pmod[nmod].typ IN [4,5])THEN
 BEGIN s:='Repeat the model forming?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrYes)THEN GOTO L1;
 END;
Writeln(fout,
 spmodn[pmod[nmod].typ]+' model '+IntToStr(nmod)+' formed');
END;
{----------}
BEGIN
END.

IF(gphv)THEN
 BEGIN IF((i>ic1)AND(i<ic2))THEN
  BEGIN fz:=(onl[i+1]-onl[i-1])/2; fzz:=(onl[i+1]-2*onl[i]+onl[i-1]);
  v:=(fzz*d/2+fz)*d+onl[i];
  END                       ELSE
 IF(i=ic2)THEN v:=onl[i]
          ELSE v:=d*onl[i+1]+(1-d)*onl[i];
  END    ELSE IF(gphv)THEN backf:=0 ELSE
