UNIT vmriasim;
INTERFACE
USES Windows,  Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs,  StdCtrls, ExtCtrls, Grids,   vzlocom,  vmria0,   vmria2,
     vmriarit, vmriahlp, vspectr,  vpeaksr, vmriarix, vstdcons, vmria00,
     vmriacry, vmria3,   varfun,   vmriainf;

PROCEDURE SimulatetheSpectrum;
PROCEDURE SimulateDSpacings;
PROCEDURE SimulateUpSp;
PROCEDURE SimulateAnisoSpectrum;

VAR anar:ARRAY[1..6] OF REAL = (0.05,1,5,5,5,5); {steps for aniso-sim}
    noerr:BOOLEAN;  {simul with or wo errors}
    jmo:INTEGER;    {0-with, 1-wo}

IMPLEMENTATION
PROCEDURE SimulatetheSpectrum;
VAR   i,N,cou,ns,nf,nn,iop,nx:INTEGER; t,dN,xx,yy,w,v,r:REAL;
      only2th,simani,useefs,sim1ph,simwob:BOOLEAN; s:STRING;
LABEL Lend,Loop,Lcom,L2th;
BEGIN L0rec:='Spectrum simulation'; MakeForm(1);
SaveHelp(SimSp_n,SimSp); WITH CB1rec DO
 BEGIN nitems:=4; indx:=mriamode+1;
 FOR i:=0 TO 3 DO ar[i+1]:=modestr[i];
 END;
MakeCombo(140,11,160); s:=' Simulate data for: ';
OuttoLabel(Form2.Label9,5,13,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN ar[1]:='  Simulate with errors'; nitems:=6;
 ar[2]:='  Use the effective spectrum';
 ar[3]:='  Simulate only single phase with background';
 ar[4]:='  Simulate single phase without background';
 ar[5]:='  Simulate only 2thetas';
 ar[6]:='  Simulate anisotropic spectrum';
 END;
MakeCheckListBox(5,60,300,101);
s:=' Put the simulated data';
OuttoLabel(Form2.Label5,5,182,clMaroon,clWhite,s);
s:=' to Spectrum:'; OuttoLabel(Form2.Label6,5,200,clMaroon,clWhite,s);
CB1rec:=Num4Rec; CB1rec.indx:=numsp; MakeRadioGroup(1,0,95,200,60,120);
WITH CB1rec DO
 BEGIN FOR i:=0 TO 2 DO ar[i+1]:=sptyp[i]; indx:=spec[numsp].tofang+1;
 nitems:=3;
 END;
OuttoLabel(Form2.Label8,205,182,clMaroon,clWhite,'Spectrum type');
MakeRadioGroup(2,0,200,200,100,90);
nf:=1; L1rec:='If single phase, specify which '; E1rec:=IntToStr(nf);
MakeEdits(10,230,350,40,1);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=ComboBox1.ItemIndex;
 IF((mriamode=3)AND(i IN [0,2]))THEN gfit.npar:=0;
 IF((mriamode<>3)AND(i=3))THEN gfit.npar:=0; mriamode:=i;
 WITH CheckListBox1 DO
  BEGIN noerr:=true; IF(Checked[0])THEN noerr:=false;
  IF(noerr)THEN jmo:=1 ELSE jmo:=0;
  useefs:=false; IF(Checked[1])THEN useefs:=true;
  sim1ph:=false; IF(Checked[2])THEN sim1ph:=true;
  simwob:=false; IF(Checked[3])THEN simwob:=true;
  only2th:=false; IF(Checked[4])THEN only2th:=true;
  simani:=false; IF(Checked[5])THEN simani:=true;
  END;
 IF(mriamode=1)THEN
  BEGIN SimulateDSpacings; Exit; {D-spacings}
  END;
 ns:=RadioGroup1.ItemIndex+1; spec[ns].tofang:=RadioGroup2.ItemIndex;

 ic1:=spec[numsp].a11; ic2:=spec[numsp].a22;
 IF(numsp<>ns)THEN CopySpectrum(numsp,ns);
 WITH spec[ns] DO IF(tofang=1)THEN {Make 2thetas}
  BEGIN Get2Thetas(ns); FOR i:=a1 TO a2 DO x[i]:=(i-1)*chw+x[a1]+delay;
  IF(only2th)THEN Exit;
  END;
 IF(mriamode=3)THEN
  BEGIN spec[numsp].tofang:=2; GOTO Lcom;
  END;
 Zval(Edit1.Text,r); nf:=MIN0(nphmax,MAX0(1,Round(r)));
 END;
Loop: iop:=1; IF(mriamode IN [0,2])THEN
 REPEAT L0rec:=''; MakeFormV(170,20,330,430,0);
 OuttoLabel(Form2.Label5,50,10,clMaroon,clWhite,'Set up:');
 WITH CB1rec DO
  BEGIN nitems:=4; indx:=iop;
  ar[1]:=' Spectral data';
  ar[2]:=' Crystallographic data';
  ar[3]:=' Parameter data';
  ar[4]:=' Exit';
  END;
 MakeRadioGroup(1,0,20,30,270,140);
 IF(simani)THEN
  BEGIN s:='Enter steps if aniso-spectrum is simulated';
  OuttoLabel(Form2.Label1,5,200,clMaroon,clWhite,s);
  strgrW[0]:=160; strgrW[1]:=80;
  strgrT[1]:=' Step in A'; strgrT[2]:=' Step in Gamma';
  strgrT[3]:=' Number of (-) A-steps';
  strgrT[4]:=' Number of (-) Gamma-steps';
  strgrT[5]:=' Number of (+) A-steps';
  strgrT[6]:=' Number of (+) Gamma-steps';
  FOR i:=1 TO 6 DO strgrNn[i,1]:=anar[i];
  PuttoTable(20,230,6,6,1,8);
  {DEBUG} WITH spec[1] DO
   BEGIN a11:=201; a22:=1000; a2:=1000; WITH lat[1] DO
    BEGIN nsg:=14; nat:=1; atoms[1,1].name:='Fe';
    END;
   END;
  END;
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  iop:=RadioGroup1.ItemIndex+1; IF(simani)THEN
   FOR i:=1 TO 6 DO Zval(Form2.StringGrid1.Cells[0,i-1],anar[i]);
  END;
 IF(iop<>4)THEN
  CASE iop OF
  1: BEGIN CheckSpectrumInfo(s,ns,ok); IF(ok)THEN iop:=2;
     END;
  2: BEGIN EnterPhaseInformation(0); EnterAtomicInformation;
     Formhkls; iop:=3;
     END;
  3: BEGIN WITH spec[numsp] DO gfit.mpoint:=a22-a11+1;
     PrepareRfPm(mriamode,ok); IF(ok)THEN ShowParameterArray; iop:=4;
     END;
  ELSE END;
 UNTIL iop=4;
CheckAtHKL; IF(ModalRes=0)THEN
 BEGIN i:=MessageDlg(msinf+' Repeat?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrYes)THEN GOTO Loop;
 END;
IF(gfit.npar=0)THEN
 BEGIN s:='No parameter data. Form?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0);
 IF(i=mrYes)THEN GOTO Loop ELSE Exit;
 END;


IF(simani)THEN  {Aniso - simulation}
 BEGIN FOR i:=1 TO 6 DO onl[i]:=anar[i]; SimulateAnisoSpectrum;
 s:=' Sp1 = AnisoSpectrum; Sp3 = initial'; GOTO Lend;
 END;
Lcom: ;
CASE mriamode OF
0,2: BEGIN s:=cnohkl+IntToStr(nf); IF(lat[nf].nhkl=0)THEN
      BEGIN ShowMess(cnohkl+IntToStr(nf)); Exit;
      END;
     FOR i:=1 TO nph DO IF(lat[i].nhkl=0)THEN
      BEGIN ShowMess(cnohkl+IntToStr(i));
      END;
     END;
3: SimulateUpSp; {For UPEAK}
ELSE END;
WITH spec[ns] DO
 BEGIN spin:=true; effn:=true; absn:=true; sfn:='SimSp '+IntToStr(nf);
 END;
amx:=AMAX1(spec[0].spx,1); amn:=AMIN1(spec[0].spn,0); WITH spec[ns] DO
 BEGIN MakeSpZero(ns,2,ic1-1); MakeSpZero(ns,ic2+1,a2);
 END;
cou:=MAX1(1,Float(ic2-ic1+1)/100); nx:=ic2 DIV cou;
WITH Form3 DO
 BEGIN Left:=150; Top:=250; Width:=250; Height:=50; Show;
 Memo1.Visible:=false; Button1.Visible:=false; Label1.Visible:=false;
 END;
FOR i:=ic1 TO ic2 DO
 BEGIN sarg:=numsp; xarg:=i;
 CASE mriamode OF
 0: BEGIN armrit(yy,w,v,i-ic1+1,4);
    IF(sim1ph)THEN v:=rb0[2+nf]+rb0[1];
    IF(simwob)THEN v:=rb0[2+nf];
    IF(useefs)THEN {Account for effect.spectrum}
     BEGIN t:=(i+spec[numsp].delay)*spec[numsp].chw;
     t:=(t-spec[0].delay)/spec[0].chw; N:=Trunc(t);
     IF(infun(N,ic1,ic2))THEN
      BEGIN q1:=spec[0].y[N+1]; q2:=spec[0].y[N]; dN:=t-N;
      xx:=(q1-q2)*dN+q2; xx:=AMAX1(xx,0.000001)/amx;
      v:=(v-gfit.par[4].p)*xx+gfit.par[4].p;
      END;
     END;
    END;
 2: BEGIN armrit(yy,w,v,i-ic1+1,4);
    END;
 3: BEGIN arpeak(yy,w,v,i-ic1+1,4);
    END;
 ELSE END;
 err:=1; IF(NOT noerr)THEN
  BEGIN rannor(r,r); err:=r*SQRT(ABS(v)+1);
  END;
 r:=v+err; spec[ns].y[i]:=AMAX1(0,r+err); spec[ns].e[i]:=err;
 WITH spec[ns] DO
  BEGIN IF(mriamode=0)THEN
  CASE tofang OF
  0: x[i]:=chtod(Float(i));
  ELSE END;
  IF(mriamode=3)THEN x[i]:=(i-1)*chw+x[1];
  END;
 s:=IntToStr((i-ic1) DIV cou)+' '+IntToStr(nx);
 IF((((i-ic1)MOD cou)=0)AND(jmo<>0))THEN Form3.Caption:=s;
 END;
Form3.Close; s:=' Spectrum has been simulated.';
spec[ns].fismax1; ConvertStr(spec[ns].spx,10,0);
Lend: MakeForm(1); WITH LB1rec DO
 BEGIN nitems:=2; ar[1]:=s;
 ar[2]:='      Max= '+sedz; Writeln(fout,ar[1]+ar[2]);
 END;
MakeListBox(20,40,270,120); Form2.ShowModal;
ncl:=0; SetNoPrep(15,true);
END;
PROCEDURE SimulateDSpacings;
VAR   i,j,iph,hh,kk,ll,m,mx,jmode:INTEGER;
      dmin,dmax,q,cosa,cosb,cosg,r,z,per:REAL; ok_delete:BOOLEAN;
 PROCEDURE Syngonize(iph:INTEGER);
 BEGIN
 CASE lat[iph].syng OF
 1,7: ;
 2,6: kmin[iph]:=MAX0(kmin[iph],0);
 ELSE hmin[iph]:=MAX0(hmin[iph],0); kmin[iph]:=MAX0(kmin[iph],0); END;
 END;
 PROCEDURE CleanHKL(iph:INTEGER);
 VAR i:INTEGER;
 BEGIN m:=0; FOR i:=1 TO lat[iph].nhkl DO
  BEGIN hklr:=hkla[i,iph]; IF(hklr.dk<>0)THEN
   BEGIN Inc(m); hkla[m,iph]:=hklr;
   END;
  END;
 lat[iph].nhkl:=m;
 END;
{********************}
BEGIN EnterPhaseInformation(1); IF(ModalRes=0)THEN Exit;
dmin:=10000; dmax:=0;
FOR iph:=1 TO nph DO WITH lat[iph].lpd DO
 BEGIN r:=2.5; IF(lat[iph].syng>2)THEN r:=3.5;
 dmin:=AMIN1(dmin,AMIN1(AMIN1(a/r,b/r),c/r));
 dmax:=AMAX1(dmax,AMAX3(a,b,c));
 END;
L0rec:=''; MakeForm(1);
strgrW[0]:=170; strgrW[1]:=70;
strgrT[1]:=' d_min ='; strgrNn[1,1]:=dmin;
strgrT[2]:=' d_max ='; strgrNn[2,1]:=dmax;
strgrT[3]:=' Error ='; strgrNn[3,1]:=epsauto;
strgrT[4]:=' % for deletion ='; strgrNn[4,1]:=10;
strgrT[5]:=' Max.number of ds ='; strgrNn[5,1]:=30;
s:='  Set the bounds for d-s ';
OuttoLabel(Form2.Label3,5,45,clMaroon,clWhite,s);
PuttoTable(50,65,5,5,1,8);
WITH CB1rec DO
 BEGIN ar[1]:='  Disturb the reflections by errors'; nitems:=2;
 ar[2]:='  Delete some reflections';
 END;
MakeCheckListBox(10,210,300,40);
Form2.CheckListBox1.Checked[0]:=true;
Form2.CheckListBox1.Checked[1]:=true;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 5 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
 dmin:=har[1]; dmax:=har[2]; IF((dmin=dmax)OR(AMAX1(dmin,dmax)=0))THEN
  BEGIN ShowMess('Wrong dmin,dmax'); Exit;
  END;
 IF(CheckListBox1.Checked[0])THEN jmode:=1 ELSE jmode:=0;
 ok_delete:=CheckListBox1.Checked[1]; epsauto:=har[3]; per:=har[4];
 mx:=Round(har[5]);
 END;
mdsp:=0; FOR iph:=1 TO nph DO WITH lat[iph] DO      {Loop for hkls}
 BEGIN L0rec:='Set the info for indexing, phase= '+IntToStr(iph);
 MakeForm(1);
 hmax[iph]:=Round(lpd.a/dmin)+1; hmin[iph]:=-hmax[iph];
 kmax[iph]:=Round(lpd.b/dmin)+1; kmin[iph]:=-kmax[iph];
 lmax[iph]:=Round(lpd.c/dmin)+1; Syngonize(iph);
 strgrT[1]:=' h_max ='; strgrNn[1,1]:=hmax[iph];
 strgrT[2]:=' h_min ='; strgrNn[2,1]:=hmin[iph];
 strgrT[3]:=' k_max ='; strgrNn[3,1]:=kmax[iph];
 strgrT[4]:=' k_min ='; strgrNn[4,1]:=kmin[iph];
 strgrT[5]:=' l_max ='; strgrNn[5,1]:=lmax[iph];
 s:='  Set the bounds for hkls ';
 OuttoLabel(Form2.Label3,5,45,clMaroon,clWhite,s); ConvertStr(vol,9,2);
 OuttoLabel(Form2.Label3,5,245,clMaroon,clWhite,'Volume= '+sedz);
 PuttoTable(50,65,5,5,1,8);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 5 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
  hmax[iph]:=Round(har[1]); hmin[iph]:=Round(har[2]);
  kmax[iph]:=Round(har[3]); kmin[iph]:=Round(har[4]);
  lmax[iph]:=Round(har[5]);
  Syngonize(iph);
  END;
 END;
FormHKL; j:=0; FOR i:=1 TO nph DO j:=j+lat[i].nhkl; IF(j=0)THEN
 BEGIN ShowMess('No hkls can be generated'); Exit;
 END;
FOR iph:=1 TO nph DO
 BEGIN FOR i:=1 TO lat[iph].nhkl DO
  BEGIN hh:=hkla[i,iph].h; kk:=hkla[i,iph].k; ll:=hkla[i,iph].l;
  r:=radian; WITH lat[iph].lpi DO
   BEGIN cosa:=COS(alpha/r); cosb:=COS(beta/r); cosg:=COS(gamma/r);
   q:=SQR(a*hh)+SQR(b*kk)+SQR(c*ll)+
      2*(a*hh*b*kk*cosg+b*kk*c*ll*cosa+c*ll*a*hh*cosb);
   IF(q<=0)THEN r:=0 ELSE r:=1/SQRT(q);
   IF(NOT rinfun(r,dmin,dmax))THEN r:=0; hkla[i,iph].dk:=r;
   END;
  END;
 CleanHKL(iph);
 END;
BubbleSortHKLs;
FOR iph:=1 TO nph DO  {Purge the superfl.hkls}
 BEGIN FOR i:=1 TO lat[iph].nhkl-1 DO
  IF(ABS(hkla[i,iph].dk-hkla[i+1,iph].dk)<AMAX1(epsauto,0.01))THEN
   BEGIN hkla[i+1,iph].dk:=(hkla[i,iph].dk+hkla[i+1,iph].dk)*0.5;
   hkla[i,iph].dk:=0;
   END;
 CleanHKL(iph);
 END;
m:=0; FOR iph:=1 TO nph DO FOR i:=1 TO lat[iph].nhkl-1 DO
  IF(hkla[i,iph].dk<>0)THEN Inc(m);
IF(m>200)THEN
 BEGIN ShowMess('D-interval too large. Curtail.'); Exit;
 END;
mdsp:=0; FOR iph:=1 TO nph DO FOR i:=1 TO lat[iph].nhkl DO
 WITH hkla[i,iph] DO IF(rinfun(dk,dmin,dmax)AND(mdsp<201))THEN
  BEGIN Inc(mdsp); r:=SQRT(12)*epsauto; dspa[mdsp].e:=epsauto;
  dspa[mdsp].ph:=iph; dspa[mdsp].th:=dk;
  dspa[mdsp].h:=h; dspa[mdsp].k:=k; dspa[mdsp].l:=l;
  dspa[mdsp].d:=dk+jmo*(rndm(-1)-0.5)*r;
  END;
IF(ok_delete)THEN
 BEGIN r:=mdsp*per/100; m:=Round(r); i:=0;
 IF(m<>0)THEN
  REPEAT j:=MIN0(mdsp,iRandom(mdsp)+1); dspa[j].d:=0; Inc(i);
  UNTIL i=m;
 m:=0; FOR i:=1 TO mdsp DO IF(dspa[i].d<>0)THEN
  BEGIN Inc(m); dspa[m]:=dspa[i];
  END;
 mdsp:=m;
 END;
ArrangeDSpacings; mdsp:=MIN0(mdsp,mx);
MakeForm(1); WITH LB1rec DO
 BEGIN nitems:=1;
 ar[1]:='D-spacings prepared '+IntToStr(mdsp)+' items';
 END;
MakeListBox(20,40,270,120); Form2.ShowModal;
Writeln(fout,nph:1,'-phase ds simulated',mdsp:4,' items, eps=',
 epsauto:8:4);
END;
PROCEDURE SimulateUpSp;
VAR i,j,nm:INTEGER;
BEGIN L0rec:='  Set the data for spectrum simulation';
MakeForm(1); WITH spec[numsp] DO
 BEGIN s:='Total spectrum range ='+IntToStr(a1)+'-'+IntToStr(a2);
 OuttoLabel(Form2.Label2,50,5,clGreen,clWhite,s);
 s:=' Interval for the analysis ';
 OuttoLabel(Form2.Label3,10,50,clMaroon,clWhite,s);
 strgrW[0]:=130; strgrW[1]:=70;
 strgrT[1]:=' Beginning(chan) ='; strgrNn[1,1]:=a11;
 strgrT[2]:=' End(chan) ='; strgrNn[2,1]:=a22;
 PuttoTable(10,70,2,2,1,8);
 OuttoLabel(Form2.Label1,10,120,clRed,clBlack,' Background mode ');
 CB1rec:=DBackRec; CB1rec.indx:=spec[numsp].dback+2;
 MakeRadioGroup(1,0,10,140,200,210);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 2 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
  IF((har[2]<=har[1])OR(MAX1(har[1],har[2])>nspch))THEN
   BEGIN ShowMess('Wrong spectrum bounds'); Exit;
   END;
  a11:=MAX0(Round(har[1]),a1); a22:=MIN0(Round(har[2]),a2);
  dback:=RadioGroup1.ItemIndex-1;
  END;
 END;
L0rec:='Enter peak positions, amplitudes and model numbers';
MakeForm(1);
i:=gfit.npar; IF(i<>0)THEN npeak:=(gfit.npar-14)DIV 2 ELSE npeak:=0;
MakeMemo(5,310);
WITH Form2.Memo1 DO FOR i:=1 TO npeak DO WITH gfit DO
 BEGIN s:=''; ConvertStr(par[i+6+npeak].p,10,2); s:=s+sedz;
 ConvertStr(par[i+6].p,12,1); s:=s+sedz; s:=s+'     '+IntToStr(tam[i]);
 Lines.Add(s);
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 WITH Memo1.Lines DO WITH gfit DO
  BEGIN npeak:=Count;
  FOR i:=1 TO npeak DO
   BEGIN s:=Strings[i-1]; fffins(j,s); par[i+6+npeak].p:=onl[1];
   par[i+6].p:=onl[2]; tam[i]:=Round(onl[3]);
   IF(NOT infun(tam[i],1,4))THEN tam[i]:=1;
   END;
  npar:=2*npeak+14;
  END;
 END;
MakeForm(1);
s:='Enter width for each model';
OuttoLabel(Form2.Label1,15,20,clMaroon,clWhite,s);
nm:=0; FOR i:=1 TO npeak DO nm:=MAX0(nm,tam[i]);
FOR i:=1 TO nm DO WITH gfit DO
 BEGIN strgrT[i]:=' Width0 (chan) ='; strgrNn[i,1]:=par[2*npeak+6+i].p;
 strgrT[i+nm]:=' Width1 (chan) ='; strgrNn[i+nm,1]:=par[2*npeak+10+i].p;
 END;
IF(nm<>0)THEN
 BEGIN PuttoTable(50,40,2*nm,2*nm,1,8);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 2*nm DO Zval(StringGrid1.Cells[0,i-1],har[i]);
  FOR i:=1 TO nm DO
   BEGIN gfit.par[2*npeak+6+i].p:=har[i]; IF(har[i]=0)THEN
    ShowMess('Warning, width0 = 0');
   gfit.par[2*npeak+10+i].p:=har[i+nm];
   END;
  END;
 END;
MakeForm(1);
s:='Enter background parameters';
OuttoLabel(Form2.Label1,15,20,clMaroon,clWhite,s);
FOR i:=1 TO 6 DO WITH gfit DO
 BEGIN strgrT[i]:=' Backg.'+IntToStr(i); strgrNn[i,1]:=par[i].p;
 END;
PuttoTable(50,35,6,6,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 6 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
 FOR i:=1 TO 6 DO gfit.par[i].p:=har[i];
 END;
END;
PROCEDURE SimulateAnisoSpectrum;
{ani spectrum to sp2, true to sp3}
VAR i,j,k,N,cou,i0,mam,map,mgm,mgp:INTEGER;
    stl,sta,s,w,v,r,A0,B0,C0,alpha0,beta0,gamma0:REAL;
 PROCEDURE PutCellPar(jj,kk:INTEGER);
 BEGIN WITH lat[1] DO WITH gfit DO
  BEGIN lpd.a:=A0; lpd.b:=B0; lpd.c:=C0+jj*stl;
  lpd.alpha:=alpha0; lpd.beta:=beta0; lpd.gamma:=gamma0+kk*sta;
  InverseLatPar(lpd,lpi,voli,0); FormLatMatrix(1);
  i0:=Geti0(1); par[i0+2].p:=a11; par[i0+3].p:=a22; par[i0+4].p:=a33;
  par[i0+5].p:=a23; par[i0+6].p:=a13; par[i0+7].p:=a12;
  END;
 END;
BEGIN WITH lat[1] DO
 BEGIN A0:=lpd.a; B0:=lpd.b; C0:=lpd.c;
 alpha0:=lpd.alpha; beta0:=lpd.beta; gamma0:=lpd.gamma;
 END;
ic1:=spec[numsp].a11; ic2:=spec[numsp].a22;
N:=gfit.npar; IF(lat[1].nhkl=0)THEN
 BEGIN ShowMess(cnohkl+IntToStr(1)); Exit;
 END;
stl:=onl[1]; sta:=onl[2];
mam:=Round(onl[3]); mgm:=Round(onl[4]);
map:=Round(onl[5]); mgp:=Round(onl[6]);
cou:=0; WITH Form3 DO
 BEGIN Left:=150; Top:=250; Width:=250; Height:=50; Show;
 Memo1.Visible:=false; Button1.Visible:=false; Label1.Visible:=false;
 END;
CopySpectrum(1,3);
FOR j:=-mam TO map DO FOR k:=-mgm TO mgp DO {main loop}
 BEGIN PutCellPar(j,k); FOR i:=ic1 TO ic2 DO
  BEGIN sarg:=numsp; xarg:=i; armrit(r,w,v,i-ic1+1,4);
  spec[2].y[i]:=AMAX1(0,v);
  END;
 Form3.Caption:=IntToStr(cou)+' / '+IntToStr((mam+map+1)*(mgm+mgp+1));
 Inc(cou);
 r:=EXP(-Float(j*j+k*k)/2)/3.141595; s:=s+r;

 {IF(j>0)THEN r:=EXP(-Float(j*j)/2) ELSE r:=EXP(-Float(j*j)/4);
 IF(k>0)THEN r:=r*EXP(-Float(k*k)/2) ELSE r:=r*EXP(-Float(k*k)/4);}
 r:=r/3.141595*8; s:=s+r;
 {Writeln(fout,j:4,k:4,r:9:6,s:9:6);}
 WITH spec[1] DO FOR i:=ic1 TO ic2 DO y[i]:=y[i]+r*spec[2].y[i];
 IF((j=0)AND(k=0))THEN
  FOR i:=ic1 TO ic2 DO spec[3].y[i]:=spec[2].y[i];
 END;
IF(NOT noerr)THEN FOR i:=ic1 TO ic2 DO WITH spec[1] DO
 BEGIN rannor(r,r); err:=SQRT(ABS(y[i])+1)*r; e[i]:=ABS(err);
 y[i]:=AMAX1(0,y[i]+err);
 END;
s:=0; WITH spec[1] DO FOR i:=ic1 TO ic2 DO s:=s+y[i];
Writeln(fout,'Sum2= ',s:12:1);
s:=0; WITH spec[3] DO FOR i:=ic1 TO ic2 DO s:=s+y[i];
Writeln(fout,'Sum3= ',s:12:1);
spec[3].sfn:='True_sp'; spec[1].sfn:='Aniso_sp';
Form3.Close;
PutCellPar(0,0);
spec[1].fismax1; spec[3].fismax1; ConvertStr(spec[1].spx,10,0);
END;


END.
