UNIT vacthlp;  {Oct 31 2001}

INTERFACE

USES Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, vactiv0,  vzlocom;

CONST
{*}GeneralH_n:INTEGER = 42;
   GeneralH:ARRAY[1..84] OF STRING = (
'   The purpose of VISUAL ACTIV is the processing of gamma- or X-ray',
'spectra in a visual mode:',
'',
'1) calibration of the measurement apparatus',
'2) deleting the blunders (outliers) from the spectrum',
'3) peak model forming, using large peaks on the graph',
'4) marking of the spectrum, i.e. its dividing into intervals',
'   and peak search in them: automatically, by user/s data,',
'   by list of energies or lines of interest,',
'   or clicking on the graph',
'5) processing,i.e. determination of peak positions',
'   and areas by the least squares estimator;',
'',
'"Visual mode" means interactive control of the program',
'and instant graphical illustration of the results.',
'VACTIV can process a single spectrum or series of spectra.',
'For input of series of spectra use command: DATA, Input_sp_file_names',
'The input information is entered (directly from the screen)',
'or input from files.',
'The output information is stored in a visual table and',
'in a result text file.',
'Data for calibration for energy and registration efficiency can be',
'input either from a file (Data key), or from the screen (Info key).',
'In both the cases the data is a sequence of strings; each',
'(in free field format):     ch   E   err  (energy calib.)',
'or    E   k  err  (effic. calib.)',
'Here ch=channel, E=energy, err=error, k = efficiency coefficient.',
'If the marking is carried out by energy list, the corresponding file',
'contains sequence (in free field format) of these energies',
'(in energy units) or channels (if no energy calibration is available)',
'Ready-to-use marking data has the following format:',
' -ch1_1  p1_1  p2_1 ... -ch2_1',
' -ch1_2  p1_2  p2_2 ... -ch2_2',
'...',
'Here ch1_i,ch2_i are interval bounds, p1_i,p2_i,...=peaks in ith',
'spectrum interval.',
'The file with these data can be input, command; DATA, input mark.data',
'Preliminary data can be input using ini-file: VACTIV.INI. It has:',
'1/ commands, having "......" in front of it',
'2/ comments, having asterisc at 1st line position ',
'3/ data, pertaining to the commands.',
'The standard ini-file is commented so that data can be changed easily',
'    ணࠬ VISUAL ACTIV  ࠡ⪠ -  X-',
'ᯥ஢  㠫쭮 ०:',
'',
'1) ஢ ⥫쭮 ',
'2) ࠭  訡 (blunders)  ᯥ',
'3) ஥    ᭮ 䨪 ᯥ',
'4) ࠧ⪠ ᯥ, ..    ࢠ',
'       : ⮬᪨,  ᭮  짮⥫,',
'    ᯨ ࣨ  ,',
'    㪠 誮 אַ  䨪 ᯥ',
'5) ࠡ⪠, .. ।  ',
'    頤 ⮤  ⮢;',
'',
'"㠫 ०" 砥 ࠪ⨢ ࠢ ணࠬ',
' ⨢   १⮢.',
'VACTIV  ࠡ뢠 ⤥ ᯥ   ᯥ஢.',
'  ਨ ᯥ஢ ࠡ : DATA, Input_sp_file_names',
'室 ଠ  אַ  ࠭',
'   䠩. (ᥣ  ଠ ᢮ )',
'室 ⠡ ࠭  㠫㥬 ⠡ ',
' ⥪⮢ 䠩 १⮢.',
'  ஢  ࣨ  䥪⨢  ',
'   䠩 ( Data),   ࠭ ( Info).',
'     ᫥⥫쭮 ப;',
'      ch   E   err  (. ࣨ)',
'    E   k  err  (. 䥪⨢)',
' ch=, E=ࣨ, err=訡, k = 樥 䥪⨢.',
'᫨ ஢   ᯨ ࣨ, ᮮ⢥騩 䠩',
'ᮤন ᯨ᮪ ࣨ ( ࣥ᪨ )',
'  (᫨ ஢  ࣨ )',
'⮢  ࠧ⪨  ᫥騩 ଠ:',
' -ch1_1  p1_1  p2_1 ... -ch2_1',
' -ch1_2  p1_2  p2_2 ... -ch2_2',
'...',
' ch1_i,ch2_i ࠭ ࢠ, p1_i,p2_i,...=  i-',
'ࢠ ᯥ.',
'  ⨬ 묨  ; DATA, input mark.data',
'।⥫쭮     १ ini-file: VACTIV.INI:',
'1/ ਧ  窨 ...... ᯥ। ',
'2/ ਨ  asterisc  1- 樨 ப.',
'3/     ᢮ ଠ ᫥ .',
'⠭ ini-file ஢      㤠.'
);
{*}GetStart_n:INTEGER =18;
   GetStart:ARRAY[1..36] OF STRING = (
'               Getting started.',
'',
'The simplest analysis is:',
'1/ spectrum input:',
'      Click on FILE, INPUT_THE_SPECTRUM',
'2/ graphing it:',
'      Click on GRAPH,  GRAPH_THE_SPECTRUM',
'3/ Select the interval for processing:',
'      Click on MARK,  MAKE_THE_INTERVAL',
'3/ spectrum marking;',
'      Click on OPERATION, AUTOMATIC_SPECTRUM_MARKING',
'4/ fit;',
'      Click on OPERATION, INTERVAL_FIT.',
'5/ save the results in a file',
'      Click on FILE,  SAVE_THE_SUMMARY_TABLE',
'',
'All menu commands are self-explaining, contain hints',
'and need no further comments.',
'                 ࠡ  VACTIV.',
'',
'ਬ ⥩襣 :',
'1/  ᯥ:',
'      Click on FILE, INPUT_THE_SPECTRUM',
'2/ ந 䨪 ᯥ:',
'      Click on GRAPH,  GRAPH_THE_SPECTRUM',
'3/  ࢠ  :',
'      Click on MARK,  MAKE_THE_INTERVAL',
'3/ ࠧ⪠ ᯥ;',
'      Click on OPERATION, AUTOMATIC_SPECTRUM_MARKING',
'4/ (⨭);',
'      Click on OPERATION, INTERVAL_FIT.',
'5/ ᯠ १   䠩',
'      Click on FILE,  SAVE_THE_SUMMARY_TABLE',
'',
'   ᠬ騥, ᮤঠ ᪠',
'  㦤  쭥 .'
);
{*}ShowMaP_n:INTEGER = 9;
   ShowMaP:ARRAY[1..18] OF STRING = (
'Ready-to-use marking data has the following format:',
' -ch1_1  p1_1  p2_1 ... -ch2_1',
' -ch1_2  p1_2  p2_2 ... -ch2_2',
'...',
'Here ch1_i,ch2_i are interval bounds, p1_i,p2_i,...=peaks in ith',
'spectrum interval, ranging between ch1_i and ch2_i.',
'The file with these data can be input, command; DATA, input mark.data',
'While showing -ch1 and -ch2 are displayed separately, but in the',
'program array they are placed as said above.',
'⮢  ࠧ⪨  ᫥騩 ଠ:',
' -ch1_1  p1_1  p2_1 ... -ch2_1',
' -ch1_2  p1_2  p2_2 ... -ch2_2',
'...',
' ch1_i,ch2_i ࠭ i- ࢠ, p1_i,p2_i,...=   i-',
'ࢠ ᯥ, 祭  ch1_i  ch2_i.',
'  ⨬ 묨   , ; DATA,input mark.data',
' ᬮ -ch1  -ch2 뤥 ᮡ,    PC ',
'ᯮ ⠪,  ᠭ .'
);
{*}SaveRes_n:INTEGER = 3;
   SaveRes:ARRAY[1..6] OF STRING = (
'Command saves the results of the analysis and resets all the counters',
'of the analysis; till saving all the results of current analysis are',
'added to table of results.',
' ᯠᠥ १   뢠  稪  ',
' ᯠᥭ ஬ १   ⥪饩 ⠡',
'१⮢.'
);
{*}FoSMod_n:INTEGER = 2;
   FoSMod:ARRAY[1..4] OF STRING = (
'One can set up some standard peak models as:',
'Gaussian, the IAEA peak model, and peak model for detector 4.',
' ⠭ ᫥騥 ⠭  :',
'ᨠ, ᪠      ⥪ 4.'
);
{*}InpEnC_n:INTEGER = 10;
   InpEnC:ARRAY[1..20] OF STRING = (
'Energy calibration is converting channels to energies:',
'  non-linear mode, using spline interpolation;',
'  linear mode by linear fitting.',
'This command inputs the energy calibration data from a text file',
'containing a sequence of lines; each: (in free field format)',
'           ch   E   err',
'Here ch=channel, E=its energy, err=energy error.',
'The calibration data is automatically arranged.',
'See the input data, use command =  Info, Energy calibration data.',
'See the graph of input data, command =  Graph, Energy calibration.',
'ࣥ᪠ ஢ -     ࣨ(2 ०):',
'  ,  ᭮ ᯫ ௮樨;',
'  ,  אַ .',
'    ஢  ⥪⮢ 䠩, ᮤঠ饣',
'᫥⥫쭮 ப;  ப: ( ଠ ᢮.)',
'           ch   E   err',
' ch=, E= ࣨ, err=訡 ࣨ.',
' ஢ ⮬᪨ ࠭.',
'   㢨 = Info, Energy calibr. data.',
' ᬮ 䨪  =  Graph, Energy calibration.'
);
{*}InpEfC_n:INTEGER = 8;
   InpEfC:ARRAY[1..16] OF STRING = (
'Efficiency calibration is converting peak areas to intensities',
'dividing them by registration efficiency coefficient.',
'This command inputs the efficiency calibration data from a text file',
'containing a sequence of lines; each: (in free field format)',
'           E    k  err',
'Here E=energy,  k = efficiensy coefficient, err=its error.',
'The input data is automatically arranged.',
'See the input data, use command =  Info, Efficiency calibration data.',
'஢  䥪⨢ -  頤   ⥭ᨢ',
'   樥 䥪⨢ ॣ樨.',
'    ஢  ⥪⮢ 䠩, ',
'ᮤঠ饣 ᫥⥫쭮 ; ( ଠ ᢮.)',
'           E    k  err',
' E=ࣨ,  k = 樥 䥪⨢, err= 訡.',
'  ⮬᪨ ࠭.',
'     =Info, Effic. calibration data.'
);
{*}CorrBl_n:INTEGER = 4;
   CorrBl:ARRAY[1..8] OF STRING = (
'If small neighbor of each spectrum point is flat',
'(chi^2 of its fitting is < chibc), the squared deviation of this',
'point from the fitting curve is calculated and if it is > order,',
'the point is considered as blunder and replaced by fitting value.',
'᫨  ⭮ 窨 ᯥ ,',
'(chi^2  ⨭ < chibc), 筮 㪫 ⮩ 窨',
' 饩 ਢ   ᫨  > order, 窠 ⠥',
' ᮬ    饥 祭.'
);
{*}InpSpH_n:INTEGER = 16;
   InpSpH:ARRAY[1..32] OF STRING = (
'Spectrum File Type are: (length < 16385)',
' 1=   binary file, 2 bytes per word',
' 2=   binary file ,4 bytes per word',
' 3=   ASCII free field array (separators commas or blanks)',
' 4=   ASCII X,Y file, each line is:      X,  spectrum value, [error]',
' If the spectrum has a header, it can be skipped (click on Check Box)',
' If the spectrum values have the inverse byte order, they can be',
'    reversed (click on Check Box)',
'After the spectrum has been input, one has then take the interval',
'from it for the analysis; this interval is marked: divided into small',
'cadres, containing single peaks or multiplets and processed.',
'For taking the interval use commands: Set Spectrum Data or',
'Mark: Make the interval.',
'Command = Graph: Cut the Cadre takes a small piece of the spectrum',
'for viewing (using keys: Next, Previous)',
'or for processing of selected small spectrum part (marked, fitted).',
'   ᫥ ⨯: ( < 16385)',
' 1=    䠩, 2   ᫮',
' 2=    䠩, 4   ᫮',
' 3=   ASCII ᨢ  ᢮ ଠ (᥯ ஡  )',
' 4=   ASCII X,Y 䠩,  :    X, 祭 ᯥ, [訡]',
' ᫨ ᯥ  header,   ய饭 (click  Check Box)',
' ᫨ ᫮ ᯥ   冷 ⮢,   ',
'    饭 (click  Check Box)',
'᫥  ᯥ ᫥ 뤥 ࢠ  ࠡ⪨.',
' ࢠ   ࠧ祭: ࠧ   ࢠ,',
'ᮤঠ騥    ⨯,  ⥬ ࠡ⠭.',
'᫥ 뢮 ᯥ  䨪 ࢠ 뤥   :',
'Mark: Make the interval, ⥬ ᤥ click   ࢠ;',
'Settings: Set the Spectrum Data,   祭 殢 ࢠ',
'           ᮮ⢥騥  ⠡.',
'訡 ᯥ  ᮭ᪨   ⮬᪨.'
);
{*}SFDhelp_n:INTEGER = 11;
   SFDhelp:ARRAY[1..22] OF STRING = (
'Width Variable    = w1 in width dependence: w = w0 + w1*ch',
'Delta Width V     = accuracy of w1',
'N of iterations   = while peak fitting, not more than N iterations',
'Step              = in iterations;  0 < step <= 1',
'Damper            = if LSM-matrix is good, damper about 0.0001',
'                    if ill-conditioned then about 0.05 - 0.1',
'Background degree = Maximum polynomial degree for bckr. <= 3',
'                    if negative, then defined automatically.',
'Delta Pos(chan)   = Peak position deviation while fitting',
'Norm.coefficient  = Intensities are normalized by N.c.',
'If normalization uses selected peak, set N.c. to its channel.',
'Width Variable    = w1  㭪樨 ਭ: w = w0 + w1*ch',
'Delta Width V     = 譮 w1',
'N of iterations   =   N 権  ⨭',
'Step              =  ;  0 < step <= 1',
'Damper            =   ᫮ -',
'                    damper ~ 0.0001; ᫨ , damper ~ 0.05 - 0.1;',
'Background degree = ᨬ쭠 ⥯ 䮭 . <= 3',
'                    ᫨ < 0, ⥯ । ⮬᪨.',
'Delta Pos(chan)   = ࠭      .',
'Norm.coefficient  = ⥭ᨢ ନ  Norm.coeff.',
'᫨ ନ  頤 ࠭ , Norm.c.= .'
);
{*}SMDhelp_n:INTEGER = 11;
   SMDhelp:ARRAY[1..22] OF STRING = (
'Marking is peak search and spectrum division into intervals with 1',
'or more peaks for their further fit',
'Smoothing    = smoothing coefficient for peak search',
'Max.interval = maximum length of the marked interval. default=128',
'Sensitivity  = if 1 then normal peaks are found.',
'               if weak peaks are missed take lesser sens.',
'               if too many peaks found take greater sens.',
'Resolution   = if -1 normal multiplets resolved',
'               if 1,2... all multiplets resolved',
'Positive res is recommended if exact peak model',
'and width function are available',
'⪠ -     ᯥ  ࢠ  1 ',
' ⨯⮬    쭥襬.',
'Smoothing    = 樥 ᣫ  ᪥ .',
'Max.interval = ᨬ쭠  ࢠ;  㬮.=128 ',
'Sensitivity  =  1 室   "ଠ쭮" 頤.',
'               ᫨ ᫠  ய᪠,   sens.',
'               ᫨ 室 ᫨誮  ,  sens.',
'Resolution   =  -1 ࠧ ⮫쪮  ⨯',
'                ⥫쭮 res 直 ⨯.',
'⥫쭮 祭 res ᫥ , ᫨ ⭠ 筠 ',
'  筠 㭪 ਭ.'
);
{*}IShelp_n:INTEGER = 27;
   IShelp:ARRAY[1..54] OF STRING = (
'Spectrum is the total data, interval is spectrum part for analysis.',
'The meaning of the data names is here as follows:',
'a1 = Spectrum beginnig channel',
'a2 = Spectrum end channel',
'b1 = Interval beginnig channel',
'b2 = Interval end channel',
'Sp.File Type = Spectrum file type: ',
'The following spectrum file types (length < 16385) are admissible:',
' 1.   binary file, 2 bytes per word',
' 2.   binary file ,4 bytes per word',
' 3.   ASCII free field array (separators commas or blanks)',
' 4.   ASCII X,Y file, each line is: X,  spectrum value',
'Small statistics = level at which the count statistics',
'                   is considered small',
'Covar =  the formula for the variance building:',
'          .9*sp(i) + .1*(covar*sp(i))**2 + 1',
'sp(i) = spectrum value at channel i',
'Order for blunders = while blunder deletion, chi-square,',
'admissible for a deviation of local spectrum part from a parabola',
'Chi2 for blunders = while blunder deletion, chi-square,',
'    good for parabolic fit',
'Width_1 = Width (chan) at interval beginning',
'Width_2 = Width (chan) at interval end',
'Delta Width = Deviation of width (in channels)',
'Dependence - width versus channel - is built',
'w = a * ch + b   +- delta_width, where w = fwhm, ch = channel',
'Formula is used for both marking and fit.',
' ᯥ஬  楫 ᯥ,  ࢠ -   ',
'ࠡ⪨.  祭 稭 ᫥騥:',
'a1 = 砫  ᯥ',
'a2 =   ᯥ',
'b1 = 砫  ࢠ ᯥ',
'b2 =   ࢠ ᯥ',
'Sp.File Type = ⨯ ᯥࠫ쭮 䠩. ',
'騥 ⨯ 䠩 ( < 16385 ᫮) ⨬:',
' 1=    䠩, 2   ᫮',
' 2=    䠩, 4   ᫮',
' 3=   ASCII ᨢ  ᢮ ଠ (᥯ ஡  )',
' 4=   ASCII X,Y 䠩,  :    X, 祭 ᯥ, [訡]',
'Small statistics = ஢  ஬ ⨪ ᯥ',
'                   ⠥ .',
'Covar =  㫠  ନ஢ ᯥᨨ ᯥ v(i):',
'          v(i) = 0.9*sp(i) + 0.1*(covar*sp(i))^2 + 1',
'sp(i) = 祭 ᯥ   i',
'Order for blunders =  ࠭ ᮢ -,',
'⨬  ⪫ 쭮 ⪠ ᯥ  ࠡ',
'Chi2 for blunders =  ࠭ ᮢ -,',
'    ⨬  ⪫   । 祭.',
'Width_1 = ਭ  ()  砫 ࢠ',
'Width_2 = ਭ  ()   ࢠ',
'Delta_Width = 譮 ਭ ( )',
'    ந 㭪 ਭ,  :',
'   w = a * ch + b   +- delta_width,  w = fwhm, ch = ',
'㫠 ᯮ   ᪠ , ⠪   .'
);
{*}EntMarkEn_n:INTEGER = 11;
   EntMarkEn:ARRAY[1..22] OF STRING = (
'The energy list of peaks of interest allows us to process in the',
'spectrum only peaks of interest; in addition to this for spectra with',
'different energetical meanings of the channels the spectrum marking',
'may remain the same.',
'Energies are typed in the Memo field in free field format; quantities',
'are separated from each other by blank(s) or comma.',
'While marking spectrum in this mode, if energy calibration data was',
'not set previously, the energies in the list are treated as channels.',
'Uninteresting peaks, which are too close to those of interest, are',
'included into the final marking array automatically (not to disturb',
'the fitting).',
'᮪ ࣨ     ࠡ뢠 ',
'ᯥ ⮫쪮 ; ஬ ⮣,  ࠧ⪠  ᯮ짮',
' ࠡ⪨ ࠧ ᯥ஢  ࠧ묨 ࣥ᪨ ஢',
'ࣨ 뢠  ଠ ᢮ . 稭 ⤥',
'  㣠 ஡  ⮩.',
' ࠧ⪥  ⮬ ०, ᫨ ࣥ᪠ ஢  뫠',
'⠭ ࠭, ࣨ  ᯨ᪠ ࠪ  .',
' ᯥ,   騥,    ࠧ祭,',
'   (⮡  । ⨭).',
'',
''
);
{*}SScaleM_n:INTEGER = 4;
   SScaleM:ARRAY[1..8] OF STRING = (
'Scales are used only for graphs, the spectrum itself remains',
'unaffected',
'Trimming coefficient means the cut-off level (between 0 and 1) of the',
'maximum spectrum amplitude, above which all values vanish.',
' ᯮ ⮫쪮  䨪, ᠬ ᯥ   ',
'.',
'樥 Trimming - ஢ १ ( 0  1) ᨬ쭮',
' ᯥ, 祭  ண .'
);
{*}ShResT_n:INTEGER = 6;
   ShResT:ARRAY[1..12] OF STRING = (
'Crit = criterion for the significance of the peak:',
'      C = (A - B)/SQRT(A + B + 1),  where',
'           A = total area, B = area of the background.',
'If C > 3, the peak is statistically significant.',
'More precise value of criterion for peak detection',
'is defined on test spectra.',
'Crit = ਩ 稬 :',
'      C = (A - B)/SQRT(A + B + 1),  ',
'           A =  頤, B = 頤 䮭.',
'᫨  C > 3,  ᪨ 稬.',
' 筮 祭  㦥 ',
'।  ⮢ ᯥࠬ.'
);
{*}AutoCal_n:INTEGER = 4;
   AutoCal:ARRAY[1..8] OF STRING = (
'For auto-calibration Ra226 or Eu162 peaks are taken as sample.',
'Peaks in the spectrum analized should be found, and their energy' ,
'range, compatible with the sample, should be specified.',
'See that the fitted spectrum peaks match well the calibration peaks.',
' -஢   Ra226  Eu162 (⠫).',
'    㥬 ᯥ  㪠  騩',
' ⠫  ࣨ.',
'室 ⮡ fit-  ᮮ⢥⢮  ⠫.'
);

IMPLEMENTATION

END.
