PROGRAM vactiv;
{Purpose: to process the gamma-ray spectra;  Version: Jan 13 2000 }
USES
  Forms,  SysUtils, Controls, comctrls, Dialogs, Graphics, Classes,
  vzlocom, vactfit, varfun,   vactsg,   vspectr, vgfit,    vpmodel,
  vpeaksr,
  vactiv0 in 'vactiv0.pas',
  vactiv1 in 'vactiv1.pas' {Form1},
  vactiv2 in 'vactiv2.pas' {Form2},
  vactiv3 in 'vactiv3.pas' {Form3};

VAR ft:TEXTFILE;
{$R *.RES}

PROCEDURE CalibrSpectrum(VAR ncen,mocan:INTEGER);
{ to perform energy and efficiency calibration, Dec 20 1996}
VAR i,j,k:INTEGER;
BEGIN fffin(ft,1,2,k,onl); ncen:=Round(onl[1]); ncen:=MIN0(ncen,30);
 mocan:=Round(onl[2]); j:=0; FOR i:=1 TO ncen DO
 BEGIN fffin(ft,1,3,k,onl); Inc(j);
 wenc[i].y:=onl[2]; wenc[i].e:=onl[3]; wenc[i].x:=onl[1];
 CheckZero(ok); IF(NOT ok)THEN Dec(j);
 END;
ncen:=j;
END;
PROCEDURE InitializeVar;
VAR s:STRING; r:REAL;
BEGIN ResizeF1(1.5,1); ResizeF2(1.5,1); ResizeF2(1,1); scrsize:=1;
WITH Form1 DO
 BEGIN N1.Enabled:=false; N2.Enabled:=false; N3.Enabled:=false;
 N4.Enabled:=false; N5.Enabled:=false;
 HideComponents;
 END;
Form2.OpenDialog1.InitialDir:='C:\';
Form2.SaveDialog1.InitialDir:='C:\';
GetDir(0,dirn); ifn:=dirn+'\vactiv.ini'; dirs:=dirn;
s:=dirn+'\vactiv.fn'; IF(FileExists(s))THEN GetSetInfo(s);
r:=scrsize; IF(r<>1)THEN
 BEGIN ResizeF1(r,r); ResizeF2(r,r);
 END;
Form1.FitLoop1.Enabled:=false;
Form1.FitforGraphs1.Enabled:=false;
END;
PROCEDURE IniDataIn;
VAR   i,j:INTEGER; comm:STRING[11];
LABEL Lend,L1;
BEGIN s:=ifn; IF(NOT FileExists(s))THEN GOTO Lend;
AssignFile(ft,s); Reset(ft); WHILE(NOT EoF(ft))DO
 BEGIN Readln(ft,s); IF(s[1]='*')THEN Continue; comm:='';
 FOR i:=1 TO Length(s) DO IF(s[i] IN ['A'..'Z'])THEN comm:=comm+s[i];
 IF(comm='STOP')THEN Exit;
 IF(comm='IS')THEN
  BEGIN {InputSpectrum;} fffin(ft,1,5,j,onl); WITH spec DO
   BEGIN a1:=Round(onl[1]); a2:=Round(onl[2]); smosp:=Round(onl[3]);
   END;
  IF(onl[4]=1)THEN skiph:=true ELSE skiph:=false;
  IF(onl[5]=1)THEN revby:=true ELSE revby:=false;
  EnterStr(ft); spec.sfn:=sedz; dirs:=ExtractFileDir(sedz);
  END;
 IF(comm='MS')THEN
  BEGIN {MarkSpectrum} fffin(ft,1,4,j,onl); mrkmod:=Round(onl[1]);
  sens:=onl[2]; res:=onl[3]; defps:=Round(onl[4]);
  END;
 IF(comm='SAB')THEN
  BEGIN {SetAnalysisBounds} fffin(ft,1,2,j,onl); WITH spec DO
   BEGIN a11:=Round(onl[1]); a22:=Round(onl[2]);
   ic1:=a11; ic2:=a22; cadl:=ic2-ic1+1; aini1:=a11; aini2:=a22;
   END;
  END;
 IF(comm='EWI')THEN
  BEGIN {Enter Width Info} fffin(ft,1,3,j,onl); WITH spec DO
   BEGIN w0:=onl[1]; w1:=onl[2]; dw0:=onl[3];
   cw1:=(w1-w0)/(a2-a1); cw0:=w0-cw1*a1;
   END;
  END;
 IF(comm='EVWI')THEN
  BEGIN {Enter Var Width Info} fffin(ft,1,2,j,onl);
  spec.wv:=onl[1]; spec.dwv:=onl[2];
  END;
 IF((comm='MAXINT')OR(comm='MI'))THEN
  BEGIN {Enter MAX-INT} fffin(ft,1,1,j,onl); linx:=Round(onl[1]);
  END;
 IF(comm='FS')THEN
  BEGIN {Fit Spectrum} fffin(ft,1,2,j,onl); mogr:=Round(onl[2]);
  END;
 IF(comm='COVAR')THEN
  BEGIN {Covar} fffin(ft,1,1,j,onl); covar:=Round(onl[1]);
  END;
 IF(comm='SMAST')THEN
  BEGIN {SMAST} fffin(ft,1,1,j,onl); smast:=Round(onl[1]);
  END;
 IF(comm='ORDER')THEN
  BEGIN {Order} fffin(ft,1,1,j,onl); order:=Round(onl[1]);
  END;
 IF(comm='CHIO')THEN
  BEGIN {Chio} fffin(ft,1,1,j,onl); chibc:=Round(onl[1]);
  END;
 IF(comm='DPOS')THEN
  BEGIN {DPos} fffin(ft,1,1,j,onl); dpos[1]:=Round(onl[1]);
  END;
 IF((comm='DBACK')OR(comm='DB'))THEN
  BEGIN {DBack} fffin(ft,1,1,j,onl); spec.dback:=Round(onl[1]);
  END;
 IF(comm='STEP')THEN
  BEGIN {Step} fffin(ft,1,1,j,onl); step:=Round(onl[1]);
  END;
 IF(comm='DAMP')THEN
  BEGIN {Damp} fffin(ft,1,1,j,onl); damp:=Round(onl[1]);
  END;
 IF(comm='NITER')THEN
  BEGIN {NIter} fffin(ft,1,1,j,onl); niter:=Round(onl[1]);
  END;
 IF(comm='SGM')THEN
  BEGIN {Set Graph Mode} fffin(ft,1,1,j,onl); nscale:=Round(onl[1]);
  END;
 IF(comm='EDENC')THEN
  BEGIN {Energy Calibr.} CalibrSpectrum(ncen,mocan);
  ArrangeEnergCalibr; FOR i:=1 TO ncen DO enc[i]:=wenc[i]; encm:=true;
  IF(mocan=1)THEN LinearCalibration;
  END;
 IF(comm='EDEFC')THEN
  BEGIN {Effic. Calibr.} CalibrSpectrum(ncef,mocaf);
  FOR i:=1 TO ncef DO efc[i]:=wenc[i]; efcm:=true; ArrangeEfficCalibr;
  END;
 IF(comm='FPM')THEN
  BEGIN {Form Peak Models}
  END;
 {IF(comm='SSI')THEN SimulateSpectrumInterv;
 IF(comm='PST')THEN SummaryTable;}
 END;
CloseFile(ft);
Lend:;
END;
PROCEDURE Inipg;
{sets up the initial control data; Version 10.13.1988}
VAR i:INTEGER;
{---------------------------------------------------------------}
BEGIN spec:=TSpectrum.Create(dirn); spec.smosp:=1;
pmod[1]:=TPeakModel.Create; peaksr:=TPeakSearch.Create;
i:=2*npimxc+6; afit:=TParameter.Create(i,i,nintmax); WITH afit DO
 BEGIN mpoint:=0; FormCB; cb.eps:=0.1; cb.step:=0.99; cb.damp:=0.01;
 cb.gnit:=10; cb.delta:=4; cb.beta:=0.25;
 npar:=i; FormParameters; npar:=0;
 END;
linx:=128; cali:=1;
WITH spec DO
 BEGIN a1:=1; a2:=4096; wv:=0; dwv:=0; w0:=4; w1:=6; dw0:=3.5;
 cw1:=(w1-w0)/(a2-a1); cw0:=w0-cw1*a1; smosp:=1;
 a11:=2; a22:=4095; dback:=-3; sfn:='';
 END;
ic1:=1; ic2:=4096; cadl:=4096;
xclb1:=1; xclb2:=4096;
cam:=1; cre:=1; dpos[1]:=5; mogr:=0; kcurr:=1; cmprs:=2;
niter:=7; step:=0.99; damp:=0.01; ncen:=0; ncef:=0;
rl:=0.5; sens:=1; res:=-1;
nscale:=1; pmode:=0; trimm:=0.50;
ntab:=0; nosaved:=false; encm:=false; efcm:=false;
ncl:=0; grst:=0; nreac:=0; ncadr:=0; nenm:=0;
encf:='enc.dat'; efcf:='efc.dat'; mrkf:='mark.dat';
nsfn:=0; snff:='spfn.tab'; loopfn:='vactiv.tab';
END;
{--------------------------------------------------------------- }
BEGIN scrsize:=1; fntsize:=10;
  Application.Initialize;
  Application.CreateForm(TForm1, Form1);
  Application.CreateForm(TForm2, Form2);
  Application.CreateForm(TForm3, Form3);
  InitializeVar;
  Inipg;
  IniDataIn;
  Application.Run;
END.
